/****************************************************************************/
/*                       PC QNX SEISLOG Software              Version 6.0   */
/****************************************************************************/
/*                                                                          */
/*                                      University of Bergen                */
/*                                      Institute of Solid Earth Physics    */
/*                                      Seismological Observatory           */
/*                                      Allegaten 41, 5007 Bergen, Norway   */
/*                                      Tlf. +47 55 213408 +47 55213419     */
/*                                      Fax  +47 55 233337 +47 55320009     */
/*                                      Author: Terje Utheim, Jens Havskov  */
/*                                      E-mail: terje.utheim@ifjf.uib.no    */
/*                                              jens.havskov@ifjf.uib.no    */
/*                                                                          */
/*                                      Date:25/07/00                       */
/* Program:BCK_WEB                                                          */
/*                                                                          */
/* Last update:                                                             */
/*                                                                          */
/* Program description:                                                     */
/*                                                                          */
/* Make directory structure for backup, distribution and installation.      */
/*                                                                          */
/****************************************************************************/
#include <stdio.h>
#include <dirent.h>
#include <string.h>
main(argc,argv)
int argc;
char **argv;
{
DIR *dirp;                             /* pointer to directory              */
FILE*  buf;                            /* pointer to file                   */
FILE*  in;
int    ret;                            /* return value                      */
char   filename[100];                  /* names to backup                   */
char   syscall1[100];                  /* char storage                      */
char   syscall2[100];                  /* char storage                      */
#include "shar_mem.h"
#include <sys/mman.h>
#include <fcntl.h>
#include <stdlib.h>
int      cnt;
int      ix;
int      i;
int      all;
int      fd;                                /* return value open share      */
smod     *ptr;                              /* pointer to shared region     */
if(argc !=2)
{
    all=0;
}else{
    all=1;
}
printf("ALL %d\n",all);
/*--------------------------------------------------------------------------*/
/* open shared memory region                                                */
/*--------------------------------------------------------------------------*/
fd=shm_open("SEISLOG",O_RDWR | O_CREAT, 0777);
if(fd== -1) 
{
    fprintf(stderr,"BCK_WEB_01 open failed:%s\n",strerror(errno));
    exit(1);
}
/*--------------------------------------------------------------------------*/
/* set size of memory region                                                */
/*--------------------------------------------------------------------------*/
ltrunc(fd,sizeof(smod),SEEK_SET);
/*--------------------------------------------------------------------------*/
/* Compute pointer to shared memory region                                  */
/*--------------------------------------------------------------------------*/
ptr=mmap(0,sizeof(smod),PROT_READ | PROT_WRITE,MAP_SHARED,fd,0);
if((int)ptr == -1) 
{
    fprintf(stderr,"BCK_WEB_02 mmap failed : %s\n",strerror(errno));
    exit(1);
}
system("/home/seislog/webvers");       /* enter new version number          */
dirp=opendir("/home/SEISWEB");
if(dirp == NULL)
{
    printf("BCK_WEB: Backup directory tree does not exist, create it !\n");
/*--------------------------------------------------------------------------*/
/* make directory structure for backup, distribution, installation          */
/*--------------------------------------------------------------------------*/
    system("mkdir /home/SEISWEB");
    system("mkdir /home/SEISWEB/webdoc");
    system("mkdir /home/SEISWEB/cgi-bin");
    system("mkdir /home/SEISWEB/seislog");
    system("mkdir /home/SEISWEB/include");
    system("mkdir /home/SEISWEB/java");
    printf("BCK_WEB: New directory tree created.\n");
/*--------------------------------------------------------------------------*/
/* change the access permitions for the new directory structure             */
/*--------------------------------------------------------------------------*/
    system("chmod a+rwx /home/SEISWEB");
    system("chmod a+rwx /home/SEISWEB/webdoc");
    system("chmod a+rwx /home/SEISWEB/cgi-bin");
    system("chmod a+rwx /home/SEISWEB/seislog");
    system("chmod a+rwx /home/SEISWEB/include");
    system("chmod a+rwx /home/SEISWEB/java");
    printf("BCK_WEB: Access modes changed in new directory structure.\n");
}else{
    printf("BCK_WEB: Backup directory tree exists.\n");
}
closedir(dirp);
/*--------------------------------------------------------------------------*/
/* remove all old files in /home/SEISWEB                                    */
/*--------------------------------------------------------------------------*/
system("rm -f /home/SEISWEB/webdoc/*");
system("rm -f /home/SEISWEB/cgi-bin/*");
system("rm -f /home/SEISWEB/seislog/*");
system("rm -f /home/SEISWEB/include/*");

system("cp /usr/webdoc/about.html /home/SEISWEB/webdoc/about.html");
system("cp /usr/webdoc/frontpage.html /home/SEISWEB/webdoc/frontpage.html");
system("cp /usr/webdoc/index.html /home/SEISWEB/webdoc/index.html");
system("cp /usr/webdoc/index2.html /home/SEISWEB/webdoc/index2.html");
system("cp /usr/webdoc/innhaut.html /home/SEISWEB/webdoc/innhaut.html");
system("cp /usr/webdoc/innhold.html /home/SEISWEB/webdoc/innhold.html");
system("cp /usr/webdoc/jcom_a.html /home/SEISWEB/webdoc/jcom_a.html");
system("cp /usr/webdoc/jdpl_a.html /home/SEISWEB/webdoc/jdpl_a.html");
system("cp /usr/webdoc/jlast_a.html /home/SEISWEB/webdoc/jlast_a.html");
system("cp /usr/webdoc/jmon_a.html /home/SEISWEB/webdoc/jmon_a.html");
system("cp /usr/webdoc/jsts_a.html /home/SEISWEB/webdoc/jsts_a.html");
system("cp /usr/webdoc/h1.html /home/SEISWEB/webdoc/h1.html");
system("cp /usr/webdoc/h2.html /home/SEISWEB/webdoc/h2.html");
system("cp /usr/webdoc/h3.html /home/SEISWEB/webdoc/h3.html");

system("cp /usr/cgi-bin/getdef.c /home/SEISWEB/cgi-bin/getdef.c");
system("cp /usr/cgi-bin/copypar.c /home/SEISWEB/cgi-bin/copypar.c");
system("cp /usr/cgi-bin/boot.c /home/SEISWEB/cgi-bin/boot.c");
system("cp /usr/cgi-bin/restart.c /home/SEISWEB/cgi-bin/restart.c");
system("cp /usr/cgi-bin/stopp.c /home/SEISWEB/cgi-bin/stopp.c");
system("cp /usr/cgi-bin/parwrt.c /home/SEISWEB/cgi-bin/parwrt.c");
system("cp /usr/cgi-bin/validate.c /home/SEISWEB/cgi-bin/validate.c");
system("cp /usr/cgi-bin/validate2.c /home/SEISWEB/cgi-bin/validate2.c");

system("cp /home/seislog/jall_s.c /home/SEISWEB/seislog/jall_s.c");
system("cp /home/seislog/jlgs_s.c /home/SEISWEB/seislog/jlgs_s.c");
system("cp /home/seislog/jmon_s.c /home/SEISWEB/seislog/jmon_s.c");
system("cp /home/seislog/jsts_s.c /home/SEISWEB/seislog/sts_s.c");
system("cp /home/seislog/jrtp_s.c /home/SEISWEB/seislog/jrtp_s.c");
system("cp /home/seislog/sndfile.c /home/SEISWEB/seislog/sndfile.c");

system("cp /home/seislog/slinger /home/SEISWEB/seislog/slinger");
system("cp /home/seislog/sockets*.lib /home/SEISWEB/seislog");

system("cp /usr/include/netdb.h /home/SEISWEB/include/netdb.h");
system("cp /usr/include/netinet/in.h /home/SEISWEB/include/in.h");

system("cp /usr/include/sys/socket.h /home/SEISWEB/include/socket.h");
system("cp /usr/include/sys/sock_msg.h /home/SEISWEB/include/sock_msg.h");

system("cp /home/seislog/jall_a.java /home/SEISWEB/java/jall_a.java");
system("cp /home/seislog/jdpl_a.java /home/SEISWEB/java/jdpl_a.java");
system("cp /home/seislog/jlast_a.java /home/SEISWEB/java/jlast_a.java");
system("cp /home/seislog/jlgs_a.java /home/SEISWEB/java/jlgs_a.java");
system("cp /home/seislog/jmon_a.java /home/SEISWEB/java/jmon_a.java");
system("cp /home/seislog/jsts_a.java /home/SEISWEB/java/jsts_a.java");
system("cp /home/seislog/jpar_a.java /home/SEISWEB/java/jpar_a.java");
system("cp /home/seislog/jpar_b.java /home/SEISWEB/java/jpar_b.java");

if(all==1)
{
dirp=opendir("/dos/a/SEISWEB");
if(dirp == NULL)
{
    printf("BCK_WEB: Backup directory tree does not exist, create it !\n");
/*--------------------------------------------------------------------------*/
/* make directory structure for backup, distribution, installation          */
/*--------------------------------------------------------------------------*/
    system("mkdir /dos/a/SEISWEB");
    system("mkdir /dos/a/SEISWEB/webdoc");
    system("mkdir /dos/a/SEISWEB/cgi-bin");
    system("mkdir /dos/a/SEISWEB/seislog");
    system("mkdir /dos/a/SEISWEB/include");
    system("mkdir /dos/a/SEISWEB/java");
    printf("BCK_WEB: New directory tree created.\n");
/*--------------------------------------------------------------------------*/
/* change the access permitions for the new directory structure             */
/*--------------------------------------------------------------------------*/
    system("chmod a+rwx /dos/a/SEISWEB");
    system("chmod a+rwx /dos/a/SEISWEB/webdoc");
    system("chmod a+rwx /dos/a/SEISWEB/cgi-bin");
    system("chmod a+rwx /dos/a/SEISWEB/seislog");
    system("chmod a+rwx /dos/a/SEISWEB/include");
    system("chmod a+rwx /dos/a/SEISWEB/java");
    printf("BCK_WEB: Access modes changed in new directory structure.\n");
}else{
    printf("BCK_WEB: Backup directory tree exists.\n");
}
closedir(dirp);
/*--------------------------------------------------------------------------*/
/* remove all old files in /home/SEISWEB                                    */
/*--------------------------------------------------------------------------*/
//system("rm -f /dos/a/SEISWEB/webdoc/*");
//system("rm -f /dos/a/SEISWEB/cgi-bin/*");
//system("rm -f /dos/a/SEISWEB/seislog/*");
//system("rm -f /dos/a/SEISWEB/include/*");
printf("UP TO HERE\n");
system("cp /usr/webdoc/about.html /dos/a/SEISWEB/webdoc/about.h");
system("cp /usr/webdoc/frontpage.html /dos/a/SEISWEB/webdoc/front.h");
system("cp /usr/webdoc/index.html /dos/a/SEISWEB/webdoc/index.h");
system("cp /usr/webdoc/index2.html /dos/a/SEISWEB/webdoc/index2.h");
system("cp /usr/webdoc/innhaut.html /dos/a/SEISWEB/webdoc/innhaut.h");
system("cp /usr/webdoc/innhold.html /dos/a/SEISWEB/webdoc/innhold.h");
system("cp /usr/webdoc/jcom_a.html /dos/a/SEISWEB/webdoc/jcom_a.h");
system("cp /usr/webdoc/jdpl_a.html /dos/a/SEISWEB/webdoc/jdpl_a.h");
system("cp /usr/webdoc/jlast_a.html /dos/a/SEISWEB/webdoc/jlast_a.h");
system("cp /usr/webdoc/jmon_a.html /dos/a/SEISWEB/webdoc/jmon_a.h");
system("cp /usr/webdoc/jsts_a.html /dos/a/SEISWEB/webdoc/jsts_a.h");
system("cp /usr/webdoc/h1.html /dos/a/SEISWEB/webdoc/h1.h");
system("cp /usr/webdoc/h2.html /dos/a/SEISWEB/webdoc/h2.h");
system("cp /usr/webdoc/h3.html /dos/a/SEISWEB/webdoc/h3.h");

system("cp /usr/cgi-bin/getdef.c /dos/a/SEISWEB/cgi-bin/getdef.c");
system("cp /usr/cgi-bin/copypar.c /dos/a/SEISWEB/cgi-bin/copypar.c");
system("cp /usr/cgi-bin/boot.c /dos/a/SEISWEB/cgi-bin/boot.c");
system("cp /usr/cgi-bin/restart.c /dos/a/SEISWEB/cgi-bin/restart.c");
system("cp /usr/cgi-bin/stopp.c /dos/a/SEISWEB/cgi-bin/stopp.c");
system("cp /usr/cgi-bin/parwrt.c /dos/a/SEISWEB/cgi-bin/parwrt.c");
system("cp /usr/cgi-bin/validate.c /dos/a/SEISWEB/cgi-bin/validate.c");
system("cp /usr/cgi-bin/validate2.c /dos/a/SEISWEB/cgi-bin/validate2.c");

system("cp /home/seislog/jall_s.c /dos/a/SEISWEB/seislog/jall_s.c");
system("cp /home/seislog/jlgs_s.c /dos/a/SEISWEB/seislog/jlgs_s.c");
system("cp /home/seislog/jmon_s.c /dos/a/SEISWEB/seislog/jmon_s.c");
system("cp /home/seislog/jsts_s.c /dos/a/SEISWEB/seislog/jsts_s.c");
system("cp /home/seislog/jrtp_s.c /dos/a/SEISWEB/seislog/jrtp_s.c");
system("cp /home/seislog/sndfile.c /dos/a/SEISWEB/seislog/sndfile.c");

system("cp /home/seislog/slinger /dos/a/SEISWEB/seislog/slinger");
system("cp /home/seislog/sockets*.lib /dos/a/SEISWEB/seislog");

system("cp /usr/include/netdb.h /dos/a/SEISWEB/include/netdb.h");
system("cp /usr/include/netinet/in.h /dos/a/SEISWEB/include/in.h");

system("cp /usr/include/sys/socket.h /dos/a/SEISWEB/include/socket.h");
system("cp /usr/include/sys/sock_msg.h /dos/a/SEISWEB/include/sock_msg.h");

system("cp /home/seislog/jall_a.java /dos/a/SEISWEB/java/jall_a.j");
system("cp /home/seislog/jdpl_a.java /dos/a/SEISWEB/java/jdpl_a.j");
system("cp /home/seislog/jlast_a.java /dos/a/SEISWEB/java/jlast_a.j");
system("cp /home/seislog/jlgs_a.java /dos/a/SEISWEB/java/jlgs_a.j");
system("cp /home/seislog/jmon_a.java /dos/a/SEISWEB/java/jmon_a.j");
system("cp /home/seislog/jsts_a.java /dos/a/SEISWEB/java/jsts_a.j");
system("cp /home/seislog/jpar_a.java /dos/a/SEISWEB/java/jpar_a.j");
system("cp /home/seislog/jpar_b.java /dos/a/SEISWEB/java/jpar_b.j");

}


printf("\n                            *** BACKUP FINISHED ***\n");
}