/****************************************************************************/
/*                       PC QNX SEISLOG Software              Version 7.0   */
/****************************************************************************/
/*                                                                          */
/*                                      University of Bergen                */
/*                                      Institute of Solid Earth Physics    */
/*                                      Seismological Observatory           */
/*                                      Allegaten 41, 5007 Bergen, Norway   */
/*                                      Tlf. +47 55583408 +47 55583419      */
/*                                      Fax  +47 55589669                   */
/*                                      Author: Terje Utheim, Jens Havskov  */
/*                                      E-mail: terje.utheim@ifjf.uib.no    */
/*                                              jens.havskov@ifjf.uib.no    */
/*                                                                          */
/*                                      Date:08/03/95                       */
/* Program:                                                                 */
/*                                                                          */
/* Last update:09/07/97                                                     */
/*                                                                          */
/* Program description:                                                     */
/*                                                                          */
/* This program is used to allocate the number                              */
/* of ring-buffer files specified in the                                    */
/* parameterfile:                              /home/buffer/R0000           */
/*                                             /home/buffer/R0001 etc.....  */
/* The program allocates the detection number                               */
/* file, and initialize the DPX number to 0    /home/seislog/pr/detnr       */
/* The program allocates the sequence number                                */
/* file, and initialize the CONTNR to 0        /home/seislog/pr/contnr      */
/* The program allocates the detection file    /home/buffer/event           */
/* The program allocates the ringbuffer log                                 */
/* file and initialize it to empty status      /home/buffer/idx_log         */
/*                                                                          */
/****************************************************************************/  

#include "shar_mem.h"                  /* shared data- and parameter module */
#include <string.h>
#include <unistd.h>
#include <errno.h>
#include "filedef.h"
#include <sys/mman.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <errno.h>
#include <stdlib.h>
#include "timexrou.h"
char     idx_log[500];
char     text[200];
char     rngnam[100];
FILE     *in;
FILE     *idx;
/****************************************************************************/
/*       DSK_ALL - generate the continuous record space                     */
/****************************************************************************/
main()
{
time_t   time_of_day;
auto     char buf[26];
char     evnam[DIRNAMLEN+EVNAMLEN+10];
char     fnam[EVNAMLEN+10];
int      PathNo;                       /* Pathnumber to file                */
int      PathNo2;                      /* Pathnumber to lo file             */
int      i;                            /* Counter                           */
int      k;                            /* Counter                           */
int      ret;                          /* Return value allocating the file  */
int      size_file;                    /* filesize each rinbuffer           */
int      rnghdr;                       /* size of header + displ            */
char     head[SIZ_EV_HDR+1];
char     *logptr;
int      fd;                           /* return value open share           */
smod     *ptr;                         /* pointer to shared region          */
/*--------------------------------------------------------------------------*/
/* open shared memory region                                                */
/*--------------------------------------------------------------------------*/
fd=shm_open("SEISLOG",O_RDWR | O_CREAT, 0777);
if(fd== -1) 
{
    fprintf(stderr,"DSK_ALL_01 open failed:%s\n",strerror(errno));
    exit(1);
}
/*--------------------------------------------------------------------------*/
/* set size of memory region                                                */
/*--------------------------------------------------------------------------*/
ltrunc(fd,sizeof(smod),SEEK_SET);
/*--------------------------------------------------------------------------*/
/* Compute pointer to shared memory region                                  */
/*--------------------------------------------------------------------------*/
ptr=mmap(0,sizeof(smod),PROT_READ | PROT_WRITE,MAP_SHARED,fd,0);
if((int)ptr == -1) 
{
    fprintf(stderr,"DSK_ALL_02 mmap failed : %s\n",strerror(errno));
    exit(1);
}
system("'\'rm -f /home/buffer/CIRCLE");     /* remove all ringbuffers           */

PathNo2     = open("/home/buffer/CIRCLE",O_RDWR | O_CREAT,
             S_IRUSR | S_IWUSR | S_IRGRP | S_IWGRP);
if(PathNo2 != -1)
{
    if( chsize(PathNo2,CRCSIZ) != 0)
    {
        printf("Error extending /home/buffer/CIRCLE file\n");
    }
    close(PathNo2);
}
system("chmod 777 /home/buffer/CIRCLE");
printf("/home/buffer/CIRCLE allocated and extended\n");

}