/****************************************************************************/
/*                       PC QNX SEISLOG Software              Version 6.0   */
/****************************************************************************/
/*                                                                          */
/*                                      University of Bergen                */
/*                                      Institute of Solid Earth Physics    */
/*                                      Seismological Observatory           */
/*                                      Allegaten 41, 5007 Bergen, Norway   */
/*                                      Tlf. +47 55 213408 +47 55213419     */
/*                                      Fax  +47 55 233337 +47 55320009     */
/*                                      Author: Terje Utheim, Jens Havskov  */
/*                                      E-mail: terje.utheim@ifjf.uib.no    */
/*                                              jens.havskov@ifjf.uib.no    */
/*                                                                          */
/*                                      Date:15/05/95                       */
/* Program:COPY_DOS                                                         */
/*                                                                          */
/* Last update:                                                             */
/*                                                                          */
/* Program description:                                                     */
/*                                                                          */
/* Program to copy events from QNX partition to DOS partition. Filenames are*/
/* converted to 8 letters.                                                  */
/*                                                                          */
/****************************************************************************/
#include <stdio.h>                 
#include <errno.h>

main ()
{
char    com[80];
char    dum[80];
char    ch;
char    fnam1[80];
char    fnam2[80];
char    syscall[100];
char    name[80];
int     nbyte;
int     k;
int     i;
int     year;
int     month;
int     day;
int     hour;
int     min;
int     sec;
int     answer;
FILE*   evt;
printf("Enter letter 'a' or 'c' to copy to floppy or disk\n");
answer=getch();
printf("%c\n",answer);
/*--------------------------------------------------------------------------*/
/* make listing of all files in events directory                            */
/*--------------------------------------------------------------------------*/
system("ls /home/events/*T.* > /home/seislog/evt.lis"); 

if((evt=fopen("/home/seislog/evt.lis","r"))==NULL)
{
    fclose(evt); 
    printf("Could not open file containing events summary\n");
    exit(0);
}
/*--------------------------------------------------------------------------*/
/*                read in names until EOF                                   */
/*--------------------------------------------------------------------------*/
i=1;
for(;;)
{
    nbyte=fread(com,39,1,evt);
    if(nbyte==0)                       /* if no more names => finish        */
        goto fin;
    printf("%3d  ",i);
    for(k=0;k<38;k++)
        printf("%c",com[k]);           /* print out original name           */
    sscanf(com,"%13c%2d%2d%c%2d%c%2d%2d%c%2d",
dum,&year,&month,dum,&day,dum,&hour,&min,dum,&sec);
    sprintf(fnam1,"%s",com);           /* original name into fnam1          */
    if(answer=='c')
    {
    sprintf(fnam2,"/dos/c/seismo/wor/"); /* dos partition directory to fnam2*/
    }else{
    sprintf(fnam2,"/dos/a/");
    }
    sprintf(name,"%2d%2d%2d%2d.T%2d\n",year,month,day,hour,min); /* new name*/
    for(k=0;k<12;k++)                  /* check new name for spaces         */
    {
        if(name[k]==' ')
            name[k]='0';
    }
    strncat(fnam2,name);               /* concatenate new name into fnam2   */
    printf("  to  %s",fnam2);          /* print out new name                */
    fnam1[38]='\0';                    /* insert null character at the end  */
    fnam2[38]='\0';                    /* insert null character at the end  */
    sprintf(syscall,"cp %s %s",fnam1,fnam2); /* put string into syscall     */
    system(syscall);                   /* execute copy and string           */
    i=i+1;
}
fin:
printf("Number of files copied:%d\n",i-1);    
}

/*-------end: configure_ring----------------------------------------------*/
