#include "shar_mem.h"                  /* shared memory definitions         */
#include <sys/mman.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/dev.h>
#include <fcntl.h>
#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <time.h>
#include <conio.h>
#include <sys/irqinfo.h>               /* needed for interrupt-routines     */
#include <sys/proxy.h>
#include <sys/kernel.h>                /* needed for interrupt-routines     */
#include <sys/name.h>
#define  BASE 0x300                    /* base address for DAS1802 board    */
#define  IRQ  0x5                     /* interrupt level                   */
char     snd_msg[30];
char     rec_msg[30];
pid_t    proxy;
volatile unsigned counter;
int      fd;                           /* return value open share           */
volatile smod     *ptr;                /* pointer to shared region          */
volatile unsigned char  mux;
volatile unsigned char  status;
volatile unsigned short  val1;
volatile unsigned char  val2;
volatile unsigned char  ch;
volatile unsigned short cnt;
volatile unsigned short temp;
volatile unsigned char kanaler;
volatile unsigned char  irqen;
volatile int            sample;
volatile short          verdi;
volatile int            i;
volatile int            scan;
volatile unsigned char  sts;
volatile int            index;
volatile int            tel;
volatile int            samp;
volatile int            irq_block;
volatile int            mil;
volatile int            sc_sec;
volatile int            ms;
volatile int            ms1;
volatile int            chan;
volatile int            teller;
volatile int            bank;
volatile int            inc;
/****************************************************************************/
/*      The Hardware Interrupt handler for DAS 1802 board                   */
/*--------------------------------------------------------------------------*/
/****************************************************************************/
#pragma off( check_stack );
pid_t far handler()
{
//    ptr->vadc[teller]=inp(BASE+0x7);
//    teller++;
    outp(BASE+0x5,0x20);               /*disable interrupts                 */
    outp(BASE+0x7,0x80);               /* enable conversions & clear int bit*/
    for(i=0;i<ptr->nchan;i++)
    {
//        ptr->vadc[teller]=(i+1)*10;
//        teller++;
        val1=inpw(BASE);                   /* read LSB                          */
        if(i<=chan)    
        {
            outpw(BASE,0x0000);           /* start conversion as soon as possib*/
        }
            verdi=val1;                    /* signed long integer               */
            sample=verdi;
            ptr->ibuf[irq_block][scan+i+HEADER]=sample; /* into shared memory          */
        if(i<=chan)
        {
            for(inc=0;inc<20;inc++)                        /* WAIT FOR SOMETHING IN FIFO        */
            {
                sts=inp(BASE+0x7);         /* get status reg 7                  */
                sts=sts>>6;
//                ptr->vadc[teller]=sts;
//                teller++;
                if(sts == 3)
                    goto fnd;
            }
        }
fnd:
        outp(BASE+0x7,0x80);
    }
outp(BASE+0x5,0x10);                   /* enable interrupt on NOT empty irq5*/
outp(BASE+0xa,kanaler);                   /* re-initialize                     */

    tel++;                             /* increment scan counter            */
    scan=scan+ptr->nchan;              /* increment buffer index            */
    if(tel==sc_sec)                    /* check for 1 second                */
    {
        irq_block=(irq_block + 1) % 2; /* switch buffer                     */
        scan=0;                        /* zero index                        */
        tel=0;                         /* zero index                        */
        return(proxy);             /* signal main to save 1 sec buffer  */
    }
    return(0);
}
#pragma on( check_stack);
/****************************************************************************/
/*      The Hardware Interrupt Handler counting milliseconds                */
/*--------------------------------------------------------------------------*/
/* This interrupt handler is connected up with the systems own timer, and   */
/* is not more accurate than the systems CPU time. However, it is accurate  */
/* enough to count to 1000 milliseconds.                                    */
/****************************************************************************/
#pragma off( check_stack );
pid_t far mil_handler()
{
    mil++;
    if(mil == ms)
    {
        mil=0;
        outpw(BASE,0x0000);               /* start conversion new scan         */
    }
return(0);
}
#pragma on( check_stack);

main()
{
int      dig_met_id;                   /* id this process                   */
int      buf_pip_id;                   /* id BUF_PIP                        */
char     rep_msg[10];
char     rec_msg[10];
unsigned int cop;
unsigned int kan;
unsigned int g;
int      j;
int      k;
int      gps_garm_id;
int      id;                           /* id for the 1 PPS interrupt handler*/
int      idd;                          /* id for the 1msec interrupt handler*/
int      fh;                           /* file descriptor for serial device */
struct   timespec start;               /* structure for setting system time */
dig_met_id=qnx_name_attach(0,"dig_m18");
if(dig_met_id == 1)
{
    printf("DIG_MET attach failed\n");
    exit(0);
}

/*--------------------------------------------------------------------------*/
/* open shared memory region                                                */
/*--------------------------------------------------------------------------*/
fd=shm_open("SEISLOG",O_RDWR | O_CREAT, 0777);
if(fd== -1) 
{
    fprintf(stderr,"DIG_MET_01 open failed:%s\n",strerror(errno));
    exit(1);
}
/*--------------------------------------------------------------------------*/
/* set size of memory region                                                */
/*--------------------------------------------------------------------------*/
ltrunc(fd,sizeof(smod),SEEK_SET);
/*--------------------------------------------------------------------------*/
/* Compute pointer to shared memory region                                  */
/*--------------------------------------------------------------------------*/
ptr=mmap(0,sizeof(smod),PROT_READ | PROT_WRITE,MAP_SHARED,fd,0);
if((int)ptr == -1) 
{
    fprintf(stderr,"DIG_MET_02 mmap failed : %s\n",strerror(errno));
    exit(1);
}
setprio(getpid(),18);                  /* set the priority this process=14  */
printf("rate:%d\n",ptr->rate);
sc_sec=ptr->rate;
ms=(int)(ptr->srate * 1000.0 + 0.000001);
printf("Samplerate: %d Scans per second: %d\n",ms,sc_sec);
chan=ptr->nchan-2;
printf("CHAN=%d\n",chan);
/*--------------------------------------------------------------------------*/
/* locate BUF_PIP and get its process id                                    */
/*--------------------------------------------------------------------------*/
buf_pip_id=qnx_name_locate(0,"buf_pip",0,&cop);
/*--------------------------------------------------------------------------*/
/* set up a proxy for the interrupt handler to kick                         */
/*--------------------------------------------------------------------------*/
if((proxy = qnx_proxy_attach(0,0,0,0)) == -1)
{
    printf("DIG_MET Unable to attach proxy. ");
    return;
}
/*--------------------------------------------------------------------------*/
/* Attach the interrupt for the DAS1802 board                               */
/*--------------------------------------------------------------------------*/
if(( id=qnx_hint_attach(IRQ,&handler,FP_SEG(&counter)))==-1)
{
    printf("Unable to attach the interrupt.");
    exit(0);
}
system("ticksize 1");                  /* set ticksize of system to 1 msec  */
samp=0;
teller=0;
tel=0;
cnt=0;
scan=0;
mil=0;
irq_block=0;                           /* initial buffer index              */
kanaler=(char)ptr->nchan-1;            /* last channel number to digitize   */
outp(BASE+0x7,0x00);                   /* disable conversions               */
outp(BASE+0x2,0x01);                   /* QRAM                              */
outp(BASE+0xa,kanaler);                /* 4 channels                        */
for(i=0;i<ptr->nchan;i++)              /* set up channels and gains         */
{
    kan=i;
printf("Gain= %d ",ptr->gain[i]);
    switch(ptr->gain[i])
    {
        case 1:
        break;
        case 2:
        kan=kan | 0x0040;
        break;
        case 4:
        kan=kan | 0x0080;
        break;
        case 8:
        kan=kan | 0x00c0;
        break;
    }
    outpw(BASE+0x0,kan);
printf("kan: %d %x\n",kan,kan);
}

outp(BASE+0xa,kanaler);                   /* re-initialize                     */
outp(BASE+0x6,0x40);                   /* bipolar + 64 channels            */
outp(BASE+0x4,0x01);                   /* enable FIFO                       */
outp(BASE+0x2,0x00);                   /* point to A/D FIFO                 */
outp(BASE+0x7,0x80);                   /* enable a/d conversions            */
outp(BASE+0x5,0x10);                   /* enable interrupt on NOT empty irq5*/


ptr->index=0;                          /* pointer to first buffer to fill   */
Send(buf_pip_id,&snd_msg,&rec_msg,1,1); /* send to buf_pip to give id       */
if(ptr->intclk == 0)
{

/*--------------------------------------------------------------------------*/
/* Attach the interrupt to count milliseconds                               */
/*--------------------------------------------------------------------------*/
if(( idd=qnx_hint_attach(0,&mil_handler,FP_SEG(&counter)))==-1)
{
    printf("Unable to attach the interrupt.");
    return;
}
}else{
    outp(BASE+0x6,0x42);
}

for(;;)
{
    ptr->alive[1]=1;                   /* tell I am alive                   */
    Receive(proxy,0,0);                /* value ready                       */
teller=0;
//exit(0);
    Send(buf_pip_id,&snd_msg,&rec_msg,1,1);
}
}
