/****************************************************************************/
/*                       PC QNX SEISLOG Software              Version 6.0   */
/****************************************************************************/
/*                                                                          */
/*                                      University of Bergen                */
/*                                      Institute of Solid Earth Physics    */
/*                                      Seismological Observatory           */
/*                                      Allegaten 41, 5007 Bergen, Norway   */
/*                                      Tlf. +47 55 213408 +47 55213419     */
/*                                      Fax  +47 55 233337 +47 55320009     */
/*                                      Author: Terje Utheim, Jens Havskov  */
/*                                      E-mail: terje.utheim@ifjf.uib.no    */
/*                                              jens.havskov@ifjf.uib.no    */
/*                                                                          */
/*                                      Date:05/04/96                       */
/* Program:DIG_MET                                                          */
/*                                                                          */
/* Last update:                                                             */
/*                                                                          */
/* Program description:                                                     */
/*                                                                          */
/*                                                                          */
/****************************************************************************/     
#include "shar_mem.h"                  /* shared memory definitions         */
#include <sys/mman.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/dev.h>
#include <fcntl.h>
#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <time.h>
#include <conio.h>
#include <sys/irqinfo.h>               /* needed for interrupt-routines     */
#include <sys/proxy.h>
#include <sys/kernel.h>                /* needed for interrupt-routines     */
#include <sys/name.h>
#define  BASE 0x380                    /* base address for DAS1202 board    */
#define  IRQ  0x5                      /* interrupt level                   */
char     snd_msg[30];
char     rec_msg[30];
pid_t    proxy;
volatile unsigned counter;
int      fd;                           /* return value open share           */
volatile smod     *ptr;                /* pointer to shared region          */
volatile unsigned char  mux;
volatile unsigned char  val1;
volatile unsigned char  val2;
volatile unsigned char  ch;
volatile unsigned short cnt;
volatile unsigned short temp;
volatile unsigned char  irqen;
volatile int            sample;
volatile int            i;
volatile int            scan;
volatile unsigned char  sts;
volatile int            index;
volatile int            tel;
volatile int            samp;
volatile int            irq_block;
volatile int            mil;
volatile int            sc_sec;
volatile int            ms;
volatile int            ms1;
volatile int            chan;
volatile int            teller;
volatile int            bank;
/****************************************************************************/
/*      The Hardware Interrupt handler for DAS 1200 board                   */
/*--------------------------------------------------------------------------*/
/****************************************************************************/
#pragma off( check_stack );
pid_t far handler2()
{
    val1=inp(BASE);                /* read LSB                          */
    val2=inp(BASE+0x1);            /* read MSB                          */
    outp(BASE+0x8,0x00);           /* clear interrupt                   */
    cnt=val1;
    temp=val2;
    temp=temp<<8;
    cnt=cnt | temp;
    cnt=cnt>>4;                    /* shift out channel number          */
    sample=cnt;                    /* signed long integer               */
    sample=sample-2048;            /* from binary offset to +/- 2048    */
    ptr->ibuf[irq_block][scan+i+HEADER]=sample; /* into shared memory          */
    i++;
    if(i >= ptr->nchan)
    {
        i=0;
        tel++;                             /* increment scan counter            */
        scan=scan+ptr->nchan;              /* increment buffer index            */
        if(tel==sc_sec)                    /* check for 1 second                */
        {
            irq_block=(irq_block + 1) % 2; /* switch buffer                     */
            scan=0;                        /* zero index                        */
            tel=0;                         /* zero index                        */
            ms1=ptr->itmde;
            return(proxy);             /* signal main to save 1 sec buffer  */
        }
    }
    return(0);
}
#pragma on( check_stack);
/****************************************************************************/
/*      The Hardware Interrupt handler for DAS 1200 board                   */
/*--------------------------------------------------------------------------*/
/****************************************************************************/
#pragma off( check_stack );
pid_t far handler()
{
    for(i=0;i<ptr->nchan;i++)
    {
//        outp(BASE+0x9,0x70);           /* disable interrupt */
        val1=inp(BASE);                /* read LSB                          */
        val2=inp(BASE+0x1);            /* read MSB                          */
        outp(BASE+0x8,0x00);           /* clear interrupt                   */
        if(i <= chan)
            outp(BASE,0x00);           /* start conversion                  */
        cnt=val1;
        temp=val2;
        temp=temp<<8;
        cnt=cnt | temp;
        cnt=cnt>>4;                    /* shift out channel number          */
        sample=cnt;                    /* signed long integer               */
        sample=sample-2048;            /* from binary offset to +/- 2048    */
        ptr->ibuf[irq_block][scan+i+HEADER]=sample; /* into shared memory          */
        do
        {
        teller++;
        }while ( (inp(BASE+0x8) & 0x80) != 0); /* AD busy ?                     */
    }
    tel++;                             /* increment scan counter            */
    scan=scan+ptr->nchan;              /* increment buffer index            */
    if(tel==sc_sec)                    /* check for 1 second                */
    {
        irq_block=(irq_block + 1) % 2; /* switch buffer                     */
        scan=0;                        /* zero index                        */
        tel=0;                         /* zero index                        */
        outp(BASE+0x8,0x00);           /* clear interrupt                   */
//    outp(BASE+0x9,irqen);              /* enable IRQ + external trigger     */
        return(proxy);             /* signal main to save 1 sec buffer  */
    }
    outp(BASE+0x8,0x00);               /* clear interrupt                   */
//    outp(BASE+0x9,irqen);              /* enable IRQ + external trigger     */
    return(0);
}
#pragma on( check_stack);
/****************************************************************************/
/*      The Hardware Interrupt Handler counting milliseconds                */
/*--------------------------------------------------------------------------*/
/* This interrupt handler is connected up with the systems own timer, and   */
/* is not more accurate than the systems CPU time. However, it is accurate  */
/* enough to count to 1000 milliseconds.                                    */
/****************************************************************************/
#pragma off( check_stack );
pid_t far mil_handler()
{
    mil++;
    if(mil == ms)
    {
        mil=0;
        outp(BASE,0x00);
    }
return(0);
}
#pragma on( check_stack);
main()
{
int      dig_met_id;                   /* id this process                   */
int      buf_pip_id;                   /* id BUF_PIP                        */
char     rep_msg[10];
char     rec_msg[10];
unsigned int cop;
unsigned char kanaler;
int      j;
int      k;
int      gps_garm_id;
int      id;                           /* id for the 1 PPS interrupt handler*/
int      idd;                          /* id for the 1msec interrupt handler*/
int      fh;                           /* file descriptor for serial device */
struct   timespec start;               /* structure for setting system time */
dig_met_id=qnx_name_attach(0,"dig_met");
if(dig_met_id == 1)
{
    printf("DIG_MET attach failed\n");
    exit(0);
}
/*--------------------------------------------------------------------------*/
/* open shared memory region                                                */
/*--------------------------------------------------------------------------*/
fd=shm_open("SEISLOG",O_RDWR | O_CREAT, 0777);
if(fd== -1) 
{
    fprintf(stderr,"DIG_MET_01 open failed:%s\n",strerror(errno));
    exit(1);
}
/*--------------------------------------------------------------------------*/
/* set size of memory region                                                */
/*--------------------------------------------------------------------------*/
ltrunc(fd,sizeof(smod),SEEK_SET);
/*--------------------------------------------------------------------------*/
/* Compute pointer to shared memory region                                  */
/*--------------------------------------------------------------------------*/
ptr=mmap(0,sizeof(smod),PROT_READ | PROT_WRITE,MAP_SHARED,fd,0);
if((int)ptr == -1) 
{
    fprintf(stderr,"DIG_MET_02 mmap failed : %s\n",strerror(errno));
    exit(1);
}
setprio(getpid(),14);                  /* set the priority this process=14  */
printf("rate:%d\n",ptr->rate);
sc_sec=ptr->rate;
ms=(int)(ptr->srate * 1000.0 + 0.000001);
printf("Samplerate: %d Scans per second: %d\n",ms,sc_sec);
chan=ptr->nchan-2;
/*--------------------------------------------------------------------------*/
/* locate BUF_PIP and get its process id                                    */
/*--------------------------------------------------------------------------*/
buf_pip_id=qnx_name_locate(0,"buf_pip",0,&cop);
/*--------------------------------------------------------------------------*/
/* set up a proxy for the interrupt handler to kick                         */
/*--------------------------------------------------------------------------*/
if((proxy = qnx_proxy_attach(0,0,0,0)) == -1)
{
    printf("DIG_MET Unable to attach proxy. ");
    return;
}
//if(ptr->intclk == 1)
//{
/*--------------------------------------------------------------------------*/
/* Attach the interrupt for the DAS1200 board                               */
/*--------------------------------------------------------------------------*/
//if(( id=qnx_hint_attach(IRQ,&handler2,FP_SEG(&counter)))==-1)
//{
//    printf("Unable to attach the interrupt.");
//    return;
//}
//}else{
/*--------------------------------------------------------------------------*/
/* Attach the interrupt for the DAS1200 board                               */
/*--------------------------------------------------------------------------*/
if(( id=qnx_hint_attach(IRQ,&handler,FP_SEG(&counter)))==-1)
{
    printf("Unable to attach the interrupt.");
    return;
}
//}
system("ticksize 1");                  /* set ticksize of system to 1 msec  */
//if(ptr->intclk == 1)
//{
//    irqen=IRQ<<4 | 0x2;                /* IRQ + external trigger            */
//}else{
    irqen=IRQ<<4 | 0x0;                /* IRQ + software start a/d          */
//}
irqen=irqen | 0x80;                    /* enable interrupt                  */
samp=0;
tel=0;
cnt=0;
scan=0;
mil=0;
irq_block=0;                           /* initial buffer index              */
kanaler=(char)ptr->nchan-1;            /* last channel number to digitize   */
kanaler=kanaler << 4;                  /* shift left into high nibble       */
outp(BASE+0x2,kanaler);                /* write to multiplex register       */
outp(BASE+0x8,0x00);                   /* clear interrupt                   */
//if(ptr->intclk==1)
//{
//    outp(BASE+0x9,irqen);              /* enable int IRQ 2 + timer-counter  */
//}else{
//    outp(BASE+0x406,0x40);             /* enable 1600 mode                  */
//    outp(BASE+0x405,0x40);             /* enable burst mode                 */
//    outp(BASE+0xa,kanaler);            /* set burst length                  */
//    outp(BASE+0xb,0xff);               /* set burst rate                    */
//}
ptr->index=0;                          /* pointer to first buffer to fill   */
Send(buf_pip_id,&snd_msg,&rec_msg,1,1); /* send to buf_pip to give id       */
//if(ptr->intclk == 0)
//{
/*--------------------------------------------------------------------------*/
/* Attach the interrupt to count milliseconds                               */
/*--------------------------------------------------------------------------*/
if(( idd=qnx_hint_attach(0,&mil_handler,FP_SEG(&counter)))==-1)
{
    printf("Unable to attach the interrupt.");
    return;
}
//}
//if(ptr->intclk == 1)
    outp(BASE+0x9,irqen);              /* enable IRQ + external trigger     */
for(;;)
{
    ptr->alive[1]=1;                   /* tell I am alive                   */
//printf("         bank=%d\n",bank);
    Receive(proxy,0,0);                /* value ready                       */
/*    outp(BASE+0x8,0x00); */          /* clear interrupt                   */
    bank=teller;
    teller=0;
    Send(buf_pip_id,&snd_msg,&rec_msg,1,1);
}
}
