
/****************************************************************************/
/*                       PC QNX SEISLOG Software              Version 7.0   */
/****************************************************************************/
/*                                                                          */
/*                                      University of Bergen                */
/*                                      Institute of Solid Earth Physics    */
/*                                      Seismological Observatory           */
/*                                      Allegaten 41, 5007 Bergen, Norway   */
/*                                      Tlf. +47 55583408 +47 55583419      */
/*                                      Fax  +47 55589669                   */
/*                                      Author: Terje Utheim, Jens Havskov  */
/*                                      E-mail: terje.utheim@ifjf.uib.no    */
/*                                              jens.havskov@ifjf.uib.no    */
/*                                                                          */
/*                                      Date:16/02/95                       */
/* Program:DLY                                                              */
/*                                                                          */
/* Last update:                                                             */
/* 16/09/97 include help file                                               */
/*                                                                          */
/* Program description:                                                     */
/*                                                                          */
/* This program is used when you want to force a given delay (positive or   */
/* negative) to the current time. The time delay is only valid for the      */
/* current session of SEISLOG. After a STP, the time delay will fall back   */
/* to the delay found in the parameterfile.                                 */
/****************************************************************************/

#include "shar_mem.h"                  /* shared memory definitions         */
#include <sys/mman.h>
#include <fcntl.h>
#include <errno.h>
#include <stdlib.h>
#ifdef __USAGE
------------------------------------------------------------------------------
%C                                             Date: 01/10/97     Version 7.00
------------------------------------------------------------------------------
Description: This program is used when you want to force a given delay
             (positive or negative) to the current time. The time delay is
             only valid for the current session of SEISLOG. After a STP, the
             time delay will fall back to the delay found in the parameterfile.

Usage:       dly (program will ask for input)     
#endif


main()
{
float    del;
int      fd;                                /* return value open share      */
smod     *ptr;                              /* pointer to shared region     */
/*--------------------------------------------------------------------------*/
/* open shared memory region                                                */
/*--------------------------------------------------------------------------*/
fd=shm_open("SEISLOG",O_RDWR | O_CREAT, 0777);
if(fd== -1) 
{
    fprintf(stderr,"DLY_01 open failed:%s\n",strerror(errno));
    exit(1);
}
/*--------------------------------------------------------------------------*/
/* set size of memory region                                                */
/*--------------------------------------------------------------------------*/
ltrunc(fd,sizeof(smod),SEEK_SET);
/*--------------------------------------------------------------------------*/
/* Compute pointer to shared memory region                                  */
/*--------------------------------------------------------------------------*/
ptr=mmap(0,sizeof(smod),PROT_READ | PROT_WRITE,MAP_SHARED,fd,0);
if((int)ptr == -1) 
{
    fprintf(stderr,"DLY_02 mmap failed : %s\n",strerror(errno));
    exit(1);
}

printf("Type in delay (+/-) in floating point:");
scanf("%f",&del);
ptr->delay=del;
}
