/****************************************************************************/
/*                       PC QNX SEISLOG Software              Version 6.0   */
/****************************************************************************/
/*                                                                          */
/*                                      University of Bergen                */
/*                                      Institute of Solid Earth Physics    */
/*                                      Seismological Observatory           */
/*                                      Allegaten 41, 5007 Bergen, Norway   */
/*                                      Tlf. +47 55 213408 +47 55213419     */
/*                                      Fax  +47 55 233337 +47 55320009     */
/*                                      Author: Terje Utheim, Jens Havskov  */
/*                                      E-mail: terje.utheim@ifjf.uib.no    */
/*                                              jens.havskov@ifjf.uib.no    */
/*                                                                          */
/*                                      Date:31/05/00                       */
/* Program:EDN_HDR                                                          */
/*                                                                          */
/* Last update:                                                             */
/*                                                                          */
/* Program description:                                                     */
/*                                                                          */
/* Program to read HEADER info from ED24.                                   */
/*                                                                          */
/****************************************************************************/
#include "shar_mem.h"                  /* shared memory definitions         */
#include <sys/mman.h>
#include <fcntl.h>
#include <errno.h>
#include <stdlib.h>
#include <string.h>
#include <sys/name.h>
#include <sys/kernel.h>
#include <sys/sched.h>


/* read a2 bytes from in and store them at a1                               */

#define numfread(a1,a2) numread = fread(a1,1,a2,in)
#define numfwrite(a1,a2) numwrite= fwrite(a1,1,a2,in)

int  sizeofMOD; // size of MOD in bytes (excl. Identifier and size) 184
char DeviceID[12];  // device id in ascii
char version[6];    // version
char serialNO[4];   // serial number
char testpattern[8]; // test pattern
int  blockcount;     // block count
int  ncomps;         // number of components
int  samplerate;     // number of samples per block per component
int  bytespersample; // bytes per sample
int  deci12;        // decimation factor filter 3
int  deci10;        // decimation factor filter 4
char answer[5];
int  rate;          // samplerate in samples per second
int  count;
int  vent;          // wait milliseconds

int           kval;
unsigned char *bp;
unsigned char byt[1500];               /* Input buffer                      */
unsigned char cmd1[20];
unsigned char cmd2[20];
unsigned char cmd3[20];
unsigned char cmd4[20];
int dec10,dec12;
int           ba;
int           retu;
int           indx;                    /* index current channel             */
FILE          *in;                     /* input file pointer                */
int           i;                       /* counter                           */
int           numread;                 /* read definition                   */
int           numwrite;                /* write definition                  */
int           err_cnt;                 /* error counter                     */
int           hold;                    /* switch to hold recording until GPS fix */
int           fd;                      /* return value open share           */
smod          *ptr;                    /* pointer to shared region          */
main()
{
int			  ret_val;				   /* return value for ED3 function	    */
int           slow;
count=0;
err_cnt=0;                             /* set error counter to zero         */
slow=0;
input1:
count=0;
if(count==0)
{
  printf("Enter baud-rate:\n");
  scanf("%d",&ba);
}
/*--------------------------------------------------------------------------*/
/* Open device for reading data from ED_24                                  */
/*--------------------------------------------------------------------------*/
readagain:
switch(ba)
{
  case 9600:
  system("stty +raw -ihflow -osflow baud=9600 </dev/ser1");
  in=fopen("/dev/ser1","r+");
  if(in == 0)
  {
    printf("Cant open serial line at 9600\n");
    exit(0);
  }
  break;
  case 19200:
  system("stty +raw -ihflow -osflow baud=19200 </dev/ser1");
  in=fopen("/dev/ser1","r+");
  if(in == 0)
  {
    printf("Cant open serial line at 19200\n");
    exit(0);
  }
  break;
  case 38400:
  system("stty +raw -ihflow -osflow baud=38400 </dev/ser1");
  in=fopen("/dev/ser1","r+");
  if(in == 0)
  {
    printf("Cant open serial line at 38400\n");
    exit(0);
  }
  break;
  case 57600:
  system("stty +raw -ihflow -osflow baud=57600 </dev/ser1");
  in=fopen("/dev/ser1","r+");
  if(in == 0)
  {
    printf("Cant open serial line at 57600\n");
    exit(0);
  }
  break;
  case 115200:
  system("stty +raw -ihflow -osflow baud=115200 </dev/ser1");
  in=fopen("/dev/ser1","r+");
  if(in == 0)
  {
    printf("Cant open serial line at 115200\n");
    exit(0);
  }
  break;
}
/*--------------------------------------------------------------------------*/
/* Read data from ED_24 until one 5 sync character is detected.             */
/*--------------------------------------------------------------------------*/
    retu=Sync();
    if(retu==1)
    {
      printf("DIG_EDN   : SYNC found, Receiving data from digitizer !\n");
      goto found;
    }else{
      printf("No SYNC found\n");
      fclose(in);
    }
printf("Cant find sync on baudrate: %d\n",ba);
goto input1;

found:
ret_val = ED_SR();   // read some bytes after SYNC sequence
fclose(in);
if(ret_val != -1)
  goto input2;
fclose(in);
printf("Can't read data after SYNC has been found ??\n");
printf("Try something else.....\n");
exit(0);
input2:
if(count==0)
{
  printf("Want to change setup ?\n");
  scanf("%s",answer);
  if(answer[0]=='n')
  {
    exit(0);
  }else{
    printf("Enter new samplerate:\n");
    scanf("%d",&rate);
    printf("Enter delay:\n");
    scanf("%d",&vent);

  }
}
SR();
//delay(500);
//for(i=0;i<1000;i++)
//{
  delay(vent);
  bp=cmd1;
  numfwrite(bp,5);
  fflush(in);
  bp=cmd2;
  numfwrite(bp,5);
  fflush(in);
  bp=cmd3;
  numfwrite(bp,3);
  fflush(in);
  vent=vent+1;
//}
count++;
if(count < 10)
{
  goto readagain;
}else{
  count=0;
  goto input2;
}

printf("Enter delay\n");
scanf("%d",&vent);
printf("%d\n",vent);
  retu=Sync();
  delay(vent);
    bp=cmd1;
    numfwrite(bp,5);
    fflush(in);
    bp=cmd2;
    numfwrite(bp,5);
    fflush(in);
    bp=cmd3;
    numfwrite(bp,3);
    fflush(in);
  
//    sleep(2);
    ret_val = ED_SR();
    if(ret_val != -1)
      goto ok;
//    delay(vent+i);
ok:
printf("Sample rate correct\n");

do
{
  retu=Sync();
  ret_val = ED_NC();
} while (ret_val == -1);
printf("Number of channels correct\n");

do
{
  retu=Sync();
  ret_val = ED_BS();
} while (ret_val == -1);
printf("Number of bytes per sample correct\n");

do
{
  retu=Sync();
  ret_val = ED_BB();
} while (ret_val == -1);
printf("Number of bytes per block correct\n");


}

Sync()
{
unsigned char *buf_ptr;
unsigned short sync_value = 0;
int nn;
buf_ptr = byt;
    for(nn=0;nn<1000;nn++)
    {
        numfread(buf_ptr,1);
        if(numread == 0)
        {
            clearerr(in);
        }else{
            sync_value = sync_value << 8 | *buf_ptr;
        }
        if(sync_value==0x4d4f)      // Search for MO
          return(1);
    }
    return(-1); 
/*putchar(0x07);*/
}
void SR()
{

  switch(rate)
  {
    case 50:
    cmd1[0]=0x24; // $
    cmd1[1]=0x53; // S
    cmd1[2]=0x46; // F
    cmd1[3]=0x3;  // filter no. 3 
    cmd1[4]=0x4;  // 4

    cmd2[0]=0x24; // $
    cmd2[1]=0x53; // S
    cmd2[2]=0x46; // F
    cmd2[3]=0x4;  // filter no. 4 
    cmd2[4]=0x5;  // 5


    cmd3[0]=0x24; // $
    cmd3[1]=0x52; // R
    cmd3[2]=0x57; // W
    break;

    case 100:
    cmd1[0]=0x24; // $
    cmd1[1]=0x53; // S
    cmd1[2]=0x46; // F
    cmd1[3]=0x3;  // 1
    cmd1[4]=0xa;  // 10

    cmd3[0]=0x24; // $
    cmd3[1]=0x52; // R
    cmd3[2]=0x57; // W
    break;

    case 75:
    cmd1[0]=0x24; // $
    cmd1[1]=0x53; // S
    cmd1[2]=0x46; // F
    cmd1[3]=0x3;  // 4
    cmd1[4]=0xa;  // 10

    cmd3[0]=0x24; // $
    cmd3[1]=0x52; // R
    cmd3[2]=0x57; // W
 
    cmd4[0]=0x24; // $
    cmd4[1]=0x52; // R
    cmd4[2]=0x44; // D

   break;

  }
}

int    ED_SR()
{
static int block_length;
unsigned char *byt_ptr;
int chk;

byt_ptr=byt;
block_length = 200;                    /* assume this for now */

numfread(byt_ptr,block_length);         /* read in the header = 192 bytes
									    *   less the 1st 2 bytes (already read)
										*   plus the data header 8 bytes
										*   plus the data (75Hz, 3C, 3bytes/samp) = 675 bytes
									    *   plus the checksum 12 bytes */

if(numread<block_length)               /* read OK ?                         */
{
    clearerr(in);                      /* clear error                       */
}

sizeofMOD=(int)0;
printf("%x %x %x %x\n",byt[2],byt[3],byt[4],byt[5]);
sizeofMOD=(byt[5] << 8) | byt[4];
sizeofMOD=(sizeofMOD << 8) | byt[3];
sizeofMOD=(sizeofMOD << 8) | byt[2];
printf("sizeofMOD:%6d (should be: 184)\n",sizeofMOD);

for(i=0;i<12;i++)
  DeviceID[i]=byt[i+6];
printf("DeviceID     :  ");
for(i=0;i<12;i++)
  printf("%c",DeviceID[i]);
printf("\n");

for(i=0;i<6;i++)
  version[i]=byt[i+18];
printf("Version      : ");
for(i=0;i<6;i++)
  printf("%c",version[i]);
printf("\n");

for(i=0;i<8;i++)
  testpattern[i]=byt[i+30];
printf("testpattern  : ");
for(i=0;i<8;i++)
  printf("%x ",testpattern[i]);
printf("\n");

blockcount=(int)0;
printf("%x %x %x %x\n",byt[38],byt[39],byt[40],byt[41]);
blockcount=(byt[41] << 8) | byt[40];
blockcount=(blockcount << 8) | byt[39];
blockcount=(blockcount << 8) | byt[38];
printf("blockcount   : %6d (increases by 1 every second\n",blockcount);

ncomps=(int)0;
ncomps=(byt[43] << 8) | byt[42];
printf("ncomps       : %6d \n",ncomps);

samplerate=(int)0;
samplerate=(byt[45] << 8) | byt[44];
printf("samplerate   : %6d \n",samplerate);

bytespersample=(int)0;
bytespersample=(byt[47] << 8) | byt[46];
printf("bytes/sample : %6d \n",bytespersample);

deci12=(int)0;
deci12=(byt[51] << 8) | byt[50];
printf("deci12       : %6d \n",deci12);

deci10=(int)0;
deci10=(byt[53] << 8) | byt[52];
printf("deci10       : %6d \n",deci10);
return(1);
}
int    ED_NC()
{
int nch;
static int block_length;
unsigned char *byt_ptr;
byt_ptr=byt;
block_length = 200; /* assume this for now */

numfread(byt_ptr,block_length);         /* read in the header = 192 bytes
									    *   less the 1st 2 bytes (already read)
										*   plus the data header 8 bytes
										*   plus the data (75Hz, 3C, 3bytes/samp) = 675 bytes
									    *   plus the checksum 12 bytes */
if(numread<block_length)               /* read OK ?                         */
{
    clearerr(in);                      /* clear error                       */
}
nch = (byt[43] << 8) | byt[42];
if (nch != ptr->nchan)
{
	printf("DIG_EDN Error: mismatch in number of channels\n");
	printf("\tNo of channels in parameter file %d", ptr->nchan);
	printf(" no of components in digitiser %d\n", nch);
	return(-1);
}
return 0;
}
int    ED_BS()
{
static int block_length;
int bs;
unsigned char *byt_ptr;
char time_inc[20];
int chk;
byt_ptr=byt;
block_length = 200; /* assume this for now */


numfread(byt_ptr,block_length);         /* read in the header = 192 bytes
									    *   less the 1st 2 bytes (already read)
										*   plus the data header 8 bytes
										*   plus the data (75Hz, 3C, 3bytes/samp) = 675 bytes
									    *   plus the checksum 12 bytes */
if(numread<block_length)               /* read OK ?                         */
{
    clearerr(in);                      /* clear error                       */
}
bs = (byt[47] << 8) | byt[46];
if(bs != 3)
  return(-1);
return 0;
}
int    ED_BB()
{
static int block_length;
int bs;
unsigned char *byt_ptr;
long DAT_s;
int dbl;
byt_ptr=byt;
block_length = 200; /* assume this for now */
dbl=ptr->nchan * ptr->rate *3;

numfread(byt_ptr,block_length);         /* read in the header = 192 bytes
									    *   less the 1st 2 bytes (already read)
										*   plus the data header 8 bytes
										*   plus the data (75Hz, 3C, 3bytes/samp) = 675 bytes
									    *   plus the checksum 12 bytes */
if(numread<block_length)               /* read OK ?                         */
{
    clearerr(in);                      /* clear error                       */
}
DAT_s = (long)0;
DAT_s = (byt[197] << 24) | (byt[196] << 16) | (byt[195] << 8) | byt[194];
if(DAT_s != (long)dbl)
  return(-1);
return(0);
}
