/****************************************************************************/
/*                       PC QNX SEISLOG Software              Version 6.0   */
/****************************************************************************/
/*                                                                          */
/*                                      University of Bergen                */
/*                                      Institute of Solid Earth Physics    */
/*                                      Seismological Observatory           */
/*                                      Allegaten 41, 5007 Bergen, Norway   */
/*                                      Tlf. +47 55 213408 +47 55213419     */
/*                                      Fax  +47 55 233337 +47 55320009     */
/*                                      Author: Terje Utheim, Jens Havskov  */
/*                                      E-mail: terje.utheim@ifjf.uib.no    */
/*                                              jens.havskov@ifjf.uib.no    */
/*                                                                          */
/*                                      Date:15/05/95                       */
/* Program:FIL_DPX                                                          */
/*                                                                          */
/* Last update:                                                             */
/*                                                                          */
/* Program description:                                                     */
/*                                                                          */
/* Program to copy events from QNX partition to DOS partition. Filenames are*/
/* converted to 8 letters.                                                  */
/*                                                                          */
/****************************************************************************/
#include <stdio.h>                 
#include <errno.h>
#include <dirent.h>
#include <string.h>
main (argc,argv)
int    argc;
char   *argv[];
{
DIR *dirp;
struct dirent *direntp;

char    com[80];
char    dum[80];
char    ch;
char    fnam1[80];
char    fnam2[80];
char    syscall[100];
char    name[80];
int     nbyte;
int     k;
int     i;
int     year;
int     month;
int     day;
int     hour;
int     min;
int     sec;
int     answer;
FILE*   evt;
FILE*   lst;
FILE*   ust;
if(argc==2)
{
    sprintf(dum,"%s\0",argv[1]);
//    printf("%s\n",dum);
    sprintf(syscall,"ls /home/work/%s > /home/seislog/evt.lis",dum);
    system(syscall);
    exit(0);
}else{
/*--------------------------------------------------------------------------*/
/* make listing of all files in events directory                            */
/*--------------------------------------------------------------------------*/
if((ust=fopen("/home/work/ust.lis","w"))==NULL)
{
    fclose(ust); 
    printf("Could not open file containing events summary\n");
    exit(0);
}
dirp=opendir("/home/work");
if(dirp == NULL)
{
    perror( "" );
}else{
    for(;;)
    {
        direntp=readdir(dirp);
        if(direntp == NULL) break;
        {
            sprintf(fnam1,"%s\n",direntp->d_name);
            sprintf(fnam2,"/home/work/");
            if(fnam1[0] =='1' || fnam1[0] =='2')
            {
                strcat(fnam2,fnam1);
                printf("%s", fnam2);
                fprintf(ust,"%s",fnam2);
//                getch();
            }
        }
    }
    closedir(dirp);
    fclose(ust);
    system("sort /home/work/ust.lis > /home/seislog/evt.lis");
}
//system("ls /home/work/*T.* > /home/seislog/evt.lis"); 
//exit(0);
}
if((evt=fopen("/home/seislog/evt.lis","r"))==NULL)
{
    fclose(evt); 
    printf("Could not open file containing events summary\n");
    exit(0);
}
system("rm -f /home/work/dpx.lis");
if((lst=fopen("/home/work/dpx.lis","w"))==NULL)
{
    printf("Could not open file containing dpx summary\n");
    exit(0);
}
/*--------------------------------------------------------------------------*/
/*                read in names until EOF                                   */
/*--------------------------------------------------------------------------*/
i=1;
for(;;)
{
    nbyte=fread(com,40,1,evt);
    if(nbyte==0)                       /* if no more names => finish        */
        goto fin;
//    printf("%3d  ",i);
    com[39]='\0';
//printf("%5d %s\n",i,com);
fprintf(lst,"%5d %s\n",i,com);
    i=i+1;
}
fin:
fclose(lst);
printf("Number of files:%d\n",i-1);    
}

/*-------end: configure_ring----------------------------------------------*/
