/****************************************************************************/
/*                       PC QNX SEISLOG Software              Version 6.0   */
/****************************************************************************/
/*                                                                          */
/*                                      University of Bergen                */
/*                                      Institute of Solid Earth Physics    */
/*                                      Seismological Observatory           */
/*                                      Allegaten 41, 5007 Bergen, Norway   */
/*                                      Tlf. +47 55 213408 +47 55213419     */
/*                                      Fax  +47 55 233337 +47 55320009     */
/*                                      Author: Terje Utheim, Jens Havskov  */
/*                                      E-mail: terje.utheim@ifjf.uib.no    */
/*                                              jens.havskov@ifjf.uib.no    */
/*                                                                          */
/*                                      Date:12/04/96                       */
/* Program:GUR_RST                                                          */
/*                                                                          */
/* Last update:                                                             */
/*                                                                          */
/* Program description:                                                     */
/*                                                                          */
/*                                                                          */
/****************************************************************************/     

#include "shar_mem.h"                  /* shared memory definitions         */
#include <sys/mman.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/dev.h>
#include <fcntl.h>
#include <errno.h>
#include <stdlib.h>
#include <unistd.h>
#include <i86.h>
#include <time.h>
#include <conio.h>

int      fd;                           /* return value open share           */
smod     *ptr;                         /* pointer to shared region          */

main()
{
struct   timespec start;
int      i;                            /* counter                           */
unsigned char bit;                     /* bit on par port 0-9               */
/*--------------------------------------------------------------------------*/
/* open shared memory region                                                */
/*--------------------------------------------------------------------------*/
fd=shm_open("SEISLOG",O_RDWR | O_CREAT, 0777);
if(fd== -1) 
{
    fprintf(stderr,"GUR_RST_01 open failed:%s\n",strerror(errno));
    exit(1);
}
/*--------------------------------------------------------------------------*/
/* set size of memory region                                                */
/*--------------------------------------------------------------------------*/
ltrunc(fd,sizeof(smod),SEEK_SET);
/*--------------------------------------------------------------------------*/
/* Compute pointer to shared memory region                                  */
/*--------------------------------------------------------------------------*/
ptr=mmap(0,sizeof(smod),PROT_READ | PROT_WRITE,MAP_SHARED,fd,0);
if((int)ptr == -1) 
{
    fprintf(stderr,"GUR_RST_02 mmap failed : %s\n",strerror(errno));
    exit(1);
}
for(;;)
{
    ptr->alive[1]=0;               /* zero all indicators               */
    sleep(10);                         /* sleep for 15 seconds              */
        if(ptr->alive[1]==0)               /* check if DIG_GUR  is alive ?      */
        {                                  /* no, do something                  */
            printf("DIG_GUR is not running\n");
            putchar(0x07);                 /* send BELL                         */
            sprintf(ptr->err_msg,"GUR_RST: *** AUTO RESTART *** DIG_GUR dead");
            errlog(ptr);
            system("slay -f -Q dig_g24");
            system("/home/seislog/dig_g24&");
        }
}
}
