/*** ili_24b.h - include file for 24 bit ILI comms ***/

#include <sys/types.h>
#include <sys/kernel.h>

/* the size of the ILI ring buffer, in bytes */
#define SIZEOF_ILI_24B_RB	15000

/* the size of transfers we expect from the ILI  */
#define HEADER_SIZE			264
#define DATA_SIZE			900       /* 3 component * 75Hz * 4 bytes */
#define MAX_TRANSFER_SIZE	14664
#define MAX_ILI_CHAN        48      /* maximum no ILI channels, 3 * 16 */

/* the IRQ for the ILI */
#define ILI_24B_IRQ			0x07

/* the port addresses on the 8255 */
#define P8255_PORT_A		0x280
#define P8255_PORT_B		0x281
#define P8255_PORT_C		0x282
#define P8255_CTRL_PORT		0x283

/* forward declarations - ili_24b.h */
int start_ili_24b (void);
void stop_ili_24b (void);
int get_ili_24b_data_size (void);
int get_ili_24b_data (unsigned char *data);

/* forward declarations - ili_24b_irq.h */
pid_t far ili_24b_irq_handler (void);
pid_t far timeout_handler (void);

/* union to convert bytes to 16-bit and 32-bit words */
union Join
{
  unsigned char byte [4];
  short int word_16b;
  unsigned long int word_32b;
};

