/****************************************************************************/
/*                       PC QNX SEISLOG Software              Version 7.0   */
/****************************************************************************/
/*                                                                          */
/*                                      University of Bergen                */
/*                                      Institute of Solid Earth Physics    */
/*                                      Seismological Observatory           */
/*                                      Allegaten 41, 5007 Bergen, Norway   */
/*                                      Tlf. +47 55583408 +47 55583419      */
/*                                      Fax  +47 55589669                   */
/*                                      Author: Terje Utheim, Jens Havskov  */
/*                                      E-mail: terje.utheim@ifjf.uib.no    */
/*                                              jens.havskov@ifjf.uib.no    */
/*                                                                          */
/*                                      Date:23/03/98                       */
/* Program:LOGG                                                             */
/*                                                                          */
/* Last update:                                                             */
/*                                                                          */
/* Program description:                                                     */
/*                                                                          */
/* program to look at or update logg files each station                     */
/*                                                                          */
/****************************************************************************/     
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#ifdef __USAGE
------------------------------------------------------------------------------
%C                                        Date: 01/10/97     Version 7.00
------------------------------------------------------------------------------
Description: Program to look at or update logg files for each station

Usage:       logg 'station name'
             ex.: logg kmy
#endif

main(argc,argv)
int argc;
char *argv[];
{
char inp[100];
int  ret;
int  i;
sprintf(inp,"%s\n",argv[1]);
for(i=0;i<3;i++)
    inp[i]=toupper(inp[i]);
ret=strncmp(inp,"KMY",3);              /* look at the Karmy log            */
if(ret==0)
{
    if(chdir("/home/KMY") != 0)
        exit(0);
    system("vedit info");
    exit(0);
}
ret=strncmp(inp,"BLS",3);              /* look at the Blsj log            */
if(ret==0)
{
    if(chdir("/home/BLS") != 0)
        exit(0);
    system("vedit info");
    exit(0);
}
ret=strncmp(inp,"FOO",3);              /* look at the Flor log             */
if(ret==0)
{
    if(chdir("/home/FOO") != 0)
        exit(0);
    system("vedit info");
    exit(0);
}
ret=strncmp(inp,"HYA",3);              /* look at the Hyanger log          */
if(ret==0)
{
    if(chdir("/home/HYA") != 0)
        exit(0);
    system("vedit info");
    exit(0);
}
ret=strncmp(inp,"MOL",3);              /* look at the Molde log             */
if(ret==0)
{
    if(chdir("/home/MOL") != 0)
        exit(0);
    system("vedit info");
    exit(0);
}
ret=strncmp(inp,"KTK",3);              /* look at the Kautokeino log        */
if(ret==0)
{
    if(chdir("/home/KTK") != 0)
        exit(0);
    system("vedit info");
    exit(0);
}
ret=strncmp(inp,"BJO",3);              /* look at the Bjrnya log          */
if(ret==0)
{
    if(chdir("/home/BJO") != 0)
        exit(0);
    system("vedit info");
    exit(0);
}
ret=strncmp(inp,"JMI",3);              /* look at the Jan Mayen log         */
if(ret==0)
{
    if(chdir("/home/JMI") != 0)
        exit(0);
    system("vedit info");
    exit(0);
}
ret=strncmp(inp,"LOF",3);              /* look at the Lofoten log           */
if(ret==0)
{
    if(chdir("/home/LOF") != 0)
        exit(0);
    system("vedit info");
    exit(0);
}
ret=strncmp(inp,"MOR",3);              /* look at the Mo i Rana log         */
if(ret==0)
{
    if(chdir("/home/MOR") != 0)
        exit(0);
    system("vedit info");
    exit(0);
}
ret=strncmp(inp,"NSS",3);              /* look at the Namsos log            */
if(ret==0)
{
    if(chdir("/home/NSS") != 0)
        exit(0);
    system("vedit info");
    exit(0);
}
ret=strncmp(inp,"ODD",3);              /* look at the Odda log              */
if(ret==0)
{
    if(chdir("/home/ODD") != 0)
        exit(0);
    system("vedit info");
    exit(0);
}
ret=strncmp(inp,"RND",3);              /* look at the Rundemann log         */
if(ret==0)
{
    if(chdir("/home/RND") != 0)
        exit(0);
    system("vedit info");
    exit(0);
}
ret=strncmp(inp,"SUE",3);              /* look at the Sulen log             */
if(ret==0)
{
    if(chdir("/home/SUE") != 0)
        exit(0);
    system("vedit info");
    exit(0);
}
ret=strncmp(inp,"TRO",3);              /* look at the Troms log            */
if(ret==0)
{
    if(chdir("/home/TRO") != 0)
        exit(0);
    system("vedit info");
    exit(0);
}
ret=strncmp(inp,"TRH",3);              /* look at the Trondheim log         */
if(ret==0)
{
    if(chdir("/home/TRH") != 0)
        exit(0);
    system("vedit info");
    exit(0);
}
ret=strncmp(inp,"WNN",3);              /* look at the Vest Norsk log        */
if(ret==0)
{
    if(chdir("/home/WNN") != 0)
        exit(0);
    system("vedit info");
    exit(0);
}
ret=strncmp(inp,"CIG",3);              /* look at the CIG log               */
if(ret==0)
{
    if(chdir("/home/CIG") != 0)
        exit(0);
    system("vedit info");
    exit(0);
}
ret=strncmp(inp,"HON",3);              /* look at the HON log               */
if(ret==0)
{
    if(chdir("/home/HON") != 0)
        exit(0);
    system("vedit info");
    exit(0);
}
ret=strncmp(inp,"NIC",3);              /* look at the NIC log               */
if(ret==0)
{
    if(chdir("/home/NIC") != 0)
        exit(0);
    system("vedit info");
    exit(0);
}
ret=strncmp(inp,"UCR",3);              /* look at the UCR log               */
if(ret==0)
{
    if(chdir("/home/UCR") != 0)
        exit(0);
    system("vedit info");
    exit(0);
}
ret=strncmp(inp,"UPA",3);              /* look at the UPA log               */
if(ret==0)
{
    if(chdir("/home/UPA") != 0)
        exit(0);
    system("vedit info");
    exit(0);
}
ret=strncmp(inp,"GUA",3);              /* look at the GUA log               */
if(ret==0)
{
    if(chdir("/home/GUA") != 0)
        exit(0);
    system("vedit info");
    exit(0);
}
ret=strncmp(inp,"DST",3);              /* look at the DST log               */
if(ret==0)
{
    if(chdir("/home/DST") != 0)
        exit(0);
    system("vedit info");
    exit(0);
}
printf("This station does not exist: %s\n",inp);
}