//****************************************************************************/
/*                       PC QNX SEISLOG Software              Version 6.0   */
/****************************************************************************/
/*                                                                          */
/*                                      University of Bergen                */
/*                                      Institute of Solid Earth Physics    */
/*                                      Seismological Observatory           */
/*                                      Allegaten 41, 5007 Bergen, Norway   */
/*                                      Tlf. +47 55 213408 +47 55213419     */
/*                                      Fax  +47 55 233337 +47 55320009     */
/*                                      Author: Terje Utheim, Jens Havskov  */
/*                                      E-mail: terje.utheim@ifjf.uib.no    */
/*                                              jens.havskov@ifjf.uib.no    */
/*                                                                          */
/*                                      Date:29/10/95                       */
/* Program:MAP                                                              */
/*                                                                          */
/* Last update:                                                             */
//               13 10 97 jh : make sure message written if no epicenter
//               oct 98      : postscript, read date and time
//               april 2000  : test with latest epi and plt
/*                                                                          */
/* Program description:                                                     */
/*                                                                          */
/*                                                                          */
/****************************************************************************/     

#include <math.h>
#include "shar_mem.h"
#include <sys/mman.h>
#include <fcntl.h>
#include <errno.h>
#include "filedef.h"
#include <stdio.h>
#include <conio.h>
#include <graph.h>
#include <sys/qnxterm.h>
#include <stdlib.h>
#include <term.h>
#include <sys/qioctl.h>
#include <signal.h>


FILE *in;
FILE *con;
FILE *ps;
FILE *sta;
float  xjm[5000],yjm[5000];
main()
{
float    velocity[4];                  /* velocity                          */
int      mov;
int      ndepth;                       /* number of depths to test for      */
float    depth;
int      year,month,day,hour,min;
int      nstation;
float    h0;
float    c1,c2,c3;
float    slatt[100],slonn[100];        /* station lat and lon               */
char     stat[100][5];                 /* station names from station file   */
int      fd;                           /* return value open share           */
smod     *ptr;                         /* pointer to shared region          */
int      nco;
int      n;                            /* number of fonts                   */
int      ks;
int      x;                            /* MOUSE                             */
int      y;                            /* MOUSE                             */

/**********************************/
/**********************************/
int    ix0,iy0;                        /* screen coordinates of origin      */
/*int    lon;*/                       /* lat and lon, whole degrees        */
float  stlat[4],stlon[4];              /* station coordinates               */
char   epiin[20];                      /* epicenter file name               */
int    noepi;                          /* no epicenter available if 1*/
char   symbol;                         /* epi plot symbol                   */
float  xscalejm;                         /* screen coordinates/degree         */
float  yscale;
float  lat0,lon0;
float  slon1,slon2,slat1,slat2;        /* min,max lon and lat               */
char   value[80];                      /* used for plotting text            */
char   value1[80];
int    ijm;
int    klat1,klat2;
int    klat;
float  slat;
int    klon1,klon2;
int    klon;
float  slon;
int    nevent;
int    kjm,ljm;
float  elat;
float  elon;
float  elat_o;
float  elon_o;
float  mag;
float  rms;        /*residual rms*/
int    ilon;
int    ixjm;
int    iyjm;
int    ix1;
// for ps
float  xx,yy;
char ctld=4;
float yps=500.0;   /* top of post script page*/
//
int    iy1;
int    ix2;
int    iy2;
int    is;
float  sx,sy;
/*static char stat[]={"JMIJNEJNW"};*/      /* put in station names              */

/**********************************/
/**********************************/
char     buf[80];
int      color;
int      indx;
unsigned ch = 0;


int      upper;                        /* end of top header                 */
FILE     *fp;                          /* pointer to input                  */
char     b;                            /* one character                     */
int      fnt_no;                       /* font number to use                */
int      con_ser;                      /* switch to tell cosole or serial   */
int      type_io;                      /* return value from inp_name_dpx    */
int      ystart[MAXCHA+1];             /* y-offset each channel             */
float    delta;                        /* pixels between traces             */
char     thead[50];                    /* time string of event header       */
char     st[5];                        /* temporary storage station code    */
char     co[5];                        /* temporary storage component       */
char     dum[100];                     /* temporary storage strings         */
char     stcode[4*MAXCHA];             /* station codes                     */
char     comp[4*MAXCHA];               /* component codes                   */
float    amp[MAXCHA];                  /* gain factor each channel          */
static float    c[500];                /* room for filter coefficients      */
int      chan[MAXCHA];                 /* channel number to plot            */
int      nchtot;                       /* selected number of channels to plt*/
int      ret;                          /* return value from functions       */
int      dpx;                          /* detection number                  */
int      i;                            /* counter                           */
int      k;                            /* counter                           */
int      j;                            /* counter                           */
int      l;                            /* counter                           */
int      curdpx;                       /* current dpx number                */
int      tot;                          /* total duration of event in sec    */
int      ix,iy;                        /* plot vector                       */
float    xstep;                        /* plot x step scale                 */
float    xscale;                       /* Xplot scale in tekunits pr sec    */
char*    fontpath=getenv("WINFONTS");  /* define windows fonts              */
x=1;
y=200;
n=_registerfonts(fontpath);            /* register all fonts                */
fnt_no=61;                             /* choose font number                */

/*--------------------------------------------------------------------------*/
/* open shared memory region                                                */
/*--------------------------------------------------------------------------*/
fd=shm_open("SEISLOG",O_RDWR | O_CREAT, 0777);
if(fd== -1) 
{
    fprintf(stderr,"PIC01 open failed:%s\n",strerror(errno));
    exit(1);
}
// open and initialize postscript output
//
ps=fopen("map.ps","w");
fputs("%!PS-Adobe-2.0 EPSF-2.0\n",ps);
fputs("%%BoundingBox: 0 0 595 841\n",ps);
fputs("newpath\n",ps);
fputs("0.1 setlinewidth\n",ps);
fputs("/Times-Roman findfont\n",ps);
fputs("[20 0 0 15 0 0] makefont\n",ps);
fputs("   0.5 scalefont\n",ps);
fputs("setfont\n",ps);
//
/*--------------------------------------------------------------------------*/
/* set size of memory region                                                */
/*--------------------------------------------------------------------------*/
ltrunc(fd,sizeof(smod),SEEK_SET);
/*--------------------------------------------------------------------------*/
/* Compute pointer to shared memory region                                  */
/*--------------------------------------------------------------------------*/
ptr=mmap(0,sizeof(smod),PROT_READ | PROT_WRITE,MAP_SHARED,fd,0);
if(ptr == -1) 
{
    fprintf(stderr,"PIC02 mmap failed : %s\n",strerror(errno));
    exit(1);
}
/*--------------------------------------------------------------------------*/
/* read in color map file                                                   */
/*--------------------------------------------------------------------------*/
system("/home/seislog/rd_color");
/*--------------------------------------------------------------------------*/
/* decide if I am started from console or remote terminal                   */
/*--------------------------------------------------------------------------*/
con_ser=line_typ();

top:
cls_alp();                             /* clear and home screen             */
/********** Legg in map program *****/

stlat[1]=70.928;                       /* put in station latitudes          */
stlat[2]=70.990;
stlat[3]=71.029;
stlon[1]=-8.731;                       /* put in station longitudes         */
stlon[2]=-8.297;
stlon[3]=-8.428;
/* set fixed parameters such as plot scale and plot window                  */
ix0=85;                                /* screen lower left hand corner     */
iy0=420;

/*   open and read parameters and station list, read to end of file*/
     sta=fopen("/home/seislog/pr/station","r");

/*   read velocites*/
     fscanf(sta,"%f %f",&velocity[1],&velocity[2]);
     printf("P-velocity:    %5.1f S-velocity:  %5.1f  \n",velocity[1],velocity[2]);     

/*  read fixed depth or starting depth and number of depths to test*/
/*  if number of test depths is 1, only the first start depth is used*/
     fscanf(sta,"%f  %d",&h0,&ndepth);
     printf("Depth used %5.1f    Number of dephts to test for %d\n",h0,ndepth);

/*  read coda scale parameters*/
     fscanf(sta,"%f %f %f",&c1,&c2,&c3);
     printf("Coda paramters %6.2f %6.4f %6.2f\n",c1,c2,c3);
//
//  read min/max long and lat
//
    fscanf(sta,"%f %f %f %f",&slon1,&slon2,&slat1,&slat2);
    printf("Min/max lon lat:%f %f %f %f\n",slon1,slon2,slat1,slat2);
//
//  read stations until end of file
//
     i=0;
read_station:
     while(k=fscanf(sta,"%s %f %f",stat[i],&slatt[i],&slonn[i])!=EOF)
     {
      printf("%s %f %f\n",stat[i],slatt[i],slonn[i]);
//     printf("%s %f %f\n",stat[i],slatt[i],slonn[i]);
       i=i+1;
       goto read_station;
     }
     fclose(sta);
     nstation=i;
     printf("Number of stations in station file: %d \n",nstation);

lat0=slat1;
lon0=slon1;
xscalejm=(535-ix0)/(slon2-slon1);
yscale=(360)/(slat2-slat1);
/* DRAW LATITUDES  */
klat1=(int)(slat1*10.0);
klat2=(int)(slat2*10.0);
/* 0.5 deg distance between lines */
graphic_mode(con_ser);
plt_hdr_box(ptr,con_ser);
plt_plt_box(ptr,con_ser,fnt_no);
_setcolor(3);

for(klat=klat1;klat<=klat2;klat=klat+5)
{
    slat=klat/10.0;
    trss(slat,slon1,lat0,lon0,xscalejm,yscale,&ix1,&iy1,ix0,iy0);  
    sprintf(value,"%4.1f",slat);
    _moveto(ix1-40,iy1-5);
    _outgtext(value);
// ps
    xx=ix1-40.0;
    yy=yps-(iy1-1);
    fprintf(ps,"%f %f moveto\n",xx,yy);
    fprintf(ps,"(%s) show\n",value);
//
    _moveto(ix1,iy1);
    xx=ix1;
    yy=yps-iy1;
    fprintf(ps,"%f %f moveto\n",xx,yy);
    trss(slat,slon2,lat0,lon0,xscalejm,yscale,&ix2,&iy2,ix0,iy0);  
    _lineto(ix2,iy2);
    xx=ix2;
    yy=yps-iy2;
    fprintf(ps,"%f %f lineto\n",xx,yy);
}
//
/* draw longitudes */
//
klon1=(int)(slon1*10.0);
klon2=(int)(slon2*10.0);
/* 2 degrees distance between lines */
for(klon=klon1;klon<=klon2;klon=klon+20)
{
    slon=klon/10.0;
    trss(slat1,slon,lat0,lon0,xscalejm,yscale,&ix1,&iy1,ix0,iy0);  
    sprintf(value,"%5.1f",slon);
    trss(slat2,slon,lat0,lon0,xscalejm,yscale,&ix2,&iy2,ix0,iy0);  
    _moveto(ix1-30,iy1+17);
    _outgtext(value);
// ps
    xx=ix1-8.0;
    yy=yps-iy1-17;
    fprintf(ps,"%f %f moveto\n",xx,yy);
    fprintf(ps,"(%s) show\n",value);
    _moveto(ix1,iy1);
    _lineto(ix2,iy2);
    xx=ix1;
    yy=yps-iy1;
    fprintf(ps,"%f %f moveto\n",xx,yy);
    xx=ix2;
    yy=yps-iy2;
    fprintf(ps,"%f %f lineto\n",xx,yy);

}
//
/* PLOT CONTOURS */
//
_setcolor(14);
//con=fopen("/home/seislog/pr/janmap.krt","r");
//con=fopen("/home/seislog/pr/ca.krt","r");
//con=fopen("/home/seislog/pr/norway.map","r");
con=fopen("/home/seislog/pr/input.map","r");
ljm=1;
more:
if(fscanf(con,"%d",&nco)!=EOF)
{
    for(kjm=0;kjm<nco;kjm++)
    {
        fscanf(con,"%f",&xjm[kjm]);
        fscanf(con,"%f",&yjm[kjm]);
    }
//sx=xjm[0];
//sy=yjm[0];
//if(sx >= slat1 && sx <=slat2 && sy >= slon1 && sy <= slon2)
//{
//    trss(sx,sy,lat0,lon0,xscalejm,yscale,&ixjm,&iyjm,ix0,iy0);  
//    _moveto(ixjm,iyjm);                           /* move to first point in contour */
//}
_setcolor(11);
mov=0;
for(kjm=0;kjm<=(nco-1);kjm++)
{
    sx=xjm[kjm];
    sy=yjm[kjm];
    if(sx>=slat1 && sx<=slat2 && sy>=slon1 && sy<=slon2) /* INSIDE ?        */
    {
        if(mov==1)                     /* YES, but have we moved inside ?   */
        {                              /* YES, then draw to new point       */
            trss(sx,sy,lat0,lon0,xscalejm,yscale,&ixjm,&iyjm,ix0,iy0);  
            _lineto(ixjm,iyjm);
// ps
    xx=ixjm;
    yy=yps-iyjm;
    fprintf(ps,"%f %f lineto\n",xx,yy);
//            mov=0;
        }else{
            trss(sx,sy,lat0,lon0,xscalejm,yscale,&ixjm,&iyjm,ix0,iy0);  
            _moveto(ixjm,iyjm);
//ps
    xx=ixjm;
    yy=yps-iyjm;
    fprintf(ps,"%f %f moveto\n",xx,yy);

            mov=1;
        }
    }else{
        mov=0;
    }
}
goto more;
}
fclose(con);
//symbol=getch();                            /* read one character from keyboard  */
//
/* Plot stations on map */
//
_setcolor(14);
for (i=0;i<nstation;i++)
{
sprintf(value,stat[i]);
trss(slatt[i],slonn[i],lat0,lon0,xscalejm,yscale,&ixjm,&iyjm,ix0,iy0);  
_moveto(ixjm,iyjm);                           
    xx=ixjm;
    yy=yps-iyjm;
    fprintf(ps,"%f %f moveto\n",xx,yy);
    fprintf(ps,"(%s) show\n",value);
_outgtext(value);
}
//
/* Plot Epicenter      */
//
con=fopen("/home/work/epicenter","r");  
noepi=1;                                /* epicenter by defaut */
elat=99.0;                              /* if not changed, something wrong*/
if(con==(FILE *) NULL)    /* chek if file there */
     noepi=0;
//
// Read epicenterand time 
//
    if(noepi==1)
    {
    fscanf(con,"%d %d %d %d %d",&year,&month,&day,&hour,&min);
    fscanf(con,"%f %f %f %f %f",&elat,&elon,&depth,&mag,&rms);
    fclose(con);
    noepi=0;
    if(elat==99.0) goto no_epi;      /* something wrong in input file */
    if(elat>90.0) goto no_epi;      /* something wrong in input file */
    if(elat<-90.0) goto no_epi;      /* something wrong in input file */
    if(elon>180.0) goto no_epi;      /* something wrong in input file */
    if(elon<-180.0) goto no_epi;      /* something wrong in input file */
    noepi=1;
    } 
    else
    {
      goto no_epi;
    }
//
//  save original epi info
//
   elat_o=elat;
   elon_o=elon;
//
symbol='+';                            /* symbol for plotting inside map    */
if(elat < slat1)                       /* check if epicenter is inside map  */
{
    elat=slat1;                        /* plot epicenter on edge of map     */
    symbol='O';                        /* with symbol o                     */
}
if(elat > slat2)                       /* check latitude upper limit        */
{
    elat=slat2;
    symbol='O';
}
if(elon < slon1)                       /* check longitude lower limit       */
{
    elon=slon1;
    symbol='O';
}
if(elon > slon2)                       /* check longitude upper limit       */
{
    elon=slon2;
    symbol='O';
}
sprintf(value,"%c",symbol);
trss(elat,elon,lat0,lon0,xscalejm,yscale,&ixjm,&iyjm,ix0,iy0);  
//
//   epicenter and magnitude info
//
    sprintf(value1,"Epicenter: Lat= %6.3f   Lon= %6.3f  Depth= %5.1f  Mag= %5.1f   RMS= %5.2f",elat_o,elon_o,depth,mag,rms);
_setcolor(14);
    _moveto(10,10);
    _outgtext(value1);
//ps
//    sprintf(value1,"Epicenter: Lat= %6.3f   Lon= %6.3f    Mag= %5.1f   RMS= %5.2f",elat_o,elon_o,mag,rms);
    xx=90.0;
    yy=yps-10.0;
    fprintf(ps,"%f %f moveto\n",xx,yy);
    fprintf(ps,"(%s) show\n",value1);
    sprintf(value1,"Date and time: %d %d %d %d %d",year,month,day,hour,min);
    _moveto(315,26);
    _outgtext(value1);
// ps
    xx=90.0;
    yy=yps-30.0;
    fprintf(ps,"%f %f moveto\n",xx,yy);
    fprintf(ps,"(%s) show\n",value1);
_setcolor(1);
_moveto(ixjm,iyjm);                           
//ps
    xx=ixjm;
    yy=yps-iyjm;
    fprintf(ps,"%f %f moveto\n",xx,yy);
    fprintf(ps,"(%s) show\n",value);
//
for(i=0;i<5;i++)
{
    _moveto(ixjm,iyjm);                           
    _outgtext(value);
sleep(1);
    _setcolor(14);
    _moveto(ixjm,iyjm);                           
    _outgtext(value);
sleep(1);
    _setcolor(1);
}

no_epi:
if(noepi==0)
   {
     sprintf(value,"No epicenter calculated ***********");
    _moveto(10,10);
    _outgtext(value);
   }
//   close post script
    fputs("0.1 setlinewidth\n",ps);
    fputs("stroke\n",ps);
    fputs("showpage\n",ps); 
    fprintf(ps,"%c\n",ctld);
    close(ps);
    sprintf(value1,"Push any character to continue");
    _moveto(10,26);
    _outgtext(value1);
//
//   wait here for char
//
symbol=getch();                            /* read one character from keyboard  */
//    system("textto -c map.ps");   /*  put in CR */
}



/*-------------------------------------------------------------------------*/
/* Pick out station codes and components for corresponding channels        */
/*-------------------------------------------------------------------------*/
stacomp(nchan,stcode,comp,head)
int nchan;
char* stcode;
char* comp;
char* head;
{
int l;
int i;
int k;
k=160;
for(i=0;i<nchan;i++)
{
    for(l=0;l<4;l++)
    {
        stcode[i*4+l]=head[k+l];
        comp[i*4+l]=head[k+l+4];
    }
    k=k+8;
}
}
/*-------------------------------------------------------------------------*/
/* Get current DPX number                                                  */
/*-------------------------------------------------------------------------*/
Get_Current_DPX()
{
    FILE    *det;                        /* pointer current detection no.  */
    int     curdpx;                      /* current dpx number             */
    det=fopen(DETNUMBER,"r");
    fscanf(det,"%d",&curdpx);
    fclose(det);
    return(curdpx);
}

static void Press_any_key()
/*=======================*/
/*  wait for keyboard input */
{
    _settextposition( 30, 64 );
    _outtext( "Press any key..." );
    getch();
}

sid_lab(ptr,con_ser,fnt_no,k,iy,delta,upper,nchtot,ichan,stcode,comp,maxamp)
smod*    ptr;
int      con_ser;
int      fnt_no;
int      k;
int      iy;
float    delta;
int      upper;
int      nchtot;
int      ichan;
char     *stcode;
char     *comp;
int      maxamp;
{
char     st[5];
char     co[5];
char     buf[10];                      /* help string for fonts             */
char     dum[80];                      /* string for text                   */
int      l;
int      i;
if(nchtot <= 6)
{
    l=0;
    for(i=0;i<5;i++)
	    st[i]=co[i]='\0';
    for(i=(ichan-1)*4;i<(ichan-1)*4+4;i++)
    {
        st[l]=stcode[i];
        co[l]=comp[i];
        l=l+1;
    }
    if(con_ser==1)                     /* serial line ?                     */
    {
    }else{
        sprintf(dum,"%2d %s %s max=%8d\n",ichan,st,co,maxamp);
        sprintf(buf,"n%d",fnt_no);     /* select the font                   */
        _setfont(buf);                 /* set the font to use               */
        _setcolor(ptr->plt_are_txt_col);/* set the color                    */
        _moveto(2,iy-delta/2);         /* set text position                 */
        _outgtext(dum);
    }
}
}
top_hdr_txt(ptr,con_ser,fnt_no,thead)
smod*    ptr;
int      con_ser;
int      fnt_no;
char*    thead;
{
char     buf[10];
char     dum[80];
if(con_ser == 1)                       /* serial ?                          */
{
}else{
    _setcolor(ptr->top_hdr_txt_col);   /* set color                         */
    sprintf(buf,"n%d",fnt_no);         /* select fonts                      */
    _setfont(buf);                     /* set the font                      */
    _moveto(0,0);                      /* move to start text                */
    _outgtext(thead);
    sprintf(dum,"Options:");
    _moveto(200,0);
    _outgtext(dum);
    sprintf(dum,"R   Same event");
    _moveto(260,0);
     _outgtext(dum);
    sprintf(dum,"Q   Quit");
    _moveto(260,13);
    _outgtext(dum);
    sprintf(dum,"CR New event");
    _moveto(260,26);
    _outgtext(dum);
    sprintf(dum,"F  Filter");
    _moveto(370,0);
    _outgtext(dum);
    sprintf(dum,"S  Specter");
    _moveto(370,13);
    _outgtext(dum);
    sprintf(dum,"Z  Zoom");
    _moveto(370,26);
    _outgtext(dum);
    sprintf(dum,"V  Overlay");
    _moveto(480,0);
    _outgtext(dum);
    sprintf(dum,"N  Next");
    _moveto(480,13);
    _outgtext(dum);
    sprintf(dum,"E  Epicenter");
    _moveto(480,26);
    _outgtext(dum);
}
}
crlf()
{
putchar(0x0d);
putchar(0x0a);
}
flu()
{
fflush(stdout);
fflush(stdin);
}
finish_program()
{
    cls_alp();                         /* clear and home screen             */
    crlf();
    printf("Exit Program\n");
    flu();
    crlf();
    exit(0);
}
/*--------------------------------------------------------------------------*/
/* called by: BUF_PIPE                                                      */
/*--------------------------------------------------------------------------*/
/* compute total number of seconds.milliseconds                             */
/* input : yrn     year                                                     */
/*         mon     month                                                    */
/*         day     day                                                      */
/*         hrn     hours                                                    */
/*         min     minutes                                                  */
/*         sec     seconds                                                  */
/* output: sectot  total number of seconds                                  */
/*--------------------------------------------------------------------------*/
timsec(yrn,mon,day,hrn,min,sec,seconds)
long   yrn;
long   mon;
long   day;
long   hrn;
long   min;
float  sec;
double *seconds;
{
    long   dyr;
    long   iyr;
    long   ydy;

    if(yrn >=1900) yrn=yrn-1900;
    dyr=0;
    if(yrn%4==0)dyr=1;
    iyr=yrn/4-dyr+1;
    *seconds=iyr*366+(yrn-iyr)*365;
    *seconds=*seconds*86400.0;
    if(mon==1)ydy=day-1;
    if(mon==2)ydy=day+30;
    if(mon==3)ydy=day+dyr+58;
    if(mon==4)ydy=day+dyr+89;
    if(mon==5)ydy=day+dyr+119;
    if(mon==6)ydy=day+dyr+150;
    if(mon==7)ydy=day+dyr+180;
    if(mon==8)ydy=day+dyr+211;
    if(mon==9)ydy=day+dyr+242;
    if(mon==10)ydy=day+dyr+272;
    if(mon==11)ydy=day+dyr+303;
    if(mon==12)ydy=day+dyr+333;
    *seconds=*seconds+ydy*86400.0+hrn*3600+min*60+sec;
}
/*--------------------------------------------------------------------------*/
/* called by: BUF_PIPE                                                      */
/*--------------------------------------------------------------------------*/
/* SECTIM                                                                   */
/* convert total number of seconds back to year,month,day,etc...            */
/* input : sectot     total number of seconds                               */
/* output: yrn        year                                                  */
/*         mon        month                                                 */
/*         day        day                                                   */
/*         hrn        hours                                                 */
/*         min        minutes                                               */
/*         doy        day of year                                           */
/*         sec        seconds                                               */
/*--------------------------------------------------------------------------*/
sectim(yrn,mon,day,hrn,min,doy,sectot,secs)
long   *yrn;
long   *mon;
long   *day;
long   *hrn;
long   *min;
long   *doy;
double sectot;
float  *secs;
{
    double secday;
    double secyr;
    long   year;
    long   day_of_year;
    long   month;
    long   days;
    long   i;
    float  ind;
    int    start_year;
    secday=86400.0;
    secyr=31536000.0;
        start_year=0;
/*        start_year=70;*/    /* change to 70 */
    for(i=start_year;i< 201;i+=1)
    {
        ind=0.0;
        if(i%4==0)ind=1.0;
        if(sectot < (secyr+ind*secday))
        {
           year=i;
           *yrn=year;
           goto found_year;
        }
        else
            sectot=sectot-(secyr+ind*secday);
    }
    year=-1;
    found_year:
    day_of_year=sectot/secday+1;
    *doy=day_of_year;
    dte(year,day_of_year,&month,&days);
    *mon=month;
    *day=days;
    sectot=sectot-(day_of_year-1)*secday;
    *hrn=sectot/3600;
    sectot=sectot-*hrn*3600.0;
    *min=sectot/60;
    *secs=sectot-*min*60.0;
}

/*--------------------------------------------------------------------------*/
/* called by: BUF_PIPE                                                      */
/*--------------------------------------------------------------------------*/
/* DTE                                                                      */
/* Convert Day Of Year to Date                                              */
/* Input : doy                                                              */
/* Output: mon,day                                                          */
/*--------------------------------------------------------------------------*/
dte(yrn,doy,mon,day)
long yrn;
long doy;
long *mon;
long *day;
{
int   mth[13];                         /* days in each month                */
int   j,m,n;                           /* counters                          */
    
/* assign days of month to array                                            */

for (j=1;j< 8; j+=2)
{
    mth[j] = 31;
}
for(j=8;j<13;j+=2)
{
    mth[j] = 31;
}
mth[2]=28;
mth[4]=30;
mth[6]=30;
mth[9]=30;
mth[11]=30;
if(yrn%4==0)
    mth[2]=29;
m=0;
for(j=1;j<13;j++)
{
    m=m+mth[j];
    n=doy-m;
    if(n<=0)
    {
        *mon=j;
        *day=n + mth[j];
        break;
    }
}
}       
trss(slat,slon,lat0,lon0,xscale,yscale,ix,iy,ix0,iy0)
float slat;
float slon;
float lat0;
float lon0;
float xscale;
float yscale;
int*   ix;
int*   iy;
int   ix0;
int   iy0;
{
*iy=iy0-(float)((slat-lat0)*yscale);
*ix=ix0+(float)((slon-lon0)*xscale);
//printf("SLAT=%f SLON=%f LAT0=%f LON0=%f",slat,slon,lat0,lon0);
//crlf();
//flu();
//printf("XSCALE=%f YSCALE=%f IX0=%d IY0=%d IX=%d IY=%d",
//xscale,yscale,ix0,iy0,*ix,*iy);
//crlf();
//flu();
//getch();
return;
}
