/****************************************************************************/
/*                       PC QNX SEISLOG Software              Version 7.0   */
/****************************************************************************/
/*                                                                          */
/*                                      University of Bergen                */
/*                                      Institute of Solid Earth Physics    */
/*                                      Seismological Observatory           */
/*                                      Allegaten 41, 5007 Bergen, Norway   */
/*                                      Tlf. +47 55583408 +47 55583419      */
/*                                      Fax  +47 55589669                   */
/*                                      Author: Terje Utheim, Jens Havskov  */
/*                                      E-mail: terje.utheim@ifjf.uib.no    */
/*                                              jens.havskov@ifjf.uib.no    */
/*                                                                          */
/*                                      Date:13/08/98                       */
/* Program:MIN_PLS                                                          */
/*                                                                          */
/* Last update:                                                             */
/*                                                                          */
/* Program description:                                                     */
/*                                                                          */
/* The program is started from within the CLK_GEN program.                  */
/*                                                                          */
/****************************************************************************/

#include "shar_mem.h"                  /* shared memory definitions         */
#include <sys/mman.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/dev.h>
#include <fcntl.h>
#include <errno.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/name.h>
#include <i86.h>
#include <time.h>
#include <conio.h>
#include <sys/irqinfo.h>               /* needed for interrupt-routines     */
#include <sys/proxy.h>
#include <sys/kernel.h>                /* needed for interrupt-routines     */

smod     *ptr;                         /* pointer to shared region          */
main()
{
int      fd;
/*--------------------------------------------------------------------------*/
/* open shared memory region                                                */
/*--------------------------------------------------------------------------*/
fd=shm_open("SEISLOG",O_RDWR | O_CREAT, 0777);
if(fd== -1) 
{
    sprintf(ptr->err_msg,"CLK_PPS: Can't open shared memory.");
    exit(1);
}
/*--------------------------------------------------------------------------*/
/* set size of memory region                                                */
/*--------------------------------------------------------------------------*/
ltrunc(fd,sizeof(smod),SEEK_SET);
/*--------------------------------------------------------------------------*/
/* Compute pointer to shared memory region                                  */
/*--------------------------------------------------------------------------*/
ptr=mmap(0,sizeof(smod),PROT_READ | PROT_WRITE,MAP_SHARED,fd,0);
if((int)ptr == -1) 
{
    sprintf(ptr->err_msg,"CLK_PPS: Can't map shared memory.");
    errlog(ptr);
    exit(0);
}
outp(0x378,0x00);                      /* set d0-d7 on par port to 0        */
outp(0x378,inp(0x378) ^ 0x04);         /* invert bit 2                      */
delay(ptr->min_dur);                   /* duration of pulse in msec         */
outp(0x378,inp(0x378) ^ 0x04);         /* invert bit 2 back to normal       */
//printf("MINUTE\n");
}


