/****************************************************************************/
/*                       PC QNX SEISLOG Software              Version 7.0   */
/****************************************************************************/
/*                                                                          */
/*                                      University of Bergen                */
/*                                      Institute of Solid Earth Physics    */
/*                                      Seismological Observatory           */
/*                                      Allegaten 41, 5007 Bergen, Norway   */
/*                                      Tlf. +47 55583408 +47 55583419      */
/*                                      Fax  +47 55589669                   */
/*                                      Author: Terje Utheim, Jens Havskov  */
/*                                      E-mail: terje.utheim@ifjf.uib.no    */
/*                                              jens.havskov@ifjf.uib.no    */
/*                                                                          */
/*                                      Date:11/03/98                       */
/* Program:MKMAIL                                                           */
/*                                                                          */
/* Last update:                                                             */
/*                                                                          */
/* Program description:                                                     */
/*                                                                          */
/* Program generates the file newmail.txt to be sent                        */
/*                                                                          */
/****************************************************************************/     
#include "shar_mem.h"
#include <sys/mman.h>
#include <fcntl.h>
#include <stdlib.h>
#include <stdio.h>
#include <dirent.h>
#include <time.h>
main()
{
int      fd;                           /* return value open share           */
smod     *ptr;                         /* pointer to shared region          */
float    vno;                          /* version number                    */
char     syscall[100];
char     dirname[50];
char     savename[50];
char     remname[50];
int      i;
DIR      *dirp;                        /* pointer to directory              */
struct   tm time_of_day;
time_t   ltime;
auto     char com[26];
FILE*    buf;                          /* pointer to file                   */
char     ans;
char     ans1;
/*--------------------------------------------------------------------------*/
/* open shared memory region                                                */
/*--------------------------------------------------------------------------*/
fd=shm_open("SEISLOG",O_RDWR | O_CREAT, 0777);
if(fd== -1) 
{
    fprintf(stderr,"MKMAIL_01 open failed:%s\n",strerror(errno));
    exit(1);
}
/*--------------------------------------------------------------------------*/
/* set size of memory region                                                */
/*--------------------------------------------------------------------------*/
ltrunc(fd,sizeof(smod),SEEK_SET);
/*--------------------------------------------------------------------------*/
/* Compute pointer to shared memory region                                  */
/*--------------------------------------------------------------------------*/
ptr=mmap(0,sizeof(smod),PROT_READ | PROT_WRITE,MAP_SHARED,fd,0);
if((int)ptr == -1) 
{
    fprintf(stderr,"MKMAIL_02 mmap failed : %s\n",strerror(errno));
    exit(1);
}
/*--------------------------------------------------------------------------*/
/* check if a file containing version and date already exists               */
/*--------------------------------------------------------------------------*/

if((buf=fopen("/home/seislog/newmail.txt","r"))!=NULL)
{
    fclose(buf); 
    system("rm -f /home/seislog/newmail.txt"); /* remove it                 */
}   
/*--------------------------------------------------------------------------*/
/* make new one                                                             */
/*--------------------------------------------------------------------------*/
sprintf(dirname,"/home/seislog/newmail.txt");

time(&ltime);
_localtime(&ltime,&time_of_day);
sprintf(syscall,"Date and time is: %s Station: %s\n",
_asctime(&time_of_day,com),ptr->name);
syscall[42]=' ';
if((buf=fopen("/home/seislog/newmail.txt","w"))!=NULL)
{
    fprintf(buf,"%s\n",syscall);
    fclose(buf); 
}   
}