/****************************************************************************/
/*                       PC QNX SEISLOG Software              Version 7.0   */
/****************************************************************************/
/*                                                                          */
/*                                      University of Bergen                */
/*                                      Institute of Solid Earth Physics    */
/*                                      Seismological Observatory           */
/*                                      Allegaten 41, 5007 Bergen, Norway   */
/*                                      Tlf. +47 55583408 +47 55583419      */
/*                                      Fax  +47 55589669                   */
/*                                      Author: Terje Utheim, Jens Havskov  */
/*                                      E-mail: terje.utheim@ifjf.uib.no    */
/*                                              jens.havskov@ifjf.uib.no    */
/*                                                                          */
/*                                      Date:23/01/95                       */
/* Program:ONN                                                              */
/*                                                                          */
/* Last update:                                                             */
/* 15/09/97 Included help file                                              */
/*                                                                          */
/* Program description:                                                     */
/*                                                                          */
/* This program turns on MTRIG flag in data module                          */
/* Manual trigger is turned on                                              */
/*                                                                          */
/****************************************************************************/
#include "shar_mem.h"                  /* shared memory definitions         */
#include <sys/mman.h>
#include <fcntl.h>
#include <errno.h>
#include <stdlib.h>
#ifdef __USAGE
------------------------------------------------------------------------------
%C                                             Date: 01/10/97     Version 7.00
------------------------------------------------------------------------------
Description: Program switches the shared variable 'mtrig' to position 1 to
             force the detection flag on. A manual event will be recorded as
             as long as this variable is turned on.

Usage:       onn (no parameters)
#endif
main ()
{
int      fd;                                /* return value open share      */
smod     *ptr;                              /* pointer to shared region     */
int seconds,ii,max;
int idx;
unsigned int tabel[20];
/*--------------------------------------------------------------------------*/
/* open shared memory region                                                */
/*--------------------------------------------------------------------------*/
fd=shm_open("SEISLOG",O_RDWR | O_CREAT, 0777);
if(fd== -1) 
{
    fprintf(stderr,"ONN_01 open failed:%s\n",strerror(errno));
    exit(1);
}
/*--------------------------------------------------------------------------*/
/* set size of memory region                                                */
/*--------------------------------------------------------------------------*/
ltrunc(fd,sizeof(smod),SEEK_SET);
/*--------------------------------------------------------------------------*/
/* Compute pointer to shared memory region                                  */
/*--------------------------------------------------------------------------*/
ptr=mmap(0,sizeof(smod),PROT_READ | PROT_WRITE,MAP_SHARED,fd,0);
if((int)ptr == -1) 
{
    fprintf(stderr,"ONN_02 mmap failed : %s\n",strerror(errno));
    exit(1);
}

for(seconds=0;seconds<SERSIZ;seconds++)
{
       idx=seconds * ptr->cha_def[0][15]; 
      for(ii=0;ii<16;ii++)
         tabel[ii]=ptr->mulpip[0][idx+ii]; 
        printf("%s\n",tabel);
getch();
}
}
