/****************************************************************************/
/*                       PC QNX SEISLOG Software              Version 6.0   */
/****************************************************************************/
/*                                                                          */
/*                                      University of Bergen                */
/*                                      Institute of Solid Earth Physics    */
/*                                      Seismological Observatory           */
/*                                      Allegaten 41, 5007 Bergen, Norway   */
/*                                      Tlf. +47 55 213408 +47 55213419     */
/*                                      Fax  +47 55 233337 +47 55320009     */
/*                                      Author: Terje Utheim, Jens Havskov  */
/*                                      E-mail: terje.utheim@ifjf.uib.no    */
/*                                              jens.havskov@ifjf.uib.no    */
/*                                                                          */
/*                                      Date:29/10/95                       */
/* Program:PIC                                                              */
/*                                                                          */
/* Last update:                                                             */
/*                                                                          */
/* Program description:                                                     */
/*                                                                          */
/*                                                                          */
/****************************************************************************/     

#include <math.h>
#include "shar_mem.h"
#include <sys/mman.h>
#include <malloc.h>
#include <fcntl.h>
#include <errno.h>
#include "filedef.h"
#include <stdio.h>
#include <conio.h>
#include <graph.h>
#include <sys/qnxterm.h>
#include <stdlib.h>
#include <term.h>
#include <sys/qioctl.h>
#include <signal.h>
#include <ctype.h>
#define XL 600.
#define YL 100.
#define ULX 16
#define ULY 190

#define M2(arr,x,y) (*((arr)+(y)*(dimx)+(x)))

FILE *in;
FILE *phas;    /* output file for phases*/




#define  SIZ 256                       /* max size of input line            */
#define  LIVEC 50000
#define  CR 10
#define  t term_state
int      ltr;
int      fd;                           /* return value open share           */
smod     *ptr;                         /* pointer to shared region          */
int      n;                            /* number of fonts                   */
int      mouse;                        /* MOUSE                             */
int      resize;                       /* MOUSE                             */
char     *key_name( unsigned c );      /* MOUSE                             */
int      x;                            /* MOUSE                             */
int      y;                            /* MOUSE                             */
unsigned cmu;                          /* MOUSE                             */
short    aa[42];                       /* MOUSE                             */
float *matr;
int      type_io1;   /* return value from inp_name_dpx    */
int      dpx1;                         /* to plot */
int      mem_switch;
int dimx;
int dimy;


main()
{
char rngbuf[200];
double   MSECS;
double   MSEC70;
float    SEC;
int      YR,DOY,MTH,DAY,HR,MIN;
int      SECL;
char     buf[90];
int      rr1;
int      color;
int      indx;
int      selects;
int      chan_count;
long  doy;
int      antkar;
int      kchan;                  /*channel in pick */
float    time_phase;             /* time of phase */
FILE     *rr;
double sectot;
int      from;
int      to;
    int n_coef;                        /* number of filter coefficients     */
    int iord;
    static bandpass[2]={'B','P'};
    static proto[2]   ={'B','U'};
    float fl;
    float fh;
    float eqavst;

float    valfl;
int      smp;
int      flt_typ;
unsigned ch = 0;

float    nyquist;
float    scfac;
char     infile1[DIRNAMLEN+10];        /* input filename or DPX no          */

int      NN;
int      NN2;
float    maxa;
int      cnt;
char     longf[DIRNAMLEN+20];          /* file to look for                  */
int      upper;                        /* end of top header                 */
FILE     *fp;                          /* pointer to input                  */
char     b;                            /* one character                     */
char     lbuf[SIZ];                    /* area for input line               */
char*    fontpath=getenv("WINFONTS");  /* define windows fonts              */
int      fnt_no;                       /* font number to use                */
int      filter_switch;                /* filter on/off 0/1                 */
int      con_ser;                      /* switch to tell cosole or serial   */
int      type_io;                      /* return value from inp_name_dpx    */
int      ystart[MAXCHA+1];             /* y-offset each channel             */
char     head[SIZ_EV_HDR+100];          /* header of event                   */
float    delta;                        /* pixels between traces             */
char     thead[100];                    /* time string of event header       */
char     st[5];                        /* temporary storage station code    */
char     co[5];                        /* temporary storage component       */
char     dum[100];                     /* temporary storage strings         */
char     stcode[4*MAXCHA];             /* station codes                     */
char     comp[4*MAXCHA];               /* component codes                   */
float    amp[MAXCHA];                  /* gain factor each channel          */


static int      iworkl[60000];          /* data from one buffer (long)       */
static int      ivec[60000];           /* trace data after dmxs, scaling    */
static float    data[60000];
static float    outp[60000];           /* output from filter                */
static float    spdat[60000];
static float    spec[60000];
static float    c[500];                /* room for filter coefficients      */


int      chan[MAXCHA];                 /* channel number to plot            */
int      nchtot;                       /* selected number of channels to plt*/
int      ret;                          /* return value from functions       */
int      dpx;                          /* detection number                  */
int      i;                            /* counter                           */
int      k;                            /* counter                           */
int      j;                            /* counter                           */
int      rng;
int      l;                            /* counter                           */
int      curdpx;                       /* current dpx number                */
int      tot;                          /* total duration of event in sec    */
long      year;                         /* year from header                  */
long      month;                        /* month from header                 */
long      day;                          /* day from header                   */
long      hour;                         /* hour from header                  */
long      min;                          /* minute from header                */
float    sec;                          /* seconds from header               */
int      nchan;                        /* number of channels from header    */
float    srate;                        /* samplerate from header            */
int      ntotal;                       /* ntotal from header                */
int      unit;                         /* unit from header                  */
int      nsamp;                        /* nsamp from header                 */
int      recsize;
int      reclength;
int      nplot;                        /* number of samples for one plot    */
int      skip;                         /* every skip point is plotted       */
int      ix,iy;                        /* plot vector                       */
int      ichan;                        /* channel counter                   */
int      isamp;                        /* counter/index  of samples         */
int      kbuf;                         /* buffer counter                    */
int      lplot;                        /* number to plot after skip         */
int      maxamp;                       /* maximum amplitude of trace        */
float    xstep;                        /* plot x step scale                 */
float    xscale;                       /* Xplot scale in tekunits pr sec    */
float    ttotal;                       /* total duration of event           */
float    time1;                        /* start time relative to first sampl*/
float    time1_old;                    /* ------- zoom window               */
float    time2;                        /* end time relative to first sample */
int      izoom;                        /* counter for two clicks in zoom    */
float    tbuf;                         /* total time of one buffer          */
int      firstbl;                      /* first block to read from file     */
int      lastbl;                       /* last block to read from file      */
int      nbuf;                         /* number of blocks to read from file*/
int      specter_switch;
char     nc;
FILE     *evt;                         /* pointer to event file to plot     */

mem_switch=0;

YR=1970;
MTH=1;
DAY=1;
HR=0;
MIN=0;
SEC=0.0;
TIMSEC (YR,MTH,DAY,HR,MIN,SEC,&MSEC70);

/*--------------------------------------------------------------------------*/
/* decide if I am started from console or remote terminal                   */
/*--------------------------------------------------------------------------*/
con_ser=line_typ();
if (con_ser < 0)
{
  fprintf (stderr, "Unable to determine console type [%d]\n", con_ser);
  exit (1);
}

selects=0;
chan_count=0;
specter_switch=0;
x=1;
y=200;
if (con_ser == 2)
	n=_registerfonts(fontpath);    /* register all fonts                */
fnt_no=61;                             /* choose font number                */
filter_switch=0;                       /* filter off                        */
//
//  open file for readings
//
phas=fopen("/home/work/phases","w");



/*--------------------------------------------------------------------------*/
/* open shared memory region                                                */
/*--------------------------------------------------------------------------*/
fd=shm_open("SEISLOG",O_RDWR | O_CREAT, 0777);
if(fd== -1) 
{
    fprintf(stderr,"PIC01 open failed:%s\n",strerror(errno));
    exit(1);
}
/*--------------------------------------------------------------------------*/
/* set size of memory region                                                */
/*--------------------------------------------------------------------------*/
ltrunc(fd,sizeof(smod),SEEK_SET);
/*--------------------------------------------------------------------------*/
/* Compute pointer to shared memory region                                  */
/*--------------------------------------------------------------------------*/
ptr=mmap(0,sizeof(smod),PROT_READ | PROT_WRITE,MAP_SHARED,fd,0);
if((int)ptr == -1) 
{
    fprintf(stderr,"PIC02 mmap failed : %s\n",strerror(errno));
    exit(1);
}

signal(SIGINT,&exit);
if (con_ser == 2)
{
	term_load();
	    mouse=(term_mouse_on() == 0);      /* MOUSE Attempt to attach the mouse */

	/* Indicate which mouse events we want to be notified of                    */
	ch = TERM_MOUSE_SELECT | TERM_MOUSE_ADJUST | TERM_MOUSE_MENU |    /* MOUSE  */
	     TERM_MOUSE_HELD | TERM_MOUSE_RELEASE;                        /* MOUSE  */
	    term_mouse_flags( ch, ch );        /* MOUSE                             */
}

/*--------------------------------------------------------------------------*/
/* read in color map file                                                   */
/*--------------------------------------------------------------------------*/
system("/home/seislog/rd_color");

top:
cls_alp();                             /* clear and home screen             */
even:
rr1=0;
type_io=inp_name_dpx(lbuf);            /* Input: filename to plot           */
//printf("typeio %d\n",type_io);
//crlf();
                                       /*        dpx number to plot         */
                                       /*        -n list n last filenames   */
                                       /*        RETURN to quit             */
top2:
if(type_io==0)                         /* check for exit                    */
    finish_program();
//printf("typeio %d\n",type_io);
if(type_io==3)
    goto ringbuffer;
//printf("typeio 2 %d\n",type_io);
//getch();
if(type_io==1)                         /* is it a negative number ?         */
{
    list_last_nn(lbuf);                /* list last nn events               */
    crlf();
    crlf();
    type_io=inp_name_dpx(lbuf);        /* Input: filename to plot           */
                                       /*        dpx number to plot         */
                                       /*        -n list n last filenames   */
                                       /*        RETURN to quit             */
    cls_alp();
    goto top2;
}
if(type_io==2)                         /* is it a DPX number ?              */
{
//printf("DPX\n");
    sscanf(lbuf,"%d",&dpx);            /* read the DPX number               */
    curdpx=Get_Current_DPX();          /* get current DPX number            */
    dpx1=dpx;                        
    if(dpx > curdpx)                   /* is the event recorded ?           */
    {
        crlf();
        printf("DPX number %d not recorded",dpx);
        flu();
        crlf();
        type_io=inp_name_dpx(lbuf);    /* Input: filename to plot           */
                                       /*        dpx number to plot         */
                                       /*        -n list n last filenames   */
                                       /*        RETURN to quit             */
        goto top2;
    }
    dpxnam(dpx,infile1,&ttotal);       /* recorded, extract filename        */
    crlf();
    printf("File to use: %s",infile1);
}else{                                 /* assume the user typed a filename  */
    strcpy(infile1,lbuf);
    crlf();
    printf("File to use: %s",infile1);
}
/*--------------------------------------------------------------------------*/
/* Look in current default directory                                        */
/*--------------------------------------------------------------------------*/
strcpy(longf,infile1);
if((int)(evt=fopen(longf,"r"))!=NULL)  /* try to open the event file        */
{
    goto found;
}else{
    crlf();
    printf("File %s is NOT in current",longf);
    flu();
}
/*--------------------------------------------------------------------------*/
/* Look in events directory                                                 */
/*--------------------------------------------------------------------------*/
sprintf(longf,"/home/events/");
strcat(longf,infile1);
if((int)(evt=fopen(longf,"r"))!=NULL)  /* try to open the event file        */
{
    goto found;
}else{
    crlf();
    printf("File %s is NOT in events directory",longf);
    flu();
}
/*--------------------------------------------------------------------------*/
/* look in save directory                                                   */
/*--------------------------------------------------------------------------*/
sprintf(longf,"/home/save/");
strcat(longf,infile1);
if((int)(evt=fopen(longf,"r"))!=NULL)  /* try to open the event file        */
{
    goto found;
}else{
    crlf();
    printf("File %s is NOT in save directory",longf);
    flu();
}
/*--------------------------------------------------------------------------*/
/* look in work directory                                                   */
/*--------------------------------------------------------------------------*/
sprintf(longf,"/home/work/");
strcat(longf,infile1);
if((int)(evt=fopen(longf,"r"))!=NULL)  /* try to open the event file        */
{
    goto found;
}else{
    crlf();
    printf("File %s is NOT in work directory",longf);
    flu();
}
crlf();
printf("File *** %s *** is NOT found.",infile1);
crlf();
ringbuffer:
cls_alp();                             /* clear and home screen             */

type_io=inp_rng(lbuf);
if(type_io==0)                         /* check for exit                    */
{
    crlf();
    goto even;
}
//    finish_program();

if(type_io==1)                         /* is it a negative number ?         */
    goto even;
if(type_io==2)                         /* is it a DPX number ?              */
{
    sscanf(lbuf,"%d",&rng);            /* read the DPX number               */
    antkar=18;
}
newring:
dpx1=rng;
rr1=1;
    rngopen(rng,&evt,longf,rngbuf);
    goto found;



printf("                             Press RETURN to continue.....");
flu();
getch();
goto top;

found:
cls_alp();

printf("File : %s FOUND !!!",longf);
//printf("File : %s FOUND !!!",rngbuf);

for(i=0;i<MAXCHA;i++)
    amp[i]=0.0;
/*--------------------------------------------------------------------------*/
/* Read header part of event                                                */
/*--------------------------------------------------------------------------*/
fseek(evt,0,0);
fread(head,1024,1,evt);
/*--------------------------------------------------------------------------*/
/* extract header information from event header                             */
/*--------------------------------------------------------------------------*/
hdr_info(head,&year,&month,&day,&hour,&min,&sec,&nchan,&srate,&ntotal,&unit,&nsamp,&recsize,&reclength);
ttotal=(float)(ntotal/nsamp);
sprintf(thead,"%2d:%2d:%6.3f %2d/%2d/%4d\n",hour,min,sec,day,month,year);

crlf();
if(type_io1 !=7) printf("Total duration of recording (seconds):%7.2f",ttotal); 
flu();
crlf();
//printf("THEAD %s\n",thead);
//printf(" 2. YEAR:%4d MONTH:%2d DAY:%2d HOUR:%2d MIN:%2d SEC: %6.3f",
//year,month,day,hour,min,sec);
//exit(0);
/*flu();*/
/*crlf();*/
/*printf("NCHAN:%2d SRATE:%16.7f NTOTAL:%8d UNIT:%2d NSAMP:%6d",\*/
/*nchan,srate,ntotal,unit,nsamp);*/
/*flu();*/
/*crlf();*/

if(type_io1 != 7) getch();  

dimx=nchan;
dimy=(int)ttotal*nsamp;
dimy=1200*nsamp;
if(mem_switch==0)
{
  if(!(matr=(float *)malloc(dimx*dimy*sizeof(float)) ))
  {
    crlf();
    printf("Out of memory !!");
    flu();
    getch();
  }
  mem_switch=1;
}
/*--------------------------------------------------------------------------*/
/* read whole event into memory matrix                                      */
/*--------------------------------------------------------------------------*/
isamp=0;                               /* record counter                    */
for(kbuf = (1024/reclength)+1; kbuf < (int)ttotal+(1024/reclength)+1; kbuf++)
{
    fseek(evt,kbuf*reclength,SEEK_SET);/* position at next record           */
    fread(iworkl,reclength,1,evt);     /* read 1 block of data              */
    dmx_buf(isamp,nsamp,nchan,(int)ttotal,iworkl); /* demultiplex record    */
    isamp=isamp+1;                     /* icrement record counter           */
}
fclose(evt);
/*--------------------------------------------------------------------------*/
/*   Get station codes and components for NCHAN channels                    */
/*--------------------------------------------------------------------------*/
stacomp(nchan,stcode,comp,head);
/*--------------------------------------------------------------------------*/
/*   Get plot choices                                                       */
/*--------------------------------------------------------------------------*/
top3:
time1=0.0;
time2=ttotal;
type_io=plt_opt();                     /* Input: O more options             */
                                       /*        RETURN to quit             */

if(type_io==-1)                        /* check for wrong input             */
    goto top3;
if(type_io==0)                         /* check for RETURN and default      */
{
    time1=0.0;
    time2=ttotal;
/*printf("TIME1:%f TIME2:%f\n",time1,time2);*/
/*--------------------------------------------------------------------------*/
/*   get default channels from /dd/PARAMETER/pic.def                        */
/*--------------------------------------------------------------------------*/
    ret=defchan(chan,&nchtot);
    if(ret==0)                         /* no PIC.DEF file, plot all         */
    {
        for(i=0;i<nchan;i++)           /* initialize 1-nchan                */
            chan[i]=i+1;
        nchtot=nchan;
        goto defaults;
    }else{
    	goto defaults;
    }
}else{
/*--------------------------------------------------------------------------*/
/*   Print out available channels                                           */
/*--------------------------------------------------------------------------*/
    cls_alp();                         /* clear and home screen             */
    avail_chan(nchan,stcode,comp);
/*--------------------------------------------------------------------------*/
/*   Input channels to plot                                                 */
/*--------------------------------------------------------------------------*/
top4:
    type_io=inp_chan_plt(lbuf,nchan,chan,&nchtot);
    switch(type_io)
    {
        case -1:                       /* not allowed with space as 1. char */
        cls_alp();                     /* clear and home screen             */
        printf("First character MUST be a numeric or RETURN !");
        flu();
        avail_chan(nchan,stcode,comp);
        goto top4;
        break;

        case -2:                       /* not allowed space as last char    */
        cls_alp();                     /* clear and home screen             */
        printf("Last character MUST be a numeric or RETURN !");
        flu();
        avail_chan(nchan,stcode,comp);
        goto top4;
        break;

        case -3:                       /* none space or none numeric        */
        cls_alp();                     /* clear and home screen             */
        printf("None SPACE or none numeric dicovered !");
        flu();
        avail_chan(nchan,stcode,comp);
        goto top4;
        break;        

        case -4:                       /* more than 1 space in sequence     */
        cls_alp();                     /* clear and home screen             */
        printf("More than 1 SPACE in secuence !");
        flu();
        avail_chan(nchan,stcode,comp);
        goto top4;
        break;
    }
/*crlf();*/
/*printf("NCHTOT:%d",nchtot);*/
/*flu();*/
/*for(i=0;i<nchtot;i++)*/
/*{*/
/*    crlf();*/
/*    printf("CHAN:%d",chan[i]);*/
/*    flu();*/
/*}*/
/*getch();*/
/*--------------------------------------------------------------------------*/
/*   Optional setting of gain                                               */
/*--------------------------------------------------------------------------*/
cls_alp();                             /* clear and home screen             */
top5:
type_io=inp_sca();                     /* Input: O more options             */
                                       /*        RETURN to quit             */

if(type_io==-1)                        /* check for wrong input             */
{
    cls_alp();                         /* clear and home screen             */
    printf("Error in input !\n");
    goto top5;
}
if(type_io!=0)                         /* check for RETURN and default      */
{
    cls_alp();                         /* clear and home screen             */
    gain_factors(nchtot,chan,amp);     /* get scale factors                 */
}
/*--------------------------------------------------------------------------*/
/*   Enter start time and stop time for plotting                            */
/*--------------------------------------------------------------------------*/
cls_alp();                             /* clear and home screen             */
top6:
type_io=inp_tim();                     /* Input: O more options             */
                                       /*        RETURN to quit             */

if(type_io==-1)                        /* check for wrong input             */
{
    cls_alp();                         /* clear and home screen             */
    printf("Error in input !\n");
    goto top6;
}
if(type_io!=0)                         /* check for RETURN and default      */
{
    cls_alp();                         /* clear and home screen             */
    start_stop(ttotal,&time1,&time2);
}else{
    time1=0.0;
    time2=ttotal;
}
/*printf("TIME1:%f TIME2:%f\n",time1,time2);    */
/*getch();*/
}
defaults:
/*--------------------------------------------------------------------------*/
/* Read header part of event                                                */
/*--------------------------------------------------------------------------*/
fseek(evt,0,0);
fread(head,1024,1,evt);
/*--------------------------------------------------------------------------*/
/* extract header information from event header                             */
/*--------------------------------------------------------------------------*/
hdr_info(head,&year,&month,&day,&hour,&min,&sec,&nchan,&srate,&ntotal,&unit,&nsamp,&recsize,&reclength);
ttotal=(float)(ntotal/nsamp);
sprintf(thead,"%2d:%2d:%6.3f %2d/%2d/%4d\n",hour,min,sec,day,month,year);

YR=year;
MTH=month;
DAY=day;
HR=hour;
MIN=min;
SEC=sec;
TIMSEC (YR,MTH,DAY,HR,MIN,SEC,&MSECS);
MSECS=MSECS+time1;
SECTIM (MSECS,&YR,&DOY,&MTH,&DAY,&HR,&MIN,&SEC);
sprintf(thead,"%2d:%2d:%6.3f %2d/%2d/%4d\n",HR,MIN,SEC,DAY,MTH,YR);
/*crlf();*/
/*printf("YRN:%2d MON:%2d DAY:%2d HRN:%2d MIN:%2d SEC:%f",*/
/*year,month,day,hour,min,sec);*/
/*flu();*/

/*getch();*/

if(con_ser == 1)                       /* serial ?                          */
{
upper=714;                              /* lower limit of top header         */
if(nchtot == 1)
{
    delta=630./((float)nchtot*3);
}else{
    delta=630./(float)nchtot;          /* pixels per trace                  */
for(i=0;i<nchtot;i++)                  /* initialize y start pixel each     */
    ystart[i]=upper-((delta/2)+(i*delta)); /* channel                           */
}
}else{
upper=47;                              /* lower limit of top header         */
if(nchtot == 1)
{
    delta=380./((float)nchtot*3);
}else{
    delta=380./(float)nchtot;          /* pixels per trace                  */
}
for(i=0;i<nchtot;i++)                  /* initialize y start pixel each     */
    ystart[i]=upper+(delta/2)+i*delta; /* channel                           */
}
/*--------------------------------------------------------------------------*/
/*   compute the time for one buffer                                        */
/*--------------------------------------------------------------------------*/
tbuf=1.0;
/*printf("NSAMP:%d TBUF:%f\n",nsamp,tbuf);*/
/*--------------------------------------------------------------------------*/
/*   compute first, last and number of buffers in plot window, remember to  */
/*   skip header buffer                                                     */
/*--------------------------------------------------------------------------*/
nbuf=(int)(time2-time1);               /* number of blocks to plot          */
/*--------------------------------------------------------------------------*/
/*   compute number of points to use, skip and number of points to plot,    */
/*   only plot whole buffers.                                               */
/*--------------------------------------------------------------------------*/
nplot=(int)(time2-time1)*nsamp;
if (con_ser == 1) skip = nplot/1000;
else skip=nplot/640;
if(skip == 0)
    skip=1;
if (con_ser == 1) xscale=999.0/(time2-time1);
else xscale=639.0/(time2-time1);
/*printf("NPLOT:%d SKIP:%d XSCALE:%f\n",nplot,skip,xscale);*/
/*--------------------------------------------------------------------------*/
/* distance between points plotted in tek units, note that in this program  */
/* whole buffers are selected. This means that for a time interval of e.g.  */
/* 2 seconds and srate 50, 100 points will be used, not 101 and the last    */
/* point on the x-axis is blank                                             */
/*--------------------------------------------------------------------------*/
xstep=(float)skip*xscale/(1./srate);
/*printf("XSTEP:%f\n",xstep);*/
/*getch();*/
/*--------------------------------------------------------------------------*/
/*   start point of trace                                                   */
/*--------------------------------------------------------------------------*/
//fil:
ix=0;
/*--------------------------------------------------------------------------*/
/* enter graphics mode                                                      */
/*--------------------------------------------------------------------------*/
graphic_mode(con_ser);
plt_hdr_box(ptr,con_ser);              /* prepare top header box            */
plt_plt_box(ptr,con_ser,fnt_no);       /* prepare plotting area             */
top_hdr_txt(ptr,con_ser,fnt_no,thead);
axis(ptr,con_ser,fnt_no,thead,xscale,time1,time2,upper);/* and plot axis           */

from=(int)(time1/srate);
to  =(int)(time2/srate);
for(k=0;k<nchtot;k++)                  /* plot selected channels            */
{
    iy=ystart[k];                      /* y-position of trace               */
    ichan=chan[k];                     /* current channel                   */
    isamp=ntotal;                      /* counter for number of samples     */
    indx=0;
    for(smp=from;smp<to;smp++)         /* extract into plot vector      */
    {
        valfl=M2(matr,ichan-1,smp);
        ivec[indx]=(int)valfl;
        data[indx]=valfl;
        indx=indx+1;
    }
    for(j=0;j<indx;j++)
        ivec[j]=(int)data[j];    
/*--------------------------------------------------------------------------*/
/*    do skipping                                                           */
/*--------------------------------------------------------------------------*/
    j=0;
    for(i=0;i<(indx);i=i+skip)
    {
        ivec[j]=ivec[i];
        j=j+1;
    }
    lplot=j-1;                         /* number of samples after skipping  */
/*--------------------------------------------------------------------------*/
/*    scale data                                                            */
/*--------------------------------------------------------------------------*/
        maxamp=conv(lplot,ivec,delta,amp,ichan);
/*--------------------------------------------------------------------------*/
/*    plot trace                                                            */
/*--------------------------------------------------------------------------*/
    color=14;
    plotseis(ptr,con_ser,ivec,iy,lplot,xstep,color);
/*--------------------------------------------------------------------------*/
/*    plot trace notation                                                   */
/*--------------------------------------------------------------------------*/
    sid_lab(ptr,con_ser,fnt_no,k,iy,delta,upper,nchtot,ichan,stcode,comp,maxamp);
}                                      /* k-loop                            */
//
//   clear zoom parameters if previous choise was not zoom
//

if(cmu!=' ')
  {
time1=0.0;            
time1_old=0.0;
izoom=0;
  }
///////////////////////////////////////////////////////////////////////////////
/****************************************************************************/
/* DO INPUT FROM MENU ON TOP OF GRAPHIC SCREEN, main interactive loop       */
/****************************************************************************/
///////////////////////////////////////////////////////////////////////////////

input:

if (con_ser == 1) get_tek_input ();
else mouse_test();                          /* get input form keyboard or mouse */

switch(cmu)
{
    case 'o':                          /*  Other choise                     */
    case 'O':                          /*  Other choise                     */
    filter_switch=specter_switch=0;
    fclose(evt);
//    free(matr);                        /* deallocate memory                 */
//_heapshrink();

    if (con_ser == 2)
    {
      _setvideomode( _DEFAULTMODE );	   /* reset the screen                  */
      cls_alp();                         /* clear and home screen             */
    }
    else gmode (0);
    goto top;                          
    break;    

    case 'q':                            /* QUIT PROGRAM                      */
    case 'Q':                            /* QUIT PROGRAM                      */
    fclose(evt);
//    free(matr);                          /* deallocate memory                 */
//_heapshrink();

    if (con_ser == 2)
        _setvideomode( _DEFAULTMODE );	 /* reset the screen                  */
    else
	gmode (0);
    finish_program();
    break;

    case 'r':                            /* SAME EVENT, new parameters        */
    case 'R':                            /* SAME EVENT, new parameters        */
    filter_switch=specter_switch=0;
//    _setvideomode( _DEFAULTMODE );	   /* reset the screen                  */
//    cls_alp();                         /* clear and home screen             */
//    fseek(evt,0,0);                    /* rewind file                       */
//    goto top3;
    goto defaults;
    break;

    case 'f':                            /* BANDPASS FILTER data on screen    */
    case 'F':                            /* BANDPASS FILTER data on screen    */
    if (con_ser == 2) 
	_setvideomode( _DEFAULTMODE ); /* reset the screen                  */
    else
        gmode (0);
    fseek(evt,0,0);                    /* rewind file                       */
    filter_switch=1;                   /* set filter active                 */        
err1:
    cls_alp();
    flt_typ=filt_type();               /* check for filter type             */
    switch(flt_typ)
    {
        case -1:                       /* error                             */
        goto err1;
        break;

        case 1:                        /* standard                          */
        inp_filt_par_bp(&n_coef,&fl,&fh);
        bandps(n_coef,c,fl,fh,srate);
        break;

        case 2:                        /* recursive                         */
        iord=4;    
        inp_filt_par(&fl,&fh);
        design(iord,"BP","BU",30.0,0.3,fl,fh,srate);
        break;
    }
    ix=0;
/*--------------------------------------------------------------------------*/
/* enter graphics mode                                                      */
/*--------------------------------------------------------------------------*/
    graphic_mode(con_ser);
    plt_hdr_box(ptr,con_ser);          /* prepare top header box            */
    plt_plt_box(ptr,con_ser,fnt_no);   /* prepare plotting area             */
    top_hdr_txt(ptr,con_ser,fnt_no,thead);
    axis(ptr,con_ser,fnt_no,thead,xscale,time1,time2,upper);/* and plot axis*/

    from=(int)(time1/srate);
    to  =(int)(time2/srate);
    for(k=0;k<nchtot;k++)              /* plot selected channels            */
    {
        iy=ystart[k];                  /* y-position of trace               */
        ichan=chan[k];                 /* current channel                   */
        isamp=ntotal;                  /* counter for number of samples     */
        indx=0;
        for(smp=from;smp<to;smp++)     /* extract into plot vector      */
        {
            valfl=M2(matr,ichan-1,smp);
            ivec[indx]=(int)valfl;
            data[indx]=valfl;
            indx=indx+1;
        }
        if(filter_switch+specter_switch == 2 && nchtot == 1)
        {
            for(j=0;j<indx;j++)
                ivec[j]=(int)data[j];    
/*--------------------------------------------------------------------------*/
/*    do skipping                                                           */
/*--------------------------------------------------------------------------*/
            j=0;
            for(i=0;i<(indx);i=i+skip)
            {
                ivec[j]=ivec[i];
                j=j+1;
            }
            lplot=j-1;                 /* number of samples after skipping  */
/*--------------------------------------------------------------------------*/
/*    scale data                                                            */
/*--------------------------------------------------------------------------*/
            maxamp=conv(lplot,ivec,delta,amp,ichan);
/*--------------------------------------------------------------------------*/
/*    plot trace                                                            */
/*--------------------------------------------------------------------------*/
            color=14;
            plotseis(ptr,con_ser,ivec,iy,lplot,xstep,color);
/*--------------------------------------------------------------------------*/
/*    plot trace notation                                                   */
/*--------------------------------------------------------------------------*/
            sid_lab(ptr,con_ser,fnt_no,k,iy,delta,upper,nchtot,ichan,stcode,comp,maxamp);
/*--------------------------------------------------------------------------*/
/* plot specter                                                             */
/*--------------------------------------------------------------------------*/
            plt_spec(con_ser,nyquist,scfac,NN,spec);
            iy=delta*3;
        }
        switch(flt_typ)
        {
            case 1:
            filt1(indx,data,outp,n_coef,c);
            for(j=0;j<indx;j++)
                data[j]=outp[j];
            break;
            case 2:                    /* recursive                         */
            apply(data,indx,1);
for(ltr=0;ltr<50;ltr++)
    data[ltr]=0;
            break;
        }
        for(j=0;j<indx;j++)
            ivec[j]=(int)data[j];    
/*--------------------------------------------------------------------------*/
/*    do skipping                                                           */
/*--------------------------------------------------------------------------*/
        j=0;
        for(i=0;i<(indx);i=i+skip)
        {
            ivec[j]=ivec[i];
            j=j+1;
        }
        lplot=j-1;                     /* number of samples after skipping  */
/*--------------------------------------------------------------------------*/
/*    scale data                                                            */
/*--------------------------------------------------------------------------*/
        maxamp=conv(lplot,ivec,delta,amp,ichan);
/*--------------------------------------------------------------------------*/
/*    plot trace                                                            */
/*--------------------------------------------------------------------------*/
        color=14;
        plotseis(ptr,con_ser,ivec,iy,lplot,xstep,color);
/*--------------------------------------------------------------------------*/
/*    plot trace notation                                                   */
/*--------------------------------------------------------------------------*/
        sid_lab(ptr,con_ser,fnt_no,k,iy,delta,upper,nchtot,ichan,stcode,comp,maxamp);
        if (con_ser == 2)
        {
          _setcolor(15);
          sprintf(buf,"n%d",fnt_no);
          _setfont(buf);
          sprintf(buf,"FL:%7.4f FH:%7.4f",fl,fh);
          _moveto(10,430);
          _outgtext(buf);
        }
        else
        {
          sprintf(buf,"FL:%7.4f FH:%7.4f",fl,fh);
          text(10, 10, buf);
        }
    }
    if(filter_switch+specter_switch == 2 && nchtot == 1)
    {
/*--------------------------------------------------------------------------*/
/*    specter of data                                                       */
/*--------------------------------------------------------------------------*/
        cnt=0;
        for(j=1;j<indx*2;j=j+2)
        {
            spdat[j]=data[cnt];
            spdat[j+1]=0.0;
            cnt=cnt+1;
        }
/*--------------------------------------------------------------------------*/
/*    specter of data ?                                                     */
/*--------------------------------------------------------------------------*/
        if(isamp < 32)
            NN=32;
        if(isamp < 64 && isamp > 32)
            NN=64;
        if(isamp < 128 && isamp > 64)
            NN=128;
        if(isamp < 256 && isamp > 128)
            NN=256;
        if(isamp < 512 && isamp > 256)
            NN=512;
        if(isamp < 1024 && isamp > 512)
            NN=1024;
        if(isamp < 2048 && isamp > 1024)
            NN=2048;
        if(isamp < 4096 && isamp > 2048)
            NN=4096;
        if(isamp < 8192 && isamp > 4096)
            NN=8192;

        for(i=j;i<NN*2;i=i+2)
        {
            spdat[i]=0.0;
            spdat[i+1]=0.0;
        }
        nyquist=1.0/(2.0*srate);
        scfac=XL/(NN/2);
        four1(spdat,NN,1);
        ex_spec(spdat,NN,spec);
        maxa=0.0;
        spec[0]=0.0;
        for(i=0;i<=NN/2;i++)           /* find max value to scale specter   */
        {
            if(spec[i] > maxa)
            maxa=spec[i];
        }
        for(i=0;i<=NN/2;i++)           /* scale specter to max 1.0          */
            spec[i]=spec[i]/maxa;

        scfac=XL/(float)(NN/2);        /* pixels per value                  */
/*--------------------------------------------------------------------------*/
/* plot specter                                                             */
/*--------------------------------------------------------------------------*/
        plt_spec_ovl(con_ser,nyquist,scfac,NN,spec);

    }
    goto input;
    break;
/****************************************************************************/
/*                                 SPECTER                                  */
/****************************************************************************/
    case 'k':                            /* make specter of trace             */
    case 'K':                            /* make specter of trace             */
    if(nchtot > 1)                     /* more than 1 channel ?             */
    {
        one_chan_only();               /* NOT allowed. Select one channel   */
        fseek(evt,0,0);                /* rewind file                       */
        goto found;
    }
    specter_switch=1;
    ix=0;
/*--------------------------------------------------------------------------*/
/*    specter of data                                                       */
/*--------------------------------------------------------------------------*/
    cnt=0;
    for(j=1;j<indx*2;j=j+2)
    {
        spdat[j]=data[cnt];
        spdat[j+1]=0.0;
        cnt=cnt+1;
    }
/*--------------------------------------------------------------------------*/
/*    specter of data ?                                                     */
/*--------------------------------------------------------------------------*/
    if(isamp < 32)
        NN=32;
    if(isamp < 64 && isamp > 32)
        NN=64;
    if(isamp < 128 && isamp > 64)
        NN=128;
    if(isamp < 256 && isamp > 128)
        NN=256;
    if(isamp < 512 && isamp > 256)
        NN=512;
    if(isamp < 1024 && isamp > 512)
        NN=1024;
    if(isamp < 2048 && isamp > 1024)
        NN=2048;
    if(isamp < 4096 && isamp > 2048)
        NN=4096;
    if(isamp < 8192 && isamp > 4096)
        NN=8192;

    for(i=j;i<NN*2;i=i+2)
    {
        spdat[i]=0.0;
        spdat[i+1]=0.0;
    }
    nyquist=1.0/(2.0*srate);
    scfac=XL/(NN/2);
    four1(spdat,NN,1);
    ex_spec(spdat,NN,spec);
    maxa=0.0;
    spec[0]=0.0;
    for(i=0;i<=NN/2;i++)               /* find max value to scale specter   */
    {
        if(spec[i] > maxa)
        maxa=spec[i];
    }
    for(i=0;i<=NN/2;i++)               /* scale specter to max 1.0          */
        spec[i]=spec[i]/maxa;

    scfac=XL/(float)(NN/2);            /* pixels per value                  */
/*--------------------------------------------------------------------------*/
/* plot specter                                                             */
/*--------------------------------------------------------------------------*/
    plt_spec(con_ser,nyquist,scfac,NN,spec);
    goto input;
    break;
/****************************************************************************/
/*                                ZOOM                                      */
/****************************************************************************/
    x=1;
    if(nchtot == 1)
    {
        y=180;
    }else{
        y=440;
    }

  case ' ':                                     /* zoom */
        if(izoom==0)                              /* first zoom click */
       {    time1=(float)x/xscale+time1_old;
            izoom=izoom+1;
            if (con_ser == 1)
            {
                 move (x,40);
                 draw (x,upper);
            }
            else
            {
                _moveto(x,460);
                _lineto(x,upper);
            }
           goto  input;
       }
        else
       {
           time2=(float)x/xscale+time1_old;
           time1_old=time1;
           izoom=0;                           /* reset since 2. zoom click */
           if (con_ser == 2)
           {
            _moveto(x,460);
            _lineto(x,upper);
           }
           if(time2 < time1)                  /* back to original */
       {     time1=0.0;
             time2=ttotal;
             time1_old=0.0;
       }
           goto defaults;
           break;   
        } 
        break;

///////////    STOP   ///////////////////////////////////////////////////

        case 'x':
        case 'X':
        goto stopp;
        break;
///////////    Pick  phases /////////////////////////////////////////////

        case 'p':
        case 'P':
           time_phase=(float)x/xscale+time1;
           kchan=(y-upper)/delta+1;
           if (con_ser == 1)
           {
          	    move(x,ystart[kchan-1]+(int)(delta/3));
           	    draw(x,ystart[kchan-1]-(int)(delta/3));
	            sprintf(dum,"P");
        	    text(x, ystart[kchan-1]+(int)(delta/3)+10, dum);
           }
           else
           {
               _moveto(x,ystart[kchan-1]+delta/3);
               _lineto(x,ystart[kchan-1]-delta/3);
               sprintf(dum,"P");
               _moveto(x,ystart[kchan-1]-delta/3-8);
               _outgtext(dum);
           }
           fprintf(phas,"%c",stcode[ (chan[kchan-1]-1)*4]);
           fprintf(phas,"%c",stcode[ (chan[kchan-1]-1)*4+1]);
           fprintf(phas,"%c",stcode[ (chan[kchan-1]-1)*4+2]);
           fprintf(phas,"%c",stcode[ (chan[kchan-1]-1)*4+3]);
           fprintf(phas," %f7    1 \n",time_phase);
           goto input;
        break;
       
        case 's':
        case 'S':
           time_phase=(float)x/xscale+time1;
           kchan=(y-upper)/delta+1;
	   if (con_ser == 1)
	   {
	           move(x, ystart[kchan-1]+(int)(delta/3));
    	       draw(x, ystart[kchan-1]-(int)(delta/3));
	           sprintf(dum,"S");
        	   text(x,ystart[kchan-1]+(int)(delta/3)+10,dum);
	   }
	   else
	   {
               _moveto(x,ystart[kchan-1]+delta/3);
               _lineto(x,ystart[kchan-1]-delta/3);
               sprintf(dum,"S");
               _moveto(x,ystart[kchan-1]-delta/3-8);
               _outgtext(dum);
           }
           fprintf(phas,"%c",stcode[ (chan[kchan-1]-1)*4]);
           fprintf(phas,"%c",stcode[ (chan[kchan-1]-1)*4+1]);
           fprintf(phas,"%c",stcode[ (chan[kchan-1]-1)*4+2]);
           fprintf(phas,"%c",stcode[ (chan[kchan-1]-1)*4+3]);
           fprintf(phas," %f7    2 \n",time_phase);
           goto input;
        break;
       
        case 'c':
        case 'C':
           time_phase=(float)x/xscale + time1;
           kchan=(y-upper)/delta+1;
	   if (con_ser == 1)
	   {
	           move(x,ystart[kchan-1]+(int)(delta/3));
    	       draw(x,ystart[kchan-1]-(int)(delta/3));
	           sprintf(dum,"C");
	           text(x,ystart[kchan-1]+(int)(delta/3)+10,dum);
	   }
	   else
	   {
               _moveto(x,ystart[kchan-1]+delta/3);
               _lineto(x,ystart[kchan-1]-delta/3);
               sprintf(dum,"C");
               _moveto(x,ystart[kchan-1]-delta/3-8);
               _outgtext(dum);
           }
           fprintf(phas,"%c",stcode[ (chan[kchan-1]-1)*4]);
           fprintf(phas,"%c",stcode[ (chan[kchan-1]-1)*4+1]);
           fprintf(phas,"%c",stcode[ (chan[kchan-1]-1)*4+2]);
           fprintf(phas,"%c",stcode[ (chan[kchan-1]-1)*4+3]);
           fprintf(phas," %f7    3 \n",time_phase);
           goto input;
        break;
        case 'y':
        case 'Y':
           time_phase=(float)x/xscale + time1;
           kchan=(y-upper)/delta+1;
	   if (con_ser == 1)
	   {
	           move(x,ystart[kchan-1]+(int)(delta/3));
    	       draw(x,ystart[kchan-1]-(int)(delta/3));
	           sprintf(dum,"X");
	           text(x,ystart[kchan-1]+(int)(delta/3)+10,dum);
	   }
	   else
	   {
               _moveto(x,ystart[kchan-1]+delta/3);
               _lineto(x,ystart[kchan-1]-delta/3);
               sprintf(dum,"X");
               _moveto(x,ystart[kchan-1]-delta/3-8);
               _outgtext(dum);
           }
           fprintf(phas,"%c",stcode[ (chan[kchan-1]-1)*4]);
           fprintf(phas,"%c",stcode[ (chan[kchan-1]-1)*4+1]);
           fprintf(phas,"%c",stcode[ (chan[kchan-1]-1)*4+2]);
           fprintf(phas,"%c",stcode[ (chan[kchan-1]-1)*4+3]);
           fprintf(phas," %f7    6  %2d\n",time_phase,kchan);
           chan[selects]=kchan;
           selects++;

           goto input;
        break;
case 'g':
case 'G':
nchtot=selects;
goto defaults;
break;
////////////   Locate event ////////////////////////////////////////////////

        case 'l':
        case 'L':
           fclose(phas);
           system("rm -f /home/work/epiout");/* make sure no old epicneter */
           system("epi< /home/work/phases>/home/work/epiout");
           system("cp /home/work/phases /home/work/phase");   /* save phase readings */
           phas=fopen("phases","w");
           system("map");
           goto defaults;                /*plot again*
        break;
       
        default:   
        goto input;
        break;

/****************************************************************************/
/*                          ORIGINAL+FILTERED                               */
/****************************************************************************/
    case 'v':


    if (con_ser == 2)
        _setvideomode( _DEFAULTMODE );	   /* reset the screen                  */
    else
	gmode (0);
     fseek(evt,0,0);                    /* rewind file                       */
    filter_switch=1;                   /* set filter active                 */        
err6:
    cls_alp();
    flt_typ=filt_type();               /* check for filter type             */
    switch(flt_typ)
    {
        case -1:                       /* error                             */
        goto err6;
        break;

        case 1:                        /* standard                          */
        inp_filt_par_bp(&n_coef,&fl,&fh);
        bandps(n_coef,c,fl,fh,srate);
        break;

        case 2:                        /* recursive                         */
        iord=4;    
        inp_filt_par(&fl,&fh);
        design(iord,"BP","BU",30.0,0.3,fl,fh,srate);
        break;
    }
    ix=0;
    x=1;
/*--------------------------------------------------------------------------*/
/* Read header part of event                                                */
/*--------------------------------------------------------------------------*/
    fseek(evt,0,0);
    fread(head,1024,1,evt);
/*--------------------------------------------------------------------------*/
/* extract header information from event header                             */
/*--------------------------------------------------------------------------*/
    hdr_info(head,&year,&month,&day,&hour,&min,&sec,&nchan,&srate,&ntotal,&unit,&nsamp,&recsize,&reclength);
    ttotal=(float)(ntotal/nsamp);
    sprintf(thead,"%2d:%2d:%6.3f %2d/%2d/%4d\n",hour,min,sec,day,month,year);
    YR=year;
    MTH=month;
    DAY=day;
    HR=hour;
    MIN=min;
    SEC=sec;
    TIMSEC (YR,MTH,DAY,HR,MIN,SEC,&MSECS);
    sectot=MSECS+time1;
    MSECS=sectot;
    SECTIM (MSECS,&YR,&DOY,&MTH,&DAY,&HR,&MIN,&SEC);
    sprintf(thead,"%2d:%2d:%6.3f %2d/%2d/%2d\n",HR,MIN,SEC,DAY,MTH,YR);
    if(con_ser == 1)                   /* serial ?                          */
    {
	upper=714;                              /* lower limit of top header         */
	if(nchtot == 1)
	{
    	delta=630./((float)nchtot*3);
	}else{
    	delta=630./(float)nchtot;          /* pixels per trace                  */
	for(i=0;i<nchtot;i++)                  /* initialize y start pixel each     */
    	ystart[i]=upper-((delta/2)+(i*delta)); /* channel                           */
	}
     }else{
    upper=47;                          /* lower limit of top header         */
    if(nchtot == 1)
    {
        delta=380./((float)nchtot*3);
    }else{
        delta=380./(float)nchtot;      /* pixels per trace                  */
    }
    for(i=0;i<nchtot;i++)              /* initialize y start pixel each     */
        ystart[i]=upper+(delta/2)+i*delta; /* channel                       */
    }
/*--------------------------------------------------------------------------*/
/*   compute the time for one buffer                                        */
/*--------------------------------------------------------------------------*/
    tbuf=1.0;
/*printf("NSAMP:%d TBUF:%f\n",nsamp,tbuf);*/
/*--------------------------------------------------------------------------*/
/*   compute first, last and number of buffers in plot window, remember to  */
/*   skip header buffer                                                     */
/*--------------------------------------------------------------------------*/
    nbuf=(int)(time2-time1);           /* number of blocks to plot          */
/*--------------------------------------------------------------------------*/
/*   compute number of points to use, skip and number of points to plot,    */
/*   only plot whole buffers.                                               */
/*--------------------------------------------------------------------------*/
    nplot=(int)(time2-time1)*nsamp;
    if (con_ser == 1) skip=nplot/1000;
    else skip=nplot/640;
    if(skip == 0)
        skip=1;
    if (con_ser == 1) xscale=999.0/(time2-time1);
    else xscale=639.0/(time2-time1);
/*printf("NPLOT:%d SKIP:%d XSCALE:%f\n",nplot,skip,xscale);*/
/*--------------------------------------------------------------------------*/
/* distance between points plotted in tek units, note that in this program  */
/* whole buffers are selected. This means that for a time interval of e.g.  */
/* 2 seconds and srate 50, 100 points will be used, not 101 and the last    */
/* point on the x-axis is blank                                             */
/*--------------------------------------------------------------------------*/
    xstep=(float)skip*xscale/(1./srate);
/*printf("XSTEP:%f\n",xstep);*/
/*getch();*/
/*--------------------------------------------------------------------------*/
/*   start point of trace                                                   */
/*--------------------------------------------------------------------------*/

    ix=0;
/*--------------------------------------------------------------------------*/
/* enter graphics mode                                                      */
/*--------------------------------------------------------------------------*/
    graphic_mode(con_ser);
    plt_hdr_box(ptr,con_ser);          /* prepare top header box            */
    plt_plt_box(ptr,con_ser,fnt_no);   /* prepare plotting area             */
    top_hdr_txt(ptr,con_ser,fnt_no,thead);
    axis(ptr,con_ser,fnt_no,thead,xscale,time1,time2,upper);/* and plot axis*/

    from=(int)(time1/srate);
    to  =(int)(time2/srate);
    for(k=0;k<nchtot;k++)              /* plot selected channels            */
    {
        iy=ystart[k];                  /* y-position of trace               */
        ichan=chan[k];                 /* current channel                   */
        isamp=ntotal;                  /* counter for number of samples     */
        indx=0;
        for(smp=from;smp<to;smp++)     /* extract into plot vector      */
        {
            valfl=M2(matr,ichan-1,smp);
            ivec[indx]=(int)valfl;
            data[indx]=valfl;
            indx=indx+1;
        }
        for(j=0;j<indx;j++)
            ivec[j]=(int)data[j];    
/*--------------------------------------------------------------------------*/
/*    do skipping                                                           */
/*--------------------------------------------------------------------------*/
        j=0;
        for(i=0;i<(indx);i=i+skip)
        {
            ivec[j]=ivec[i];
            j=j+1;
        }
        lplot=j-1;                     /* number of samples after skipping  */
/*--------------------------------------------------------------------------*/
/*    scale data                                                            */
/*--------------------------------------------------------------------------*/
        maxamp=conv(lplot,ivec,delta,amp,ichan);
/*--------------------------------------------------------------------------*/
/*    plot trace                                                            */
/*--------------------------------------------------------------------------*/
        color=4;
        plotseis(ptr,con_ser,ivec,iy,lplot,xstep,color);
/*--------------------------------------------------------------------------*/
/*    plot trace notation                                                   */
/*--------------------------------------------------------------------------*/
        sid_lab(ptr,con_ser,fnt_no,k,iy,delta,upper,nchtot,ichan,stcode,comp,maxamp);
    }                                      /* k-loop                            */
    from=(int)(time1/srate);
    to  =(int)(time2/srate);

    for(k=0;k<nchtot;k++)              /* plot selected channels            */
    {
        iy=ystart[k];                  /* y-position of trace               */
        ichan=chan[k];                 /* current channel                   */
        isamp=ntotal;                  /* counter for number of samples     */
        indx=0;
        for(smp=from;smp<to;smp++)     /* extract into plot vector      */
        {
            valfl=M2(matr,ichan-1,smp);
            ivec[indx]=(int)valfl;
            data[indx]=valfl;
            indx=indx+1;
        }
        switch(flt_typ)
        {
            case 1:
            filt1(indx,data,outp,n_coef,c);
            for(j=0;j<indx;j++)
                data[j]=outp[j];
            break;
            case 2:                    /* recursive                         */
            apply(data,indx,1);
for(ltr=0;ltr<50;ltr++)
    data[ltr]=0;
            break;
        }
        for(j=0;j<indx;j++)
            ivec[j]=(int)data[j];    
/*--------------------------------------------------------------------------*/
/*    do skipping                                                           */
/*--------------------------------------------------------------------------*/
        j=0;
        for(i=0;i<(indx);i=i+skip)
        {
            ivec[j]=ivec[i];
            j=j+1;
        }
        lplot=j-1;                     /* number of samples after skipping  */
/*--------------------------------------------------------------------------*/
/*    scale data                                                            */
/*--------------------------------------------------------------------------*/
        maxamp=conv(lplot,ivec,delta,amp,ichan);
/*--------------------------------------------------------------------------*/
/*    plot trace                                                            */
/*--------------------------------------------------------------------------*/
        color=14;
        plotseis(ptr,con_ser,ivec,iy,lplot,xstep,color);
/*--------------------------------------------------------------------------*/
/*    plot trace notation                                                   */
/*--------------------------------------------------------------------------*/
/*        sid_lab(ptr,con_ser,fnt_no,k,iy,delta,upper,nchtot,ichan,stcode,comp,maxamp);*/
    }
    goto input;
    break;    
/****************************************************************************/
/*                        NEXT EVENT                                        */
/****************************************************************************/
    case 'n':
//    free(matr);
//_heapshrink();

    if (con_ser == 2)
    {
        _setvideomode(_DEFAULTMODE);
        cls_alp();
    }
    else gmode (0);
    if(rr1==1)
    {
        rng++;
        sprintf(lbuf,"%d",rng);
        type_io1=7;
        type_io=2;
//        free(matr);
//_heapshrink();

        goto newring;
    }else{
        dpx=dpx+1;
        sprintf(lbuf,"%d",dpx);
        type_io1=7;    
        type_io=2;  
//        free(matr);                        /* deallocate memory                 */
//_heapshrink();

        goto top2;
    }
    break;
/****************************************************************************/
/*                     NEXT RINGBUFFER                                      */
/****************************************************************************/
    case 't':
    if (con_ser == 2)
    {
        _setvideomode(_DEFAULTMODE);
        cls_alp();
    }
    else gmode (0);
    rng=rng+1;
    goto newring;
    break;
/****************************************************************************/
/*                        BACK one event                                    */
/****************************************************************************/
    case 'b':
    if (con_ser == 2)
    {
        _setvideomode(_DEFAULTMODE);
        cls_alp();
    }
    else gmode (0);
    dpx=dpx-1;
    sprintf(lbuf,"%d",dpx);
    type_io1=7;    
    type_io=2;  
    goto top2;
    break;
}
stopp:
printf("STOPP\n");
}





///////////////////////////////////////////////////////////////////////////


plotseis(ptr,con_ser,ivec,iy,lplot,xstep,color)
smod* ptr;
int con_ser;
int *ivec;
int iy;
int lplot;
float xstep;
int color;
{
    int i;
    int ix;
    if (con_ser == 1)
    {
        move(1,iy-ivec[0]);
    	for(i=1;i<lplot;i++)
    	{
    	    ix=(float)(i-1)*xstep + 1.0;
        	if(ix > 1000) ix=1000;
//	        draw(ix,iy-ivec[i]);
	        draw(ix,iy+ivec[i]);
    	}
    }
    else
    {
        _setcolor(ptr->plt_are_plt_col);
        _setcolor(color);
        _moveto(1,ivec[0]+iy);
        for(i=1;i<lplot;i++)
        {
            ix=(float)(i-1)*xstep + 1.0;
            if(ix > 640)
                ix=640;
//        _lineto(ix,ivec[i]+iy);
            _lineto(ix,ivec[i]* -1 +iy);
        }
    }
}
/*-----------------------------------------------------------------------*/
/* scale data                                                            */
/*-----------------------------------------------------------------------*/
    conv(lplot,ivec,delta,amp,ichan)
int lplot;
int *ivec;
float delta;
float *amp;
int ichan;
{
    float sum;
    float avg;
    float factor;
    int i;
    int maxa;
    sum=0.0;
    maxa=0;
    for(i=0;i<lplot;i++)               /* find DC                       */
        sum=sum+(float)ivec[i];
    avg=sum/(float)lplot;
    for(i=0;i<lplot;i++)                /* remove dc                    */
        ivec[i]=ivec[i]-(int)avg;
    for(i=0;i<lplot;i++)               /* find max value                */
    {
        if(abs(ivec[i]) > maxa)
            maxa=abs(ivec[i]);
    }
// printf("%3d %f %d\n",ichan,avg,maxa);
    if(maxa == 0)
        maxa=1;
    factor=delta*0.5/(float)maxa;
    if(amp[ichan] == 0.0)
    {
    	for(i=0;i<lplot;i++)
    	    ivec[i]=(float)ivec[i]*factor;
   	}else{
   	    for(i=0;i<lplot;i++)
   	        ivec[i]=(float)ivec[i]*amp[ichan]*factor;
    }
return(maxa);
}
/*-----------------------------------------------------------------------*/
/* demultiplex one channel                                               */
/*-----------------------------------------------------------------------*/
dmx(isamp,nsamp,ichan,nchan,iworkl,data)
int isamp;
int nsamp;
int ichan;
int nchan;
int iworkl[];
float data[];
{
int i;
int bufsiz;

bufsiz=nsamp*nchan+HEADER;
for(i=HEADER+ichan-1;i<bufsiz;i=i+nchan)
{
    data[isamp]=(float)iworkl[i];
    isamp=isamp+1;
}
return(isamp);
}
/*------------------------------------------------------------------------*/
/* draw axis top and bottom and help text on top                          */
/* only whole seconds are used, interval can be 1, 2, 5, 10, 20 or 60 secs*/
/* thead: time head to be printed on top, time of first sample            */
/* xscale:time scale desired in tek units/second                          */
/* time1: time of first sample to use relative to first sample in file    */
/* time2: time of last  --------------------"-------------------------    */
/*------------------------------------------------------------------------*/
axis(ptr,con_ser,fnt_no,thead,xscale,time1,time2,upper)
smod*    ptr;
int      con_ser;
int      fnt_no;
char *thead;
float xscale;
float time1;
float time2;
int   upper;
{
char buf[10];
char tempo[10];                        /* temporary string                  */
char dum[80];
    int ix0;
    int nsec;
    int tsize;
    int isec;
    int ix;
int i;                                 /* counter                           */
    int hour;
    int min;
float sec;                             /* seconds of start time plot        */
    float delsec;


if(con_ser==1)                     /* serial line ?                     */
{
  /* find distance between ticks assuming 100 tek units between ticks         */
  i=100.0/xscale;
  if(i<=1)
    delsec=1;
  if(i>1)
    delsec=2;
  if(i>2)
    delsec=5;
  if(i>5)
    delsec=10;
  if(i>10)
    delsec=20;
  if(i>20)
    delsec=30;
  nsec=(time2-time1);
  isec=sec/delsec+1;
  isec=isec*delsec;
  /* +1.0 in next line because plot starts at x=1 in tek units             */
  ix0=((float)isec-sec)*xscale+1.0;
  isec=(isec % 60);
  /* now plot axis                                                          */
  tsize=10;
  move(1,upper);                      /* upper axis                        */
  draw(999,upper);                    /* upper axis                        */
  move(999,39);                      /* lower axis                        */
  draw(1,39);                        /* lower axis                        */

  for(i=1;i<(nsec/(int)delsec)+1;i++)    /* make tick marks and second no.    */
  {
    ix=(float)ix0+(float)(i-1)*(float)delsec*xscale;
    if(ix<=1000)
    {
        sprintf(dum,"%2d",isec);     /* numbers                           */
        text(ix-10, 10, dum);
        if(isec == 60)
        {
            isec=0;
            tsize=200;                  /* minute ticks                      */
        }
        move(ix,upper);             /* ticks                             */
        draw(ix,upper-tsize);       /* ticks                             */
        move(ix,39);               /* ticks                             */
        draw(ix,39+tsize);         /* ticks                             */
        tsize=10;                   /* second ticks                      */
        isec=isec+delsec;
    }
  }
}else{
sprintf(buf,"n%d",fnt_no);             /* select fonts                      */
_setfont(buf);                         /* select the font to use            */
for(i=0;i<7;i++)
    tempo[i]=thead[i+6];
sscanf(tempo,"%f6.3",&sec);            /* get seconds of start time plot    */

/* find distance between ticks assuming 100 tek units between ticks         */

i=100.0/xscale;
if(i<=1)
    delsec=1;
if(i>1)
    delsec=2;
if(i>2)
    delsec=5;
if(i>5)
    delsec=10;
if(i>10)
    delsec=20;
if(i>20)
    delsec=30;
nsec=(time2-time1);
isec=sec/delsec+1;
isec=isec*delsec;
/* +1.0 in next line because plot starts at x=1 in tek units             */
ix0=((float)isec-sec)*xscale+1.0;
isec=(isec % 60);
/* now plot axis                                                          */
tsize=10;
_setcolor(ptr->tim_sca_plt_col);       /* set color for time scaling        */
_moveto(1,upper);                      /* upper axis                        */
_lineto(639,upper);                    /* upper axis                        */
_moveto(639,460);                      /* lower axis                        */
_lineto(1,460);                        /* lower axis                        */

for(i=1;i<(nsec/(int)delsec)+1;i++)    /* make tick marks and second no.    */
{
    ix=(float)ix0+(float)(i-1)*(float)delsec*xscale;
    if(ix<=640)
    {
        sprintf(dum,"%2d\n",isec);     /* numbers                           */
        _moveto(ix-10,460+1);
        _outgtext(dum);
        if(isec == 60)
        {
            isec=0;
            tsize=200;                  /* minute ticks                      */
        }
        _moveto(ix,upper);             /* ticks                             */
        _lineto(ix,upper+tsize);       /* ticks                             */
        _moveto(ix,460);               /* ticks                             */
        _lineto(ix,460-tsize);         /* ticks                             */
        tsize=10;                      /* second ticks                      */
        isec=isec+delsec;
    }
}
}
}
/*------------------------------------------------------------------------*/
/* enter start time and stop time                                         */
/*------------------------------------------------------------------------*/
start_stop(ttotal,time1,time2)
float ttotal;
float *time1;
float *time2;
{
    FILE *fp;
    char lbuf[SIZ];
    float t1;
    float t2;
fp=stdin;
printf("Total time for event: %10.1f seconds\n",ttotal);
printf("Enter start time in seconds, press RETURN for t=0    :");
input_line(fp,lbuf,SIZ);               /* read input                        */
if(lbuf[0]==NULL)                      /* RETURN use default                */
{
    t1=0.0;
}else{
    sscanf(lbuf,"%f",&t1);
}
printf("Enter stop  time in seconds, press RETURN for t=total:");
input_line(fp,lbuf,SIZ);               /* read input                        */
if(lbuf[0]==NULL)                      /* RETURN use default                */
{
    t2=ttotal;
}else{
    sscanf(lbuf,"%f",&t2); 
}
if(t2 > ttotal)
    t2=ttotal;
*time1=t1;
*time2=t2;
}
/*------------------------------------------------------------------------*/
/* manual setting of gain factors for each channel selected for plotting  */
/*------------------------------------------------------------------------*/
gain_factors(nchtot,chan,amp)
int nchtot;
int *chan;
float *amp;
{
    int i;
    printf("\n");
    printf("        Enter gain for individual channels in floating point\n");
    for(i=0;i<nchtot;i++)
    {
        printf("Enter gain for channel:%3d Gain:",chan[i]);
        scanf("%f",&amp[chan[i]]);
    }
}
/*------------------------------------------------------------------------*/
/* Input channels to plot                                                 */
/*------------------------------------------------------------------------*/
chan_plot(nchan,chan,nchtot)
int nchan;
int *chan;
int *nchtot;
{
    int dum;
    int nc;
    int i;
    int l;
    int j;
    char kan1[5];
    char kan2[5];
    char kan3[5];
    printf("Channels number to plot, one per line, CR for all,\
 and CR to end\n");
    for(i=0;i<nchan;i++)
    {
        for(j=0;j<5;j++)
            kan1[j]=kan2[j]=kan3[j]='\0';
        nc=read(0,kan1,1);              /* read character and determine   */
                                        /* what to do                     */
        if(kan1[0]=='\r' || kan1[0]== '\n')               /* check if CR                    */
        {
            printf("\n");
            if(i==0)                    /* check if first loop            */
            {
                for(l=0;l<nchan;l++)    /* YES, plot all channels         */
                    chan[l]=l+1;
                *nchtot=nchan;
                goto sl;
            }
            *nchtot=i;
            goto sl;
        }
        nc=read(0,kan2,1);
        if(kan2[0]=='\r' || kan2[0]=='\n')                /* check if seconf char is CR    */
        {
            printf("\n");
            sscanf(kan1,"%1d",&chan[i]);
            if(chan[i] > nchan)
            {
                printf("Channel number:%d not valid\n",chan[i]);
                i=i-1;
                goto more;
            }
        }else{
            nc=read(0,kan3,1);
            if(kan3[0]=='\r' || kan3[0]=='\n')
            {
                printf("\n");
                strncat(kan1,kan2,1);
                sscanf(kan1,"%d",&chan[i]);
                if(chan[i] > nchan)
                {
                    printf("Channel number:%d not valid\n",chan[i]);
                    i=i-1;
                    goto more;
                }
            }else{
                printf("\n");
            	printf("Channel number not valid\n");
                i=i-1;
            	goto more;
            }
        }
more:
dum=0;
    }
sl:
dum=0;
}
/*------------------------------------------------------------------------*/
/* Print out available channels                                           */
/*------------------------------------------------------------------------*/
avail_chan(nchan,stcode,comp)
int nchan;
char *stcode;
char *comp;
{
    int k1,k2,cnt;
    printf("Available channels:");
    cnt=0;
    putchar(0x0d);
    putchar(0x0a);
    for(k1=0;k1<nchan;k1++)
    {
        printf("%4d ",k1+1);
        for(k2=k1*4;k2<k1*4+4;k2++)
            printf("%c",stcode[k2]);
        for(k2=k1*4;k2<k1*4+4;k2++)
            printf("%c",comp[k2]);
        cnt=cnt+1;
        if(cnt==5)
        {
            putchar(0x0d);
            putchar(0x0a);
            cnt=0;
        }
    }
    putchar(0x0d);
    putchar(0x0a);
}
/*-------------------------------------------------------------------------*/
/* get default channels to plot from /dd/PARAMETER/pic.def                 */
/*-------------------------------------------------------------------------*/
defchan(chan,nchtot)
int *chan;
int *nchtot;
{
    int val;
    int k;
    FILE *par;
    if((int)(par=fopen("/home/seislog/pr/pic.def","r"))==NULL)
    {
    	*nchtot=0;
        return(0);
    }
    for(k=0;k<MAXCHA;k++)
    {
        val=fscanf(par,"%2d",&chan[k]);
        if(val==EOF)
        {
            *nchtot=k;
/*            printf("NCHTOT:%d\n",*nchtot);*/
            goto fin;
        }
    }
fin:
fclose(par);
return(1);
}
/*-------------------------------------------------------------------------*/
/* Pick out station codes and components for corresponding channels        */
/*-------------------------------------------------------------------------*/
stacomp(nchan,stcode,comp,head)
int nchan;
char* stcode;
char* comp;
char* head;
{
int l;
int i;
int k;
k=160;
for(i=0;i<nchan;i++)
{
    for(l=0;l<4;l++)
    {
        stcode[i*4+l]=head[k+l];
        comp[i*4+l]=head[k+l+4];
    }
    k=k+8;
}
}
/*-------------------------------------------------------------------------*/
/* Get filenames on old detections and their duration                      */
/*-------------------------------------------------------------------------*/
dpxnam(i,infile,ttotal)
int i;
char* infile;
float* ttotal;
{
    FILE    *det;
    int     nn;
    int     kl;
    char    detrec[512];
    char    dur[16];
    int     istart;
    float   locdur;
    det=fopen(DETECTION,"r");
    nn=i/EVTSIZ;
    kl=nn*EVTSIZ;
    istart=(i-1-kl)*512;
    fseek(det,istart,0);
    fread(detrec,512,1,det);
    for(kl=0;kl<DIRNAMLEN;kl++)
        infile[kl]='\0';
    for(kl=0;kl<28;kl++)
        infile[kl]=detrec[kl+206];
    for(kl=0;kl<16;kl++)
        dur[kl]=detrec[kl+64];
    sscanf(dur,"%f8.3\n",&locdur);
    *ttotal=locdur;
    fclose(det);
}
/*-------------------------------------------------------------------------*/
/* Get current DPX number                                                  */
/*-------------------------------------------------------------------------*/
Get_Current_DPX()
{
    FILE    *det;                        /* pointer current detection no.  */
    int     curdpx;                      /* current dpx number             */
    det=fopen(DETNUMBER,"r");
    fscanf(det,"%d",&curdpx);
    fclose(det);
    return(curdpx);
}

static void Press_any_key()
/*=======================*/
/*  wait for keyboard input */
{
    _settextposition( 30, 64 );
    _outtext( "Press any key..." );
    getch();
}

inp_name_dpx(lbuf)
char*    lbuf;
{
char     karak[80];
int      i;
int      nr;
int      let;

printf("Filename, DPX # or -nn last events, plot ringbuffer press 'r':");
flu();
for(i=0;i<80;i++)
{

    let=getch();                       /* read character                    */
    if(i== 0 && (let == '\r' || let == '\n'))            /* first character CR ?              */
        return(0);                     /* return to main                    */
    if(i==0 && let == 0x72)            /* check for r to plot ringbuffer    */
        return(3);
    if(i !=0 && (let == '\r' || let == '\n'))            /* later CR ?                        */
        goto tolk;

/*TESTING*/
/*    if(let==0x7f)   BACSPACE future */


    putchar(let);                      /* echo character                    */
    flu();
    karak[i]=let;
    lbuf[i]=let;
}
tolk:                                  /* interpret inputstring             */
karak[i]='\0';
lbuf[i]='\0';
/*crlf();*/
/*printf("%s",karak);*/
/*flu();*/
/*crlf();*/
/*printf("I=%d",i);*/
/*flu();*/
if(karak[0]=='-')                      /* negative number ?                 */
{
    sscanf(karak,"%d",&nr);
/*    crlf();*/
/*    printf("NEG=%d",nr);*/
/*    flu();*/
/*    getch();*/
    return(1);
}
if(karak[0] >= '0' && karak[0] <='9')  /* is it a positive number ?         */
{
    sscanf(karak,"%d",&nr);
/*    crlf();*/
/*    printf("POS=%d",nr);*/
/*    flu();*/
/*    getch();*/
    return(2);
}
return(-1);
}
hdr_info(head,year,month,day,hour,min,sec,nchan,srate,ntotal,unit,nsamp,recsize,reclength)
char*    head;
long    *year;
long     *month;
long     *day;
long     *hour;
long     *min;
float    *sec;
int      *nchan;
float    *srate;
int      *ntotal;
int      *unit;
int      *nsamp;
int      *recsize;
int      *reclength;
{
char     dum[100];
int      i;
//for(i=0;i<20;i++)
//    printf("%c ",head[i]);
//printf("\n");
sscanf(head,"%14c%4d%5c%2d%c%2d%c%2d%c%2d%c%f6.3\n",
dum,year,dum,month,dum,day,dum,hour,dum,min,dum,sec);
if(head[62]==' ')
{
    dum[0]=head[63];
    sscanf(dum,"%1d",nchan);
}else{
    dum[0]=head[62];
    dum[1]=head[63];
    sscanf(dum,"%2d",nchan);
}
for(i=0;i<16;i++)
    dum[i]=head[i+64];
sscanf(dum,"%f16.7",srate);
for(i=0;i<8;i++)
    dum[i]=head[i+80];
sscanf(dum,"%8d",ntotal);
dum[0]=head[96];
dum[1]=head[97];
sscanf(dum,"%2d",unit);
for(i=0;i<6;i++)
    dum[i]=head[i+122];
dum[i]='\0';
sscanf(dum,"%d",nsamp);
for(i=0;i<8;i++)
    dum[i]=head[i+104];
sscanf(dum,"%8d",recsize);
sscanf(dum,"%8d",reclength);
/*printf("NCHAN:%2d SRATE:%16.7f NTOTAL:%8d UNIT:%2d NSAMP:%6d\n",\*/
/*nchan,srate,ntotal,unit,nsamp);*/
/*printf("RECSIZE:%8d RECLENGTH:%8d\n",recsize,reclength);*/
}

//////////////////////////////////////////////////////////////////////////////

plt_opt()
{
FILE     *fp;
char     buf;
char     nc;

fp=stdin;
putchar(0x0d);
putchar(0x0a);
if(type_io1 != 7 ) printf("Defaults, press RETURN. Options press O");
fflush(stdin);
fflush(stdout);
if(type_io1 !=7 )  
    {
    nc=getch();         /* read one character from keyboard  */
/*putchar(0x0d);*/
/*putchar(0x0a);*/
/*printf("NC=%x",nc);*/
/*getch();*/
if(nc=='\r' || nc=='\n')                             /* RETURN ?                          */
    return(0);
if(nc=='O')                            /* O for options ?                   */
    return(1);
if(nc=='o')                            /* o for options ?                   */
    return(1);
return(-1);                            /* error                             */
   }
   else
   {
return(0);
   }
}


inp_chan_plt(lbuf,nchan,chan,nchtot)
char*    lbuf;
int      nchan;
int      *chan;
int      *nchtot;
{
FILE     *fp;
int      i;
int      k;
int      j;
int      p;
int      cnt;
int      spcnt;
int      kanaler[65];
char     karak[80];
int      tel;
int      let;
char     temp[10];
char     kopi[SIZ];
tel=0;
fp=stdin;
for(k=0;k<nchan;k++)
    chan[k]=0;
crlf();
printf("                     Enter channels to plot:");
crlf();
printf("                     -----------------------");
crlf();
printf("Enter channel numbers on one line with space in between, finish with RETURN");
crlf();
printf("To use default values, just press RETURN.");
crlf();
flu();
for(i=0;i<80;i++)
{
    let=getch();
    putchar(let);
/*    printf("KAR=%x",let);*/
    fflush(stdin);
    fflush(stdout);
    if(i==0 && (let == '\r' || let == '\n'))
        goto def;
    karak[i]=let;
    if(i > 0 && (let == '\r' || let == '\n'))
    goto tolk;
}
def:
    for(k=0;k<nchan;k++)               /* plot all channels                 */
        chan[k]=k+1;
    *nchtot=nchan;
    return(0);                         /* RETURN, use defaults              */
tolk:
if(karak[0]==' ')                      /* check first character is SPACE ?  */
    return(-1);                        /* not allowed return error -1       */
cnt=0;
for(k=0;k<80;k++)
{
    if(karak[k] != '\r' && karak[k] != '\n')
    {
        cnt=cnt+1;
    }else{
        k=k-1;
        goto out;
    }
}

out:
/*printf("Number of characters:%d\n",cnt);*/
if(karak[cnt-1]==' ')                   /* check if last character is SPACE  */
    return(-2);                        /* not allowed return error -2       */
for(i=0;i<cnt;i++)                     /* check for non numeric or non space*/
{
    if(karak[i] < '0' && karak[i] > '9') /* is it a positive number ?         */
    {                                  /* no                                */
        if(karak[i]!=' ')               /* is it a space ?                   */
            return(-3);                /* no, return error -3               */
    }
}
for(i=0;i<cnt;i++)                     /* check for more than 1 space betwee*/
{
    if(karak[i]==' ')
    {
        if(karak[i+1]==' ')
            return(-4);                /* yes, return error -4              */
    }
}
spcnt=0;
for(i=0;i<cnt;i++)
{
    if(karak[i] == ' ')
        spcnt=spcnt+1;                 /* increment spaces                  */
}
*nchtot=spcnt+1;                       /* number of channels specified      */
putchar(0x0d);
putchar(0x0a);
printf("Number of channels specified:%d",spcnt+1);
k=0;
j=0;
for(p=0;p<5;p++)
    temp[p]='\0';
for(i=0;i<80;i++)
    kopi[i]=' ';
for(i=0;i<cnt;i++)
    kopi[i]=karak[i];
for(i=0;i<cnt+1;i++)
{
    if(kopi[i] != ' ')
    {
        temp[k]=karak[i];
        k=k+1;
    }else{
        k=0;
        sscanf(temp,"%d",&kanaler[j]);
        j=j+1;
        for(p=0;p<5;p++)
            temp[p]='\0';
    }
}
for(i=0;i<spcnt+1;i++)
{
    putchar(0x0d);
    putchar(0x0a);
    printf("%d %d",i,kanaler[i]);
}
for(i=0;i<spcnt+1;i++)
    chan[i]=kanaler[i];
return(1);                             /* return all well                   */
}
inp_sca()
{
FILE     *fp;
char     buf;
char     nc;

fp=stdin;
printf("\nAuto-scaling, press RETURN. Options press O");
fflush(stdin);
fflush(stdout);
nc=getch();                            /* read one character from keyboard  */
if(nc=='\r' || nc=='\n')                           /* RETURN ?                          */
    return(0);
if(nc=='O')                            /* O for options ?                   */
    return(1);
if(nc=='o')                            /* o for options ?                   */
    return(1);
return(-1);                            /* error                             */
}
inp_tim()
{
FILE     *fp;
char     buf;
char     nc;

fp=stdin;
printf("\nStart/Stop time, press RETURN. Options press O");
fflush(stdin);
fflush(stdout);
nc=getch();                            /* read one character from keyboard  */
if(nc=='\r' || nc=='\n')                           /* RETURN ?                          */
    return(0);
if(nc=='O')                            /* O for options ?                   */
    return(1);
if(nc=='o')                            /* o for options ?                   */
    return(1);
return(-1);                            /* error                             */
}
sid_lab(ptr,con_ser,fnt_no,k,iy,delta,upper,nchtot,ichan,stcode,comp,maxamp)
smod*    ptr;
int      con_ser;
int      fnt_no;
int      k;
int      iy;
float    delta;
int      upper;
int      nchtot;
int      ichan;
char     *stcode;
char     *comp;
int      maxamp;
{
char     st[5];
char     co[5];
char     buf[10];                      /* help string for fonts             */
char     dum[80];                      /* string for text                   */
int      l;
int      i;
if(nchtot <= 32)   
{
    l=0;
    for(i=0;i<5;i++)
	    st[i]=co[i]='\0';
    for(i=(ichan-1)*4;i<(ichan-1)*4+4;i++)
    {
        st[l]=stcode[i];
        co[l]=comp[i];
        l=l+1;
    }
    if(con_ser==1)                     /* serial line ?                     */
    {
        sprintf(dum,"%2d %s %s max=%8d",ichan,st,co,maxamp);
        text(2, iy+(int)(delta/2)-35, dum);
    }else{
        sprintf(dum,"%2d %s %s max=%8d\n",ichan,st,co,maxamp);
        sprintf(buf,"n%d",fnt_no);     /* select the font                   */
        _setfont(buf);                 /* set the font to use               */
        _setcolor(ptr->plt_are_txt_col);/* set the color                    */
        _moveto(2,iy-delta/2);         /* set text position                 */
        _outgtext(dum);
    }
}
}
top_hdr_txt(ptr,con_ser,fnt_no,thead)
smod*    ptr;
int      con_ser;
int      fnt_no;
char*    thead;
{
char     buf[10];
char     dum[80];
if(con_ser == 1)                       /* serial ?                          */
{
    text(2, 756, thead);
    sprintf(dum, "Event number %d",dpx1);
    text(2, 716, dum);                      
    text(310, 756, "R  Replot");
    text(310, 736, "Q  Quit");
    text(310, 716, "O  Other event");
    text(530, 756, "F, V  Filter");
    text(530, 736, "K  Spectrum");
    text(530, 716, "MLB, Sp  Zoom");
    text(730, 716, "N/B  Next/back event");               
    text(730, 756, "P, S, C  Phases");               
    text(730, 736, "L  Locate event");
}else{
    _setcolor(ptr->top_hdr_txt_col);   /* set color                         */
    sprintf(buf,"n%d",fnt_no);         /* select fonts                      */
    _setfont(buf);                     /* set the font                      */
    _moveto(5,0);                      /* move to start text                */
    _outgtext(thead);
    sprintf(dum, "Event number %5d",dpx1);
    _moveto(5,26);
    _outgtext(dum);                      
    sprintf(dum,"Options:");
    _moveto(200,0);
    _outgtext(dum);
    sprintf(dum,"R  Replot");
    _moveto(260,0);
     _outgtext(dum);
    sprintf(dum,"Q   Quit");
    _moveto(260,13);
    _outgtext(dum);
    sprintf(dum,"O  Other event");
    _moveto(260,26);
    _outgtext(dum);
    sprintf(dum,"F, V  Filter");
    _moveto(370,0);
    _outgtext(dum);
    sprintf(dum,"K  Spectrum");
    _moveto(370,13);
    _outgtext(dum);
    sprintf(dum,"MLB, Sp  Zoom");
    _moveto(370,26);
    _outgtext(dum);
     sprintf(dum,"N/B  Next/back event");  
     _moveto(480,0);
     _outgtext(dum);               
     sprintf(dum,"P, S, C  Phases");
     _moveto(480,26);
     _outgtext(dum);               
     sprintf(dum,"L  Locate event"); 
     _moveto(480,13);
     _outgtext(dum);                
}
}

//////////////////////////////////////////////////////////////////////////

inp_options()
{
char     nc;

try_again:                            
flu();
nc=getch();                            /* read one character from keyboard  */
flu();
if(nc=='\r' || nc=='\n')                           /* RETURN for another event          */
    return(0);
if(nc=='Q' || nc=='q')                 /* Q for QUIT                        */
    return(1);
if(nc=='R' || nc=='r')                 /* R for REPEAT with new options     */
    return(2);
if(nc=='F' || nc=='f')                 /* F for filter current screen       */
    return(3);
if(nc=='S' || nc=='s')                 /* S for specter of current trace    */
    return(4);
if(nc=='Z' || nc=='z')                 /* Z for zooming in on data          */
    return(5);
if(nc=='V' || nc=='v')                 /* V for overlap original with filt  */
    return(6);
if(nc=='N' || nc=='n')                 /* N for next event                  */
{
//    free(matr);
//_heapshrink();

    return(7);
}
goto try_again;                        
/*return(-1); */                         /* error                             */
}
/*--------------------------------------------------------------------------*/
/* input filter parameters for filter package                               */
/*--------------------------------------------------------------------------*/
inp_filt_par(fl,fh)
float *fl;
float *fh;
{
float flow;
float fhigh;
int   let;
int   i;
char  karak[30];
par:
cls_alp();
flu();
printf("                        ENTER FILTER PARAMETERS:");
crlf();
flu();
printf("                        ------------------------");
crlf();
printf("FILTER LOW   :");
flu();
for(i=0;i<20;i++)
{
    let=getch();
    putchar(let);
    flu();
    if(i==0 && (let == '\r' || let == '\n'))             /* first character = CR              */
        goto par;
    karak[i]=let;
    if(i > 0 && (let == '\r' || let == '\n'))
    {
        karak[i]=0xa;
        goto les2;
    }
}
les2:
sscanf(karak,"%f\n",&flow);
crlf();
printf("FILTER HIGH  :");
flu();
for(i=0;i<20;i++)
{
    let=getch();
    putchar(let);
    flu();
    if(i==0 && (let == '\r' || let == '\n'))             /* first character = CR              */
        goto par;
    karak[i]=let;
    if(i > 0 && (let == '\r' || let == '\n'))
    {
        karak[i]=0xa;
        goto les3;
   }
}
les3:
sscanf(karak,"%f\n",&fhigh);
crlf();
*fl=flow;
*fh=fhigh;
*fl=flow;
*fh=fhigh;
}
/*--------------------------------------------------------------------------*/
/* input filter parameters for bandpass filter                              */
/*--------------------------------------------------------------------------*/
inp_filt_par_bp(n,fl,fh)
int   *n;
float *fl;
float *fh;
{
float flow;
float fhigh;
int let;
char karak[20];
int i;
int nuc;
par:
cls_alp();
flu();
printf("                        ENTER FILTER PARAMETERS:");
crlf();
flu();
printf("                        ------------------------");
crlf();
printf("FILTER LENGTH:");
flu();
for(i=0;i<20;i++)
{
    let=getch();
    putchar(let);
    flu();
    if(i==0 && (let == '\r' || let == '\n'))             /* first character = CR              */
        goto par;
    karak[i]=let;
    if(i > 0 && (let == '\r' || let == '\n'))
    {
        karak[i]=0xa;
        goto les;
    }
}
les:
sscanf(karak,"%d\n",&nuc);
crlf();
printf("FILTER LOW   :");
flu();
for(i=0;i<20;i++)
{
    let=getch();
    putchar(let);
    flu();
    if(i==0 && (let == '\r' || let == '\n'))             /* first character = CR              */
        goto par;
    karak[i]=let;
    if(i > 0 && (let == '\r' || let == '\n'))
    {
        karak[i]=0xa;
        goto les2;
    }
}
les2:
sscanf(karak,"%f\n",&flow);
crlf();
printf("FILTER HIGH  :");
flu();
for(i=0;i<20;i++)
{
    let=getch();
    putchar(let);
    flu();
    if(i==0 && (let == '\r' || let == '\n'))             /* first character = CR              */
        goto par;
    karak[i]=let;
    if(i > 0 && (let =='\r' || let == '\n')) 
    {
        karak[i]=0xa;
        goto les3;
   }
}
les3:
sscanf(karak,"%f\n",&fhigh);
crlf();
*n=nuc;
*fl=flow;
*fh=fhigh;
}
/*--------------------------------------------------------------------------*/
/* filter type                                                              */
/*--------------------------------------------------------------------------*/
filt_type()
{
int let;
char karak[20];
int i;
int nuc;
//par:
cls_alp();
flu();
printf("                        Enter filter-type:");
crlf();
flu();
printf("                        ------------------");
crlf();
printf("                 Standard (RETURN) or Recursive (r)");
flu();
//let=getch();
let=0x52;
if(let == '\r' || let == '\n')                         /* first character = CR              */
    return(1);
if(let == 0x52 || let == 0x72)         /* recursive                         */
    return(2);
return(-1);                            /* error                             */
}



//////////////////////////////////////////////////////////////////////////
///////////    mouse_test ////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////
//

mouse_test()
{
int off, con_ser;
char txt[80];
if ( !mouse ) return;
term_mouse_handler(NULL);

con_ser = line_typ ();

resized:



arrow(con_ser);
mus(con_ser);

for(;;)
{
    key_press:                      /* remain in this loop until valid char*/
    cmu = term_key();
//           fprintf(phas,"%x\n",cmu);
    if ( (cmu & K_CLASS) == K_MOUSE_EVENT )
    {
        if(cmu== 0x1400)
        {
            cmu=' ';   /* this must be mouse lb,use for zoom */
            return;
        }
        if ( cmu & K_MOUSE_XMASK )
        {
            mus_off(con_ser);
            if ( cmu & K_MOUSE_XMASK == 0 )
            {
                off = 0;
            }
            else
            {
                off = 1 << ( ((cmu & K_MOUSE_XMASK) >> 4)-1 );
            }
            if ( cmu & K_MOUSE_XDIR ) off = -off;

            if ( cmu & K_MOUSE_BLEFT )
            {
/*                term_type( dy, dx, " ", 1, TERM_NORMAL );*/
/*                dx += off;*/
/*                if ( dx > t.num_cols-1 ) dx = t.num_cols-1;*/
/*                if ( dx < 0 ) dx = 0;*/
/*                term_type( dy, dx, "d", 1, TERM_NORMAL );*/
            }else{
                x += off;
                mus(con_ser);

            }
        }
        if ( cmu & K_MOUSE_YMASK )
        {
            mus_off(con_ser);
            if ( cmu & K_MOUSE_YMASK == 0 )
                off = 0;
            else
                off = 1 << ( (cmu & K_MOUSE_YMASK)-1 );
            if ( cmu & K_MOUSE_YDIR ) off = -off;

            if ( cmu & K_MOUSE_BLEFT )
            {
/*                term_type( dy, dx, " ", 1, TERM_NORMAL );*/
/*                dy -= off;*/
/*                if ( dy > t.num_rows-1 ) dy = t.num_rows-1;*/
/*                if ( dy < 0 ) dy = 0;*/
/*                term_type( dy, dx, "d", 1, TERM_NORMAL );*/
            }else{
                y -= off;

                mus(con_ser);

            }
        }
    }else{
/*        term_type( cy, cx, " ", 1, TERM_NORMAL );*/
        
        arrow_off(con_ser);
//           fprintf(phas,"%x \n",cmu);
        switch( cmu )
        {
            case K_UP:
            if ( --y < 0 ) y = 0;
            break;

            case K_DOWN:
            ++y;
            if(++y > 460) y = 460;
/*            if ( ++y > t.num_rows-1 ) y = t.num_rows-1;*/
            break;

            case K_LEFT:
            if ( --x < 0 ) x = 0;
            break;
            case K_RIGHT:

            ++x;
            if( ++x > 600) x = 600;
/*            if ( ++x > t.num_cols-1 ) x = t.num_cols-1;*/
            break;

            case K_RESIZE:
            goto resized;


            case ' ':  /*zoom*/
            mus_off(con_ser);
            return;
            break;

            case 'f':
            case 'F':
               mus_off(con_ser);
               return;
               break;

            case 'p':
            case 'P':
               mus_off(con_ser);
               return;
               break;

           case 's':
           case 'S':
               mus_off(con_ser);
               return;
               break;

//           case 't':                          /* ringbuffer system                 */
//           case 'T':
//               mus_off(con_ser);
//               return;
//               break;

            case 'c':
            case 'C':
               mus_off(con_ser);
               return;
               break;

            case 'q':
            case 'Q':
               mus_off(con_ser);
               return;
               break;

            case 'r':
            case 'R':
               mus_off(con_ser);
               return;
               break;

            case 'b':
            case 'B':
               mus_off(con_ser);
               return;
               break;

            case 'n':
            case 'N':
               mus_off(con_ser);
//               free(matr);
//_heapshrink();

               return;
               break;

            case 't':
            case 'T':
               mus_off(con_ser);
               return;
               break;

            case 'v':
            case 'V':
               mus_off(con_ser);
               return;
               break;

            case 'k':
            case 'K':
               mus_off(con_ser);
               return;
               break;

            case 'l':
            case 'L':
               mus_off(con_ser);
               return;
               break;

            case 'o':
            case 'O':
               mus_off(con_ser);
               return;
               break;
            case 'y':
            case 'Y':
               mus_off(con_ser);
               return;
               break;
            case 'g':
            case 'G':
               mus_off(con_ser);
               return;
               break;

            case 'x':
            case 'X':
/*            term_mouse_handler(term_mouse_default);*/
            return;
            break;  

            default:
            goto key_press;
            break;           
        }   
            arrow(con_ser);
/*			term_type( y, x, "c", 1, TERM_NORMAL );*/
    }
}
}

void mus(int con_ser)
{
int old;
 if (con_ser == 2)
 {
  old=_getcolor();
  save_pix_mus(con_ser);
  _setcolor(14);
  _moveto(x-10,y);
  _lineto(x+10,y);
  _moveto(x,y-10);
  _lineto(x,y+10);
  _setcolor(old);
 }
}
void arrow(int con_ser)
{
int old;
 if (con_ser == 2)
 {
  old=_getcolor();
  save_pix_arrow(con_ser);
  _setcolor(2);
  _moveto(x-10,y);
  _lineto(x+10,y);
  _moveto(x,y-10);
  _lineto(x,y+10);
  _setcolor(old);
 }
}
void arrow_off(int con_ser)
{
int old;
 if (con_ser == 2)
 {
  old=_getcolor();
  _setcolor(0);
  _moveto(x-10,y);
  _lineto(x+10,y);
  _moveto(x,y-10);
  _lineto(x,y+10);
  set_pix_arrow(con_ser);
  _setcolor(old);
 }
}
void mus_off(int con_ser)
{
int old;
 if (con_ser == 2)
 {
  old=_getcolor();
  _setcolor(0);
  _moveto(x-10,y);
  _lineto(x+10,y);
  _moveto(x,y-10);
  _lineto(x,y+10);
  set_pix_mus(con_ser);
  _setcolor(old);
 }
}
void save_pix_arrow(int con_ser)
{
int i;
 if (con_ser)
 {
   for(i=0;i<21;i++)
    aa[i]=_getpixel(x-10+i,y);
   for(i=21;i<42;i++)
    aa[i]=_getpixel(x,y-10+i-21);
 }
}
void save_pix_mus(int con_ser)
{
int i;
 if (con_ser == 2)
 {
   for(i=0;i<21;i++)
    aa[i]=_getpixel(x-10+i,y);
   for(i=21;i<42;i++)
    aa[i]=_getpixel(x,y-10+i-21);
 }
}
void set_pix_arrow(int con_ser)
{
int i;
 if (con_ser == 2)
 {
  for(i=0;i<21;i++)
  {
    _setcolor(aa[i]);
    _setpixel(x-10+i,y);
  }
  for(i=21;i<42;i++)
  {
    _setcolor(aa[i]);
    _setpixel(x,y-10+i-21);
  }
 }
}
void set_pix_mus(int con_ser)
{
int i;
 if (con_ser == 2)
 {
  for(i=0;i<21;i++)
  {
    _setcolor(aa[i]);
    _setpixel(x-10+i,y);
  }
  for(i=21;i<42;i++)
  {
    _setcolor(aa[i]);
    _setpixel(x,y-10+i-21);
  }
 }
}
crlf()
{
putchar(0x0d);
putchar(0x0a);
}
flu()
{
fflush(stdout);
fflush(stdin);
}


plt_spec(con_ser,nyquist,scfac,NN,spec)
float nyquist;
float scfac;
int NN, con_ser;
float spec[];
{
char dum[80];
int i;
    if (con_ser == 2)
    {
        _setcolor(0);
        _rectangle(_GFILLINTERIOR,0+ULX,0+ULY,(int)XL+ULX,(int)YL+ULY);
        _setcolor(15);
        _rectangle(_GBORDER,0+ULX,0+ULY,(int)XL+ULX,(int)YL+ULY);
        _setcolor(0);
        _rectangle(_GFILLINTERIOR,0+ULX,(int)YL+1+ULY,(int)XL+ULX,(int)YL+21+ULY);
        _setcolor(14);
        _moveto(0+ULX,(int)YL+ULY);

        _lineto((int)XL+ULX,(int)YL+ULY);
        if(nyquist <= 25.)
        {
            for(i=0;i<=(int)nyquist;i=i+1)
            {
                _moveto((int) ( (float)i*(XL/nyquist))+ULX,(int)YL+ULY);
                _lineto((int)((float)i*(XL/nyquist))+ULX,(int)YL+5+ULY);
                sprintf(dum,"%2d\n",i);    /* numbers                           */
                _moveto((int) ( (float)i*(XL/nyquist))+ULX-7,(int)YL+ULY+6);
                if(i != 0 && i != 25.)
                    _outgtext(dum);
            }
        }
        for(i=0;i<=(int)nyquist;i=i+10)
        {
            _moveto((int) ( (float)i*(XL/nyquist))+ULX,(int)YL+ULY);
            _lineto((int)((float)i*(XL/nyquist))+ULX,(int)YL+10+ULY);
            sprintf(dum,"%2d\n",i);        /* numbers                           */
            _moveto((int) ( (float)i*(XL/nyquist))+ULX-7,(int)YL+ULY+6);
            if(i != 0 && i != (int)nyquist)
                 _outgtext(dum);
        }
        for(i=0;i<=(int)nyquist;i=i+100)
        {
            _moveto((int) ( (float)i*(XL/nyquist))+ULX,(int)YL+ULY);
            _lineto((int)((float)i*(XL/nyquist))+ULX,(int)YL+20+ULY);
            sprintf(dum,"%2d\n",i);        /* numbers                           */
            _moveto((int) ( (float)i*(XL/nyquist))+ULX-7,(int)YL+ULY+6);
            if(i != 0 && i != (int)nyquist)
                 _outgtext(dum);
        }
        _setcolor(11);
        _moveto(0+ULX,(int)YL+ULY);
        for(i=0;i<=NN/2;i++)
            _lineto(i*scfac+ULX,(int)(spec[i]*YL*-1.+YL)+ULY);
/* terje */
/*    for(i=0;i<=NN/2;i++)*/
/*    {*/
/*        _moveto(i*scfac+ULX,(int)(spec[i]*YL*-1.+YL)+ULY);*/
/*        _lineto(i*scfac+ULX,(int)(YL+ULY));*/
/*    }*/
    }
}

plt_spec_ovl(con_ser,nyquist,scfac,NN,spec)
float nyquist;
float scfac;
int NN, con_ser;
float spec[];
{
char dum[80];
int i;
    if (con_ser == 2)
    {
        _setcolor(14);
        _moveto(0+ULX,(int)YL+ULY);
        for(i=0;i<=NN/2;i++)
            _lineto(i*scfac+ULX,(int)(spec[i]*YL*-1.+YL)+ULY);
/* terje */
/*    for(i=0;i<=NN/2;i++)*/
/*    {*/
/*        _moveto(i*scfac+ULX,(int)(spec[i]*YL*-1.+YL)+ULY);*/
/*        _lineto(i*scfac+ULX,(int)(YL+ULY));*/
/*    }*/
    }
}

one_chan_only()
{
    int con_ser;

    con_ser = line_typ();

    if (con_ser == 2)
    {
      _setvideomode(_DEFAULTMODE);
      cls_alp();                         /* clear and home screen             */
    }
    else gmode (0);
    printf("Only 1 channel at the time for specter !");
    flu();
    crlf();
    printf("Press RETURN to continue...");
    getch();
}
dmx_buf(isamp,nsamp,nchan,ntotal,iworkl)
int isamp;
int nsamp;
int nchan;
int ntotal;
int iworkl[];
{
int i;
int j;
int s;
int bufsiz;
bufsiz=nsamp*nchan+HEADER;
for(i=0;i<nchan;i++)                   /* loop channels                     */
{
    for(j=0;j<nsamp;j++)               /* loop samples                      */
    {
        s=j+isamp*nsamp;
        M2(matr,i,s)=(float)iworkl[j*nchan+i+HEADER];
    }
}
}    
finish_program()
{
    cls_alp();                         /* clear and home screen             */
    crlf();
    printf("Exit Program\n");
    flu();
    crlf();
    exit(0);
}
list_last_nn(lbuf)
char* lbuf;
{
int dpx;
int k;
int curdpx;
int i;
char infile1[80];
float ttotal;
    sscanf(lbuf,"%d",&dpx);            /* read neg no, list last '-n' events*/
    curdpx=Get_Current_DPX();          /* get current DPX number            */
    cls_alp();
    printf("Current DPX:%d",curdpx);
    flu();
    k=curdpx+dpx;
    if(k < 0 && curdpx < EVTSIZ-1)     /* check for backward wrap           */
                                       /* do backward wrap ONLY if the DPX  */
                                       /* number has gone through EVTSIZ    */
                                       /* events once or more.              */
    {
        k=0;                           /* first time through                */
    }else{
        k=curdpx+dpx+1;                /* allow for wrap                    */
    }
    for(i=k;i<curdpx+1;i++)
    {
        dpxnam(i,infile1,&ttotal);
        crlf();
        printf("DPX=%6d %s Duration (seconds):%7.1f",i,infile1,ttotal);
        flu();
    }
}
rngopen(nxt_rbf,in,longf,rngbuf)
int nxt_rbf;
FILE* *in;
char* longf;
char* rngbuf;
{ 
FILE *idx;
char indexrec[400];
int lr;
/*--------------------------------------------------------------------------*/
/* open the index file and find the corresponding ringbuffer name           */
/*--------------------------------------------------------------------------*/
idx=fopen("/home/buffer/idx_log","r");
fseek(idx,nxt_rbf*320,SEEK_SET);
fread(indexrec,320,1,idx);
for(lr=0;lr<20;lr++)
{
    rngbuf[lr]=' ';
    longf[lr]=' ';
}
for(lr=0;lr<18;lr++)
{
    rngbuf[lr]=indexrec[lr];
    longf[lr]=indexrec[lr];
}
rngbuf[18]='\0';
longf[18]='\0';
//printf("current ringbuffer: %s\n",rngbuf);
fclose(idx);
//printf("A\n");
/*--------------------------------------------------------------------------*/
/* open the corresponding ringbuffer file                                   */
/*--------------------------------------------------------------------------*/
if((*in=fopen(rngbuf, "r+"))==NULL)
{
    fprintf(stderr,"DET_EVT: Not able to open %s, error=%d\n",rngbuf,errno);
    exit(1);
}
//printf("B\n");
//printf("C\n");
}
inp_rng(lbuf)
char*    lbuf;
{
char     karak[80];
int      i;
int      nr;
int      let;

printf("Ringbuffer number:");
flu();
for(i=0;i<80;i++)
{
    let=getch();                       /* read character                    */
    if(i== 0 && (let == '\r' || let == '\n'))            /* first character CR ?              */
        return(0);                     /* return to main                    */
    if(i !=0 && (let == '\r' || let == '\n'))            /* later CR ?                        */
        goto tolk;
    putchar(let);                      /* echo character                    */
    flu();
    karak[i]=let;
    lbuf[i]=let;
}
tolk:                                  /* interpret inputstring             */
karak[i]='\0';
lbuf[i]='\0';
/*crlf();*/
/*printf("%s",karak);*/
/*flu();*/
/*crlf();*/
/*printf("I=%d",i);*/
/*flu();*/
if(karak[0]=='-')                      /* negative number ?                 */
{
    sscanf(karak,"%d",&nr);
/*    crlf();*/
/*    printf("NEG=%d",nr);*/
/*    flu();*/
/*    getch();*/
    return(1);
}
if(karak[0] >= '0' && karak[0] <='9')  /* is it a positive number ?         */
{
    sscanf(karak,"%d",&nr);
/*    crlf();*/
/*    printf("POS=%d",nr);*/
/*    flu();*/
/*    getch();*/
    return(2);
}
return(-1);
}

//////////////////////////////////////////////////////////////////////////
///////////    get_tek_input /////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////
//

get_tek_input()
{
  do
  {
    /* do a GIN transaction */
    cmu = do_gin (&x, &y);

    /* convert mouse button press to zoom events */
    if (cmu == 0xf0 || cmu == 0xf1) cmu = ' ';
  } while (! strchr (" fFpPsScCqQrRbBnNtTvVkKlLoOxX", cmu));

}
