/****************************************************************************/
/*                       PC QNX SEISLOG Software              Version 6.0   */
/****************************************************************************/
/*                                                                          */
/*                                      University of Bergen                */
/*                                      Institute of Solid Earth Physics    */
/*                                      Seismological Observatory           */
/*                                      Allegaten 41, 5007 Bergen, Norway   */
/*                                      Tlf. +47 55 213408 +47 55213419     */
/*                                      Fax  +47 55 233337 +47 55320009     */
/*                                      Author: Terje Utheim, Jens Havskov  */
/*                                      E-mail: terje.utheim@ifjf.uib.no    */
/*                                              jens.havskov@ifjf.uib.no    */
/*                                                                          */
/*                                      Date:16/10/95                       */
/* Program:RD_COLOR                                                         */
/*                                                                          */
/* Last update:                                                             */
/*                                                                          */
/* Program description:                                                     */
/*                                                                          */
/* This program reads in the color map defined in COLOR.MAP                 */
/*                                                                          */
/****************************************************************************/

#include   "shar_mem.h"            /* shared buffers,constants etc          */
#include   <stdio.h>
#include   <fcntl.h>
#include   <sys/mman.h>
#include   <stdlib.h>
#include   <string.h>
#include   "filedef.h"

FILE       *in;                    /* Pointer to name of file               */

char       com[80];                /* String text parameterfile             */
char       txt[81];                /* String text parameterfile             */
char        ch;
int     k;
int        i;
main()
{
int      fd;                                /* return value open share      */
smod     *ptr;                              /* pointer to shared region     */
/*--------------------------------------------------------------------------*/
/* open shared memory region                                                */
/*--------------------------------------------------------------------------*/
fd=shm_open("SEISLOG",O_RDWR | O_CREAT, 0777);
if(fd== -1) 
{
    fprintf(stderr,"RD_COLOR_01 open failed:%s\n",strerror(errno));
    exit(1);
}
/*--------------------------------------------------------------------------*/
/* set size of memory region                                                */
/*--------------------------------------------------------------------------*/
ltrunc(fd,sizeof(smod),SEEK_SET);
/*--------------------------------------------------------------------------*/
/* Compute pointer to shared memory region                                  */
/*--------------------------------------------------------------------------*/
ptr=mmap(0,sizeof(smod),PROT_READ | PROT_WRITE,MAP_SHARED,fd,0);
if((int)ptr == -1) 
{
    fprintf(stderr,"RD_COLOR_02 mmap failed : %s\n",strerror(errno));
    exit(1);
}
/*--------------------------------------------------------------------------*/
/* Open color map file                                                      */
/*--------------------------------------------------------------------------*/
in=fopen("/home/seislog/pr/color.map","r");         
for(k=0;k<8;k++)
    Get_Parameter();                   /* Read dummy lines in file          */
Get_Parameter();                       /* Read  1. line                     */
sscanf(com,"%d\n",&ptr->top_hdr_bck_col);
Get_Parameter();                       /* Read  2. line                     */
sscanf(com,"%d\n",&ptr->top_hdr_txt_col);
Get_Parameter();                       /* Read  3. line                     */
sscanf(com,"%d\n",&ptr->top_hdr_brd_col);
Get_Parameter();                       /* Read  4. line                     */
sscanf(com,"%d\n",&ptr->top_hdr_plt_col);
Get_Parameter();                       /* Read  5. line                     */
sscanf(com,"%d\n",&ptr->sid_lab_bck_col);
Get_Parameter();                       /* Read  6. line                     */
sscanf(com,"%d\n",&ptr->sid_lab_txt_col);
Get_Parameter();                       /* Read  7. line                     */
sscanf(com,"%d\n",&ptr->sid_lab_brd_col);
Get_Parameter();                       /* Read  8. line                     */
sscanf(com,"%d\n",&ptr->sid_lab_plt_col);
Get_Parameter();                       /* Read  9. line                     */
sscanf(com,"%d\n",&ptr->plt_are_bck_col);
Get_Parameter();                       /* Read 10. line                     */
sscanf(com,"%d\n",&ptr->plt_are_txt_col);
Get_Parameter();                       /* Read 11. line                     */
sscanf(com,"%d\n",&ptr->plt_are_brd_col);
Get_Parameter();                       /* Read 12. line                     */
sscanf(com,"%d\n",&ptr->plt_are_plt_col);
Get_Parameter();                       /* Read 13. line                     */
sscanf(com,"%d\n",&ptr->tim_sca_bck_col);
Get_Parameter();                       /* Read 14. line                     */
sscanf(com,"%d\n",&ptr->tim_sca_txt_col);
Get_Parameter();                       /* Read 15. line                     */
sscanf(com,"%d\n",&ptr->tim_sca_brd_col);
Get_Parameter();                       /* Read 16. line                     */
sscanf(com,"%d\n",&ptr->tim_sca_plt_col);

fclose(in);
}
/*-----------------------------------------------Start: Get_Parameter---*/
/* Read one line of characters from parameterfile                       */
/*----------------------------------------------------------------------*/
Get_Parameter()
{
for(i=0; (i<80) && ((ch=fgetc(in)) != EOF) && (ch !='\n'); i++)
    com[i]=ch;
com[i]='\0';        
/*printf("%s\n",com);*/
}
/*-----------------------------------------------End: Get_Parameter----*/
