/****************************************************************************/
/*                       PC QNX SEISLOG Software              Version 7.0   */
/****************************************************************************/
/*                                                                          */
/*                                      University of Bergen                */
/*                                      Institute of Solid Earth Physics    */
/*                                      Seismological Observatory           */
/*                                      Allegaten 41, 5007 Bergen, Norway   */
/*                                      Tlf. +47 55583408 +47 55583419      */
/*                                      Fax  +47 55589669                   */
/*                                      Author: Terje Utheim, Jens Havskov  */
/*                                      E-mail: terje.utheim@ifjf.uib.no    */
/*                                              jens.havskov@ifjf.uib.no    */
/*                                                                          */
/*                                      Date:28/03/98                       */
/* Program:RESAMP                                                           */
/*                                                                          */
/* Last update:                                                             */
/*                                                                          */
/* Program description:                                                     */
/*                                                                          */
/* Receives a proxy signal when an aliased filtered buffer is ready         */
/*                                                                          */
/****************************************************************************/     
#include "shar_mem.h"                  /* shared memory definitions         */
#include <sys/mman.h>
#include <sys/dev.h>
#include <fcntl.h>
#include <errno.h>
#include <stdlib.h>
#include <conio.h>
#include <math.h>
#include <graph.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/proxy.h>
#include <sys/kernel.h>
#include <sys/name.h>
#define XL 700.
#define YL 400.
float amp;
int      p;
int      fd;                           /* return value open share           */
smod     *ptr;                         /* pointer to shared region          */
main()
{
pid_t    proxy;
unsigned msg;
int      ret;
int      kan;                          /* channel number to plot            */
int      lp;
int      lc;                        /* Counter                              */
int      ll;                        /* Counter                              */
int      kl;                        /* Counter                              */
int      id;
int      fpl_id;
int      det_evt_id;
unsigned int     cop;
int      c;
unsigned int* ch_ptr;
int      sec_no;                    /* buffer number in pipe just processed */
int      k;
int      i;                            /* Counter                           */
int      skip;           /* Sample skip factor                           */
int      sw;             /* Switch to indicate plotting of station       */
float    yy;
int      ynew,yold;

/*--------------------------------------------------------------------------*/
/* open shared memory region                                                */
/*--------------------------------------------------------------------------*/
fd=shm_open("SEISLOG",O_RDWR | O_CREAT, 0777);
if(fd== -1) 
{
    fprintf(stderr,"RESAMP_01 open failed:%s\n",strerror(errno));
    exit(1);
}
/*--------------------------------------------------------------------------*/
/* set size of memory region                                                */
/*--------------------------------------------------------------------------*/
ltrunc(fd,sizeof(smod),SEEK_SET);
/*--------------------------------------------------------------------------*/
/* Compute pointer to shared memory region                                  */
/*--------------------------------------------------------------------------*/
ptr=mmap(0,sizeof(smod),PROT_READ | PROT_WRITE,MAP_SHARED,fd,0);
if((int)ptr == -1) 
{
    fprintf(stderr,"RESAMP_02 mmap failed : %s\n",strerror(errno));
    exit(1);
}
/*--------------------------------------------------------------------------*/
/* locate DET_EVT                                                           */
/*--------------------------------------------------------------------------*/
det_evt_id=qnx_name_locate(0,"det_evt",0,&cop);
if(det_evt_id == -1)
{
    printf("RESAMP: Can't find DET_EVT. SEISLOG not active\n");
    exit(0);
}
/*--------------------------------------------------------------------------*/
/* attach proxy for the terminal in use                                     */
/*--------------------------------------------------------------------------*/
    proxy=qnx_proxy_attach(0,0,0,-1);
    ptr->resamp_proxy=proxy;
/*--------------------------------------------------------------------------*/
/* attach this process under the name FPL                                   */
/*--------------------------------------------------------------------------*/
    fpl_id=qnx_name_attach(0,"resamp");
    if(fpl_id == -1)
    {
        printf("RESAMP: CONSOLE attach failed. FPL already active on console ?\n");
        exit(0);
    }
printf("Enter p:");
scanf("%d",&p);
printf("Enter amp;");
scanf("%f",&amp);
//p=1;

sw=0;
if(p==1)
{
    _setvideomode(_VRES16COLOR);
    _setcolor(1);
    _rectangle(_GFILLINTERIOR,0,0,(int)XL,(int)YL);
    _setcolor(0);
    _rectangle(_GFILLINTERIOR,0,(int)YL+1,(int)XL,(int)YL+21);
    _setcolor(14);
    _moveto(0,(int)YL);
    _setcolor(15);
    yold=0;
    _moveto(0,yold);
    i=0;
}
for (;;)                               /* enter infinite loop               */
{
    det_evt_id=Receive(0,&msg,sizeof(msg)); /* wait for buffer ready       */
    sec_no=ptr->buf_rdy_fpl;
    id=sec_no;
    if(kbhit())
    {
       getch();
       exit(0);
    }
//printf("%s\n",ptr->rsmp_time);
//printf("%d %d ",id,sw);
    switch(sw)
    {
        case 0:
        if(p==0)
            printf(" %8.3f\n",ptr->rsmp1[0]);
        yy=ptr->rsmp1[0];
        break;
        case 1:
        if(p==0)
            printf(" %8.3f\n",ptr->rsmp2[0]);
        yy=ptr->rsmp2[0];
        break;
    }
    yy=(yy-50000)*amp;
    ynew=(int)yy;    
    if(p==1)
       _lineto(i,yy+200);
    i=i+2;

    id=id % 2;
    sw=(sw+1) % 2;
}                                /* End of indefinite loop              */
}                                    /* End of main                         */






