/****************************************************************************/
/*                       PC QNX SEISLOG Software              Version 7.0   */
/****************************************************************************/
/*                                                                          */
/*                                      University of Bergen                */
/*                                      Institute of Solid Earth Physics    */
/*                                      Seismological Observatory           */
/*                                      Allegaten 41, 5007 Bergen, Norway   */
/*                                      Tlf. +47 55583408 +47 55583419      */
/*                                      Fax  +47 55589669                   */
/*                                      Author: Terje Utheim, Jens Havskov  */
/*                                      E-mail: terje.utheim@ifjf.uib.no    */
/*                                              jens.havskov@ifjf.uib.no    */
/*                                                                          */
/*                                      Date:25/02/98                       */
/* Program:RNG_STS                                                          */
/*                                                                          */
/* Last update:                                                             */
/*                                                                          */
/* Program description:                                                     */
/*                                                                          */
/* Current status of SEISLOG                                                */
/*                                                                          */
/****************************************************************************/     
#include "shar_mem.h"                  /* shared memory definitions         */
#include <sys/mman.h>
#include <fcntl.h>
#include <errno.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/kernel.h>
#include <sys/name.h>
#include <sys/types.h>
#include <sys/proxy.h>
#include <dirent.h>
#include "filedef.h"            /* This file defines the names of the major */
                                /* files for SEISLOG - ring etc..           */
#include "timexrou.h"
#include <math.h>
#include <time.h>
time_t   time_of_day;
int      fd;
smod     *ptr;
int      sec_start;
int      sec_stopp;
main()
{
int      i,j,k,l,m;
/*--------------------------------------------------------------------------*/
/* open shared memory region                                                */
/*--------------------------------------------------------------------------*/
fd=shm_open("SEISLOG",O_RDWR | O_CREAT, 0777);
if(fd== -1) 
{
    fprintf(stderr,"RNG_STS_01 open failed:%s\n",strerror(errno));
    exit(1);
}
/*--------------------------------------------------------------------------*/
/* set size of memory region                                                */
/*--------------------------------------------------------------------------*/
ltrunc(fd,sizeof(smod),SEEK_SET);
/*--------------------------------------------------------------------------*/
/* Compute pointer to shared memory region                                  */
/*--------------------------------------------------------------------------*/
ptr=mmap(0,sizeof(smod),PROT_READ | PROT_WRITE,MAP_SHARED,fd,0);
if((int)ptr == -1) 
{
    fprintf(stderr,"RNG_STS_02 mmap failed : %s\n",strerror(errno));
    exit(1);
}
Upd1_log(ptr);
}
Upd1_log(ptr)
smod* ptr;
{
int  evt_tab[2000];
char idx_log[400];
char rngnam[100];
char start_time[30];
char status[20];
char buf[50];
int iblk;
int  nok;
int  karak;
int  i;
int  k;
int  total;
int  dager,timer,minutter;
int  lf;
int  cnt;
int  events;
int  fil;
int  totalevents;
int  days,hours,minutes;
int  daysmax,hoursmax,minutesmax;
int  lu;
int  maxtime;
FILE *idx;
time_of_day=time(NULL);
iblk=ptr->iblk;
karak=ptr->it_freeze;
nok=ptr->displm;
idx=fopen("/home/buffer/idx_log","r+");
system("/home/seislog/cls");
switch(ptr->clktyp)
{
    case 0:
    sleep(2);
    break;
    case 1:
    sleep(2);
    break;
    case 2:
    sleep(2);
    break;
    case 4:
    sleep(2);
    break;
}
if(ptr->iblk <= iblk)
{
printf("CURRENT STATUS OF RINGBUFFER SYSTEM: NOT ACTIVE     %s",
_ctime(&time_of_day,buf));
}else{
printf("CURRENT STATUS OF RINGBUFFER SYSTEM:     ACTIVE     %s",
_ctime(&time_of_day,buf));
}
printf("----------------------------------------------------------------------------\n");
Start_time(ptr);
Last_Write(ptr);
printf("Total number of files in ringbuffer system_________:%5d\n",
ptr->nringbuf[0]);
printf("Number of minutes per ringbuffer___________________:%5d\n",
ptr->nmin_per_ring[0]);
total=ptr->nringbuf[0] * ptr->nmin_per_ring[0];
dager=total/1440;
timer=(total-(dager*1440))/60;
minutter=total-dager*1440-timer*60;
printf("Total time in ringbuffer system____________________:%3d days %2d hours %2d min\n",
dager,timer,minutter);
days=0;
hours=0;
minutes=0;
totalevents=0;
maxtime=0;
for(k=0;k<ptr->nringbuf[0];k++)
    evt_tab[k]=0;
for(k=0;k<ptr->nringbuf[0];k++)
{
    fseek(idx,k*320,SEEK_SET);
    fread(idx_log,320,1,idx);
    status[0]=idx_log[109];            /* tot events                        */
    status[1]=idx_log[110];
    status[2]=idx_log[111];
    status[3]=idx_log[112];
    status[4]=idx_log[113];
    status[5]=' ';
    sscanf(status,"%d",&events);
    totalevents=totalevents+events;
    if(events != 0)
        evt_tab[k]=events;
//    printf("%3d %3d %3d\n",days,hours,minutes);
}
fclose(idx);
if((int)(idx=fopen("/home/buffer/uptime","r+"))!=NULL)
{
    rewind(idx);
    fread(idx_log,9,1,idx);
    fclose(idx);
    status[0]=idx_log[0];             /* days up                           */
    status[1]=idx_log[1];
    status[2]=idx_log[2];
    status[3]=' ';
    sscanf(status,"%d",&days);
    status[0]=idx_log[4];            /* hours up                          */
    status[1]=idx_log[5];
    status[2]=' ';
    sscanf(status,"%d",&hours);
    status[0]=idx_log[7];            /* minutes up                        */
    status[1]=idx_log[8];
    status[2]=' ';
    sscanf(status,"%d",&minutes);

    printf("SEISLOG has been active for (whole ringbuffers)____:%3d days %2d hours %2d min\n",
    days,hours,minutes);
dager=ptr->var05/86400;
timer=(ptr->var05-(dager*86400))/3600;
minutter=(ptr->var05-dager*86400-timer*3600)/60;
    printf("SEISLOG has been active for a total of_____________:%3d days %2d hours %2d min\n",
    dager,timer,minutter);
    printf("Total number of detections still in ringbuffer_____:%5d\n",totalevents);
}else{
    printf("SEISLOG has NOT been active since__________________: RE_INITI\n");
    printf("Total number of detections still in ringbuffer_____:%5d\n",totalevents);
}
if(ptr->clktyp == 0)
{
        printf("Quality of GPS reception___________________________: CPU clock selected.\n");
}else{
//printf("displm %d nok %d var05 %d\n",ptr->displm,nok,ptr->var05);
    if(ptr->displm > nok)
    {
        switch(ptr->clktyp)
        {
            case 4:
            printf("Quality of MSF reception___________________________:%3d%% SYNCHRONIZED Now IN \n",ptr->percent_gps);
            break;
            case 5:
            printf("Quality of GPS reception___________________________:%3d%% SYNCHRONIZED Now IN \n",(100 * ptr->displm)/ptr->var05);
            break;
            case 7:
            printf("Quality of GPS reception___________________________:%3d%% SYNCHRONIZED Now IN \n",(100 * ptr->displm)/ptr->var05);
            break;
            case 6:
            printf("Quality of GPS reception___________________________:%3d%% SYNCHRONIZED Now IN \n",(100 * ptr->displm*2)/ptr->var05);
            break;
        }
    }else{
        switch(ptr->clktyp)
        {
            case 4:
            printf("Quality of MSF reception___________________________:%3d%% SYNCHRONIZED Now OUT\n",(100 * ptr->displm)/ptr->var05);
            break;
            case 5:
            if(ptr->var05 != 0)
            { 
                printf("Quality of GPS reception___________________________:%3d%% SYNCHRONIZED Now OUT\n",(100 * ptr->displm)/ptr->var05);
            }else{
                printf("Quality of GPS reception___________________________:  0%% SYNCHRONIZED Now OUT\n");
            }
            break;
            case 7:
            printf("Quality of GPS reception___________________________:%3d%% SYNCHRONIZED Now OUT\n",(100 * ptr->displm*2)/ptr->var05);
            break;
            case 6:
            printf("Quality of GPS reception___________________________:%3d%% SYNCHRONIZED Now OUT\n",(100 * ptr->displm*2)/ptr->var05);
            break;
        }
    }
}
if(ptr->clktyp == 0)
{
        printf("Last reception of valid GPS time___________________: CPU clock selected\n");
}else{
    if(ptr->clktyp == 4)
    {
        printf("Last reception of valid MSF time___________________:");
    }else{
        printf("Last reception of valid GPS time___________________:");
    }
    for(lu=0;lu<25;lu++)
        printf("%c",ptr->Timsav[lu]);
    printf("\n");
}
switch(ptr->it_freeze-karak)
{
    case 0:
    printf("NOT RECEIVING characters from GPS\n");
    break;
    default:
    printf("RECEIVING     characters from GPS\n");
    break;
}
cnt=0;
for(k=0;k<ptr->nringbuf[0];k++)
{
    if(evt_tab[k] != 0)
    {
        printf("%5d->%2d",k,evt_tab[k]);
        cnt++;
        if(cnt == 8)
        {
            cnt=0;
            printf("\n");
        }
    }
}
printf("\n");
printf("File:%5d has so far:%3d events\n",ptr->ringidx[0],ptr->events_per_file[ptr->ringidx[0]]);
}
Start_time(ptr)
smod* ptr;
{
char idx_log[400];
char rngnam[100];
char starttid[30];
char buf[50];
int  i;
int  k;
FILE *idx;
for(k=0;k<30;k++)
    starttid[k]=' ';
if((int)(idx=fopen("/home/buffer/start_time","r+"))!=NULL)
{
    rewind(idx);
    fread(starttid,24,1,idx);
    fclose(idx);
    printf("SEISLOG was last time started______________________:");
    for(k=0;k<24;k++)
       printf("%c",starttid[k]);
    printf("\n");
}else{
printf("SEISLOG was last time started______________________:Not yet started\n");
//return(0);
}

}
Last_Write(ptr)
smod* ptr;
{
char idx_log[400];
char rngnam[100];
char starttid[30];
char buf[50];
int  i;
int  k;
FILE *idx;
for(k=0;k<30;k++)
    starttid[k]=' ';
if((int)(idx=fopen("/home/buffer/last_write","r+"))!=NULL)
{
    rewind(idx);
    fread(starttid,28,1,idx);
    fclose(idx);
    printf("Last record written to ringbuffer__");
    for(k=0;k<4;k++)
        printf("%c",starttid[k+24]);
    printf("____________:");
    for(k=0;k<24;k++)
       printf("%c",starttid[k]);
    printf("\n");
}else{
    printf("Last record written to ringbuffer__________________:Not yet started\n");
//return(0);
}

}
