/****************************************************************************/
/*                       PC QNX SEISLOG Software              Version 6.0   */
/****************************************************************************/
/*                                                                          */
/*                                      University of Bergen                */
/*                                      Institute of Solid Earth Physics    */
/*                                      Seismological Observatory           */
/*                                      Allegaten 41, 5007 Bergen, Norway   */
/*                                      Tlf. +47 55 213408 +47 55213419     */
/*                                      Fax  +47 55 233337 +47 55320009     */
/*                                      Author: Terje Utheim, Jens Havskov  */
/*                                      E-mail: terje.utheim@ifjf.uib.no    */
/*                                              jens.havskov@ifjf.uib.no    */
/*                                                                          */
/*                                      Date:19/02/98                       */
/* Program:SAV_VER                                                          */
/*                                                                          */
/* Last update:                                                             */
/*                                                                          */
/* Program description:                                                     */
/*                                                                          */
/* Make tar saveset in /home/"version number directory                      */
/*                                                                          */
/****************************************************************************/
#include <stdio.h>
#include <dirent.h>
#include <time.h>
main()
{
float    vno;                          /* version number                    */
char     syscall[100];
char     dirname[50];
char     savename[50];
char     remname[50];
int      i;
DIR      *dirp;                        /* pointer to directory              */
struct   tm time_of_day;
time_t   ltime;
auto     char com[26];
FILE*    buf;                          /* pointer to file                   */
char     ans;
char     ans1;
input1:
printf("Distribution backup only,        enter D\n");
printf("Distribution backup and saveset, enter B\n"); 
printf("No backup and no saveset,        enter N\n");
printf("QUIT,                            enter Q\n");
printf("OPTION:");
fflush(stdin);
ans=getchar();
switch(ans)
{
    case 'D':
    case 'd':
    ans='D';
    break;
    case 'B':
    case 'b':
    ans='B';
    break;
    case 'Q':
    case 'q':
    exit(0);
    break;
    case 'N':
    case 'n':
    exit(0);
    break;
    default:
    goto input1;
    break;
}
/*--------------------------------------------------------------------------*/
/* check if a file containing version and date already exists               */
/*--------------------------------------------------------------------------*/

if((buf=fopen("/home/seislog/version.lis","r"))!=NULL)
{
    fclose(buf); 
    printf("Current version:\n");
    system("cat /home/seislog/version.lis");   /* print it                  */
    system("rm -f /home/seislog/version.lis"); /* remove it                 */
}   
/*--------------------------------------------------------------------------*/
/* make new one                                                             */
/*--------------------------------------------------------------------------*/
printf("Enter SEISLOG version number:");
scanf("%f",&vno);
/*--------------------------------------------------------------------------*/
/* check if this version exists                                             */
/*--------------------------------------------------------------------------*/
if(ans == 'B')
{
    sprintf(dirname,"/home/V%5.2f",vno);
    if(dirname[7]==' ') dirname[7]='0';
    if(dirname[8]==' ') dirname[8]='0';
    if(dirname[9]==' ') dirname[9]='0';
    if(dirname[10]==' ') dirname[10]='0';
    if(dirname[11]==' ') dirname[11]='0';
    dirp=opendir(dirname);
    if(dirp == NULL)
    {
        printf("SAV_VER: This version does not exist, go on !\n");
    }else{
        printf("Version %s already exists as a saveset.\n",dirname);
        printf("Change version number or use existing saveset.\n");
input2:
        printf("Do you want to replace it (Y/N)?");
        fflush(stdin);
        ans1=getchar();
        switch(ans1)
        {
            case 'Y':
            case 'y':
            ans1='Y';
/* here we need code to remove old saveset */
printf("Old save set will be removed\n");
            remname[0]=dirname[0];
            remname[1]=dirname[1];
            remname[2]=dirname[2];
            remname[3]=dirname[3];
            remname[4]=dirname[4];
            remname[5]=dirname[5];
            remname[6]=dirname[6];
            remname[7]=dirname[7];
            remname[8]=dirname[8];
            remname[9]=dirname[9];
            remname[10]=dirname[10];
            remname[11]=dirname[11];
            remname[12]=dirname[0];
            remname[13]='S';
            remname[14]='L';
            remname[15]='_';
            remname[16]=dirname[6];
            remname[17]=dirname[7];
            remname[18]=dirname[8];
            remname[19]=dirname[9];
            remname[20]=dirname[10];
            remname[21]=dirname[11];
            remname[22]='\0';
            printf("Remove %s\n",remname);
            sprintf(syscall,"rm -f %s",remname);
            system(syscall);
            printf("Remove directory: %s\n", dirname);
            sprintf(syscall,"rmdir %s",dirname);
            system(syscall);
            break;
            case 'N':
            case 'n':
            ans1='N';
            printf("Making a distribution backup only.\n");
            break;
            default:
            goto input2;
            break;
        }
    }
}
time(&ltime);
_localtime(&ltime,&time_of_day);
sprintf(syscall,"Date and time is: %s SEISLOG version: %5.2f\n",
_asctime(&time_of_day,com),vno);
syscall[42]=' ';
if((buf=fopen("/home/seislog/version.lis","w"))!=NULL)
{
    fprintf(buf,"%s\n",syscall);
    fclose(buf); 
}   
/*--------------------------------------------------------------------------*/
/* if a distribution backup is requested or a saveset, this has to be done  */
/*--------------------------------------------------------------------------*/
dirp=opendir("/home/backup");
if(dirp == NULL)
{
    printf("SAV_VER: Backup directory tree does not exist, create it !\n");
/*--------------------------------------------------------------------------*/
/* make directory structure for backup, distribution, installation          */
/*--------------------------------------------------------------------------*/
    system("mkdir /home/backup");
    system("mkdir /home/backup/buffer");
    system("mkdir /home/backup/error");
    system("mkdir /home/backup/save");
    system("mkdir /home/backup/seismo");
    system("mkdir /home/backup/events");
    system("mkdir /home/backup/seislog");
    system("mkdir /home/backup/seislog/pr");
    system("mkdir /home/backup/seislog/digi1");
    system("mkdir /home/backup/seislog/fonts");
    system("mkdir /home/backup/work");
    printf("SAV_VER: New directory tree created.\n");
/*--------------------------------------------------------------------------*/
/* change the access permitions for the new directory structure             */
/*--------------------------------------------------------------------------*/
    system("chmod a+rwx /home/backup");
    system("chmod a+rwx /home/backup/buffer");
    system("chmod a+rwx /home/backup/error");
    system("chmod a+rwx /home/backup/save");
    system("chmod a+rwx /home/backup/seismo");
    system("chmod a+rwx /home/backup/events");
    system("chmod a+rwx /home/backup/seislog");
    system("chmod a+rwx /home/backup/seislog/pr");
    system("chmod a+rwx /home/backup/seislog/digi1");
    system("chmod a+rwx /home/backup/seislog/fonts");
    system("chmod a+rwx /home/backup/work");
    printf("SAV_VER: Access modes changed in new directory structure.\n");
}else{
    printf("SAV_VER: Backup directory tree exists.\n");
}
/*--------------------------------------------------------------------------*/
/* copy  the original .profile files into the new directory structure       */
/*--------------------------------------------------------------------------*/
system("cp /home/seislog/.profile /home/backup/seislog/.profile");
system("cp /home/events/.profile  /home/backup/events/.profile");
system("cp /home/work/.profile    /home/backup/work/.profile");
printf("SAV_VER: All .profile files copied.\n");
/*--------------------------------------------------------------------------*/
/* copy the configuration file for the editor to the user directories       */
/*--------------------------------------------------------------------------*/
system("cp /home/seislog/.vedit.cfg /home/backup/seislog");
system("cp /home/seislog/.vedit.cfg /home/backup/events");
system("cp /home/seislog/.vedit.cfg /home/backup/work");
printf("SAV_VER: Editor configuration file copied.\n");
/*--------------------------------------------------------------------------*/
/* copy all necessary files to backup tree                                  */
/*--------------------------------------------------------------------------*/
system("cp /home/seislog/version.lis /home/backup/seislog/version.lis");
system("cp /home/seislog/*.c /home/backup/seislog");
printf("SAV_VER: All C-files copied.\n");
system("cp /home/seislog/pr/* /home/backup/seislog/pr");
printf("SAV_VER: All parameter files copied.\n");
//system("cp /home/seislog/digi1/*.* /home/backup/seislog/digi1");
//printf("SAV_VER: All DIGI board files copied.\n");
system("cp /home/seislog/fonts/* /home/backup/seislog/fonts");
printf("SAV_VER: All font files copied.\n");
system("cp /home/seislog/*.h /home/backup/seislog");
printf("SAV_VER: All h-files copied.\n");
/*--------------------------------------------------------------------------*/
/* copy makefile for a/d driver to backup tree                              */
/*--------------------------------------------------------------------------*/
system("cp /home/seislog/Makefile /home/backup/seislog");
printf("SAV_VER: Makefile for a/d copied.\n");
/*--------------------------------------------------------------------------*/
/* copy use file for a/d driver                                             */
/*--------------------------------------------------------------------------*/
system("cp /home/seislog/rbo_use.x /home/backup/seislog");
printf("SAV_VER: Use file for a/d driver copied.\n");
printf("\n                            *** BACKUP FINISHED ***\n");
if(ans == 'B')
{
    sprintf(dirname,"/home/V%5.2f",vno);
    if(dirname[7]==' ') dirname[7]='0';
    if(dirname[8]==' ') dirname[8]='0';
    if(dirname[9]==' ') dirname[9]='0';
    if(dirname[10]==' ') dirname[10]='0';
    if(dirname[11]==' ') dirname[11]='0';
    printf("%s\n",dirname);
    dirp=opendir(dirname);
    if(dirp == NULL)
    {
        printf("SAV_VER: This version does not exist, create it !\n");
        sprintf(syscall,"mkdir %s",dirname);
        system(syscall);
        printf("SAV_VER: New version directory created.\n");
        if(chdir("/home/backup") != 0)
            exit(0);
        sprintf(savename,"/SL_V%5.2f",vno);
        if(savename[5]==' ') savename[5]='0';
        if(savename[6]==' ') savename[6]='0';
        if(savename[7]==' ') savename[7]='0';
        if(savename[8]==' ') savename[8]='0';
        if(savename[9]==' ') savename[9]='0';
        for(i=0;i<10;i++)
            dirname[i+12]=savename[i];
        dirname[22]=0x0;
         sprintf(syscall,"tar -cvf %s - .",dirname);
         printf("%s\n",syscall);
        system(syscall);
    }else{
        printf("SAV_VER: This version already exists as a saveset.\n");
        printf("SAV_VER: Change version number or use existing saveset.\n");
    }
}
//system("/home/seislog/qnx_dist");
}