
/****************************************************************************/
/*                       PC QNX SEISLOG Software              Version 6.0   */
/****************************************************************************/
/*                                                                          */
/*                                      University of Bergen                */
/*                                      Institute of Solid Earth Physics    */
/*                                      Seismological Observatory           */
/*                                      Allegaten 41, 5007 Bergen, Norway   */
/*                                      Tlf. +47 55 213408 +47 55213419     */
/*                                      Fax  +47 55 233337 +47 55320009     */
/*                                      Author: Terje Utheim, Jens Havskov  */
/*                                      E-mail: terje.utheim@ifjf.uib.no    */
/*                                              jens.havskov@ifjf.uib.no    */
/*                                                                          */
/*                                      Date:13/10/95                       */
/* Program:SLOG                                                              */
/*                                                                          */
/* Last update:                                                             */
/* 29/05/00 PLOT_BUFFER multiply by 'gain'
/*                                                                          */
/* Program description:                                                     */
/*                                                                          */
/* library of routines for SEISLOG                                          */
/*                                                                          */
/****************************************************************************/  

#include "shar_mem.h"
#include <sys/types.h>
#include <math.h>
#include <stdlib.h>
#include <graph.h>
#include <conio.h>
#include <sys/dev.h>
#include "filedef.h"
#include "timexrou.h"
#define SWAP(a,b) tempr=(a);(a)=(b);(b)=tempr /* for FOUR1 FFT              */

errlog(ptr)
smod*  ptr;
{
#include <time.h>                      
char   idx_log[400];
char   syscall[200];
char   tempo[200];
char   buf[50];
int    err_no;
int    i;
int    k;
int    number;
FILE   *idx;                           /* pointer to err_log file           */ 
FILE   *in;                            /* Pointer to err_no-file            */
FILE   *html;
time_t time_of_day;                    /* structure for time of day         */
if((int)(in = fopen("/home/buffer/err_no","r+")) == ERROR)
    printf("CLN_LNK: Error logging not in operation\n");
fscanf(in,"%d",&err_no);               /* Read old error number             */
number=err_no + 1;                     /* Update error number               */
if(number>=500) number=0;              /* wrap, restart at record 0         */
rewind(in);
fprintf(in,"%8d",number);              /* Write new error-number            */
fclose(in);                            /* Close file                        */
/*--------------------------------------------------------------------------*/
/* open status file ringbuffers                                             */
/*--------------------------------------------------------------------------*/
idx=fopen("/home/buffer/err_log","r+");
if(idx == NULL)
{
    printf("Error opening /home/buffer/err_log\n");
    exit(0);
}
fseek(idx,err_no*80,SEEK_SET);
time_of_day=time(NULL);
sprintf(tempo,"%s",_ctime(&time_of_day,buf));
for(k=0;k<80;k++)                      /* put blancs into error record      */
    idx_log[k]=' ';
sprintf(tempo,"%3d",err_no);           /* put error number into errorrecord */
idx_log[0]=tempo[0];
idx_log[1]=tempo[1];
idx_log[2]=tempo[2];
for(k=0;k<24;k++)                      /* put date and time into errorrecord*/
    idx_log[k+4]=buf[k+4];
idx_log[24]=' ';
for(k=0;k<80;k++)                      /* put blancs into temporary storage */
    tempo[k]=' ';
sprintf(tempo,"%s",ptr->err_msg);      /* print message into temporary      */
for(k=0;k<200;k++)
{
    if(tempo[k]==0x00) tempo[k]=' ';
}
for(k=0;k<53;k++)                      /* put message into error record     */
    idx_log[k+25]=tempo[k];
idx_log[79]='\n';
fwrite(idx_log,80,1,idx);             /* write error record                */
fclose(idx);                           /* close error log                   */
for(k=0;k<100;k++)
{
  if(idx_log[k]==0x0a)
    idx_log[k]=0x20;
  if(idx_log[k]==0x01)
    idx_log[k]=0x20;
  if(idx_log[k]==0x0e)
    idx_log[k]=0x20;
}
//system("cp /home/buffer/err_log /usr/local/apache/htdocs/FILES/err_log");
//if((int)(html = fopen("/usr/webdoc/err_log","a+")) == ERROR)
//    printf("CLN_LNK: Error logging not in operation\n");
//fprintf(html,"%s<br>\n",idx_log);
//fclose(html);
}
/*---------------------------------------------------Start:Assign_err_no----*/
int Assign_err_no(err_no,errfile)
   int* err_no;
   char* errfile;
{
int      number;
FILE     *in;                          /* Pointer to err_log-file           */
if((int)(in = fopen(errfile,"r+")) == ERROR)
         return (ERROR);               /* Open err_log-file                 */
fscanf(in,"%d",err_no);                /* Read old error number             */
number=*err_no + 1;                    /* Update error number               */
if(number>=500) number=0;              /* wrap, restart at record 0         */
rewind(in);
fprintf(in,"%8d",number);              /* Write new error-number            */
fclose(in);                            /* Close file                        */
return (*err_no);
}
/*----------------------------------------------------End:Assign_err_no-----*/

/*--------------------------------------------------------------------------*/
/*           PROGRAM STARTED FROM CONSOLE OR SERIAL LINE ?                  */
/*--------------------------------------------------------------------------*/
/* calling sequence  : con_ser=line_typ();                                  */
/* in calling routine: int con_ser                                          */
/* input             : none                                                 */
/* return value      : integer 1 SERIAL or 2 CONSOLE -1 ERR01 -2 ERR02      */
/*--------------------------------------------------------------------------*/
line_typ()
{
struct   _dev_info_entry info;         /* structure to find terminal type   */
char     typ[10];
static int ret_val = 999;                      /* return value                      */

/* check if we already have the answer */
if (ret_val != 999) return ret_val;

if(dev_info(0,&info)==0)
{
    sprintf(typ,"%s",&info.tty_name[8]);
}else{
    ret_val=-2;                        /* Can't find type of line           */
    return(ret_val);
}
if(typ[0] != 's' && typ[0] != 'c' && typ[0] != 't')     /* check if recognized at all ?      */
{
    ret_val=-1;                        /* Not CONSOLE Not SERIAL.           */
    return(ret_val);
}
if(typ[0]=='s' || typ[0]=='t')                        /* check if 'serial' ?               */
{
    ret_val=1;
    return(ret_val);
}
if(typ[0]=='c')                        /* check if 'console' ?              */
{
    ret_val=2;
    return(ret_val);
}
ret_val = -3;
return(ret_val);
}
/*--------------------------------------------------------------------------*/
/*           CLEAR QNX SCREEN WHEN IN ALPHANUMERIC MODE                     */
/*--------------------------------------------------------------------------*/
/* calling sequence  : cls_alp();                                           */
/* input             : none                                                 */
/* return value      : none                                                 */
/*--------------------------------------------------------------------------*/
cls_alp()
{
  if (line_typ() == 2)
  {
/*--------------------------------------------------------------------------*/
/* home cursor                                                              */
/*--------------------------------------------------------------------------*/
    putchar(0x1b);
    putchar(0x3d);
    putchar(0x20);
    putchar(0x20);
/*--------------------------------------------------------------------------*/
/* clear to end of screen                                                   */
/*--------------------------------------------------------------------------*/
    putchar(0x1b);
    putchar(0x4a);
  }
  else gmode (0);
}
/*--------------------------------------------------------------------------*/
/*                    SET SCREEN INTO GRAPHICS MODE                         */
/*--------------------------------------------------------------------------*/
/* calling sequence  : graphic_mode(con_ser);                               */
/* in calling routine: int con_ser                                          */
/* input             : con_ser 1 SERIAL 2 CONSOLE                           */
/* return value      : none                                                 */
/*--------------------------------------------------------------------------*/
graphic_mode(con_ser)
int con_ser;
{
if(con_ser == 1)
    gmode (1); 
if(con_ser == 2)
    _setvideomode(_VRES16COLOR);
}
/*--------------------------------------------------------------------------*/
/*                    GET KEY PRESSED FROM TERMINAL                         */
/*--------------------------------------------------------------------------*/
/* calling sequence  : key=GetKey(con_ser)                                  */
/* in calling routine: int con_ser                                          */
/* input             : con_ser    1 SERIAL " CONSOLE                        */
/* return value      : code for arrows tab and escape                       */
/*--------------------------------------------------------------------------*/
int GetKey(con_ser)
int      con_ser;
{
int      c;                            /* input character                   */
int      d;                            /* input character                   */
int      left;                         /* characters left in input buffer   */
int      kb;
int      i;
fflush(stdin);                         /* flush input buffer                */
fflush(stdout);                        /* flush output buffer               */

c=getch();                             /* Read 1 character from keyboard    */
if(con_ser==2)                         /* CONSOLE                           */
{
    switch(c)                          /* what character pressed ?          */
    {
        case 0xff:                     /* multi byte character              */
        d=getch();                     /* read another character            */
        switch(d)                      /* what character is this ?          */
        {
            case 0xa1:                 /* ARROW UP                          */
            return(1);
            break;
            case 0xa9:                 /* ARROW DOWN                        */
            return(2);
            break;
            case 0xa6:                 /* ARROW RIGHT                       */
            return(3);
            break;
            case 0xa4:                 /* ARROW LEFT                        */
            return(4);
            break;
        }            
        break;
        case 0x09:                     /* TAB                               */
        return(6);
        break;
        case 0x1b:                     /* ESCAPE                            */
        return(5);
        default:
        break;
    }
}
if(con_ser==1)                         /* SERIAL                            */
{
for(i=0;i<100000;i++)
    kb=i;
/*printf("1. %x\n",c);*/
    switch(c)                          /* what character pressed ?          */
    {
        case 0x1b:                     /* Escape or multibyte string        */
        left=kbhit();                  /* check if more characters in buffer*/
        if(left!=0)                    /* more charaters ?                  */
        {                              /* yes.........                      */
            d=getch();                 /* get next charater                 */
/*printf("2. %x\n",d);*/
            d=getch();                 /* get next charater                 */
/*printf("3. %x\n",d);*/
            switch(d)                  /* what charater ?                   */
            {
                case 0x41:
                return(1);             /* ARROW UP                          */
                break;
                case 0x42:          
                return(2);             /* ARROW DOWN                        */
                break;
                case 0x43:
                return(3);             /* ARROW RIGHT                       */
                break;
                case 0x44:
                return(4);             /* ARROW LEFT                        */
                break;
            }
        }else{                         /* No more characters in buffer      */
            return(5);                 /* ESCAPE                            */
        }
        break;
        case 0x09:
        return(6);                     /* TAB                               */
        break;
    }
}
return(c);
}
/*--------------------------------------------------------------------------*/
/*            CLEAR SCREEN AND SET SCREEN INTO ALFANUMERIC MODE             */
/*--------------------------------------------------------------------------*/
/* calling sequence  : clr_scr(con_ser);                                    */
/* in calling routine: int con_ser                                          */
/* input             : con_ser 1 SERIAL 2 CONSOLE                           */
/* return value      : none                                                 */
/*--------------------------------------------------------------------------*/
clr_scr(con_ser)
int con_ser;
{
if(con_ser == 1)                       /* SERIAL terminal ?                 */
{
    gmode (0);
}else{
    _clearscreen(_GCLEARSCREEN);
}
}
/*--------------------------------------------------------------------------*/
/*                        PLOT HEADER BOX                                   */
/*--------------------------------------------------------------------------*/
/* calling sequence  : plt_hdr_box(ptr,con_ser)                             */
/* in calling routine: int con_ser                                          */
/* input             : ptr        pointer to shared memory                  */
/*                   : con_ser    1 SERIAL 2 CONSOLE                        */
/* return value      : none                                                 */
/*--------------------------------------------------------------------------*/
plt_hdr_box(ptr,con_ser)
smod*    ptr;
int      con_ser;
{
if(con_ser == 1)                       /* SERIAL terminal ?                 */
{
    move(0,780);
    draw(1000,780);
    draw(1000,715);
    draw(0,715);
    draw(0,780);
}else{
    _setcolor(ptr->top_hdr_bck_col);
    _rectangle(_GFILLINTERIOR,0,0,640,45);
    _setcolor(ptr->top_hdr_brd_col);
    _rectangle(_GBORDER,0,0,639,45);
}
}
/*--------------------------------------------------------------------------*/
/*                        PREPARE PLOT AREA                                 */
/*--------------------------------------------------------------------------*/
/* calling sequence  : plt_plt_box(ptr,con_ser,fnt_no);                     */
/* in calling routine: int con_ser,fnt_no                                   */
/* input             : ptr        pointer to shared memory                  */
/*                   : con_ser    1 SERIAL 2 CONSOLE                        */
/*                   : fnt_no     font number for text in header box        */
/* return value      : none                                                 */
/*--------------------------------------------------------------------------*/
plt_plt_box(ptr,con_ser,fnt_no)
smod*    ptr;
int      con_ser;
int      fnt_no;
{
if(con_ser == 1)                       /* SERIAL terminal ?                 */
{
    move(0,715);
    draw(1000,715);
    draw(1000,40);
    draw(0,40);
    draw(0,715);
}else{
    _setcolor(ptr->plt_are_bck_col);
    _rectangle(_GFILLINTERIOR,0,46,640,461);
    _setcolor(ptr->plt_are_brd_col);
    _rectangle(_GBORDER,0,46,639,461);
}
}
/*--------------------------------------------------------------------------*/
/*                        PREPARE PLOT AREA                                 */
/*--------------------------------------------------------------------------*/
/* calling sequence  : plt_plt_box(ptr,con_ser,fnt_no);                     */
/* in calling routine: int con_ser,fnt_no                                   */
/* input             : ptr        pointer to shared memory                  */
/*                   : con_ser    1 SERIAL 2 CONSOLE                        */
/*                   : fnt_no     font number for text in header box        */
/* return value      : none                                                 */
/*--------------------------------------------------------------------------*/
plt_plt_box2(ptr,con_ser,fnt_no)
smod*    ptr;
int      con_ser;
int      fnt_no;
{
if(con_ser == 1)                       /* SERIAL terminal ?                 */
{
    move(0,715);
    draw(1000,715);
    draw(1000,40);
    draw(0,40);
    draw(0,715);
}else{
    _setcolor(0);
    _rectangle(_GFILLINTERIOR,0,46,640,461);
    _setcolor(ptr->plt_are_brd_col);
    _rectangle(_GBORDER,0,46,639,461);
}
}
/*--------------------------------------------------------------------------*/
/*                     PRINT TIME FIRST BUFFER ON PLOT                      */
/*--------------------------------------------------------------------------*/
/* calling sequence  : time(ptr,fnt_no,con_ser);                            */
/* in calling routine: int con_ser,fnt_no + pointer ptr                     */
/* input             : ptr        pointer to shared memory                  */
/*                   : fnt_no     font number for text in header box        */
/*                   : con_ser    1 SERIAL 2 CONSOLE                        */
/* return value      : none                                                 */
/*--------------------------------------------------------------------------*/
Time(ptr,fnt_no,con_ser)
smod* ptr;
int   fnt_no;
int   con_ser;
{
short    l;
char     as[80];
char     buf[10];

for(l=0;l<31;l++)                      /* extract time string               */
    as[l]=ptr->timcpy[l];
as[l]='\0';
if(con_ser == 1)                       /* SERIAL ?                          */
{
    text(5,755,as);
}else{                                 /* CONSOLE                           */ 
    _setcolor(ptr->top_hdr_txt_col);   /* set text color                    */
    sprintf(buf,"n%d",fnt_no);         /* select the font                   */
    _setfont(buf);                     /* set the font                      */
    _moveto(4,1);                      /* move to start point time string   */
    _outgtext(as);                     /* print text                        */
}
}
/*--------------------------------------------------------------------------*/
/*                     PRINT TIME FIRST BUFFER ON PLOT                      */
/*--------------------------------------------------------------------------*/
/* calling sequence  : time(ptr,&seconds);                                  */
/* in calling routine: int con_ser,fnt_no + pointer ptr                     */
/* input             : ptr        pointer to shared memory                  */
/*                   : seconds    second value of first buffer incl msec    */
/* return value      : none                                                 */
/*--------------------------------------------------------------------------*/
Time1(ptr,seconds)
smod* ptr;
float *seconds;
{
int ik;
char time[15];
float sekunder;

for(ik=0;ik<14;ik++)
    time[ik]=ptr->timcpy[ik+6];
sscanf(time,"%f6.3",&sekunder);
*seconds=sekunder;
}

timscale(ptr,con_ser,msec,secdot,number,sekhel,delta,upper,fnt_no)
smod*    ptr;
int      con_ser;
float msec;
float secdot;
int   number;
int   sekhel;
int   delta;
int   upper;
int   fnt_no;
{
int sectel;
int l;
float xfl;
int  x;
int sw;
float d_sec;
int xst;
int yst;
sectel=sekhel;
xst=80;
yst=upper+number*delta;

plt_tim_box(ptr,con_ser,number,delta,upper,xst,yst,fnt_no);

if (con_ser == 2)
{
  _setcolor(ptr->tim_sca_plt_col);
  _moveto(xst,yst);
  _lineto(639,yst);
  d_sec=1./secdot;
  _moveto(xst,yst);
  xfl=(float)xst;
  xfl=xfl+(1.-msec)/secdot;
  x=(int)xfl;
  sectel=sectel+1;
  sw=(sectel % 10);
  _lineto(x,yst);
  if(sw != 0)
  {
    _lineto(x,yst+8);
  }else{
    _lineto(x,yst+12);
    _lineto(x,yst-4);
  }
  _moveto(x,yst);
  for(l=1;l<640;l++)
  {
    sectel=sectel+1;
    sw=(sectel % 10);
    xfl=xfl+d_sec;
    x=(int)xfl;
    if(x>=639)
        return(0);
    _lineto(x,yst);
    if(sw != 0)
    {
        _lineto(x,yst+8);
    }else{
        _lineto(x,yst+12);
        _lineto(x,yst-4);
    }
    _moveto(x,yst);
  }
}
return(0); /* terje*/
}


plt_tim_box(ptr,con_ser,number,delta,upper,xst,yst,fnt_no)
smod*    ptr;
int      con_ser;
int      number;
int      delta;
int      upper;
int      xst;
int      yst;
int      fnt_no;
{
char     as[20];
char     buf[10];
/*--------------------------------------------------------------------------*/
/* small box for time label                                                 */
/*--------------------------------------------------------------------------*/
if (con_ser == 2)
{
  _setcolor(ptr->tim_sca_bck_col);
  _rectangle(_GFILLINTERIOR,0,upper+delta*2+1,79,upper+delta*2+14);
  _setcolor(ptr->tim_sca_brd_col);
  _rectangle(_GBORDER,0,upper+delta*2+1,79,upper+delta*2+14);
/*--------------------------------------------------------------------------*/
/* put text label into box                                                  */
/*--------------------------------------------------------------------------*/
  sprintf(buf,"n%d",fnt_no);             /* set fonts                         */
  _setfont(buf);                         /* select font                       */
  sprintf(as,"seconds\0");
  _moveto(5,upper+delta*2);
  _setcolor(ptr->tim_sca_txt_col);
  _outgtext(as);
/*--------------------------------------------------------------------------*/
/* box for time scale tick marks                                            */
/*--------------------------------------------------------------------------*/
  _setcolor(ptr->plt_are_bck_col);
  _rectangle(_GFILLINTERIOR,xst+1,yst-4,638,yst-1);
 _setcolor(ptr->tim_sca_bck_col);
  _rectangle(_GFILLINTERIOR,xst,yst,639,yst+14);
  _setcolor(ptr->tim_sca_brd_col);
  _rectangle(_GBORDER,xst,yst,639,yst+14);
}
}

keyread()
{
int left;
int c;
    fflush(stdin);
    fflush(stdout);
    left=kbhit();
    if(left==0) return(0);
    c=getch();                    /* Read 1 character from terminal         */
    if(c != 0xff && c != 0x1b)
    {
        if(c == 0x09)
        {
            printf("TAB either terminal\n");
        }else{
 /*           printf("KAR:%c\n",c);*/
              return(99);
        }
     }else{
        left=kbhit();
        if(left == 0)
        {
            printf("ESC on VT100\n");
        }else{
            if(c == 0xff)
            {
                c=getch();
                switch(c)
                {
                    case 0xa1:
 /*                   printf("QNX :UP\n");*/
                    return(10);
                    break;
                    case 0xa9:
/*                    printf("QNX :DOWN\n");*/
                    return(20);
                    break;
                    case 0xa6:
/*                    printf("QNX :RIGHT\n");*/
                    return(30);
                    break;
                    case 0xa4:
/*                    printf("QNX :LEFT\n");*/
                    return(40);
                    break;
                }
            }else{
                c=getch();
                c=getch();
                switch(c)
                {
                    case 0x41:
                    printf("VT100:UP\n");
                    break;
                    case 0x42:
                    printf("VT100:DOWN\n");
                    break;
                    case 0x43:
                    printf("VT100:RIGHT\n");
                    break;
                    case 0x44:
                    printf("VT100:LEFT\n");
                    break;
                }
            }
        }
    }        
return(0);
}
/*--------------------------------------------------------------------------*/
/*                       PREPARE NEW SCREEN FOR PLOT (DPL)                  */
/*--------------------------------------------------------------------------*/
/* calling seq.  : NewPage(ptr,offset,chan,factor,skip,ix,iy,con_ser,fnt_no)*/
/* in calling routine:                                                      */
/* input             : ptr        pointer to shared memory                  */
/*                   : offset     signal offset                             */
/*                   : chan       channel to plot                           */
/*                   : factor     to multiply signal (for scaling)          */
/*                   : skip       number of samples to skip                 */
/*                   : ix,iy      current coordinate                        */
/*                   : con_ser    1 SERIAL 2 CONSOLE                        */
/*                   : fnt_no     font number for text in header box        */
/* return value      : none                                                 */
/*--------------------------------------------------------------------------*/
NewPage(ptr,offset,chan,factor,skip,ix,iy,con_ser,fnt_no,weight,gain)
smod*    ptr;
int      offset;
int      chan;
float    factor;
int      skip;
int      *ix;
int      *iy;
int      con_ser;
int      fnt_no;
float    weight;
float    gain;
{        
char     as[50];                       /* String for graphic print          */
char     buf[10];                      /* help string for fonts             */
char     a[10];                        /* help string station               */
char     b[10];                        /* help string component             */
int      i;                            /* counter                           */
int      secs;
int      intvalue;
int      old_color;                    /* save current color                */
float    value;
if(con_ser==1)                         /* SERIAL terminal ?                 */
{
    sprintf(as,"PRESS ANY KEY TO STOP PROGRAM");
    text(600,10,as);

    /*** new code 22/08/00 DJS ***/
    if (gain < 0.0)
		value = gain * -1.0;
	else

        value=25./(25./(factor*weight)) /gain;
    sprintf(as,"+%8.1f counts",value);
    text(30,689,as);
    sprintf(as,"-%8.1f counts",value);
    text(30,586,as);
    pltscale(ptr,con_ser);
    cntscale(ptr,con_ser);
    *ix=10;
    *iy=650;
    move(*ix,*iy);
    *ix=*ix+1;
}else{                                 /* CONSOLE terminal                  */
    sprintf(buf,"n%d",fnt_no);         /* select the font                   */
    _setfont(buf);                     /* set font to use                   */
    _setcolor(ptr->plt_are_txt_col);   /* set new color for text            */

    /*** new code 22/08/00 DJS ***/
    if (gain < 0.0)
		value = gain * -1.0;
	else

	    value=25./(25./(factor*weight)) /gain;
    sprintf(as,"+%8.1f cnt",value);
    _moveto(16,47);                    /* move to start point text string   */
    _outgtext(as);                     /* print out text                    */
    sprintf(as,"-%8.1f cnt",value);
    _moveto(16,96);                    /* move to start point text          */
    _outgtext(as);                     /* print out text                    */
    pltscale(ptr,con_ser);             /* plot scale for time               */
    cntscale(ptr,con_ser);             /* plot scale for amplitude          */
    *ix=10;
    *iy=80;
    _moveto(*ix,*iy);
    *ix=*ix+1;
}
}
/*--------------------------------------------------------------------------*/
/*                       PREPARE NEW SCREEN FOR PLOT (FPL)                  */
/*--------------------------------------------------------------------------*/
/* calling seq.  : NewPage2(ptr,con_ser,fnt_no,offset,chan,factor,skip,increm,number,delta,ystart,upper)*/
/* in calling routine:                                                      */
/* input             : ptr        pointer to shared memory                  */
/*                   : offset     signal offset                             */
/*                   : chan       channel to plot                           */
/*                   : factor     to multiply signal (for scaling)          */
/*                   : skip       number of samples to skip                 */
/*                   : ix,iy      current coordinate                        */
/*                   : con_ser    1 SERIAL 2 CONSOLE                        */
/*                   : fnt_no     font number for text in header box        */
/* return value      : none                                                 */
/*--------------------------------------------------------------------------*/
NewPage2(ptr,con_ser,offset,kan,fnt_no,skip,increm,number,delta,upper)
smod* ptr;
int   con_ser;
int   offset;
int   kan;
int   fnt_no;
int   skip;
float increm;
int   number;
int   delta;
int   upper;
{
int   secs;
int   intvalue;
int   sekhel;
float sekflo;
float seconds;
float msec;
float sectot;
float secdot;
if(con_ser == 1)                       /* SERIAL ?                          */
{
}else{                                 /* CONSOLE                           */
    Time1(ptr,&seconds);
    sekhel=(int)seconds;
    sekflo=(float)sekhel;
    msec=seconds-sekflo;
    sectot=(560/(ptr->rate*increm))*(skip+1);/* seconds pr screen           */
    secdot=sectot/560.;                /* seconds pr pixel                  */

    pltscale(ptr,con_ser);
    timscale(ptr,con_ser,msec,secdot,number+1,sekhel,delta,upper,fnt_no);
    return(0);
}
return(0);  /* TERJE */
}
/*--------------------------------------------------------------------------*/
/*                       FILL HEADER BOX WITH INFO                          */
/*--------------------------------------------------------------------------*/
/* calling sequence  : fill_hdr_box(ptr,offset,kan,increm,skip,con_ser,fnt_no)*/
/* in calling routine:                                                      */
/* input             : ptr        pointer to shared memory                  */
/*                   : offset     signal offset                             */
/*                   : kan        channel to plot                           */
/*                   : increm     scaling time axis                         */
/*                   : skip       number of samples to skip                 */
/*                   : con_ser    1 SERIAL 2 CONSOLE                        */
/*                   : fnt_no     font number for text in header box        */
/* return value      : none                                                 */
/*--------------------------------------------------------------------------*/
fill_hdr_box(ptr,offset,kan,increm,skip,con_ser,fnt_no)
smod*    ptr;
int      offset;
int      kan;
float    increm;
int      skip;
int      con_ser;
int      fnt_no;
{        
char     as[50];                       /* String for graphic print          */
char     as2[20];
char     as3[20];
char     buf[10];                      /* help string for fonts             */
char     a[10];                        /* help string station               */
char     b[10];                        /* help string component             */
int      i;                            /* counter                           */
float    secs;                         /* total number of seconds pr 100 pix*/
int      intvalue;

Time(ptr,fnt_no,con_ser);              /* print out time of first block     */
if(con_ser==1)                         /* SERIAL terminal ?                 */
{
    sprintf(as,"PRESS ANY KEY TO STOP PROGRAM");
    text(600,10,as);
    for(i=0;i<4;i++)
        as2[i]=ptr->compon[(kan-1)*4+i];
    as2[4]='\0';
    for(i=0;i<4;i++)
        as3[i]=ptr->statio[(kan-1)*4+i];
    as3[4]='\0';
    sprintf(as,"Channel:%2d  Station: %s  Comp.: %s",kan,as3,as2);
    text(400,755,as);
    sprintf(as,"DC offset: %4d",offset);
    text(5,730,as);

    secs=(250*(skip+1))/ptr->rate;
    sprintf(as,"%4.1f seconds",secs);
    text(750,730,as);
    pltscale(ptr,con_ser);
}else{                                 /* CONSOLE terminal                  */
    sprintf(as,"PRESS ANY KEY TO STOP PROGRAM\n");
    sprintf(buf,"n%d",fnt_no);         /* select the font                   */
    _setfont(buf);                     /* set font to use                   */
    _moveto(380,465);                  /* move to start point for text      */
    _setcolor(ptr->top_hdr_brd_col);   /* set color                         */
    _outgtext(as);                     /* print text                        */
    for(i=0;i<4;i++)                   /* extract station and component code*/
    {
        a[i]=ptr->statio[(kan-1)*4+i];
        b[i]=ptr->compon[(kan-1)*4+i];
    }
    a[4]='\0';
    b[4]='\0';
    sprintf(as,"Channel: %2d    Station:  %s   Component:  %s",kan,a,b);
    _setcolor(ptr->top_hdr_txt_col);   /* set new color for text            */
    _moveto(330,1);                    /* move to start point for text      */
    _outgtext(as);                     /* print text string                 */

    sprintf(as,"DC offset: %4d",offset);
    _moveto(4,23);                     /* move to start point text string   */
    _setcolor(ptr->top_hdr_txt_col);   /* set new color for text            */
    _outgtext(as);                     /* print out text                    */
    secs=(100*(skip+1))/(ptr->rate*increm);/* number of seconds/100 points  */
    sprintf(as,"%4.1f seconds",secs);
    _moveto(505,23);                   /* move to start point text string   */
    _setcolor(ptr->top_hdr_txt_col);   /* set new color for text            */
    _outgtext(as);                     /* print out text                    */
    pltscale(ptr,con_ser);             /* plot scale for time               */
}
}


/*--------------------------------------------------------------------------*/
/*                   FILL SIDE LABEL BOX WITH INFO                          */
/*--------------------------------------------------------------------------*/
/* calling sequence  : fill_sid_lab(ptr,offset,kan,factor,skip,ix,iy,con_ser,fnt_no)*/
/* in calling routine:                                                      */
/* input             : ptr        pointer to shared memory                  */
/*                   : offset     signal offset                             */
/*                   : kan        channel to plot                           */
/*                   : factor     to multiply signal (for scaling)          */
/*                   : skip       number of samples to skip                 */
/*                   : ix,iy      current coordinate                        */
/*                   : con_ser    1 SERIAL 2 CONSOLE                        */
/*                   : fnt_no     font number for text in header box        */
/* return value      : none                                                 */
/*--------------------------------------------------------------------------*/
fill_sid_lab(ptr,con_ser,number,factor,fnt_no,delta,upper,offset,kan,weight)
smod*    ptr;
int      con_ser;
int      number;
float    factor;
int      fnt_no;
int      delta;
int      upper;
int      offset;
int      kan;
float    weight;
{
int      i;
float    value;
char     as[50];
char     buf[10];
if (con_ser == 2)
{
  sprintf(buf,"n%d",fnt_no);
  _setfont(buf);
  for(i=0;i<(number+1);i++)
  {
    value=100./(100./(factor*weight)); /* max/min value on screen window    */
    _setcolor(ptr->sid_lab_txt_col);
    sprintf(as,"+%8.1f\n",value);
    _moveto(2,i*delta+upper);
    _outgtext(as);
    sprintf(as,"-%8.1f\n",value);
    _moveto(2,i*delta+upper+delta-15);
    _outgtext(as);
  }
  _setcolor(ptr->sid_lab_plt_col);
  _moveto(80,delta/2+upper);             /* zero line first trace             */
  _lineto(70,delta/2+upper);
  _moveto(80,delta/2+upper+delta);       /* zero line second trace            */
  _lineto(70,delta/2+upper+delta);
  _moveto(80,delta/4+upper);
  _lineto(75,delta/4+upper);
  _moveto(80,(delta/4)*3+upper);
  _lineto(75,(delta/4)*3+upper);
  _moveto(80,(delta/4)*5+upper);
  _lineto(75,(delta/4)*5+upper);
  _moveto(80,(delta/4)*7+upper);
  _lineto(75,(delta/4)*7+upper);

  sprintf(as,"Original\n");
 _moveto(10,delta/2+upper-7); 
  _outgtext(as);
  sprintf(as,"  Data\n");
  _moveto(10,delta/2+upper-7+14);
  _outgtext(as);

  sprintf(as,"Filtered\n");
  _moveto(10,delta/2+delta+upper-12);
  _outgtext(as);
  sprintf(as,"  Data\n");
  _moveto(10,delta/2+delta+upper-12+14);
  _outgtext(as);

  sprintf(buf,"n%d",64);
  _setfont(buf);



  sprintf(as,"FL:%8.4f\n",ptr->fltlo[0][kan-1]);
  _moveto(4,delta/2+delta+upper-12+14+20);
  _outgtext(as);
  sprintf(as,"FH:%8.4f\n",ptr->flthi[0][kan-1]);
  _moveto(4,delta/2+delta+upper-12+14+20+14);
  _outgtext(as);

  sprintf(as,"Poles:%2d\n",ptr->cset[0][kan-1]);
  _moveto(4,delta/2+delta+upper-12+14+20+14+14);
  _outgtext(as);
  sprintf(buf,"n%d",fnt_no);
  _setfont(buf);
}
}
/*--------------------------------------------------------------------------*/
/*                        PLOT SCALE FOR TIME AXIS                          */
/*--------------------------------------------------------------------------*/
/* calling sequence  : pltscale(ptr,con_ser);                               */
/* in calling routine: int con_ser                                          */
/* input             : ptr        pointer to shared memory                  */
/*                   : con_ser    1 SERIAL 2 CONSOLE                        */
/* return value      : none                                                 */
/*--------------------------------------------------------------------------*/
pltscale(ptr,con_ser)
smod*    ptr;
int      con_ser;
{
    if(con_ser == 1)                   /* SERIAL ?                          */
    {
        move(700,740);
        draw(700,720);
        draw(950,720);                 /* 250 points for serial             */
        draw(950,740);
    }else{                             /* CONSOLE                           */
        _setcolor(ptr->top_hdr_plt_col);
        _moveto(500,30);
        _lineto(500,41);
        _lineto(600,41);               /* 100 points for console            */
        _lineto(600,30);
   }
}
/*--------------------------------------------------------------------------*/
/*                    GENERATE FILTER COEFFICIENTS                          */
/*--------------------------------------------------------------------------*/
/* calling sequence  : bandps(n,c,fl,fh,srate;                              */
/* in calling routine:                                                      */
/* input             : n     filter length in samples                       */
/*                   : c     array to hold coefficients (static float c)    */
/*                   : fl    low cut frequency                              */
/*                   : fh    high cut frequency                             */
/*                   : srate samplerate in seconds                          */
/* return value      : none                                                 */
/*--------------------------------------------------------------------------*/
bandps(lc,c,fl,fh,ts)
int lc;
float c[];
float fl;
float fh;
float ts;
{
float fb;
float h;
float f;
float p1;
float p2;
float p3;
int i;
float sn;
float si;

fb=fh-fl;
h=fb/2.;
f=fl+h;
p1=3.14159;
p2=p1*2.*h*ts;
p3=p1*2.*f*ts;
sn=lc-1;
c[1]=4.*h*ts;
for(i=2;i<lc;i++)
{
    si=i-1;
    c[i]=2.*sin(p2*si)*cos(p3*si)*(1.-si/sn)/(p1*si);
}
}
/*--------------------------------------------------------------------------*/
/*                    BANDPASS FILTER ARRAY                                 */
/*--------------------------------------------------------------------------*/
/* calling sequence  : filt1(ls,x,y,n,c)                                 */
/* in calling routine:                                                      */
/* input             : ls    number of samples                              */
/*                   : x     input array (static float x)                   */
/*                   : y     output array (static float y)                  */
/*                   : c     array to hold coefficients (static float c)    */
/* return value      : none                                                 */
/*--------------------------------------------------------------------------*/
filt1(lx,x,y,lc,c)
int lx;
float x[];
float y[];
int lc;
float c[];
{
int ll;
int l;
int j;
int jj;
int i;
int dum;

ll=lc-1;
l=lx-ll;
for(j=0;j<l;j++)
{
    y[j]=x[j]*c[0];
    if(j >= lc)
       goto two;
    for(i=0;i<ll;i++)
        y[j]=y[j]+c[i+1]*x[j+i];
    if(j == 0)
        goto four;
    jj=j-1;
    for(i=0;i<jj;i++)
        y[j]=y[j]+c[i+1]*x[j-i];
    goto four;
two:
    for(i=0;i<ll;i++)
        y[j]=y[j]+c[i+1]*(x[j+i]+x[j-i]);
four:
dum=0;
}
l=l+1;
for(i=l;i<lx;i++)
    y[i]=0.;
}


/*--------------------------------------------------------------------------*/
/*                    PLOT SCALE FOR AMPLITUDE AXIS                         */
/*--------------------------------------------------------------------------*/
/* calling sequence  : cntscale(ptr,con_ser);                               */
/* in calling routine: int con_ser                                          */
/* input             : ptr        pointer to shared memory                  */
/*                   : con_ser    1 SERIAL 2 CONSOLE                        */
/* return value      : none                                                 */
/*--------------------------------------------------------------------------*/
cntscale(ptr,con_ser)
smod*    ptr;
int      con_ser;
{
    if(con_ser == 1)                   /* SERIAL ?                          */
    {
        move(25,700);
        draw(10,700);
        draw(10,600);
        draw(25,600);
    }else{
        _setcolor(ptr->plt_are_plt_col);
        _moveto(15,55);
        _lineto(10,55);
        _lineto(10,105);
        _lineto(15,105);
    }
}
/*--------------------------------------------------------------------------*/
/*                       PLOT ONE SCREEN OF SIGNAL                          */
/*--------------------------------------------------------------------------*/
/* calling sequen: plot_buffer(con_ser,ptr,jump,factor,offset,chan,ix,iy,id)*/
/* input             : con_ser    1 SERIAL 2 CONSOLE                        */
/*                   : ptr        pointer to shared memory                  */
/*                   : jump       samples to skip                           */
/*                   : factor     factor to multiply samples                */
/*                   : offset     signal offset                             */
/*                   : chan       channel to plot                           */
/*                   : ix,iy      coordinate to plot                        */
/*                   : id         buffer to plot                            */
/* return value      : page       switch to indicate new page               */
/*--------------------------------------------------------------------------*/
plot_buffer(con_ser,ptr,jump,factor,offset,chan,ix,iy,id,gain,weight)
int      con_ser;
smod*    ptr;
int      jump;
float    factor;
int      offset;
int      chan;
int      *ix;
int      *iy;
int      id;
float    gain;
float    weight;
{
int      lp;                           /* counter                           */
float    value;                        /* amplitude                         */
int      intval;                       /* amplitude                         */
int      y_val;                        /* new amplitude                     */
int      npage;                        /* page switch                       */

npage=0;
if(con_ser == 1)                       /* SERIAL terminal ?                 */
{
    for(lp=0;lp<ptr->bufsiz;lp=lp+jump) /* plot one buffer, one channel     */
    {
        if(*ix > 1000)                 /* new line ?                        */
        {                              /* YES                               */
            *ix=10;                    /* reset x-value to start of line    */
            *iy=*iy-110;               /* add one line to y-values          */
            if(*iy < 70)               /* check if bottom of screen ?       */
            {                          /* YES bottom of screen              */
                npage=1;               /* indicate new page                 */
                return(npage);         /* start all over                    */
            }
            move(*ix,*iy+intval);      /* NO not bottom of screen           */
            *ix=*ix+1;                 /* increment x-values                */
        }                              /* NO not new line                   */
        value=(float)ptr->ibuf[id][lp+HEADER+chan-1]-offset;

        /*** new code 22/08/00 DJS ***/
        if (gain < 0.0)
	  	   value = (value * 100.0) / (gain * -2.0);
  	    else

            value=value * (50./(factor*weight))*gain;
        intval=(int)value;

        draw(*ix,intval+*iy);
        *ix=*ix+1;
    }
    return(npage);
}else{
    _setcolor(ptr->plt_are_plt_col);
    for(lp=0;lp<ptr->bufsiz;lp=lp+jump) /* plot one buffer, one channel     */
    {
        value=(float)ptr->ibuf[id][lp+HEADER+chan-1]-offset;

        /*** new code 22/08/00 DJS ***/
        if (gain < 0.0)
	  	   value = (value * 50.0) / (gain * -2.0);
  	    else

           value=value * (25./(factor*weight))*gain;
        value=value* -1.0;
        intval=(int)value;
        y_val=intval+*iy;
        if(y_val < 47)
            y_val=47;
        if(y_val > 459)
            y_val=459;
        _lineto(*ix,y_val);
        *ix=*ix+1;
        if(*ix > 640)                  /* new line ?                        */
        {                              /* YES                               */
            *ix=10;                    /* reset x-value to start of line    */
            *iy=*iy+60;                /* add one line to y-values          */
            if(*iy > 450)              /* check if bottom of screen ?       */
            {                          /* YES bottom of screen              */
                npage=1;               /* indicate new page                 */
                return(npage);         /* start all over                    */
            }
            _moveto(*ix,*iy+intval);   /* NO not bottom of screen           */
//            _moveto(*ix,(y_val+intval));   /* NO not bottom of screen           */
            *ix=*ix+1;                 /* increment x-values                */
        }                              /* NO not new line                   */
    }
    return(npage);
}
}
/*--------------------------------------------------------------------------*/
/*                       PLOT SIDE LABEL BOX                                */
/*--------------------------------------------------------------------------*/
/* calling sequen: plot_buffer(ptr,con_ser,fnt_no,upper,delta,number)       */
/* input             : ptr        pointer to shared memory                  */
/*                   : con_ser    1 SERIAL 2 CONSOLE                        */
/*                   : fnt_no     font number                               */
/*                   : upper      start point under top header              */
/*                   : delta      total plot area vertical in pixels/3      */
/*                   : number     number of channels                        */
/* return value      : page       switch to indicate new page               */
/*--------------------------------------------------------------------------*/
plt_sid_box(ptr,con_ser,fnt_no,upper,delta,number)
smod*    ptr;
int      con_ser;
int      fnt_no;
int      upper;
int      delta;
int      number;
{
int      kk;
if (con_ser == 2)
{
  _setcolor(ptr->sid_lab_bck_col);
  _rectangle(_GFILLINTERIOR,0,upper,80,upper+delta*(number+1));
  _setcolor(ptr->sid_lab_brd_col);
  _rectangle(_GBORDER,0,upper,80,upper+delta*(number+1));
  for(kk=0;kk<2;kk++)
  {
    _moveto(0,upper+kk*delta);
    _lineto(80,upper+kk*delta);
  }
}
}
/*--------------------------------------------------------------------------*/
/*                       FAST FOURIER TRANSFORM                             */
/*Numerical Recepies in C W.H.Press,B.P.Flannery,S.A.Teukolsky,W.T.Vettering*/
/*--------------------------------------------------------------------------*/
/* calling sequence  : four1(data,nn,isign)                                 */
/* input             : data       real array of 2*nn                        */
/*                   : nn         number of complex numbers                 */
/*                   : isign      1 transform -1 inverse transform          */
/* output            : data       nn frequency components replaces input    */
/* return value      : none                                                 */
/*--------------------------------------------------------------------------*/
void four1(data,nn,isign)
float data[];
int nn,isign;
{
int n,mmax,m,j,istep,i;
double wtemp,wr,wpr,wpi,wi,theta;
float tempr,tempi;
n=nn << 1;
j=1;
for(i=1;i<n;i+=2)
{
    if(j > i)
    {
       SWAP(data[j],data[i]);
       SWAP(data[j+1],data[i+1]);
    }
    m=n >> 1;
    while(m >= 2 && j > m)
    {
        j -= m;
        m >>= 1;
    }
    j +=m;
}
mmax=2;
while(n > mmax)
{
    istep=2*mmax;
    theta=6.28318530717959/(isign*mmax);
    wtemp=sin(0.5*theta);
    wpr = -2.0*wtemp*wtemp;
    wpi = sin(theta);
    wr = 1.0;
    wi = 0.0;
    for(m=1;m<mmax;m+=2)
    {
        for(i=m;i<=n;i+=istep)
        {
            j=i+mmax;
            tempr=wr*data[j]-wi*data[j+1];
            tempi=wr*data[j+1]+wi*data[j];
            data[j]=data[i]-tempr;
            data[j+1]=data[i+1]-tempi;
            data[i] +=tempr;
            data[i+1] +=tempi;
       }
       wr=(wtemp=wr)*wpr-wi*wpi+wr;
       wi=wi*wpr+wtemp*wpi+wi;
    }
    mmax=istep;
}
}
/*--------------------------------------------------------------------------*/
/*           EXTRACT AND COMPUTE SPECTER OF FAST FOURIER TRANSFORM          */
/*--------------------------------------------------------------------------*/
/* calling sequence  : ex_spec(data,nn,spec)                                */
/* input             : data       real array of 2*nn                        */
/*                   : nn         number of complex numbers                 */
/* output            : spec       nn/2 numbers of specter data              */
/* return value      : none                                                 */
/*--------------------------------------------------------------------------*/
void ex_spec(data,nn,spec)
float    data[];                       /* transformed data                  */
int      nn;                           /* number if complex numbers         */
float    spec[];                       /* specter data                      */
{
int      n;                            /* counter                           */

spec[0]=sqrt(data[1]*data[1]+data[2]*data[2]);
for(n=3;n<=nn+1;n += 2)
    spec[(n-1)/2]=sqrt(data[n]*data[n]+data[n+1]*data[n+1]);
}




#define ESC 0x1b
#define ENQ 0x05
#define FF  0x0c

int mouse_x;
int mouse_y;

void draw(x,y)
int x,y;
 {
    putchar(((y & 0x3e0) >> 5)+0x20);
    putchar((y & 0x1f)+0x60);
    putchar(((x & 0x3e0) >> 5)+0x20);
    putchar((x & 0x1f)+0x40);
 }

void move(x,y)
int x,y;
 {
    putchar(0x1d);
    putchar(((y & 0x3e0) >> 5)+0x20);
    putchar((y & 0x1f)+0x60);
    putchar(((x & 0x3e0) >> 5)+0x20);
    putchar((x & 0x1f)+0x40);
 }

void line_style (litype)
int litype;
 {
    putchar (ESC);
    switch (litype)
    {
        case 1: putchar (0x60);
                break;
        case 2: putchar ('a');
                break;
        case 3: putchar ('b');
                break;
        case 4: putchar ('c');
                break;
        case 5: putchar ('d');
                break;
        case 6: putchar ('e');
                break;
        case 7: putchar ('f');
                break;
        case 8: putchar ('g');
    }
  }





void in_graph()
{
  putchar(0x1b);  /* Clear screen  */
  putchar(0x0c);

  putchar(0x1d);  /* Enter in graphics mode  */
  putchar(0x1f);
}

void out_graph()
 {
  putchar(0x1b);
  putchar(0x0c);
}

void gmode (flag)
int flag;
{
  if (flag)
  {
    printf ("%c[?38h", 27);			/* WYSE terminal TEK mode select */
    printf ("%c%%!0", 27);			/* TEK (and emu-tek) mode select */
    printf ("%c%c", 27, 12);		/* Kermit mode select and clear screen */
  }
  else
  {
    printf ("%c[?38l", 27);			/* WYSE terminal ANSI mode select */
    printf ("%c%%!1", 27);			/* TEK (and emu-tek) mode select */
    printf ("%c%c%c", 27, 12, 24);	/* Kermit mode select and clear screen */
    printf ("%c", 12);				/* form-feed (cheap clear screen) */
  }
  fflush (stdout);
}

int do_gin (int *x, int *y)
{

  int key_press, x_hi, x_lo, y_hi, y_lo;

  /* flush any waiting input data and put terminal in GIN mode */
  fflush (stdout);
  while (kbhit ()) getch ();
  printf ("%c%c%c", 31, 27, 26);
  fflush (stdout);

  /* get GIN data */
  key_press = getch ();
  x_hi = getch  ();
  x_lo = getch  ();
  y_hi = getch  ();
  y_lo = getch  ();

  /* i don't know why this works, but it seems to be required on
   * some terminals */
  printf ("   ");
  fflush (stdout);

  /* cancel bypass mode and flush any incoming data -
   * there may be a terminator on the GIN data to get rid of */
  printf ("%c", 31);
  fflush (stdout);
  while (kbhit ()) getch ();

  /* convert encoded cross-hair to x,y */
  *x = ((x_hi - 0x20) << 5) | (x_lo - 0x20);
  *y = ((y_hi - 0x20) << 5) | (y_lo - 0x20);

  return key_press;
}

void cursor_on()
 {
   putchar(0x1b);
   putchar(0x1a);               /* ch cursor on */
}

void small_text (flag)
int flag;
{
  putchar (27);
  putchar (flag ? ':' : '8');
}

void text (x,y,buff)
 int x,y;
 char *buff;
 {
  move(x,y);
  putchar(0x1f);
  printf("%s",buff);
}

void cursor(key,x,y)
char *key;
int *x,*y;
{
    int i,buttons,j,k;
    float rx,ry,escx,escy;
    char buff[5];
    char c,cc;
    int out2,fdes,outold;

/*     out2=dup(1);
     close(1);
     if((fdes=creat("garbage",S_IFMT|S_IWRITE))!=-1)
     {
     write(out2,fdes,2);
     c=getchar();
*/
/*     stdin->_flag |= _UNBUF;*/
     while (((k=getchar()) & 0x00ff) ==0)    /* get char from keyboard buffer */
        {
        switch((k & 0xff00) >> 8)
            {
            case(72):       /* up */
                fn_call(1,2,1,1);
                break;
            case(71):       /* up left */
                fn_call(1,3,1,1);
                break;
            case(75):       /* left */
                fn_call(1,4,1,1);
                break;
            case(79):       /* left down */
                fn_call(1,5,1,1);
                break;
            case(80):       /* down */
                fn_call(1,6,1,1);
                break;
            case(81):       /* right down */
                fn_call(1,7,1,1);
                break;
            case(77):       /* right */
                fn_call(1,0,1,1);
                break;
            case(73):       /* right up */
                fn_call(1,1,1,1);
                break;
            }
        }
     *key=k;
     j=0;
     while ((c=getchar()) !=0x0d) buff[j++]=c;
     *x=(((buff[0] & 0x1f) << 5) + (buff[1] & 0x1f));
     *y=(((buff[2] & 0x1f) << 5) + (buff[3] & 0x1f));
/*   close(fdes);
     outold=dup(out2);
    }
    else printf ("Error al crear el canal");
*/     putchar(0x1f);
}


fn_call(m1,m2,m3,m4)
        int m1,m2,m3,m4;
        {
        putchar(1);
        putchar(m1);
        putchar(m2);
        putchar(m3);
        putchar(m4);
        }

/*
   Package for general recursion filtering; taken from SAC recursion
   filtering package written by Dave Harris (Copyright, Lawrence
   Livermore National Laboratory);  Converted to C then cleaned
   up with some modification by Bob Crosson, 5/91.  Copyright notice
   from original code follows:

    Copyright 1990  Regents of the University of California
    Author:  Dave Harris
        Lawrence Livermore National Laboratory
        L-205
        P.O. Box 808
        Livermore, CA  94550
        USA
        (415) 423-0617

  GENERAL:  There are two external routines in this package that are
  available to the user: "design", and "apply".  The first
  function builds the appropriate filter coefficients according to
  the users specifications, and stores them in static variables within
  the package.  The second function does the actual recursive filtering
  using the specified filter.  Whenever a filter must be changed, a
  new call to the "design" function must be made; otherwise repeated
  filtering of new data may be carried out efficiently with the current
  filter by calling "apply" whenever a new series is to be filtered.
  See the Livermore document for the filter package: XAPIIR for more
  details on the design and use of these filters (Fortran version).

  USAGE:

  design(iord, type, aproto, a, trbndw, fl, fh, ts)

    int iord:      number of poles for filter (< 10; preferably < 5)
    char *type:    "LP" for low pass (SAC default = LP)
                   "HP" for high pass
                   "BP" for band pass
                   "BR" for band reject
    char *proto:   "BU" for Butterworth (SAC default = BU)
                   "BE" for Bessel
                   "C1" for Chebyshev type 1
                       "C2" for Chebyshev type 2
    float a:       Chebyshev stop band attenuation (ignored for others)
                   (SAC uses 30.0 for the default)
    float trbndw:  Chebyshev transition bandwidth (ignored for others)
                   (SAC uses 0.3 for the default)
    float fl:      high pass corner freq. (ignored if type LP)
                   (SAC default = 0.5)
    float fh:      low pass corner freq. (ignored if type HP)
                   (SAC default = 5.0)
    float ts:      time sample interval in secs (e.g.,0.01 = 100 samp/sec)
                   (SAC default = 0.01)

   apply(data, ndata, zp)

    float data[]:  input data array
    int ndata:     length of data
    int zp:        = 1 (TRUE) for zero phase filtering;
                   = 0 (FALSE) for normal forward filtering
*/

#include <string.h>
#include <stdio.h>
/*#include <math.h>*/
#define MIN(a,b) ((a) <= (b) ? (a) : (b))
#define MAX(a,b) ((a) >= (b) ? (a) : (b))
#define ABS(a) ((a) >= (0) ? (a) : -(a))
#define TRUE 1
#define FALSE 0

float sn[MAXPOL*3+1],sd[MAXPOL*3+1];

static int nsects;


typedef struct {float r, i;} complex;

/* Table of constant values */
static float c_b12 = 2.;
static complex c_b43 = {1.,0.};
/*static float sn[50],sd[50];*/
/*static int nsects;*/

/* Local function prototypes */
static double warp();
static int chebparm(), lptbp(), lptbr(), lpthp(), bilin2(), lp();
static int c1roots(), c2roots();
static int cutoffs(), beroots(), buroots();
static complex cmul(), cpowi(), csqrt(), conjg(), cdiv();

/*  Subroutine to apply an iir filter to a data sequence. */
/*    The filter is assumed to be stored as second order sections. */
/*    Filtering is in-place. */
/*    Zero-phase (forward and reverse) is an option. */
/*  Input Arguments: */
/*  ---------------- */
/*    DATA                           Array containing data */
/*    NSAMPS                         Number of data samples */
/*    ZP                             Logical variable, true for */
/*                                     zero phase filtering, false */
/*                                     for single pass filtering */
/*  Output Arguments: */
/*  ----------------- */
/*    DATA                          Data array (same as input) */

void apply(data,  nsamps,  zp)
float *data;
int nsamps;
int zp;
{
    /* System generated locals */
    int i__1, i__2;

    /* Local variables */
    int jptr, i, j;
    float b0, b1, b2, a1, a2, x1, x2, y1, y2, output;

    /* Parameter adjustments */
    --data;

    /* Function Body */
    jptr = 1;
    i__1 = nsects;
    for (j = 1; j <= i__1; ++j) {
    x1 = (float)0.;
    x2 = (float)0.;
    y1 = (float)0.;
    y2 = (float)0.;
    b0 = sn[jptr];
    b1 = sn[jptr + 1];
    b2 = sn[jptr + 2];
    a1 = sd[jptr + 1];
    a2 = sd[jptr + 2];
    i__2 = nsamps;
    for (i = 1; i <= i__2; ++i) {
        output = b0 * data[i] + b1 * x1 + b2 * x2;
        output -= a1 * y1 + a2 * y2;
        y2 = y1;
        y1 = output;
        x2 = x1;
        x1 = data[i];
        data[i] = output;
    }
    jptr += 3;
    }
    if (zp) {
    jptr = 1;
    i__1 = nsects;
    for (j = 1; j <= i__1; ++j) {
        x1 = (float)0.;
        x2 = (float)0.;
        y1 = (float)0.;
        y2 = (float)0.;
        b0 = sn[jptr];
        b1 = sn[jptr + 1];
        b2 = sn[jptr + 2];
        a1 = sd[jptr + 1];
        a2 = sd[jptr + 2];
        for (i = nsamps; i >= 1; --i) {
        output = b0 * data[i] + b1 * x1 + b2 * x2;
        output -= a1 * y1 + a2 * y2;
        y2 = y1;
        y1 = output;
        x2 = x1;
        x1 = data[i];
        data[i] = output;
        }
        jptr += 3;
    }
    }
    return;
}

/*  Subroutine to design IIR digital filters from analog prototypes. */
/*  Input Arguments: */
/*  ---------------- */
/*    IORD                Filter order (10 MAXIMUM) */
/*    TYPE                Character*2 variable containing filter type */
/*                          LOWPASS (LP) */
/*                          HIGHPASS (HP) */
/*                          BANDPASS (BP) */
/*                          BANDREJECT (BR) */
/*   APROTO              Character*2 variable designating analog prototype*/
/*                          Butterworth (BU) */
/*                          Bessel (BE) */
/*                          Chebyshev Type I (C1) */
/*                          Chebyshev Type II (C2) */
/*    A                   Chebyshev stopband attenuation factor */
/*    TRBNDW              Chebyshev transition bandwidth (fraction of */
/*                          lowpass prototype passband width) */
/*    FL                  Low-frequency cutoff */
/*    FH                  High-frequency cutoff */
/*    TS                  Sampling interval (in seconds) */
/*  Output Arguments: */
/*  ----------------- */
/*    SN                  Array containing numerator coefficients of */
/*                        second-order sections packed head-to-tail. */
/*    SD                  Array containing denominator coefficients */
/*                        of second-order sections packed head-to-tail. */

void design( iord, type,aproto,  a,trbndw,  fl,  fh,  ts)
int iord;
char *type;
char *aproto;
float a;
float trbndw;
float fl;
float fh;
float ts;
{
    /* System generated locals */
    float r__1;

    /* Local variables */
    complex p[10], z[10];
    char stype[3*10];
    float omegar, ripple;
    float fhw, eps, flw, dcvalue;

    /*  Analog prototype selection */

    if (strncmp(aproto, "BU", 2) == 0) {
    buroots(p, stype, &dcvalue, iord);
    } else if (strncmp(aproto, "BE", 2) == 0) {
    beroots(p, stype, &dcvalue, iord);
    } else if (strncmp(aproto, "C1", 2) == 0) {
    chebparm(a, trbndw, iord, &eps, &ripple);
    c1roots(p, stype, &dcvalue, iord, &eps);
    } else if (strncmp(aproto, "C2", 2) == 0) {
    omegar = trbndw + (float)1.;
    c2roots(p, z, stype, &dcvalue, iord, a, omegar);
    }

    /*  Analog mapping selection */

    if (strncmp(type, "BP", 2) == 0) {
    r__1 = fl * ts / (float)2.;
    flw = warp(&r__1, &c_b12);
    r__1 = fh * ts / (float)2.;
    fhw = warp(&r__1, &c_b12);
    lptbp(p, z, stype, &dcvalue, &flw, &fhw);
    } else if (strncmp(type, "BR", 2) == 0) {
    r__1 = fl * ts / (float)2.;
    flw = warp(&r__1, &c_b12);
    r__1 = fh * ts / (float)2.;
    fhw = warp(&r__1, &c_b12);
    lptbr(p, z, stype, &dcvalue, &flw, &fhw, &sn[1], &sd[1]);
    } else if (strncmp(type, "LP", 2) == 0) {
    r__1 = fh * ts / (float)2.;
    fhw = warp(&r__1, &c_b12);
    lp(p, z, stype, &dcvalue, &sn[1], &sd[1]);
    cutoffs(&sn[1], &sd[1], &fhw);
    } else if (strncmp(type, "HP", 2) == 0) {
    r__1 = fl * ts / (float)2.;
    flw = warp(&r__1, &c_b12);
    lpthp(p, z, stype, &dcvalue, &sn[1], &sd[1]);
    cutoffs(&sn[1], &sd[1], &flw);
    }

    /*  Bilinear analog to digital transformation */
    bilin2(&sn[1], &sd[1]);

    return;
}

/* BUROOTS -- SUBROUTINE TO COMPUTE BUTTERWORTH POLES FOR */
/*   NORMALIZED LOWPASS FILTER */
/* LAST MODIFIED:  SEPTEMBER 7, 1990 */
/*  OUTPUT ARGUMENTS: */
/*  ----------------- */
/*      P              COMPLEX ARRAY CONTAINING POLES */
/*                       CONTAINS ONLY ONE FROM EACH */
/*                       COMPLEX CONJUGATE PAIR, AND */
/*                       ALL REAL POLES */
/*      RTYPE          CHARACTER ARRAY INDICATING 2ND ORDER SECTION */
/*                       TYPE: */
/*                         (SP)  SINGLE REAL POLE */
/*                         (CP)  COMPLEX CONJUGATE POLE PAIR */
/*                         (CPZ) COMPLEX CONJUGATE POLE-ZERO PAIRS */
/*      DCVALUE        MAGNITUDE OF FILTER AT ZERO FREQUENCY */
/*  INPUT ARGUMENTS: */
/*  ---------------- */
/*      IORD           DESIRED FILTER ORDER */

static int buroots(p,rtype, dcvalue, iord)
complex *p;
char *rtype;
float *dcvalue;
int iord;
{
    /* System generated locals */
    int i__1, i__2;
    double d__1, d__2;
    complex q__1;

    /* Local variables */
    int half, k;
    float angle, pi;

    /* Parameter adjustments */
    rtype -= 3;
    --p;

    /* Function Body */
    pi = (float)3.14159265;

    half = iord / 2;

    /* TEST FOR ODD ORDER, AND ADD POLE AT -1 */

    nsects = 0;
    if (half << 1 < iord) {
    p[1].r = (float)-1., p[1].i = (float)0.;
    strncpy(rtype + 3, "SP", 2);
    nsects = 1;
    }
    i__1 = half;
    for (k = 1; k <= i__1; ++k) {
    angle = pi * ((float) ((k << 1) - 1)/(float) (iord << 1)+(float).5);
    ++(nsects);
    i__2 = nsects;
    d__1 = cos(angle);
    d__2 = sin(angle);
    q__1.r = d__1, q__1.i = d__2;
    p[i__2].r = q__1.r, p[i__2].i = q__1.i;
        strncpy(rtype + nsects * 3, "CP", 2);
    }
    *dcvalue = (float)1.;
    return TRUE;
}

/*  CHEBPARM - Calculates Chebyshev type I and II design parameters */
/*  INPUT ARGUMENTS */
/*  --------------- */
/*       A                Desired stopband attenuation */
/*                          i.e. max stopband amplitude is 1/ATTEN */
/*       TRBNDW           Transition bandwidth between stop and passbands */
/*                          as a fraction of the passband width */
/*       IORD             Filter order (number of poles) */
/*  OUTPUT ARGUMENTS */
/*  ---------------- */
/*       EPS              Chebyshev passband parameter */
/*       RIPPLE           Passband ripple */

static int chebparm(a, trbndw, iord, eps, ripple)
float a, trbndw;
int iord;
float *eps, *ripple;
{
    /* System generated locals */
    float r__1, r__2;

    /* Local variables */
    float g, alpha, omegar;

    omegar = trbndw + 1.;
    /* Computing 2nd power */
    r__2 = omegar;
    r__1 = omegar + sqrt(r__2 * r__2 - 1.);
    alpha = pow((double)r__1, (double)iord);
    /* Computing 2nd power */
    r__1 = alpha;
    g = (r__1 * r__1 + (float)1.) / (alpha * (float)2.);
    /* Computing 2nd power */
    r__1 = a;
    *eps = sqrt(r__1 * r__1 - (float)1.) / g;
    /* Computing 2nd power */
    r__1 = *eps;
    *ripple = (float)1. / sqrt(r__1 * r__1 + (float)1.);

    return TRUE;
}

/* C1ROOTS -- SUBROUTINE TO COMPUTE CHEBYSHEV TYPE I POLES FOR */
/*   NORMALIZED LOWPASS FILTER */
/* LAST MODIFIED:  SEPTEMBER 7, 1990 */
/*  OUTPUT ARGUMENTS: */
/*  ----------------- */
/*      P              COMPLEX ARRAY CONTAINING POLES */
/*                       CONTAINS ONLY ONE FROM EACH */
/*                       COMPLEX CONJUGATE PAIR, AND */
/*                       ALL REAL POLES */
/*      RTYPE          CHARACTER ARRAY INDICATING 2ND ORDER SECTION */
/*                       TYPE: */
/*                         (SP)  SINGLE REAL POLE */
/*                         (CP)  COMPLEX CONJUGATE POLE PAIR */
/*                         (CPZ) COMPLEX CONJUGATE POLE-ZERO PAIRS */
/*      DCVALUE        RESPONSE OF FILTER AT ZERO FREQUENCY */
/*  INPUT ARGUMENTS: */
/*  ---------------- */
/*      IORD           DESIRED FILTER ORDER */
/*      EPS            CHEBYSHEV PARAMETER RELATED TO PASSBAND RIPPLE */

static int c1roots(p, rtype, dcvalue, iord, eps)
complex *p;
char *rtype;
float *dcvalue;
int iord;
float *eps;
{
    /* System generated locals */
    int i__1, i__2;
    float r__1;
    double d__1;
    complex q__1;

    /* Local variables */
    int half;
    float c;
    int i;
    float gamma, s, angle, omega, sigma, pi;

    /* Parameter adjustments */
    rtype -= 3;
    --p;

    /* Function Body */
    pi = (float)3.14159265;
    half = iord / 2;

    /*  INTERMEDIATE DESIGN PARAMETERS */

    gamma = (sqrt(*eps * *eps + (float)1.) + (float)1.) / *eps;
    gamma = log(gamma) / (float) (iord);
    gamma = exp(gamma);
    s = (gamma - (float)1. / gamma) * (float).5;
    c = (gamma + (float)1. / gamma) * (float).5;

    /*  CALCULATE POLES */

    nsects = 0;
    i__1 = half;
    for (i = 1; i <= i__1; ++i) {
    strncpy(rtype + i * 3, "CP", 2);
    angle = (float) ((i << 1) - 1) * pi / (float) (iord << 1);
    sigma = -(double)s * sin(angle);
    omega = c * cos(angle);
    i__2 = i;
    q__1.r = sigma, q__1.i = omega;
    p[i__2].r = q__1.r, p[i__2].i = q__1.i;
    ++(nsects);
    }
    if (half << 1 < iord) {
    strncpy(rtype + (half + 1) * 3, "SP", 2);
    i__1 = half + 1;
    d__1 = -(double)s;
    q__1.r = d__1, q__1.i = (float)0.;
    p[i__1].r = q__1.r, p[i__1].i = q__1.i;
    ++(nsects);
    *dcvalue = (float)1.;
    } else {
    /* Computing 2nd power */
    r__1 = *eps;
    *dcvalue = (float)1. / sqrt(r__1 * r__1 + 1);
    }
    return TRUE;
}

/* C2ROOTS -- SUBROUTINE TO COMPUTE ROOTS FOR NORMALIZED LOWPASS */
/*   CHEBYSHEV TYPE 2 FILTER */
/* LAST MODIFIED:  SEPTEMBER 7, 1990 */
/*  OUTPUT ARGUMENTS: */
/*  ----------------- */
/*      P              COMPLEX ARRAY CONTAINING POLES */
/*                       CONTAINS ONLY ONE FROM EACH */
/*                       COMPLEX CONJUGATE PAIR, AND */
/*                       ALL REAL POLES */
/*      Z              COMPLEX ARRAY CONTAINING ZEROS */
/*                       CONTAINS ONLY ONE FROM EACH */
/*                       COMPLEX CONJUGATE PAIR, AND */
/*                       ALL REAL ZEROS */
/*      RTYPE          CHARACTER ARRAY INDICATING 2ND ORDER SECTION */
/*                       TYPE: */
/*                         (SP)  SINGLE REAL POLE */
/*                         (CP)  COMPLEX CONJUGATE POLE PAIR */
/*                         (CPZ) COMPLEX CONJUGATE POLE-ZERO PAIRS */
/*      DCVALUE        MAGNITUDE OF FILTER AT ZERO FREQUENCY */
/*  INPUT ARGUMENTS: */
/*  ---------------- */
/*      IORD           DESIRED FILTER ORDER */
/*      A              STOPBAND ATTENUATION FACTOR */
/*      OMEGAR         CUTOFF FREQUENCY OF STOPBAND */
/*                     PASSBAND CUTOFF IS AT 1.0 HERTZ */

static int c2roots(p, z, rtype, dcvalue, iord, a, omegar)
complex *p, *z;
char *rtype;
float *dcvalue;
int iord;
float a, omegar;
{
    /* System generated locals */
    int i__1, i__2;
    double d__1;
    complex q__1;

    /* Local variables */
    int half;
    float beta, c;
    int i;
    float gamma, s, alpha, angle, omega, sigma, denom, pi;

    /* Parameter adjustments */
    rtype -= 3;
    --z;
    --p;

    /* Function Body */
    pi = (float)3.14159265;
    half = iord / 2;

/*  INTERMEDIATE DESIGN PARAMETERS */

    gamma = a + sqrt(a * a - (float)1.);
    gamma = log(gamma) / (float) (iord);
    gamma = exp(gamma);
    s = (gamma - (float)1. / gamma) * (float).5;
    c = (gamma + (float)1. / gamma) * (float).5;
    nsects = 0;
    i__1 = half;
    for (i = 1; i <= i__1; ++i) {

/*  CALCULATE POLES */

    strncpy(rtype + i * 3, "CPZ", 3);
    angle = (float) ((i << 1) - 1) * pi / (float) (iord << 1);
    alpha = -(double)s * sin(angle);
    beta = c * cos(angle);
    denom = alpha * alpha + beta * beta;
    sigma = omegar * alpha / denom;
    omega = -(double)(omegar) * beta / denom;
    i__2 = i;
    q__1.r = sigma, q__1.i = omega;
    p[i__2].r = q__1.r, p[i__2].i = q__1.i;

/*  CALCULATE ZEROS */

    omega = omegar / cos(angle);
    i__2 = i;
    q__1.r = (float)0., q__1.i = omega;
    z[i__2].r = q__1.r, z[i__2].i = q__1.i;
    ++(nsects);
    }

/*  ODD-ORDER FILTERS */

    if (half << 1 < iord) {
    strncpy(rtype + (half + 1) * 3, "SP", 2);
    i__1 = half + 1;
    d__1 = -(double)(omegar) / s;
    q__1.r = d__1, q__1.i = (float)0.;
    p[i__1].r = q__1.r, p[i__1].i = q__1.i;
    ++(nsects);
    }

/*  DC VALUE */

    *dcvalue = 1.;
    return TRUE;
}

/* Subroutine to convert an prototype lowpass filter to a bandpass filter via
*/
/*    the analog polynomial transformation.  The lowpass filter is */
/*   described in terms of its poles and zeros (as input to this routine).*/
/*    The output consists of the parameters for second order sections. */
/*  Input Arguments: */
/*  ---------------- */
/*    P                       Array containing poles */
/*    Z                       Array containing zeros */
/*    RTYPE                   Character array containing type information */
/*                              (SP) single real pole  or */
/*                              (CP) complex conjugate pole pair  or */
/*                              (CPZ) complex conjugate pole/zero pairs */
/*    DCVALUE                 Zero frequency value of filter */
/*    FL                      Low-frequency cutoff */
/*    FH                      High-frequency cutoff */
/*  Output Arguments: */
/*  ----------------- */
/*    SN                      Numerator polynomials for second order */
/*                              sections. */
/*    SD                      Denominator polynomials for second order */
/*                              sections. */
/*                              This subroutine doubles the number of */
/*                              sections. */

static int lptbp(p, z, rtype, dcvalue, fl, fh)
complex *p, *z;
char *rtype;
float *dcvalue;
float *fl, *fh;
{
    /* System generated locals */
    int i__1, i__2, i__3, i__4, i__5, i__6, i__7;
    double d__1;
    complex q__1, q__2, q__3, q__4, q__5, q__6, q__7, q__8, q__9, q__10;

    /* Local variables */
    int iptr;
    float a, b;
    complex h;
    int i, n;
    complex s;
    float scale;
    complex ctemp, p1, p2;
    float twopi;
    complex z1, z2;
    float pi;

    /* Parameter adjustments */
    rtype -= 3;
    --z;
    --p;

    /* Function Body */
    pi = (float)3.14159265;
    twopi = pi * (float)2.;
    a = twopi * twopi * *fl * *fh;
    b = twopi * (*fh - *fl);

    n = nsects;
    nsects = 0;
    iptr = 1;
    i__1 = n;
    for (i = 1; i <= i__1; ++i) {
    if (strncmp(rtype + i * 3, "CPZ", 3) == 0) {
        i__2 = i;
        q__3.r = b * z[i__2].r, q__3.i = b * z[i__2].i;
            q__2 = cpowi(q__3, 2);
        d__1 = a * (float)4.;
        q__1.r = q__2.r - d__1, q__1.i = q__2.i;
        ctemp.r = q__1.r, ctemp.i = q__1.i;
            q__1 = csqrt(ctemp);
        ctemp.r = q__1.r, ctemp.i = q__1.i;
        i__2 = i;
        q__3.r = b * z[i__2].r, q__3.i = b * z[i__2].i;
        q__2.r = q__3.r + ctemp.r, q__2.i = q__3.i + ctemp.i;
        q__1.r = q__2.r * (float).5, q__1.i = q__2.i * (float).5;
        z1.r = q__1.r, z1.i = q__1.i;
        i__2 = i;
        q__3.r = b * z[i__2].r, q__3.i = b * z[i__2].i;
        q__2.r = q__3.r - ctemp.r, q__2.i = q__3.i - ctemp.i;
        q__1.r = q__2.r * (float).5, q__1.i = q__2.i * (float).5;
        z2.r = q__1.r, z2.i = q__1.i;
        i__2 = i;
        q__3.r = b * p[i__2].r, q__3.i = b * p[i__2].i;
            q__2 = cpowi(q__3, 2);
        d__1 = a * (float)4.;
        q__1.r = q__2.r - d__1, q__1.i = q__2.i;
        ctemp.r = q__1.r, ctemp.i = q__1.i;
            q__1 = csqrt(ctemp);
        ctemp.r = q__1.r, ctemp.i = q__1.i;
        i__2 = i;
        q__3.r = b * p[i__2].r, q__3.i = b * p[i__2].i;
        q__2.r = q__3.r + ctemp.r, q__2.i = q__3.i + ctemp.i;
        q__1.r = q__2.r * (float).5, q__1.i = q__2.i * (float).5;
        p1.r = q__1.r, p1.i = q__1.i;
        i__2 = i;
        q__3.r = b * p[i__2].r, q__3.i = b * p[i__2].i;
        q__2.r = q__3.r - ctemp.r, q__2.i = q__3.i - ctemp.i;
        q__1.r = q__2.r * (float).5, q__1.i = q__2.i * (float).5;
        p2.r = q__1.r, p2.i = q__1.i;
            q__2 = conjg(z1);
        q__1.r = z1.r * q__2.r - z1.i * q__2.i, q__1.i = z1.r * q__2.i +
            z1.i * q__2.r;
        sn[iptr] = q__1.r;
        sn[iptr + 1] = z1.r * (float)-2.;
        sn[iptr + 2] = (float)1.;
            q__2 = conjg(p1);
        q__1.r = p1.r * q__2.r - p1.i * q__2.i, q__1.i = p1.r * q__2.i +
            p1.i * q__2.r;
        sd[iptr] = q__1.r;
        sd[iptr + 1] = p1.r * (float)-2.;
        sd[iptr + 2] = (float)1.;
        iptr += 3;
            q__2 = conjg(z2);
        q__1.r = z2.r * q__2.r - z2.i * q__2.i, q__1.i = z2.r * q__2.i +
            z2.i * q__2.r;
        sn[iptr] = q__1.r;
        sn[iptr + 1] = z2.r * (float)-2.;
        sn[iptr + 2] = (float)1.;
            q__2 = conjg(p2);
        q__1.r = p2.r * q__2.r - p2.i * q__2.i, q__1.i = p2.r * q__2.i +
            p2.i * q__2.r;
        sd[iptr] = q__1.r;
        sd[iptr + 1] = p2.r * (float)-2.;
        sd[iptr + 2] = (float)1.;
        iptr += 3;
        nsects += 2;
    } else if (strncmp(rtype + i * 3, "CP", 2) == 0) {
        i__2 = i;
        q__3.r = b * p[i__2].r, q__3.i = b * p[i__2].i;
            q__2 = cpowi(q__3, 2);
        d__1 = a * (float)4.;
        q__1.r = q__2.r - d__1, q__1.i = q__2.i;
        ctemp.r = q__1.r, ctemp.i = q__1.i;
            q__1 = csqrt(ctemp);
        ctemp.r = q__1.r, ctemp.i = q__1.i;
        i__2 = i;
        q__3.r = b * p[i__2].r, q__3.i = b * p[i__2].i;
        q__2.r = q__3.r + ctemp.r, q__2.i = q__3.i + ctemp.i;
        q__1.r = q__2.r * (float).5, q__1.i = q__2.i * (float).5;
        p1.r = q__1.r, p1.i = q__1.i;
        i__2 = i;
        q__3.r = b * p[i__2].r, q__3.i = b * p[i__2].i;
        q__2.r = q__3.r - ctemp.r, q__2.i = q__3.i - ctemp.i;
        q__1.r = q__2.r * (float).5, q__1.i = q__2.i * (float).5;
        p2.r = q__1.r, p2.i = q__1.i;
        sn[iptr] = (float)0.;
        sn[iptr + 1] = b;
        sn[iptr + 2] = (float)0.;
            q__2 = conjg(p1);
        q__1.r = p1.r * q__2.r - p1.i * q__2.i, q__1.i = p1.r * q__2.i +
            p1.i * q__2.r;
        sd[iptr] = q__1.r;
        sd[iptr + 1] = p1.r * (float)-2.;
        sd[iptr + 2] = (float)1.;
        iptr += 3;
        sn[iptr] = (float)0.;
        sn[iptr + 1] = b;
        sn[iptr + 2] = (float)0.;
            q__2 = conjg(p2);
        q__1.r = p2.r * q__2.r - p2.i * q__2.i, q__1.i = p2.r * q__2.i +
            p2.i * q__2.r;
        sd[iptr] = q__1.r;
        sd[iptr + 1] = p2.r * (float)-2.;
        sd[iptr + 2] = (float)1.;
        iptr += 3;
        nsects += 2;
    } else if (strncmp(rtype + i * 3, "SP", 2) == 0) {
        sn[iptr] = (float)0.;
        sn[iptr + 1] = b;
        sn[iptr + 2] = (float)0.;
        sd[iptr] = a;
        i__2 = i;
        sd[iptr + 1] = -(double)b * p[i__2].r;
        sd[iptr + 2] = (float)1.;
        iptr += 3;
        ++(nsects);
    }
    }
/* Scaling - use fact that the bandpass filter amplitude at sqrt( omega_l **/
/*            equals the amplitude of the lowpass prototype at d.c. */
    d__1 = sqrt(a);
    q__1.r = (float)0., q__1.i = d__1;
    s.r = q__1.r, s.i = q__1.i;
    h.r = (float)1., h.i = (float)0.;

    iptr = 1;
    i__1 = nsects;
    for (i = 1; i <= i__1; ++i) {
    i__2 = iptr + 2;
    q__6.r = sn[i__2] * s.r, q__6.i = sn[i__2] * s.i;
    i__3 = iptr + 1;
    q__5.r = q__6.r + sn[i__3], q__5.i = q__6.i;
    q__4.r = q__5.r * s.r - q__5.i * s.i, q__4.i = q__5.r * s.i + q__5.i *
         s.r;
    i__4 = iptr;
    q__3.r = q__4.r + sn[i__4], q__3.i = q__4.i;
    q__2.r = h.r * q__3.r - h.i * q__3.i, q__2.i = h.r * q__3.i + h.i *
        q__3.r;
    i__5 = iptr + 2;
    q__10.r = sd[i__5] * s.r, q__10.i = sd[i__5] * s.i;
    i__6 = iptr + 1;
    q__9.r = q__10.r + sd[i__6], q__9.i = q__10.i;
    q__8.r = q__9.r * s.r - q__9.i * s.i, q__8.i = q__9.r * s.i + q__9.i *
         s.r;
    i__7 = iptr;
    q__7.r = q__8.r + sd[i__7], q__7.i = q__8.i;
        q__1 = cdiv(q__2, q__7);
    h.r = q__1.r, h.i = q__1.i;
    iptr += 3;
    }
    q__2.r = *dcvalue, q__2.i = (float)0.;
    d__1 = h.r;
    q__5 = conjg(h);
    q__4.r = d__1 * q__5.r, q__4.i = d__1 * q__5.i;
    q__3 = csqrt(q__4);
    q__1 = cdiv(q__2, q__3);
    scale = q__1.r;
    sn[1] *= scale;
    sn[2] *= scale;
    sn[3] *= scale;
    return TRUE;
}

/*  Subroutine to generate second order section parameterization */
/*    from an pole-zero description for lowpass filters. */
/*  Input Arguments: */
/*  ---------------- */
/*    P                       Array containing poles */
/*    Z                       Array containing zeros */
/*   RTYPE                   Character array containing root type information
*/
/*                              (SP)  Single pole or */
/*                              (CP)  Complex conjugate pole pair */
/*                             (CPZ) Complex conjugate pole and zero pairs*/
/*    DCVALUE                 Zero-frequency value of prototype filter */
/*  Output Arguments: */
/*  ----------------- */
/*    SN                      Numerator polynomials for second order */
/*                              sections. */
/*    SD                      Denominator polynomials for second order */
/*                              sections. */

static int lp(p, z, rtype, dcvalue, sn, sd)
complex *p, *z;
char *rtype;
float *dcvalue;
float *sn, *sd;
{
    /* System generated locals */
    int i__1, i__2, i__3;
    complex q__1, q__2, q__3, q__4;

    /* Local variables */
    int iptr, i;
    float scale;

    /* Parameter adjustments */
    --sd;
    --sn;
    rtype -= 3;
    --z;
    --p;

    /* Function Body */
    iptr = 1;
    i__1 = nsects;
    for (i = 1; i <= i__1; ++i) {
    if (strncmp(rtype + i * 3, "CPZ", 3) == 0) {
        i__2 = i;
        q__2 = conjg(p[i]);
        q__1.r = p[i__2].r * q__2.r - p[i__2].i * q__2.i, q__1.i = p[i__2]
            .r * q__2.i + p[i__2].i * q__2.r;
        i__3 = i;
        q__4 = conjg(z[i]);
        q__3.r = z[i__3].r * q__4.r - z[i__3].i * q__4.i, q__3.i = z[i__3]
            .r * q__4.i + z[i__3].i * q__4.r;
        scale = q__1.r / q__3.r;
        i__2 = i;
        q__2 = conjg(z[i]);
        q__1.r = z[i__2].r * q__2.r - z[i__2].i * q__2.i, q__1.i = z[i__2]
            .r * q__2.i + z[i__2].i * q__2.r;
        sn[iptr] = q__1.r * scale;
        i__2 = i;
        sn[iptr + 1] = z[i__2].r * (float)-2. * scale;
        sn[iptr + 2] = scale * (float)1.;
        i__2 = i;
        q__2 = conjg(p[i]);
        q__1.r = p[i__2].r * q__2.r - p[i__2].i * q__2.i, q__1.i = p[i__2]
            .r * q__2.i + p[i__2].i * q__2.r;
        sd[iptr] = q__1.r;
        i__2 = i;
        sd[iptr + 1] = p[i__2].r * (float)-2.;
        sd[iptr + 2] = (float)1.;
        iptr += 3;
    } else if (strncmp(rtype + i * 3, "CP", 2) == 0) {
        i__2 = i;
        q__2 = conjg(p[i]);
        q__1.r = p[i__2].r * q__2.r - p[i__2].i * q__2.i, q__1.i = p[i__2]
            .r * q__2.i + p[i__2].i * q__2.r;
        scale = q__1.r;
        sn[iptr] = scale;
        sn[iptr + 1] = (float)0.;
        sn[iptr + 2] = (float)0.;
        i__2 = i;
        q__2 = conjg(p[i]);
        q__1.r = p[i__2].r * q__2.r - p[i__2].i * q__2.i, q__1.i = p[i__2]
            .r * q__2.i + p[i__2].i * q__2.r;
        sd[iptr] = q__1.r;
        i__2 = i;
        sd[iptr + 1] = p[i__2].r * (float)-2.;
        sd[iptr + 2] = (float)1.;
        iptr += 3;
    } else if (strncmp(rtype + i * 3, "SP", 2) == 0) {
        i__2 = i;
        scale = -(double)p[i__2].r;
        sn[iptr] = scale;
        sn[iptr + 1] = (float)0.;
        sn[iptr + 2] = (float)0.;
        i__2 = i;
        sd[iptr] = -(double)p[i__2].r;
        sd[iptr + 1] = (float)1.;
        sd[iptr + 2] = (float)0.;
        iptr += 3;
    }
    }
    sn[1] = *dcvalue * sn[1];
    sn[2] = *dcvalue * sn[2];
    sn[3] = *dcvalue * sn[3];
    return TRUE;
}

/*  Subroutine to convert a lowpass filter to a band reject filter */
/*    via an analog polynomial transformation.  The lowpass filter is */
/*   described in terms of its poles and zeros (as input to this routine).*/
/*    The output consists of the parameters for second order sections. */
/*  Input Arguments: */
/*  ---------------- */
/*    P                       Array containing poles */
/*    Z                       Array containing zeros */
/*    RTYPE                   Character array containing type information */
/*                              (SP)  single real pole or */
/*                              (CP)  complex conjugate pole pair */
/*                              (CPZ) complex conjugate pole/zero pairs */
/*    DCVALUE                 Zero-frequency value of prototype filter */
/*                              prior to transformation */
/*    FL                      Low-frequency cutoff */
/*    FH                      High-frequency cutoff */
/*  Output Arguments: */
/*  ----------------- */
/*    SN                      Numerator polynomials for second order */
/*                              sections. */
/*    SD                      Denominator polynomials for second order */
/*                              sections. */
/*    NSECTS                  Number of second order sections following */
/*                              transformation.  The number is doubled. */

static int lptbr(p, z, rtype, dcvalue, fl, fh, sn, sd)
complex *p, *z;
char *rtype;
float *dcvalue;
float *fl, *fh, *sn, *sd;
{
    /* System generated locals */
    int i__1, i__2;
    double d__1;
    complex q__1, q__2, q__3;

    /* Local variables */
    complex cinv;
    int iptr;
    float a, b, h;
    int i, n;
    float scale;
    complex ctemp, p1, p2;
    float twopi;
    complex z1, z2;
    float pi;

    /* Parameter adjustments */
    --sd;
    --sn;
    rtype -= 3;
    --z;
    --p;

    /* Function Body */
    pi = (float)3.14159265;
    twopi = pi * (float)2.;
    a = twopi * twopi * *fl * *fh;
    b = twopi * (*fh - *fl);
    n = nsects;
    nsects = 0;
    iptr = 1;
    i__1 = n;
    for (i = 1; i <= i__1; ++i) {
    if (strncmp(rtype + i * 3, "CPZ", 3) == 0) {
        q__1 = cdiv(c_b43, z[i]);
        cinv.r = q__1.r, cinv.i = q__1.i;
        q__3.r = b * cinv.r, q__3.i = b * cinv.i;
            q__2 = cpowi(q__3, 2);
        d__1 = a * (float)4.;
        q__1.r = q__2.r - d__1, q__1.i = q__2.i;
        ctemp.r = q__1.r, ctemp.i = q__1.i;
        q__1 = csqrt(ctemp);
        ctemp.r = q__1.r, ctemp.i = q__1.i;
        q__3.r = b * cinv.r, q__3.i = b * cinv.i;
        q__2.r = q__3.r + ctemp.r, q__2.i = q__3.i + ctemp.i;
        q__1.r = q__2.r * (float).5, q__1.i = q__2.i * (float).5;
        z1.r = q__1.r, z1.i = q__1.i;
        q__3.r = b * cinv.r, q__3.i = b * cinv.i;
        q__2.r = q__3.r - ctemp.r, q__2.i = q__3.i - ctemp.i;
        q__1.r = q__2.r * (float).5, q__1.i = q__2.i * (float).5;
        z2.r = q__1.r, z2.i = q__1.i;
        q__1 = cdiv(c_b43, p[i]);
        cinv.r = q__1.r, cinv.i = q__1.i;
        q__3.r = b * cinv.r, q__3.i = b * cinv.i;
            q__2 = cpowi(q__3, 2);
        d__1 = a * (float)4.;
        q__1.r = q__2.r - d__1, q__1.i = q__2.i;
        ctemp.r = q__1.r, ctemp.i = q__1.i;
        q__1 = csqrt(ctemp);
        ctemp.r = q__1.r, ctemp.i = q__1.i;
        q__3.r = b * cinv.r, q__3.i = b * cinv.i;
        q__2.r = q__3.r + ctemp.r, q__2.i = q__3.i + ctemp.i;
        q__1.r = q__2.r * (float).5, q__1.i = q__2.i * (float).5;
        p1.r = q__1.r, p1.i = q__1.i;
        q__3.r = b * cinv.r, q__3.i = b * cinv.i;
        q__2.r = q__3.r - ctemp.r, q__2.i = q__3.i - ctemp.i;
        q__1.r = q__2.r * (float).5, q__1.i = q__2.i * (float).5;
        p2.r = q__1.r, p2.i = q__1.i;
        q__2 = conjg(z1);
        q__1.r = z1.r * q__2.r - z1.i * q__2.i, q__1.i = z1.r * q__2.i +
            z1.i * q__2.r;
        sn[iptr] = q__1.r;
        sn[iptr + 1] = z1.r * (float)-2.;
        sn[iptr + 2] = (float)1.;
        q__2 = conjg(p1);
        q__1.r = p1.r * q__2.r - p1.i * q__2.i, q__1.i = p1.r * q__2.i +
            p1.i * q__2.r;
        sd[iptr] = q__1.r;
        sd[iptr + 1] = p1.r * (float)-2.;
        sd[iptr + 2] = (float)1.;
        iptr += 3;
        q__2 = conjg(z2);
        q__1.r = z2.r * q__2.r - z2.i * q__2.i, q__1.i = z2.r * q__2.i +
            z2.i * q__2.r;
        sn[iptr] = q__1.r;
        sn[iptr + 1] = z2.r * (float)-2.;
        sn[iptr + 2] = (float)1.;
        q__2 = conjg(p2);
        q__1.r = p2.r * q__2.r - p2.i * q__2.i, q__1.i = p2.r * q__2.i +
            p2.i * q__2.r;
        sd[iptr] = q__1.r;
        sd[iptr + 1] = p2.r * (float)-2.;
        sd[iptr + 2] = (float)1.;
        iptr += 3;
        nsects += 2;
    } else if (strncmp(rtype + i * 3, "CP", 2) == 0) {
        q__1 = cdiv(c_b43, p[i]);
        cinv.r = q__1.r, cinv.i = q__1.i;
        q__3.r = b * cinv.r, q__3.i = b * cinv.i;
            q__2 = cpowi(q__3, 2);
        d__1 = a * (float)4.;
        q__1.r = q__2.r - d__1, q__1.i = q__2.i;
        ctemp.r = q__1.r, ctemp.i = q__1.i;
        q__1 = csqrt(ctemp);
        ctemp.r = q__1.r, ctemp.i = q__1.i;
        q__3.r = b * cinv.r, q__3.i = b * cinv.i;
        q__2.r = q__3.r + ctemp.r, q__2.i = q__3.i + ctemp.i;
        q__1.r = q__2.r * (float).5, q__1.i = q__2.i * (float).5;
        p1.r = q__1.r, p1.i = q__1.i;
        q__3.r = b * cinv.r, q__3.i = b * cinv.i;
        q__2.r = q__3.r - ctemp.r, q__2.i = q__3.i - ctemp.i;
        q__1.r = q__2.r * (float).5, q__1.i = q__2.i * (float).5;
        p2.r = q__1.r, p2.i = q__1.i;
        sn[iptr] = a;
        sn[iptr + 1] = (float)0.;
        sn[iptr + 2] = (float)1.;
        q__2 = conjg(p1);
        q__1.r = p1.r * q__2.r - p1.i * q__2.i, q__1.i = p1.r * q__2.i +
            p1.i * q__2.r;
        sd[iptr] = q__1.r;
        sd[iptr + 1] = p1.r * (float)-2.;
        sd[iptr + 2] = (float)1.;
        iptr += 3;
        sn[iptr] = a;
        sn[iptr + 1] = (float)0.;
        sn[iptr + 2] = (float)1.;
        q__2 = conjg(p2);
        q__1.r = p2.r * q__2.r - p2.i * q__2.i, q__1.i = p2.r * q__2.i +
            p2.i * q__2.r;
        sd[iptr] = q__1.r;
        sd[iptr + 1] = p2.r * (float)-2.;
        sd[iptr + 2] = (float)1.;
        iptr += 3;
        nsects += 2;
    } else if (strncmp(rtype + i * 3, "SP", 2) == 0) {
        sn[iptr] = a;
        sn[iptr + 1] = (float)0.;
        sn[iptr + 2] = (float)1.;
        i__2 = i;
        sd[iptr] = -(double)a * p[i__2].r;
        sd[iptr + 1] = b;
        i__2 = i;
        sd[iptr + 2] = -(double)p[i__2].r;
        iptr += 3;
        ++(nsects);
    }
    }
/*  Scaling - use the fact that the bandreject filter amplitude  at d.c. */
/*            equals the lowpass prototype amplitude at d.c. */
    h = (float)1.;
    iptr = 1;
    i__1 = nsects;
    for (i = 1; i <= i__1; ++i) {
    h = h * sn[iptr] / sd[iptr];
    iptr += 3;
    }
    scale = *dcvalue / ABS(h);
    sn[1] *= scale;
    sn[2] *= scale;
    sn[3] *= scale;
    return TRUE;
}

/*  Subroutine to alter the cutoff of a filter.  Assumes that the */
/*    filter is structured as second order sections.  Changes */
/*    the cutoffs of normalized lowpass and highpass filters through */
/*    a simple polynomial transformation. */
/*  Input Arguments: */
/*  ---------------- */
/*    F                       New cutoff frequency */
/*  Input/Output Arguments: */
/*  ----------------------- */
/*    SN                      Numerator polynomials for second order */
/*                              sections. */
/*    SD                      Denominator polynomials for second order */
/*                              sections. */

static int cutoffs(sn, sd, f)
float *sn, *sd;
float *f;
{
    /* System generated locals */
    int i__1;

    /* Local variables */
    int iptr, i;
    float scale;

    /* Parameter adjustments */
    --sd;
    --sn;

    /* Function Body */
    scale = *f * (float)6.2831853000000004;

    iptr = 1;
    i__1 = nsects;
    for (i = 1; i <= i__1; ++i) {

    sn[iptr + 1] /= scale;
    sn[iptr + 2] /= scale * scale;
    sd[iptr + 1] /= scale;
    sd[iptr + 2] /= scale * scale;
    iptr += 3;
    }
    return TRUE;
}

/*  Subroutine to convert a lowpass filter to a highpass filter via */
/*    an analog polynomial transformation.  The lowpass filter is */
/*   described in terms of its poles and zeroes (as input to this routine).*/
/*    The output consists of the parameters for second order sections. */
/*  Input Arguments: */
/*  ---------------- */
/*    P                       Array containing poles */
/*    Z                       Array containing zeroes */
/*   RTYPE                   Character array containing root type information
*/
/*                              (SP) single real pole or */
/*                              (CP)  complex conjugate pair */
/*                              (CPZ) complex pole/zero pairs */
/*    DCVALUE                 Zero-frequency value of prototype filter */
/*  Output Arguments: */
/*  ----------------- */
/*    SN                      Numerator polynomials for second order */
/*                              sections. */
/*    SD                      Denominator polynomials for second order */
/*                              sections. */

static int lpthp(p, z, rtype, dcvalue, sn, sd)
complex *p, *z;
char *rtype;
float *dcvalue;
float *sn, *sd;
{
    /* System generated locals */
    int i__1, i__2, i__3;
    complex q__1, q__2, q__3, q__4;

   /* Local variables */
    int iptr, i;
    float scale;

    /* Parameter adjustments */
    --sd;
    --sn;
    rtype -= 3;
    --z;
    --p;

    /* Function Body */
    iptr = 1;
    i__1 = nsects;
    for (i = 1; i <= i__1; ++i) {
    if (strncmp(rtype + i * 3, "CPZ", 3) == 0) {
        i__2 = i;
        q__2 = conjg(p[i]);
        q__1.r = p[i__2].r * q__2.r - p[i__2].i * q__2.i, q__1.i = p[i__2]
            .r * q__2.i + p[i__2].i * q__2.r;
        i__3 = i;
        q__4 = conjg(z[i]);
        q__3.r = z[i__3].r * q__4.r - z[i__3].i * q__4.i, q__3.i = z[i__3]
            .r * q__4.i + z[i__3].i * q__4.r;
        scale = q__1.r / q__3.r;
        sn[iptr] = scale * (float)1.;
        i__2 = i;
        sn[iptr + 1] = z[i__2].r * (float)-2. * scale;
        i__2 = i;
        q__2 = conjg(z[i]);
        q__1.r = z[i__2].r * q__2.r - z[i__2].i * q__2.i, q__1.i = z[i__2]
            .r * q__2.i + z[i__2].i * q__2.r;
        sn[iptr + 2] = q__1.r * scale;
        sd[iptr] = (float)1.;
        i__2 = i;
        sd[iptr + 1] = p[i__2].r * (float)-2.;
        i__2 = i;
        q__2 = conjg(p[i]);
        q__1.r = p[i__2].r * q__2.r - p[i__2].i * q__2.i, q__1.i = p[i__2]
            .r * q__2.i + p[i__2].i * q__2.r;
        sd[iptr + 2] = q__1.r;
        iptr += 3;
    } else if (strncmp(rtype + i * 3, "CP", 2) == 0) {
        i__2 = i;
        q__2 = conjg(p[i]);
        q__1.r = p[i__2].r * q__2.r - p[i__2].i * q__2.i, q__1.i = p[i__2]
            .r * q__2.i + p[i__2].i * q__2.r;
        scale = q__1.r;
        sn[iptr] = (float)0.;
        sn[iptr + 1] = (float)0.;
        sn[iptr + 2] = scale;
        sd[iptr] = (float)1.;
        i__2 = i;
        sd[iptr + 1] = p[i__2].r * (float)-2.;
        i__2 = i;
        q__2 = conjg(p[i]);
        q__1.r = p[i__2].r * q__2.r - p[i__2].i * q__2.i, q__1.i = p[i__2]
            .r * q__2.i + p[i__2].i * q__2.r;
        sd[iptr + 2] = q__1.r;
        iptr += 3;
    } else if (strncmp(rtype + i * 3, "SP", 2) == 0) {
        i__2 = i;
        scale = -(double)p[i__2].r;
        sn[iptr] = (float)0.;
        sn[iptr + 1] = scale;
        sn[iptr + 2] = (float)0.;
        sd[iptr] = (float)1.;
        i__2 = i;
        sd[iptr + 1] = -(double)p[i__2].r;
        sd[iptr + 2] = (float)0.;
        iptr += 3;
    }
    }
    sn[1] *= *dcvalue;
    sn[2] *= *dcvalue;
    sn[3] *= *dcvalue;
    return TRUE;
}

/* Transforms an analog filter to a digital filter via the bilinear transforma
ti*/
/*   Assumes both are stored as second order sections.  The transformation is
*/
/*    done in-place. */
/*  Input Arguments: */
/*  ---------------- */
/*   SN                   Array containing numerator polynomial coefficients f
or*/
/*                           second order sections.  Packed head-to-tail. */
/*   SD                   Array containing denominator polynomial coefficients
 f*/
/*                           second order sections.  Packed head-to-tail. */

static int bilin2(sn, sd)
float *sn, *sd;
{
    /* System generated locals */
    int i__1;

    /* Local variables */
    int iptr, i;
    float scale, a0, a1, a2;

    /* Parameter adjustments */
    --sd;
    --sn;

    /* Function Body */
    iptr = 1;
    i__1 = nsects;
    for (i = 1; i <= i__1; ++i) {
    a0 = sd[iptr];
    a1 = sd[iptr + 1];
    a2 = sd[iptr + 2];
    scale = a2 + a1 + a0;
    sd[iptr] = (float)1.;
    sd[iptr + 1] = (a0 - a2) * (float)2. / scale;
    sd[iptr + 2] = (a2 - a1 + a0) / scale;
    a0 = sn[iptr];
    a1 = sn[iptr + 1];
    a2 = sn[iptr + 2];
    sn[iptr] = (a2 + a1 + a0) / scale;
    sn[iptr + 1] = (a0 - a2) * (float)2. / scale;
    sn[iptr + 2] = (a2 - a1 + a0) / scale;
    iptr += 3;
    }
    return TRUE;
}

/* WARP -- FUNCTION, APPLIES TANGENT FREQUENCY WARPING TO COMPENSATE */
/*         FOR BILINEAR ANALOG -> DIGITAL TRANSFORMATION */
/* ARGUMENTS: */
/* ---------- */
/*      F       ORIGINAL DESIGN FREQUENCY SPECIFICATION (HERTZ) */
/*      TS      SAMPLING INTERVAL (SECONDS) */
/*  LAST MODIFIED:  SEPTEMBER 20, 1990 */

static double warp(f, ts)
float *f, *ts;
{
    /* System generated locals */
    float ret_val;

    /* Local variables */
    float angle, twopi;

    twopi = (float)6.2831853;
    angle = twopi * *f * *ts / (float)2.;
    ret_val = tan(angle) * (float)2. / *ts;
    ret_val /= twopi;
    return ret_val;
}

/* BEROOTS -- SUBROUTINE TO RETURN BESSEL POLES FOR */
/*   NORMALIZED LOWPASS FILTER */
/* LAST MODIFIED:  SEPTEMBER 7, 1990 */
/*  OUTPUT ARGUMENTS: */
/*  ----------------- */
/*      P              COMPLEX ARRAY CONTAINING POLES */
/*                       CONTAINS ONLY ONE FROM EACH */
/*                       COMPLEX CONJUGATE PAIR, AND */
/*                       ALL REAL POLES */
/*      RTYPE          CHARACTER ARRAY INDICATING 2ND ORDER SECTION */
/*                       TYPE: */
/*                         (SP)  SINGLE REAL POLE */
/*                         (CP)  COMPLEX CONJUGATE POLE PAIR */
/*                         (CPZ) COMPLEX CONJUGATE POLE-ZERO PAIRS */
/*      DCVALUE        MAGNITUDE OF FILTER AT ZERO FREQUENCY */
/*  INPUT ARGUMENTS: */
/*  ---------------- */
/*      IORD           DESIRED FILTER ORDER */

static int beroots(p, rtype, dcvalue, iord)
complex *p;
char *rtype;
float *dcvalue;
int iord;
{
    /* Parameter adjustments */
    rtype -= 3;
    --p;

    /* Function Body */
    if (iord == 1) {
    p[1].r = (float)-1., p[1].i = (float)0.;
    strncpy(rtype + 3, "SP", 2);
    } else if (iord == 2) {
    p[1].r = (float)-1.1016013, p[1].i = (float).6360098;
    strncpy(rtype + 3, "CP", 2);
    } else if (iord == 3) {
    p[1].r = (float)-1.0474091, p[1].i = (float).9992645;
    strncpy(rtype + 3, "CP", 2);
    p[2].r = (float)-1.3226758, p[2].i = (float)0.;
    strncpy(rtype + 6, "SP", 2);
    } else if (iord == 4) {
    p[1].r = (float)-.9952088, p[1].i = (float)1.2571058;
    strncpy(rtype + 3, "CP", 2);
    p[2].r = (float)-1.3700679, p[2].i = (float).4102497;
    strncpy(rtype + 6, "CP", 2);
    } else if (iord == 5) {
    p[1].r = (float)-.9576766, p[1].i = (float)1.4711244;
    strncpy(rtype + 3, "CP", 2);
    p[2].r = (float)-1.3808774, p[2].i = (float).7179096;
    strncpy(rtype + 6, "CP", 2);
    p[3].r = (float)-1.502316, p[3].i = (float)0.;
    strncpy(rtype + 9, "SP", 2);
    } else if (iord == 6) {
    p[1].r = (float)-.9306565, p[1].i = (float)1.6618633;
    strncpy(rtype + 3, "CP", 2);
    p[2].r = (float)-1.3818581, p[2].i = (float).9714719;
    strncpy(rtype + 6, "CP", 2);
    p[3].r = (float)-1.5714904, p[3].i = (float).3208964;
    strncpy(rtype + 9, "CP", 2);
    } else if (iord == 7) {
    p[1].r = (float)-.9098678, p[1].i = (float)1.8364514;
    strncpy(rtype + 3, "CP", 2);
    p[2].r = (float)-1.3789032, p[2].i = (float)1.1915667;
    strncpy(rtype + 6, "CP", 2);
    p[3].r = (float)-1.6120388, p[3].i = (float).5892445;
    strncpy(rtype + 9, "CP", 2);
    p[4].r = (float)-1.6843682, p[4].i = (float)0.;
    strncpy(rtype + 12, "SP", 2);
    } else if (iord == 8) {
    p[1].r = (float)-.892871, p[1].i = (float)1.9983286;
    strncpy(rtype + 3, "CP", 2);
    p[2].r = (float)-1.3738431, p[2].i = (float)1.3883585;
    strncpy(rtype + 6, "CP", 2);
    p[3].r = (float)-1.6369417, p[3].i = (float).8227968;
    strncpy(rtype + 9, "CP", 2);
    p[4].r = (float)-1.7574108, p[4].i = (float).2728679;
    strncpy(rtype + 12, "CP", 2);
    }
    nsects = iord - iord / 2;
    *dcvalue = (float)1.;
    return TRUE;
}

static complex cmul(a,b)
complex a,b;
{
    complex c;
    c.r = a.r * b.r - a.i * b.i;
    c.i = a.i * b.r + a.r * b.i;
    return c;
}

static complex cpowi(a,n)
complex a;
int n;
{
    int i;
    complex c;
    c.i = 0.;
    c.r = 1.;
    for (i = 1; i <= n; ++i) {
    c = cmul(c, a);
    }
    return c;

}
static complex csqrt(z)
complex z;
{   complex c;
    float x,y,w,r;
    if ((z.r == 0.0) && (z.i == 0.0)) {
        c.r=0.0;
        c.i=0.0;
        return c;
    } else {
        x=fabs(z.r);
        y=fabs(z.i);
        if (x >= y) {
            r=y/x;
            w=sqrt(x)*sqrt(0.5*(1.0+sqrt(1.0+r*r)));
        } else {
            r=x/y;
            w=sqrt(y)*sqrt(0.5*(r+sqrt(1.0+r*r)));
        }
        if (z.r >= 0.0) {
            c.r=w;
            c.i=z.i/(2.0*w);
        } else {
            c.i=(z.i >= 0) ? w : -w;
            c.r=z.i/(2.0*c.i);
        }
        return c;
    }
}

static complex conjg(z)
complex z;
{   complex c;
    c.r=z.r;
    c.i = -z.i;
    return c;
}

static complex cdiv(a,b)
complex a,b;
{   complex c;
    float r,den;
    if (fabs(b.r) >= fabs(b.i)) {
        r=b.i/b.r;
        den=b.r+r*b.i;
        c.r=(a.r+r*a.i)/den;
        c.i=(a.i-r*a.r)/den;
    } else {
        r=b.r/b.i;
        den=b.i+r*b.r;
        c.r=(a.r*r+a.i)/den;
        c.i=(a.i*r-a.r)/den;
    }
    return c;
}
//CXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX           
//C                                                                               
//C   TIME SUBROUTINES                                                            
//c                                                                               
//c   lates update:                                                               
//c   jan 92 by jh: add date_doy                                                  
//*                                                                               
//*   TIMSEC  - Converts time in year, month, day hour, minutes and seconds       
//*             to double precision seconds after 1.1.1900                        
//*   SECTIM  - Converts double precision seconds after 1.1.1900 to year,         
//*             day-of-year and date                                              
//*   DTE     - Converts day-of-year to date (month,day)                          
//*   TIMDIF  - Calculates time-difference in double precision seconds of         
//*             two input dates (year,month,day,hour,minute,second)               
//*   TIMADD  - Adds double precision seconds to date, and returns the new        
//*             date                                                              
//*   MONTH_DAY Find number of days in a month from month and year                
//*                                                                               
//*   DATE_DOY  Find doy from date                                                
//*-------------------------------------------------------------------------      
//*                                                                               
//* Routine to convert from time to seconds after 1.1 1900, 00:00:00.00           
//*                                                                               
//*                                                         Leif Kvamme 9-4-87    
IDATE (YR,MTH,DAY,HR,MIN,SEC)
int   *YR;
int   *MTH;
int   *DAY;
int   *HR;
int   *MIN;
float *SEC;
{
printf("Enter  Year  :");
scanf("%d",YR);
printf("Enter  Month :");
scanf("%d",MTH);
printf("Enter  Day   :");
scanf("%d",DAY);
printf("Enter  Hour  :");
scanf("%d",HR);
printf("Enter  Minute:");
scanf("%d",MIN);
printf("Enter  Second:");
scanf("%f",SEC);
printf("\n");
}
TIMSEC (YR,MTH,DAY,HR,MIN,SECS,MSECS)                         
int YR;
int MTH;
int DAY;
int HR;
int MIN;
float SECS;
double *MSECS;                         /* total seconds to be returned      */
{
int DYR;                               /* flag for leap year                */
int IYR;                               /* number of leap-years since 1900   */
int YDY;                               /* number of days in current year    */

if(YR <= 50) YR=YR+100;                /* check for 2000 or more in 2 digits*/

if(YR >= 1900) YR=YR - 1900;
DYR = 0;
if((YR % 4) == 0) DYR = 1;
IYR = YR/4 - DYR;
//                -- Seconds to beginning of     
*MSECS = (float)(IYR*366) + (float)((YR-IYR)*365);
//                -- current year                
*MSECS = *MSECS*86400.0;
//                -- January                     
if (MTH == 1) YDY = DAY;
//                -- February                    
if (MTH == 2) YDY = DAY + 31;
//                -- ....                        
if (MTH == 3) YDY = DAY + DYR + 59;       
if (MTH == 4) YDY = DAY + DYR + 90;                                     
if (MTH == 5) YDY = DAY + DYR + 120;                                    
if (MTH == 6) YDY = DAY + DYR + 151;                                    
if (MTH == 7) YDY = DAY + DYR + 181;                                    
if (MTH == 8) YDY = DAY + DYR + 212;                                    
if (MTH == 9) YDY = DAY + DYR + 243;                                    
if (MTH ==10) YDY = DAY + DYR + 273;                                    
if (MTH ==11) YDY = DAY + DYR + 304;                                    
if (MTH ==12) YDY = DAY + DYR + 334;                                    
*MSECS = *MSECS + (float)(YDY*86400 + HR*3600 + MIN*60) + SECS;
}

//*=========================================================================      
//* Routine to convert from seconds after year 1900 to time and date              
//*  NOTE: Routine calculates only from 1.1.1901 to 31.12.2099                    
//*                                                                               
//*                                                         Leif Kvamme 21-4-87   
SECTIM (MSECS,YR,DOY,MTH,DAY,HR,MIN,SEC)                      
double MSECS;
int *YR;
int *DOY;
int *MTH;
int *DAY;
int *HR;
int *MIN;
float *SEC;
{
int DDAY,MMTH;
//             -- Temporary seconds         
double SSEC;
//             -- Seconds per day           
double SECDAY;
//             -- Seconds per year          
double SECYR;
//              -- Leap-year indicators      
float  IND, SIN;
//              -- Counter                   
int    I;
SECDAY=86400.0;
SECYR =31536000.0;
//*-------------------------------------------------------------------------      
//*  Find year:                                                                   
//*                                                                               
SSEC = 0.0;
for(I=1;I<201;I++)
{
    IND = 0.0;
//               -- Leap year                 
    if ((I%4) == 0) IND = 1.0;
//               -- Add years                 
    SSEC = SSEC + SECYR + IND*SECDAY;
//               -- Year found                
    if (SSEC > MSECS) goto found;              
        SIN = IND;
}
found:                                                              
*YR = I - 1;
//*                                                                               
//*  Find day-of-year and date:                                                   
//*                                                                               
//c-- Reset remaining seconds   
SSEC = MSECS - (SSEC - SECYR - IND*SECDAY);
for(I=1;I<367;I++)
{
    SSEC = SSEC - SECDAY;
    if (SSEC < 0) goto incr;                                              
}
incr:
I = I - 1;
//           -- 366 days of year          
if (SIN > 0.0) I = I + 1;
//           --                           
if (I == 0)
{                           
//           -- Justifying if change      
    *YR = *YR - 1;
//           -- of year                   
    I  = 365;                                  
    if ((*YR%4) == 0) I = 366;
}
*DOY = I;
//-- convert from doy to date  
DTE (I,&DDAY,&MMTH,*YR);
*DAY=DDAY;
*MTH=MMTH;


if(*YR >= 100) *YR=*YR-100;            /* test for year 2000 or more        */





//*                                                                               
//*  Find hour:                                                                   
//*                                                                               
SSEC = SSEC + SECDAY;

for(I=1;I<25;I++)
{
    SSEC = SSEC - 60.0*60.0;
    if (SSEC < 0) goto seks;                                              
}
seks:
*HR = I - 1;
//*                                                                               
//*  Find minutes and remaining seconds:                                          
//*                                                                               
SSEC = SSEC + 60.0*60.0;
for(I=1;I<61;I++)
{
    SSEC = SSEC - 60.0;
    if (SSEC < 0) goto otte;
}
otte:                                              
   *MIN = I - 1;
   *SEC = SSEC + 60.0;
if(*YR < 50)
{
    *YR=*YR+2000;
}else{
    *YR=*YR+1900;
}
}
//*=========================================================================      
//*                                                                               
//* Routine to convert from day-of-year to date                                   
//*                                                         Leif Kvamme 12-1-85   
DTE (DOY,DAY,MON,YR)                                          
int DOY;
int *DAY;
int *MON;
int YR;
{
int MTH[14],J,M,N;
for(J=1;J<8;J=J+2)
    MTH[J] = 31;
for(J=8;J<13;J=J+2)
    MTH[J] = 31;
MTH[2] = 28;
MTH[4] = 30;
MTH[6] = 30;
MTH[9] = 30;
MTH[11]= 30;
if ((YR%4) == 0) MTH[2] = 29;
M = 0;                                                                    
for(J=1;J<13;J++)
{
    M = M + MTH[J];
    N = DOY - M;                                                              
    if (N <= 0)
    {                                                       
        *MON = J;
        *DAY = N + MTH[J];                                                     
        goto four;                                                               
    }
}
four:                                                                   
J=0;
}
/*                                                                      
*==========================================================================     
*                                                                               
* Routine to calculate time-difference in seconds (MSDIF = TIME_1 - TIME_2)     
*                                                                               
*                                                         Leif Kvamme 24-4-87   
       subroutine TIMDIF (YR1,MN1,DA1,HR1,MI1,SC1,                              
     .                    YR2,MN2,DA2,HR2,MI2,SC2,MSDIF)                        
*                                                                               
c-- Time in seconds        
       double precision SEC1,SEC2                      
c-- Difference (returned)  
       double precision MSDIF                          
       real             SC1, SC2                                                
c-- Time 1                 
       integer          YR1,MN1,DA1,HR1,MI1            
c-- Time 2                 
       integer          YR2,MN2,DA2,HR2,MI2            
*                                                                               
c-- Convert time 2         
       call TIMSEC (yr1,mn1,da1,hr1,mi1,sc1,SEC1)      
c-- Convert time 2         
       call TIMSEC (yr2,mn2,da2,hr2,mi2,sc2,SEC2)      
*                                                                               
c-- Calculate difference   
       MSDIF = SEC1 - SEC2                             
       return                                                                   
       end                                                                      
*___________________________________________________________________            
*                                                                               
* Routine to add time in seconds to date- and day-time (TIME_2 = TIME_1 + MSDIF)
*                                                                               
*                                                         Leif Kvamme 24-4-87   
       subroutine TIMADD (YR1,MN1,DA1,HR1,MI1,SC1,MSDIF,                        
     .                    YR2,MN2,DA2,HR2,MI2,SC2)                              
*                                                                               
c-- Seconds to be added    
       double precision MSDIF                          
c-- Time in seconds        
       double precision SEC1,SEC2                      
       real             SC1, SC2                                                
c-- Time 1                 
       integer          YR1,MN1,DA1,HR1,MI1            
c-- Time 2 (returned)      
       integer          YR2,MN2,DA2,HR2,MI2,DOY        
*                                                                               
c-- Convert time 1         
       call TIMSEC (yr1,mn1,da1,hr1,mi1,sc1,SEC1)      
*                                                                               
c-- Adding                 
       SEC2 = SEC1 + MSDIF                             
*                                                                               
c-- Reconverting           
       call SECTIM (sec2,YR2,DOY,MN2,DA2,HR2,MI2,SC2)  
       return                                                                   
       end                                                                      
*=========================================================================      
*                                                                               
* Routine to convert from month to number of days in a month                    
*                                                         J. Havskov oct 91     
*                                                         Leif Kvamme 12-1-85   
       subroutine MONTH_DAY(YR,MON,DAY)                                         
*                                                                               
       implicit none                                                            
       integer DAY,MON,YR,MTH(12),J                                             
*                                                                               
       do 1 J = 1,7,2                                                           
           MTH(J) = 31                                                          
    1  continue                                                                 
       do 2 J = 8,12,2                                                          
           MTH(J) = 31                                                          
    2  continue                                                                 
       MTH(2) = 28                                                              
       MTH(4) = 30                                                              
       MTH(6) = 30                                                              
       MTH(9) = 30                                                              
       MTH(11)= 30                                                              
       if (mod(YR,4) .eq. 0) MTH(2) = 29                                        
       DAY=MTH(MON)                                                             
       return                                                                   
       end                                                                      
                                                                                
*=========================================================================      
*                                                                               
* Routine to convert from date to day-of-year                                   
* j. havskov 1992 and Leif Kvamme 12-1-85                                       
*                                                                               
       subroutine DATE_DOY (DOY,DAY,MON,YR)                                     
*                                                                               
       integer DOY,DAY,MON,YR,MTH(12),J,M,N                                     
*                                                                               
       do 1 J = 1,7,2                                                           
           MTH(J) = 31                                                          
    1  continue                                                                 
       do 2 J = 8,12,2                                                          
           MTH(J) = 31                                                          
    2  continue                                                                 
       MTH(2) = 28                                                              
       MTH(4) = 30                                                              
       MTH(6) = 30                                                              
       MTH(9) = 30                                                              
       MTH(11)= 30                                                              
       if (mod(YR,4) .eq. 0) MTH(2) = 29                                        
c                                                                               
       doy=0                                                                    
       do j=1,mon-1                                                             
         doy=doy+mth(j)                                                         
       enddo                                                                    
       doy=doy+day	   		 	                                                      
c                                                                               
       return                                                                   
       end                                                                      
*/
/****************************************************************************/
//plt_plt_box(ptr,con_ser,fnt_no)
//smod*    ptr;
/****************************************************************************/
/*--------------------------Start: Write_event_file()-----------------------*/
int Write_event_file(ptr,evnam, head, inblk, nbuf,par, point,idur,ringname, fidx)
smod*    ptr;
char*    evnam;
char*    head;
int      inblk;
int      nbuf;
int      par;
int      point;
int      idur;
char*    ringname;
int*     fidx;
{
FILE*    new;
int      bytes;
int      i;                            /* counters                          */
int      j;
static   int datal[BUFFER];
int      newblk;                       /* find new position after each read */
int      idd;
int      fast;
int      tophdr;
int*     in_ptr_l;
int*     pk_ptr_l;
int      scans;
int      kans;
int      kj;
int      lr;
int      nxt_rbf;
char     detnam[400];
FILE     *idx;


//printf("Write event: %s\n",evnam);
new=fopen(evnam,"w");                  /* Open new event-file               */
if(new == 0)
{
    sprintf(ptr->err_msg,"CAT_EVT: a. Unable to open new eventfile with name:");
    errlog(ptr);
    sprintf(ptr->err_msg,"CAT_EVT: b. %s.",evnam);
    errlog(ptr);
    return(-1);
}

/*--------------------------------------------------------------------------*/
/* Write event header                                                       */
/*--------------------------------------------------------------------------*/
fseek(new,0,0);
bytes=fwrite(head,SIZ_EV_HDR,1,new);
if(bytes==0)
    clearerr(new);
/****************************************************************************/
/* Copy NBUF data buffers from data to new eventfile                        */
/****************************************************************************/
if(par != EXTRACT)
{
    fast=idur+ptr->prevnt[par];
}else{
    fast=idur;
}
//printf("NBUF=%d FAST=%d PREVNT[%d]=%d\n",nbuf,fast,par,ptr->prevnt[par]);
for(j=1;j<nbuf+1;j++)                  /* Pick out nbuf buffers             */
{
    ptr->alive[4]=1;                   /* tell I am alive                   */
    if(j>fast)                         /* write pre-event+duration          */
        sleep(1);
    read_ring_buf2(ptr,inblk,datal,ringname,fidx);
    next_block(ptr,&newblk,j,par);
/****************************************************************************/
/* Position for first data record is computed so that the length of the     */
/* header is always a multiple of the recordlength >= 1024                  */
/****************************************************************************/
    fseek(new,newblk,0);                /* Position eventfile               */
    if(ptr->nchstr[par] == ptr-> nchan || par == EXTRACT)
    {
        bytes=fwrite(datal,ptr->reclength,1,new);
    }else{
        in_ptr_l=datal+HEADER;
        pk_ptr_l=datal+HEADER;
        for(scans=0;scans<ptr->nsamp;scans++)
        {
            for(kans=0;kans<ptr->nchan;kans++)
            {
                if(ptr->store[par][kans]==1)
                {
                    *(in_ptr_l)=*(pk_ptr_l);
                    in_ptr_l+=1;
                    pk_ptr_l+=1;
                }else{
                    pk_ptr_l+=1;
                }
            }
        }
        bytes=fwrite(datal,ptr->newrl[par],1,new);
    }
    if(bytes==0)
        clearerr(new);
    ptr->ntick=ptr->ntick-1;
    inblk=inblk+ptr->reclength;             /* Compute new address for      */
                                            /* for inputfile (data)         */
    tophdr=(SIZ_EV_HDR/ptr->reclength+1)*ptr->reclength;
    if(inblk == ptr->maxblk*ptr->reclength+tophdr) /* Check for forward wrap*/
    {
        next_block(ptr,&inblk,1,CONTIN);   /* calculate inblk, taking       */
        (*fidx)++;
        if(*fidx==ptr->nringbuf[0]) *fidx=0;

        nxt_rbf=*fidx;
/*--------------------------------------------------------------------------*/
/* open the index file and find the corresponding ringbuffer name           */
/*--------------------------------------------------------------------------*/
        idx=fopen("/home/buffer/idx_log","r");
        fseek(idx,nxt_rbf*320,SEEK_SET);
        fread(detnam,320,1,idx);
        for(lr=0;lr<20;lr++)
            ringname[lr]=' ';
        for(lr=0;lr<18;lr++)
        ringname[lr]=detnam[lr];
        ringname[18]='\0';
        fclose(idx);
    }
    if(ptr->print_on_event == 1)
    {
        if(j<=ptr->prevnt[par])
            printf(".");
        if(j>ptr->prevnt[par] && j<= fast)
            printf("E");
        if(j> fast)
            printf("_");
        fflush(stdin);
        fflush(stdout);
    }
}   /* end of for loop writing the data */
printf("\n");
fclose(new);
return(0);
}
/*-----------------------------------------End: Write_event_file------------*/
/*--------------------------Start: Write_event_file_pip---------------------*/
int Write_event_file_pip(ptr,evnam, head, inblk, nbuf,par, point,idur)
smod*    ptr;
char*    evnam;
char*    head;
int      inblk;
int      nbuf;
int      par;
int      point;
int      idur;
{
FILE*    new;
int      bytes;
int      i;                            /* counters                          */
int      j;
static   int datal[BUFFER];
int      newblk;                       /* find new position after each read */
int      idd;
int      fast;
int      tophdr;
int*     in_ptr_l;
int*     pk_ptr_l;
int      scans;
int      kans;
int      kj;
int      lr;
int      nxt_rbf;
int      secpip;
char     detnam[400];
FILE     *idx;


new=fopen(evnam,"w");                  /* Open new event-file               */
if(new == 0)
{
    sprintf(ptr->err_msg,"CAT_EVT: a. Unable to open new eventfile with name:");
    errlog(ptr);
    sprintf(ptr->err_msg,"CAT_EVT: b. %s.",evnam);
    errlog(ptr);
    return(-1);
}

/*--------------------------------------------------------------------------*/
/* Write event header                                                       */
/*--------------------------------------------------------------------------*/
fseek(new,0,0);
bytes=fwrite(head,SIZ_EV_HDR,1,new);
if(bytes==0)
    clearerr(new);
/****************************************************************************/
/* Copy NBUF data buffers from data to new eventfile                        */
/****************************************************************************/
if(par != EXTRACT)
{
    fast=idur+ptr->prevnt[par];
}else{
    fast=idur;
}
//printf("NBUF=%d FAST=%d PREVNT[%d]=%d\n",nbuf,fast,par,ptr->prevnt[par]);
secpip=inblk;
for(j=1;j<nbuf+1;j++)                  /* Pick out nbuf buffers             */
{
//printf("%3d %3d\n",secpip,ptr->sec_ut);
    ptr->alive[4]=1;                   /* tell I am alive                   */
//    if(par == 0)
//    {
//        if(j>fast)                         /* write pre-event+duration          */
//            sleep(1);
//    }else{
        while((secpip-ptr->sec_ut) == 0) sleep(1);
//    }
    read_pipe_buf2(ptr,secpip,datal);
    next_block(ptr,&newblk,j,par);
/****************************************************************************/
/* Position for first data record is computed so that the length of the     */
/* header is always a multiple of the recordlength >= 1024                  */
/****************************************************************************/
    fseek(new,newblk,0);                /* Position eventfile               */
    if(ptr->nchstr[par] == ptr-> nchan || par == EXTRACT)
    {
        bytes=fwrite(datal,ptr->reclength,1,new);
    }else{
        in_ptr_l=datal+HEADER;
        pk_ptr_l=datal+HEADER;
        for(scans=0;scans<ptr->nsamp;scans++)
        {
            for(kans=0;kans<ptr->nchan;kans++)
            {
                if(ptr->store[par][kans]==1)
                {
                    *(in_ptr_l)=*(pk_ptr_l);
                    in_ptr_l+=1;
                    pk_ptr_l+=1;
                }else{
                    pk_ptr_l+=1;
                }
            }
        }
        bytes=fwrite(datal,ptr->newrl[par],1,new);
    }
    if(bytes==0)
        clearerr(new);
    ptr->ntick=ptr->ntick-1;

    if(ptr->print_on_event == 1)
    {
        if(j<=ptr->prevnt[par])
            printf(".");
        if(j>ptr->prevnt[par] && j<= fast)
            printf("E");
        if(j> fast)
            printf("_");
        fflush(stdin);
        fflush(stdout);
    }
    secpip=secpip+1;
    if(secpip >= ptr->sec_in_pip)
        secpip=0;
}   /* end of for loop writing the data */
printf("\n");
fclose(new);
return(0);
}
/*-----------------------------------------End: Write_event_file_pip--------*/

/*-----------------------------Start: pos_in_ring_buf-----------------------*/

pos_in_ring_buf(ptr,inblk, point, fname, fidx,type_of_evt)
smod*    ptr;
int*     inblk;
int      point;
char*    fname;          /* name of ringbuffer file should be returned here */
int*     fidx;
int      type_of_evt;
{
int      kj;
int      lr;
int      nxt_rbf;
FILE     *idx;
char     detnam[400];
char     rngbuf[50];
switch(type_of_evt)
{
    case 0:                            /* ordinary event                    */
    *inblk=ptr-> qfblk[point];         /* Get detection disk-address        */
    *fidx=ptr->qbuffile[point];        /* fresh from data-module            */
    nxt_rbf=*fidx;
    for(lr=0;lr<20;lr++)
        rngbuf[lr]=' ';
    for(lr=0;lr<18;lr++)
        fname[lr]=ptr->detnames[point][lr];
    fname[18]='\0';
    break;
    case 1:                            /* manual event                      */
    *inblk=ptr->man_fblk;
    *fidx=ptr->man_rngidx;
    nxt_rbf=*fidx;
    for(lr=0;lr<18;lr++)
        fname[lr]=ptr->man_nam[lr];
    fname[18]='\0';
    break;
    case 2:                            /* extracted event                   */
    *inblk = ptr->start_blk;
    *fidx=ptr->cur_rng;
    nxt_rbf=*fidx;
/*--------------------------------------------------------------------------*/
/* open the index file and find the corresponding ringbuffer name           */
/*--------------------------------------------------------------------------*/
    idx=fopen("/home/buffer/idx_log","r");
    fseek(idx,nxt_rbf*320,SEEK_SET);
//printf("CAT 13e\n");
    fread(detnam,320,1,idx);
//printf("CAT 13f\n");
    for(lr=0;lr<18;lr++)
        fname[lr]=detnam[lr];
    fname[18]='\0';
    fclose(idx);
    break;
}
}
/*-----------------------------End: pos_in_ring_buf-------------------------*/
/*-----------------------------Start: pos_in_pipe_buf-----------------------*/
pos_in_pipe_buf(ptr,inblk,point)
smod*    ptr;
int*     inblk;
int      point;
{
    *inblk = ptr->qfsec[point];            /* get detection pipe-address    */
                                           /* fresh from data-module        */
}
/*-----------------------------Start: read_ring_buf-------------------------*/

int read_ring_buf(ptr,inblk, input, ringname)
smod*    ptr;
int      inblk;                        /* beginning of event                */
int*     input;                        /* buffer for input                  */
char*    ringname;                     /* name of the ring buffer           */
{
FILE*    data;                         /* ring buffer                       */
int      bytes;
int      ret;
int      t;

data=fopen(ringname,"r");              /* open ring buffer file, input      */
if(data == 0)
{
    printf("Unable to open ring buffer file: %s\n",ringname);
for(t=0;t<20;t++)
    printf("%x ",ringname[t]);
printf("\n");
    sprintf(ptr->err_msg,"CAT_EVT: Unable to open ring buffer file");
    errlog(ptr);
    return(-1);
}
ret=fseek(data,inblk,SEEK_SET);        /* Position input file               */
if(ret != 0)
{
    printf("Not possible to position ringbuffer file %d\n",inblk);
    sprintf(ptr->err_msg,"CAT_EVT: Not possible to position ringbuffer file");
    errlog(ptr);
    exit(0);
}
bytes=fread((int*)input, ptr->reclength,1,data);
if(bytes==0) 
{
    sprintf(ptr->err_msg,"CAT_EVT: Error reading ring buffer file");
    errlog(ptr);
    clearerr(data);
    fclose(data);
    return(-1);
}
fclose(data);                          /* Close file                        */
return(0);
}
/*-----------------------------End: read_ring_buf---------------------------*/
/*-----------------------------Start: read_pipe_buf-------------------------*/
read_pipe_buf(inblk,input,ptr)
int      inblk;
int*     input;
smod*    ptr;
{
unsigned int* ch_ptr;
unsigned int longv;
int      kp;
ch_ptr=ptr->pipe + inblk * ((ptr->nchan * ptr->nsamp)+HEADER);
for(kp=0;kp<16;kp++)
{
    longv=*(ch_ptr);
    input[kp]=longv;
    ch_ptr+=1;
}
}
/*-----------------------------End: read_pipe_buf---------------------------*/
/*-----------------------------Start: read_ring_buf2------------------------*/

read_ring_buf2(ptr,inblk ,inputl, ringname, fidx)
smod*    ptr;
int      inblk;                        /* beginning of event                */
int*     inputl;                       /* buffer for input                  */
char*    ringname;                     /* name of the ring buffer           */
int*     fidx;
{
FILE*    data;                         /* ring buffer                       */
int      bytes;

data=fopen(ringname,"r");              /* open ring buffer file, input      */
fseek(data,inblk,0);                   /* position input file               */
bytes=fread(inputl, ptr->reclength,1,data);
if(bytes==0) clearerr(data);
fclose(data);                          /* close file                        */
}
/*-----------------------------End: read_ring_buf2--------------------------*/
/*-----------------------------Start: read_pipe_buf2------------------------*/

read_pipe_buf2(ptr,inblk ,inputl)
smod*    ptr;
int      inblk;                        /* beginning of event                */
int*     inputl;                       /* buffer for input                  */
{
unsigned int* ch_ptr;
unsigned int longv;
int kp;
int verd;
verd=(ptr->nchan * ptr->nsamp) + HEADER;
ch_ptr=ptr->pipe + inblk * ((ptr->nchan * ptr->nsamp)+HEADER);
for(kp=0;kp<verd;kp++)
{
    longv=*(ch_ptr);
    inputl[kp]=longv;
    ch_ptr+=1;
}
}
/*-----------------------------End: read_pipe_buf2--------------------------*/

/*-----------------------------Start: Compute_duration()------------------*/
Compute_duration(ptr,dur, point,type_of_evt)
smod*    ptr;
float*   dur;
int      point;
int      type_of_evt;
{
int      ival1;
int      ival2;
float    val1;
float    val2;
float    rsamp;

rsamp = ptr -> nsamp;
if(type_of_evt==1)
{
    ival1=ptr->man_dur;
}else{
    ival1 = ptr -> qdur[point];            /* Compute duration in seconds       */
}
ival2 = ptr -> rate;
val1=ival1;
val2=ival2;

*dur=val1*rsamp/val2;                  /* Duration station-type 1           */

}
/*-----------------------------End: Compute_duration()----------------------*/

/*-----------------------------Start: Compute_star()------------------------*/

int Compute_start(ptr,dur, inblk, no_of_buf, point, fname, fidx,type_of_evt,tophdr)
smod*    ptr;
float    dur;                          /* duration of event in seconds      */
int      *inblk;                       /* set at the position in the ring   */
                                       /* buffer at which trigger occurred. */
                                       /* To be returned allowing for wrap  */
                                       /* around, and for some pre-event    */
                                       /* time                              */
int      *no_of_buf;                   /* to be returned as the number of   */
                                       /* event buffers that should be      */
                                       /* written into the event file       */
int      point;                        /* number of the event in the queue  */
char*    fname;                        /* name of current file may need to  */
                                       /* be changed for wrap               */
int*     fidx;                         /* index in the buff names- which may*/
                                       /* need changing                     */
int      type_of_evt;
int      tophdr;
{
int      kj;
int      lr;
int      nxt_rbf;
char     detnam[400];
FILE     *idx;

float    ttotal;                       /* total number of seconds for event */
float    val1;                         /* help variable for calculation     */

int      lka;
int      antall;
int      par;
if(type_of_evt==1)
{
    par=MANUAL;
}else{
    par = ptr->qfsmp[point];
}
ttotal=dur + ptr->postmx[par] + ptr->prevnt[par];
/*printf("PAR:%d TTOTAL: %f\n",par,ttotal);*/
                                            /* Total number of seconds      */
val1=1.;                               /* Float of seconds per buffer       */
*no_of_buf=ttotal/val1;              /* Number of buffers for event       */

if(*no_of_buf > ptr->maxbuf[par])      /* Check for wrap-around             */
    *no_of_buf=ptr->maxbuf[par];

*inblk=*inblk-(ptr->prevnt[par]/ptr->sec_buffer)*ptr->reclength;

antall=(abs)(*inblk/(ptr->maxblk * ptr->reclength));
//printf("Computed diskaddress start recording: %d ant: %d\n",*inblk,antall);
if(antall > 0)
{
    *inblk=*inblk + antall*ptr->maxblk*ptr->reclength;
    for(lka=0;lka<antall;lka++)
        (*fidx)--;
}
if(*inblk < tophdr)                        /* Check for backward wrap           */
{
//    printf("BACKWARD WRAP\n");
    *inblk=*inblk+ptr->maxblk*ptr->reclength;
    (*fidx)--;
//    printf("INBLK: %d MAXBLK: %d FIDX: %d\n",*inblk,ptr->maxblk,*fidx);
    if(*fidx < 0) *fidx=*fidx+ptr->nringbuf[0];
    nxt_rbf=*fidx;
/*--------------------------------------------------------------------------*/
/* open the index file and find the corresponding ringbuffer name           */
/*--------------------------------------------------------------------------*/
    idx=fopen("/home/buffer/idx_log","r");
    if(idx == 0)
    {
        sprintf(ptr->err_msg,"CAT_EVT: Unable to open IDX_LOG (Compute_start)");
        errlog(ptr);
        return(-1);
    }
    fseek(idx,nxt_rbf*320,SEEK_SET);
    fread(detnam,320,1,idx);
    for(lr=0;lr<20;lr++)
       fname[lr]=' ';
    for(lr=0;lr<18;lr++)
        fname[lr]=detnam[lr];
//printf("Detection ringbuffer: %s\n",rngbuf);
    fname[18]='\0';
    fclose(idx);
}
//printf("INBLK: %d MAXBLK: %d\n",*inblk,ptr->maxblk);
//printf("Corrected diskaddress start recording: %d\n",*inblk);
return(0);
}
/*-----------------------------End: Compute_start()-------------------------*/
/*-----------------------------Start: Compute_start_pipe()------------------*/

Compute_start_pipe(ptr,dur, inblk, no_of_buf, point)
   smod* ptr;
   float dur;         /* duration of event in seconds */
   int *inblk;      /* set at the position in the ring buffer at which
                       trigger occurred. To be returned allowing for
                       wrap around, and for some pre-event time   */
   int *no_of_buf;  /* to be returned as the number of event buffers
                       that should be written into the event file  */
   int point;       /* number of the event in the queue */
{
    float ttotal;           /* total number of seconds for event  */
    int par;
    par = ptr->qfsmp[point];

    ttotal=dur + ptr->postmx[par] + ptr->prevnt[par];

    *no_of_buf=ttotal;               /* Number of buffers for event  */
    if(*no_of_buf > ptr->maxbuf[par])             /* Check for wrap-around        */
        *no_of_buf=ptr->maxbuf[par];
                                            /* Disk-address incl. pre-event */
   *inblk=*inblk-ptr->prevnt[par];
    if(*inblk < 0)                         /* Check for backward wrap      */
    {
/*        printf("BACKWARD WRAP\n");*/

        *inblk=*inblk+ptr->sec_in_pip;
    }
}
/*-----------------------------End: Compute_start_pipe()--------------------*/
/*-----------------------------Start: Det_rec_only__________________________*/

int Det_rec_only(output, dpx, detfile, ptr)
char*  output;                         /* detection record                  */
int    dpx;                            /* detection number                  */
char*  detfile;                        /* detection file name               */
smod*  ptr;                            /* pointer to shared region          */

{
FILE*  dets;                           /* pointer to detection file         */
int    bytes;                          /* return value after write          */
int    outblk;                         /* disk adress detection record      */
int    lt;                             /* counter                           */

outblk = ((dpx-1) % EVTSIZ) * EVTREC;      /* compute disk adress detection rec */

for(lt=206;lt<234;lt++)                /* fill filename with blanks         */
    output[lt]=' ';

/*--------------------------------------------------------------------------*/
/* Write detection record                                                   */
/*--------------------------------------------------------------------------*/

dets=fopen(DETECTION,"r+");
if(dets == 0)
{
    sprintf(ptr->err_msg,"CAT_EVT: a.Unable to open detection record file.");
    errlog(ptr);
    sprintf(ptr->err_msg,"CAT_EVT: b. Problem with name %s.",DETECTION);
    errlog(ptr);
    sprintf(ptr->err_msg,"CAT_EVT: c. Missed one detection record only");
    errlog(ptr);
    return(-1);
}
fseek(dets,outblk,0);
bytes=fwrite(output,EVTREC,1,dets);
if(bytes==0)
    clearerr(dets);
fclose(dets);
return(0);
}
/*-----------------------------------------Stop: Det_rec_only---------------*/
/****************************************************************************/
/*                 VME OS-9 & PC QNX SEISLOG Software          Version 6.0  */
/****************************************************************************/
/*                                                                          */
/*                                      University of Bergen                */
/*                                      Institute of Solid Earth Physics    */
/*                                      Seismological Observatory           */
/*                                      Allegaten 41, 5007 Bergen, Norway   */
/*                                      Pho +47 55 213408 +47 55 213414     */ 
/*                                      Fax +47 55 233337 +47 55 320009     */
/*                                      Author: Terje Utheim, Jens Havskov  */
/*                                      E-mail: terje.utheim@ifjf.uib.no    */
/*                                              jens.havskov@ifjf.uib.no    */
/*                                                                          */
/*                                      Date:08/03/95                       */
/* Program:                                                                 */
/*                                                                          */
/* Last update:                                                             */
/*                                                                          */
/* Program description:                                                     */
/*                                                                          */
/* Info: The following procedures are contained in this file, they are      */
/*       listed here along with the programs which use them                 */
/*                                                                          */
/* Event_Header: writes out an event header given the information           */
/*               that is needed.                                            */
/*       Used by: Detec_01.c to write headers into each ring buffer         */
/*                Cat_evts.c to write headers into event files              */
/* Event_Name:  makes up the name of an event file                          */
/*       Used by: Dsk_all.c in allocating the ring buffers for cont. record */
/*                Cat_evts.c to make up evnt file names                     */
/*                Detec_01.c to make the names of new continuous records    */ 
/****************************************************************************/

/*--------------------------------------------Start: Event_name-------------*/
/* Make file name from time-string                                          */
/*--------------------------------------------------------------------------*/
Event_Name(rec_time, fnam,point,par,ptr)
  struct date* rec_time;
  char* fnam;
  int point;
  int par;
  smod* ptr;
{   
int i;
/* The format of this event file is as follows:
   YYMM_DD_HHMM_SST.CCC_NN_P
   year,month,day,hour,mins,secs,T=temporary,station code, num of channels 
   P parameter set */
   
   char cyear[4];   /* help variable in cutting the century off year        */
   char* namptr= fnam;    /* index in fnam string                           */
   
//printf("YEAR:%d\n",rec_time->year);
//if(rec_time->year < 50)
//{
//    sprintf(cyear, "%4d", rec_time->year+2000);
//}else{
//    sprintf(cyear, "%4d", rec_time->year+1900);
//}
sprintf(cyear, "%4d",rec_time->year);

sprintf(namptr, "%4s_", cyear);
namptr+=5;
sprintf(namptr, "%2d_", rec_time->month);
namptr+=3;
sprintf(namptr, "%2d_", rec_time->day);
namptr+=3;
sprintf(namptr, "%2d%2d_", rec_time->hour, rec_time->min);
namptr+=5;
sprintf(namptr, "%2dT.", (int) rec_time->secs);
namptr+=4;
strncpy(namptr, ptr->name, 3);                   /* station code            */
namptr+=3;
*namptr++ = '_';
if(par==EXTRACT)
{
    sprintf(namptr, "%2d", ptr->nchan);
}else{   
    sprintf(namptr, "%2d", ptr->nchstr[par]);
}   

namptr+=2;
/*switch(point)*/
switch(par)
{
    case MANUAL:
    sprintf(namptr, "_M");
    break;
    case EXTRACT:
    sprintf(namptr, "_X");
    break;
    case CONTIN:
    sprintf(namptr, "_C");
    break;
    default:
    sprintf(namptr, "_%1d", point);
    break;
}
/********************JUST FOR TESTING**********************/
/*sprintf(fnam,"9504_15_1230_30T.WNN_06_C");*/
/**********************************************************/
/* fill fnam with zeros in all blank spaces */
zero_fill(fnam);

}
/*------------------------------------------End: Event_Name-----------------*/

/*--------------------------------Start: zero_fill-----------------------*/

zero_fill(string)
  char* string;
  
{
    int i;
    for(i=0; i< strlen(string); i++) 
     if(string[i] == ' ') string[i] = '0';
     
}

/*-----------------------------------End: zero_fill----------------------*/

/*---------------------------------------Start: Event_Header----------------*/
/* Create event-header                                                      */
/*  event time is passed in the date structure rec_time, and the header
    is returned in head                                                     */
/*--------------------------------------------------------------------------*/

Event_Header(rec_time, nbuf, head,par,ptr)
struct date* rec_time;
int    nbuf;                           /* number of buffers                 */
char*  head;
int    par;
smod*  ptr;
{
char   dum[10];
int    start_index;                    /* Index building headers            */
char*  hdptr = head;                   /* text pointer to header            */  
/****************************************************************************/
/* FIX FOR USING NEW VERSION SEISLOG 7.8 WITH 6.0 SEISAN                    */
/* YEAR 1999 TRUNCATED TO 99                                                */
/****************************************************************************/
//char*  fixptr = head;
int    l,j,k;                          /* counters                          */
int    newblk;
//dum[0]=0x20;
//dum[1]=0x20;
strncpy(hdptr, ptr->name, 3);          /* Put in station code               */
hdptr+=14;
/****************************************************************************/
/* FIX FOR USING NEW VERSION SEISLOG 7.8 WITH 6.0 SEISAN                    */
/* YEAR 1999 TRUNCATED TO 99                                                */
/****************************************************************************/
//fixptr+=14;
sprintf(hdptr, "%4d ", rec_time->year);

/****************************************************************************/
/* FIX FOR USING NEW VERSION SEISLOG 7.8 WITH 6.0 SEISAN                    */
/* YEAR 1999 TRUNCATED TO 99                                                */
/****************************************************************************/
//k=rec_time->year;
sprintf(hdptr, "%4d ", rec_time->year);

//printf("Inside EVENT_HEADER %d\n",rec_time->year);
hdptr+=5;
sprintf(hdptr,"%3d ", rec_time->doy);
hdptr+=4;
sprintf(hdptr,"%2d %2d     ",rec_time->month, rec_time->day);
hdptr+=9;
sprintf(hdptr,"%2d %2d %6.3f",rec_time->hour,rec_time->min,
                              rec_time->secs);
hdptr = head + 62;
//printf("%d %d %d\n",ptr->nchstr[par],ptr->nchan,par);
if(ptr->nchstr[par] == ptr-> nchan || par == EXTRACT)
{
    sprintf(hdptr, "%2d", ptr->nchan);
}else{
    sprintf(hdptr, "%2d", ptr->nchstr[par]);
}
/* Now need to put in the sample rate information */
/* SAMPLERATE start in position 64  */
hdptr = head+64;                                        
sprintf(hdptr, "%16.7f", ptr->srate);
//printf("EvtHdr1\n");
/* NUMBER OF SAMPLES EACH CHANNEL PER EVENT, 4 BYTE                         */
hdptr = head + 80;
sprintf(hdptr, "%8d       %1d",ptr->nsamp*nbuf, 4);
/* switch to indicate PC */
hdptr=head+93;
sprintf(hdptr,"%1d",2);
/* UNIT NUMBER + BYTES PER BUFFER                                           */  
hdptr = head + 96;
//printf("EvtHdr2\n");
if(ptr->nchstr[par] == ptr-> nchan || par == EXTRACT)
{
    sprintf(hdptr,"%2d      %8d",ptr->unit,ptr->reclength);
}else{
    sprintf(hdptr,"%2d      %8d",ptr->unit,ptr->newrl[par]);
}           
/* BYTES IN HEADER  + NUMBER OF SAMPLES PER CHANNEL                         */
hdptr = head + 112;
/*printf("nchstr[par] %d nchan %d\n",ptr->nchstr[par],ptr->nchan);*/
//printf("EvtHdr3\n");
//printf("PAR=%d EXTRACT= %d\n",par,EXTRACT);
if(ptr->nchstr[par] == ptr->nchan || par==EXTRACT)
{
    newblk=(SIZ_EV_HDR/ptr->reclength+1)*ptr->reclength;
}else{
//printf("EvtHdr3b\n");
//printf("SIZ_EV_HDR:%d NEWRL: %d\n", SIZ_EV_HDR,ptr->newrl[par]);
    newblk=(SIZ_EV_HDR/ptr->newrl[par]+1)*ptr->newrl[par];
}   
//printf("EvtHdr4\n");
sprintf(hdptr,"%5d     %6d",newblk,ptr->nsamp);
remove_null(head,SIZ_EV_HDR); /* DJS to avoid seg fault */
if(ptr->nchstr[par] == ptr->nchan || par==EXTRACT)     /* all channels ?                    */
{
//printf("head\n");
    k=160;
    for(j=0;j<ptr->nchan;j++)
    {
        for(l=j*4;l<(j*4)+4;l++)
        {
            head[k]=ptr -> statio[l];
            head[k+4]=ptr->compon[l];
            k=k+1;
        }
    k=k+4;
    }
}else{                                 /* selected channels                 */
    k=160;
    for(j=0;j<ptr->nchan;j++)
    {
        if(ptr->store[par][j] == 1)
        {
            for(l=j*4;l<(j*4)+4;l++)
            {
                head[k]=ptr -> statio[l];
                head[k+4]=ptr->compon[l];
                k=k+1;
            }
            k=k+4;
        }
    }
}
/* remove all the NULL characters that have been put in the string by the 
   sprintf statements */
remove_null( head, SIZ_EV_HDR); 
}
/*----------------------------------------------End: Event_Header-----------*/

/*----------------------------------------------Start: Time_Conv------------*/
/* Convert and edit timestring                                              */
/*--------------------------------------------------------------------------*/
Time_Conv(input, event_time, ptr)
  int* input;
  struct date* event_time;
  smod* ptr;
{
char    time[15],date[15],doys[5],car;
int data_type;        /* whether to interpret the data as short or int */

/*data_type = find_data_type(ptr);*/
/*if(data_type == SHORT)*/
/*   sscanf((short*)input,"%s %s %s",time,date,doys);*/
/*else*/
   sscanf((char*)input,"%s %s %s",time,date,doys);
//printf("%s %s %s\n",time,date,doys);

sscanf(time,"%2d%c%2d%c%f6.3\n",&(event_time->hour),&car,
                                &(event_time->min),&car,
                                &(event_time->secs));
sscanf(date,"%2d%c%2d%c%4d\n",&(event_time->day),&car,
                              &(event_time->month),&car,
                              &(event_time->year));
sscanf(doys,"%3d\n",&(event_time->doy));
}
/*------------------------------------------------------Stop: Time_Conv-----*/


/*-----------------------------Start: find_data_type()------------------*/
int find_data_type(ptr)
  smod *ptr;
{
     return LONG;
}
/*-----------------------------End: find_data_type()------------------*/

/*-----------------------------------Start: remove_null()-----------------*/
/* makes sure that all intermediate nulol characters are removed          */

remove_null(string, length)
 char* string;
 int length;
{
    int i;
    for(i=0; i<length; i++)
      if(string[i] == NULL) string[i] = ' ';
    string[length] = NULL;
    
}

/*--------------------------------------End: remove_null()----------------*/


/*------start: first_block(ptr, newblk)-------------------------------------*/

/****************************************************************************/
/* Position for first data record is computed so that the length of the     */
/* header is always a multiple of the recordlength >= 1024                  */
/****************************************************************************/
next_block(ptr, newblk, blocknum, par)
smod*    ptr;
int*     newblk;
int      blocknum;
int      par;                          /* current parameter set             */
        
{ 
if(ptr->nchstr[par] == ptr-> nchan || par == EXTRACT)
    {
        *newblk=(SIZ_EV_HDR/ptr->reclength+blocknum)*ptr->reclength;
    }else{
        *newblk=(SIZ_EV_HDR/ptr->newrl[par]+blocknum)*ptr->newrl[par];
    }
}
/*------------------------------------------------------Start:Assign_dpx----*/

int Assign_dpx(dpx_no,detfile)
   int* dpx_no;
   char* detfile;
{

FILE        *in;                  /* Pointer to detnr-file                  */

if((int)(in = fopen(detfile,"r+")) == ERROR)
         return (ERROR);                    /* Open detnr-file              */
fscanf(in,"%d",dpx_no);                     /* Read old detection number    */

*dpx_no = *dpx_no + 1;                      /* Update detection number      */

rewind(in);
fprintf(in,"%8d",*dpx_no);                 /* Write new detection-number   */
fclose(in);                                 /* Close file                   */
return (*dpx_no);
}
/*------------------------------------------------------End:Assign_dpx-----*/

/*-----------------------------Start: Write_info()----------------------*/
Write_info(string, dpx, dur,rec, point,ptr)
  char* string;
  int dpx;
  float dur;
  struct date* rec;
  int point;
  smod* ptr;

{
 int beamnr = 99;                         /* Dummy                        */
 int filternr= 99;                       /* Dummy                        */
 float freq  =   1.0;                        /* Dummy                        */
 float vel   =   2.0;                        /* Dummy                        */
 float azi   =   3.0;                        /* Dummy                        */
 float pwr   =   4.0;                        /* Dummy                        */ 

 float rsta = 0;
 float rlta = 0;
 float rampl = 0;
 int detsmp = 0;
 int detblk = 0;
if(point > -1)
{
    rsta = ptr->qsta[point];
    rlta = ptr->qlta[point];
    rampl = ptr->qamp[point];
    detsmp = ptr->qfsmp[point];
    detblk = ptr->qfblk[point]/ptr->reclength;
}
 
sprintf(string,"%15d %4d%4d%4d%4d%4d%4d%8.3f%8d%8d%16.3f\
%16.3f%16.3f%16.3f%8.3f%8.3f%8.3f%8.3f%16d%8d%8d%4d%4d",\
dpx,rec->year,rec->doy,rec->month,rec->day,rec->hour,
rec->min,rec->secs,beamnr,\
filternr,dur,rsta,rlta,rampl,freq,vel,azi,pwr,detblk,0,detsmp,ptr->prevnt[0],ptr->postmx[0]);
//printf("WRITE_INFO: YEAR=%d\n",rec->year);
string[192]=32;                         /* Set NUL byte to blank after write*/
 

}

/*-----------------------------End: Write_info()----------------------*/
/*-----------------------------Start: make_post()----------------------*/
make_post(string, dpx, dur,rec, point,ptr,rng)
  char* string;
  int dpx;
  float dur;
  struct date* rec;
  int point;
  smod* ptr;
  int rng;
{
FILE*    buf;                          /* pointer to file                   */
 float rsta = 0;
 float rlta = 0;
 float rampl = 0;
 int detsmp = 0;
 int detblk = 0;
if(point > -1){
 rsta = ptr->qsta[point];
 rlta = ptr->qlta[point];
 rampl = ptr->qamp[point];
 detsmp = ptr->qfsmp[point];
 detblk = ptr->qfblk[point]/ptr->reclength;
 }

sprintf(string,"\nEVT:%5d %4d/%2d/%2d %2d:%2d:%6.3f %3d%6.1f%6.1f %s\n",
dpx,rec->year,rec->month,rec->day,rec->hour,rec->min,rec->secs,rec->doy,
rsta,rlta,ptr->thisevent);

if(string[15]==' ')string[15]='0';
if(string[16]==' ')string[16]='0';

if(string[18]==' ')string[18]='0';
if(string[19]==' ')string[19]='0';

if(string[21]==' ')string[21]='0';
if(string[22]==' ')string[22]='0';

if(string[24]==' ')string[24]='0';
if(string[25]==' ')string[25]='0';

if(string[27]==' ')string[27]='0';
if(string[28]==' ')string[28]='0';
if(string[30]==' ')string[30]='0';
if(string[31]==' ')string[31]='0';
if(string[32]==' ')string[32]='0';

if((buf=fopen("/home/work/newmail.txt","r"))!=NULL)
{
    fclose(buf); 
    system("rm -f /home/work/newmail.txt"); /* remove it                 */
}   
if((buf=fopen("/home/work/newmail.txt","a"))!=NULL)
{
    fprintf(buf,"%s\n",string);
    fclose(buf); 
}   
}
/*---------------------------------Start: Det_record()----------------------*/

int Det_record(output, dpx, detfile, ptr)
char*  output;                         /* detection record                  */
int    dpx;                            /* detection number                  */
char*  detfile;                        /* detection file name               */
smod*  ptr;                            /* pointer to shared region          */
  
{
FILE*  dets;                           /* pointer to detection file         */
int    bytes;                          /* return value after write          */
int    outblk;                         /* disk adress detection record      */

outblk = ((dpx-1) % EVTSIZ) * EVTREC;      /* compute disk adress detection rec */
   
/*--------------------------------------------------------------------------*/
/* Write detection record                                                   */
/*--------------------------------------------------------------------------*/

dets=fopen(detfile,"r+");
if(dets == 0)
{
    sprintf(ptr->err_msg,"CAT_EVT: a.Unable to open detection record file.");
    errlog(ptr);
    sprintf(ptr->err_msg,"CAT_EVT: b. Problem with name %s.",detfile);
    errlog(ptr);
    return(-1);
}
/*printf("\ndet_record: outblk is: %d", outblk);*/
fseek(dets,outblk,0);
bytes=fwrite(output,EVTREC,1,dets);
if(bytes==0)
    clearerr(dets);
fclose(dets);
return(0);
}
/*-----------------------------------End: Det_record()----------------------*/

/*--------------------------------------------Start:Blank-------------------*/
/* Puts the number of blanks specified by length in the string argument     */
Blank(string, length)
  char *string;
  int length;
{
    int i;
    for(i=0;i<length;i++){
        string[i] = 32;
    }
    string[length] = 0;
}
/*--------------------------------------------Stop:Blank--------------------*/
/****************************************************************************/
/* set blanks to zero in some positions                                     */
/****************************************************************************/
zero_pad(string)
char* string;
{
    int i;
    for(i=0;i< 12; i++)
        if(string[i] == ' ') string[i]='0';
    for(i=13;i< 23; i++)
        if(string[i] == ' ') string[i]='0';
    for(i=24;i< 27; i++)
        if(string[i] == ' ') string[i]='0';
    string[23]=' ';
    }



/*--------------------------------------------------------------------------*/
/*                                                                          */
/* Read_Station_File                                                        */
/* -----------------                                                        */
/* Calling sequence: ret=Read_Station_File(velocity,h0,ndepth,c11,c22,c33,  */
/*                       slon1,slon2,slat1,slat2,statreg,slatt1,slonn1,     */
/*                       nstation);                                         */
/* where:                                                                   */
/* ret      return value -1 ERROR 1 OK                int ret               */
/* velocity velocity                                  float velocity[10]    */
/* h0       starting depth                            float h0              */
/* ndepth   number of depths to test                  int ndepth            */
/* c11      coda parameter                            float c11             */
/* c22      coda parameter                            float c22             */
/* c33      coda parameter                            float c33             */
/* slon1    minimum longitude                         float slon1           */
/* slon2    maximum longitude                         float slon2           */
/* slat1    minimum latitude                          float slat1           */
/* slat2    maximum latitude                          float slat2           */
/* statreg  station names                             char  statreg[100][5] */
/* slatt1   station latitude                          float slatt1[100]     */
/* slonn1   station longitude                         float slonn1[100]     */
/* nstation number of stations in station file        int   nstation        */
/*--------------------------------------------------------------------------*/
Read_Station_File(velocity,h0,ndepth,c11,c22,c33,slon1,slon2,slat1,slat2,statreg,slatt1,slonn1,nstation)
float velocity[];
float *h0;
int   *ndepth;
float *c11;
float *c22;
float *c33;
float *slon1;
float *slon2;
float *slat1;
float *slat2;
char  statreg[100][5];
float slatt1[];
float slonn1[];
int   *nstation;
{
int   i;
int   k;
float hh0;
int   nndepth;

FILE  *sta;

if((int)(sta=fopen("/home/seislog/pr/station","r"))==NULL)
    return(-1);

/*   read velocites*/

fscanf(sta,"%f %f",&velocity[1],&velocity[2]);

/*  read fixed depth or starting depth and number of depths to test*/
/*  if number of test depths is 1, only the first start depth is used*/

fscanf(sta,"%f  %d",&hh0,&nndepth);
*h0=hh0;
*ndepth=nndepth;

/*  read coda scale parameters*/
fscanf(sta,"%f %f %f",c11,c22,c33);

//  read min/max long and lat

fscanf(sta,"%f %f %f %f",slon1,slon2,slat1,slat2);

i=0;
read_station:
while(k=fscanf(sta,"%s %f %f",statreg[i],&slatt1[i],&slonn1[i])!=EOF)
{
    i=i+1;
    goto read_station;
}
fclose(sta);
*nstation=i;
return(1);
}

/*--------------------------------------------------------------------------*/
/*                                                                          */
/* MAX_AMPL                                                                 */
/* --------                                                                 */
/* Calling sequence: MAX_AMPL(ne,arry,sr,where,maxamp)                      */
/* where:                                                                   */
/* ne       number of samples                         int ne                */
/* arry     array with samples                        float arry            */
/* sr       sample rate in seconds                    float sr              */
/* where    second for max amplitude                  float where           */
/* maxamp   maximum amplitude in arry                 float maxamp          */
/* c22      coda parameter                            float c22             */
/*--------------------------------------------------------------------------*/
MAX_AMPL(ne,arry,sr,where,maxamp)
int   ne;
float arry[];
float sr;
float *where;
int *maxamp;
{
int i;
int maxa;
float fmax;    
float whmax;
fmax=0.0;
for(i=0;i<ne;i++)                      /* find max value                    */
{
//printf("%5d %10.3f %10.2f\n",i,(float)i*sr,arry[i]);
//getch();
    if(fabs(arry[i]) > fmax)
    {
        fmax=fabs(arry[i]);
        whmax=(float)i*sr;
    }
}
if(fmax == 0.0)
    fmax=1.;
maxa=(int)fmax;

//printf("MAX %d %10.2f\n",maxa,whmax);
//getch();

*where=whmax;                          /* return time for max amplitude     */
*maxamp=maxa;                          /* return maximum amplitude          */
}
/*--------------------------------------------------------------------------*/
/*                                                                          */
/* STA_LTA                                                                  */
/* -------                                                                  */
/* Calling sequence: STA_LTA(sr,ne,arry,ch,ws,wl,rat)                       */
/* where:                                                                   */
/* sr        sample rate in seconds                   float sr              */
/* ne        number of samples                        int   ne              */
/* arry      array with samples                       float arry            */
/* ws        short window in samples                  int   ws              */
/* wl        long window in samples                   int   wl              */
/* rat       array SNR                                float rat             */
/*--------------------------------------------------------------------------*/
STA_LTA_PH(sr,ne,arry,ws,wl,rat)
float    sr;                           /* sample rate                       */
int      ne;                           /* number of samples in vector       */
float    arry[];                       /* data vector                       */
int      ws;
int      wl;
float    rat[];
{
float    sta1;
float    lta1;
float    R;                            /* ratio sta/lta                     */
int      j;                            /* index                             */
float    extra;

/*--------------------------------------------------------------------------*/
/* compute running sta (squared values)                                     */
/* compute running lta (squared values)                                     */
/* compute running ratio sta/lta                                            */
/* save max ratio and corresponding sample index                            */
/*--------------------------------------------------------------------------*/ 
for(j=1;j<ne-1;j++)
{
    extra=arry[j]-arry[j-1];
    extra=extra*extra;
    sta1=sta1+(fabs(arry[j-1]) * fabs(arry[j-1])+3.* extra-sta1)/ws;
    lta1=lta1+(fabs(arry[j]) * fabs(arry[j])-lta1)/wl;
    R=sta1/lta1;
    rat[j]=R;
//printf("%5d %10.2f\n",j,rat[j]);
//getch();
}       
}
/*--------------------------------------------------------------------------*/
/*                                                                          */
/* SMOOTH                                                                   */
/* ------                                                                   */
/* Calling sequence: SMOOTH(ne,in,out)                                      */
/* where:                                                                   */
/* ne        number of samples                        int   ne              */
/* in        array with input samples                 float in              */
/* out       array with output samples                float out             */
/*--------------------------------------------------------------------------*/
SMOOTH(ne,in,out)
int ne;
float in[];
float out[];
{
int i;
float coeff=1./3.;
for(i=1;i<ne-1;i++)
    out[i]=coeff * (in[i-1] + in[i] + in[i+1]);
out[0]=coeff * (2. * in[0] + in[1]);
out[ne-1]=coeff * (2. * in[ne-1] + in[ne-2]);
}
/*--------------------------------------------------------------------------*/
/*                                                                          */
/* DERIV                                                                    */
/* -----                                                                    */
/* Calling sequence: DERIV(start,stopp,sr,arry,ne)                          */
/* where:                                                                   */
/* start     start second to begin derivation         float start           */
/* stopp     stopp second to stopp derivation         float stopp           */
/* sr        samplerate in seconds                    float sr              */
/* arry      array with input samples                 float arry            */
/* ne        number of samples                        int   ne              */
/*--------------------------------------------------------------------------*/
DERIV(start,stopp,sr,arry,ne)
float    start;                        /* start second                      */
float    stopp;                        /* stopp second                      */
float    sr;                           /* sample rate                       */
float    arry[];
int      ne;                           /* number of samples in vector       */
{
int      start_indx;                   /* index to start computing average  */
int      stopp_indx;                   /* index to stopp computing average  */
int      j;

start_indx=(int)start/sr;
stopp_indx=(int)stopp/sr;

/* first x2-x1 */
for(j=start_indx+1;j<ne-1;j++)
{
    arry[j]=arry[j+1]-arry[j];
    if(arry[j] < 0.0)
        arry[j]=0.0;
}
}
SEARCH(samp_indx,start,stopp,data,ne,sr,peak,TIME_MAX_AMP)
float  samp_indx;                      /* time ind seconds max amplitude    */
float  start;                          /* start_second                      */
float  stopp;                          /* stopp second                      */
float* data;
int    ne;
float  sr;
float* peak;
float  TIME_MAX_AMP;
{
int smp_max_amp;                       /* sample maximum amplitude          */
int j;
float maxtop;
int sample_top;
float to_zero;
int   sindx;
int   start_indx;                      /* start index                       */
int   stopp_indx;                      /* stopp index                       */
start_indx=(int)(start/sr)+100;
stopp_indx=(int)(stopp-start)/sr;
smp_max_amp=(int)(samp_indx/sr);    /* index maximum amplitude           */
/*--------------------------------------------------------------------------*/
/* find max top and corresponding sample                                    */
/*--------------------------------------------------------------------------*/

maxtop=0.0;
for(j=start_indx;j<stopp_indx;j++)
{
//printf("%6d %10.3f %10.3f %10.3f\n",j,(float)(j)*sr,maxtop,data[j]);
//getch();
    if(data[j] >= maxtop)
    {
        maxtop=data[j];
        sample_top=j;
//        goto okk;
    }
}
//        printf("MAX=%10.3f Time=%10.3f\n",maxtop,(float)(sample_top)*sr);
//printf("Cant find MAX\n");
//exit(0);
//okk:
sindx=sample_top;
if((TIME_MAX_AMP-(float)sample_top*sr) > 10.0)
{
    to_zero=10.0;
}else{
    to_zero=3.0;
}
for(j=(sindx-(int)(to_zero/sr));j<(sindx+(int)(to_zero/sr));j++)
    data[j]=0.0;
//printf("maxtop %10.3f\n",maxtop);
//getch();
//for(j=sample_top-10;j<sample_top+10;j++)
//    data[j]=0.0;
*peak=(float)sample_top*sr;         /* time in seconds max top           */
}
/*-----------------------------------------------------------------------*/
/* demultiplex one channel                                               */
/*-----------------------------------------------------------------------*/
dmx(isamp,nsamp,ichan,nchan,iworkl,data)
int isamp;
int nsamp;
int ichan;
int nchan;
int iworkl[];
float data[];
{
int i;
int bufsiz;

bufsiz=nsamp*nchan+HEADER;
for(i=HEADER+ichan-1;i<bufsiz;i=i+nchan)
{
    data[isamp]=(float)iworkl[i];
    isamp=isamp+1;
}
return(isamp);
}
/*-------------------------------------------------------------------------*/
/* Get filenames on old detections and their duration                      */
/*-------------------------------------------------------------------------*/
dpxnam(i,infile,ttotal)
int i;
char* infile;
float* ttotal;
{
    FILE    *det;
    int     nn;
    int     kl;
    char    detrec[512];
    char    dur[16];
    int     istart;
    float   locdur;
    det=fopen(DETECTION,"r");
    nn=i/EVTSIZ;
    kl=nn*EVTSIZ;
    istart=(i-1-kl)*512;
    fseek(det,istart,0);
    fread(detrec,512,1,det);
    for(kl=0;kl<DIRNAMLEN;kl++)
        infile[kl]='\0';
    for(kl=0;kl<28;kl++)
        infile[kl]=detrec[kl+206];
    for(kl=0;kl<16;kl++)
        dur[kl]=detrec[kl+64];
    sscanf(dur,"%f8.3\n",&locdur);
    *ttotal=locdur;
    fclose(det);
}


void log_val (char *str)
{
 char *file = "/home/seislog/dpl_log";
 FILE *fp;

  fp = fopen (file, "a");
  fprintf (fp, "%s", str);
  fclose (fp);
}