#include "shar_mem.h"                  /* shared memory definitions         */
#include <sys/mman.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <netinet/in.h>
#include <sys/select.h>
#include <netdb.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>

#include <fcntl.h>

#define TRUE 1

/*
* This program uses  select() to check that someone is trying to connect
* before calling accept().
*/

main()
{
int      fd;                                /* return value open share      */
smod     *ptr;                              /* pointer to shared region     */
  int sock, length;
  struct sockaddr_in server;
  int msgsock;
  char buf[1024];
  char filnavn[50];
  int rval;
  fd_set ready;
  struct timeval to;
  
  FILE *in;
  int fildes;
  unsigned int fSize;
  unsigned int table[10];
  unsigned char b1,b2,b3,b4;  
  unsigned char data[3000];
  int buf_cnt;
  int nblk;
  int rest;
  int i;
  buf_cnt=0;
/*--------------------------------------------------------------------------*/
/* open shared memory region                                                */
/*--------------------------------------------------------------------------*/
fd=shm_open("SEISLOG",O_RDWR | O_CREAT, 0777);
if(fd== -1) 
{
    fprintf(stderr,"ONN_01 open failed:%s\n",strerror(errno));
    exit(1);
}
/*--------------------------------------------------------------------------*/
/* set size of memory region                                                */
/*--------------------------------------------------------------------------*/
ltrunc(fd,sizeof(smod),SEEK_SET);
/*--------------------------------------------------------------------------*/
/* Compute pointer to shared memory region                                  */
/*--------------------------------------------------------------------------*/
ptr=mmap(0,sizeof(smod),PROT_READ | PROT_WRITE,MAP_SHARED,fd,0);
if((int)ptr == -1) 
{
    fprintf(stderr,"ONN_02 mmap failed : %s\n",strerror(errno));
    exit(1);
}
/* Create socket */
  sock = socket(AF_INET, SOCK_STREAM, 0);
  if (sock < 0) 
  {
    perror("opening stream socket");
    exit(1);
  }
/* Name socket using wildcards */
  server.sin_family = AF_INET;
  server.sin_addr.s_addr = htonl(INADDR_ANY);
  server.sin_port = htons(5000);
  if (bind(sock, (struct sockaddr *)&server, sizeof(server))) 
  {
    perror("binding stream socket");
    exit(1);
  }
/* Find out assigned port number and print it out */
  length = sizeof(server);
  if (getsockname(sock, (struct sockaddr *)&server, &length)) 
  {
    perror("getting socket name");
    exit(1);
  }
  printf("Socket has port #%d\n", ntohs(server.sin_port));

/* Start accepting connections */
  listen(sock, 5);
  do 
  {
    FD_ZERO(&ready);
    FD_SET(sock, &ready);
    to.tv_sec = 5;
    if (select(sock + 1, &ready, 0, 0, &to) < 0) 
    {
      perror("select");
      return EXIT_FAILURE;
    }
    if (FD_ISSET(sock, &ready)) 
    {
      msgsock =  accept(sock, (struct  sockaddr *)0, (int *)0);
      if (msgsock == -1) 
      {
        perror("accept");
		return EXIT_FAILURE;
      } else
             {
for(i=0;i<50;i++)
  buf[i]=' ';
               rval=read(msgsock,buf,41);  //  receive filename
               buf[42]='\0';

printf("BYTES=%3d %s\n",rval,buf);
sprintf(filnavn,"%s\n",buf);

               memset(buf, 0, sizeof(buf));
//               in=fopen("/home/work/1999_11_03_1953_55T.GUC_03_1","r");
//               fildes=open("/home/work/1999_11_03_1953_55T.GUC_03_1",O_RDONLY);
printf("FILNAVN: %s\n",filnavn);
filnavn[41]='\0';
               fildes=open(filnavn,O_RDONLY);
printf("FILDES=%d\n",fildes);
//sleep(20);
               if(fildes != -1)
               {
                 fSize=filelength(fildes);
//printf("SIZE %d\n",fSize);
                 b1=fSize;
                 b2=fSize>>8;
                 b3=fSize>>16;
                 b4=fSize>>24;
                 table[0]=b1;
                 table[0]=table[0]<<8 | b2;
                 table[0]=table[0]<<8 | b3;
                 table[0]=table[0]<<8 | b4;
                 close(fildes);
                 nblk=fSize/664;
                 rest=fSize-664*nblk;
//printf("NBLK=%d REST=%d\n",nblk,rest);

                 rval=write(msgsock,table,4);  // W1    send size

                 printf("RVAL=%d\n",rval);
               }else{
                 sprintf(buf,"File does not exist\n");
                 write(msgsock,buf,sizeof(buf));
               }

               rval=read(msgsock,buf,1);  // R2 receive confirmation

               if(rval !=-1)
               {
                 printf("client says it has got the filesize\n");
               }else{
                 printf("no signature from client\n");
                 goto idle;
               }
               in=fopen(filnavn,"r");
               buf_cnt=0;
               for(i=0;i<nblk;i++)
               {
      ptr->servers[5]=1;
                 rval=read(msgsock,buf,1); // R4 receive confirmation

                 fread(data,664,1,in);

                 write(msgsock,data,664);  // W3 send data buffer

                 rval=read(msgsock,buf,1); // R4 receive confirmation

                 buf_cnt++;
                 printf("%5d buffers\n",buf_cnt);
//sleep(2);
               }
               printf("FINISHED LOOP, wait for client\n");
               read(msgsock,buf,1);
if(rest != 0)
{
               fread(data,rest,1,in);
               write(msgsock,data,rest);
               printf("Last rest sent\n");
}
               rval=read(msgsock,buf,1);
               printf("Client says hi has got it\n");
               
               fclose(in);
               rval=read(msgsock,buf,1);
               goto idle;
             }
idle:
             close(msgsock);
    } else
      printf("SNDFILE idle\n");
      ptr->servers[5]=1;
  } while (TRUE);
}


