/****************************************************************************/
/*                       PC QNX SEISLOG Software              Version 7.0   */
/****************************************************************************/
/*                                                                          */
/*                                      University of Bergen                */
/*                                      Institute of Solid Earth Physics    */
/*                                      Seismological Observatory           */
/*                                      Allegaten 41, 5007 Bergen, Norway   */
/*                                      Tlf. +47 55 213408 +47 55213419     */
/*                                      Fax  +47 55 233337 +47 55320009     */
/*                                      Author: Terje Utheim, Jens Havskov  */
/*                                      E-mail: terje.utheim@ifjf.uib.no    */
/*                                              jens.havskov@ifjf.uib.no    */
/*                                                                          */
/*                                      Date:14/04/96                       */
/* Program:STP                                                              */
/*                                                                          */
/* Last update:                                                             */
/*                                                                          */
/* Program description:                                                     */
/*                                                                          */
/* Force data acquisition to stop                                           */
/*                                                                          */
/****************************************************************************/
#include <stdio.h>
#include <sys/mman.h>
#include <fcntl.h>
#include <stdlib.h>
#include "shar_mem.h"
main()
{
int      fd;                                /* return value open share      */
smod     *ptr;                              /* pointer to shared region     */
/*--------------------------------------------------------------------------*/
/* open shared memory region                                                */
/*--------------------------------------------------------------------------*/
fd=shm_open("SEISLOG",O_RDWR | O_CREAT, 0777);
if(fd== -1) 
{
    fprintf(stderr,"ONN_01 open failed:%s\n",strerror(errno));
    exit(1);
}
/*--------------------------------------------------------------------------*/
/* set size of memory region                                                */
/*--------------------------------------------------------------------------*/
ltrunc(fd,sizeof(smod),SEEK_SET);
/*--------------------------------------------------------------------------*/
/* Compute pointer to shared memory region                                  */
/*--------------------------------------------------------------------------*/
ptr=mmap(0,sizeof(smod),PROT_READ | PROT_WRITE,MAP_SHARED,fd,0);
if((int)ptr == -1) 
{
    fprintf(stderr,"ONN_02 mmap failed : %s\n",strerror(errno));
    exit(1);
}
    
    system("slay -f -Q buf_pip");
    system("slay -f -Q cat_pph");
    system("slay -f -Q cat_evt");
    system("slay -f -Q det_evt");
    system("slay -f -Q sei_act");
    system("slay -f -Q sei_acw");
    system("slay -f -Q tap_bck");
    system("slay -f -Q clk_cpu");
    system("slay -f -Q clk_gnp");
    system("slay -f -Q clk_gpp");
    system("slay -f -Q clk_ms1");
    system("slay -f -Q clk_pps");
    system("slay -f -Q set_edn");
    ptr->stop[0]=1;
    sleep(2);
    system("slay -f -Q dec_mat");
    system("slay -f -Q dig_eda");
    system("slay -f -Q dig_edn");
    system("slay -f -Q dig_edm");
    system("slay -f -Q dig_ed2");
    system("slay -f -Q dig_ge1");
    system("slay -f -Q dig_ge2");
    system("slay -f -Q dig_gur");
    system("slay -f -Q dig_g24");
    system("slay -f -Q dig_i24");
    system("slay -f -Q dig_irs");
    system("slay -f -Q dig_gbv");
    system("slay -f -Q dig_met");
    system("slay -f -Q dig_me2");
    system("slay -f -Q dig_n24");
    system("slay -f -Q dig_hhh");
    system("slay -f -Q dig_low");
    system("slay -f -Q dig_nan");
    system("slay -f -Q dig_rbo");
    system("slay -f -Q dig_ram");
    system("slay -f -Q dig_ror");
    system("slay -f -Q dig_324");
    system("slay -f -Q dig_syn");
    system("slay -f -Q dig_evr");
    system("slay -f -Q dig_wav");
    system("slay -f -Q gur_rst");
    system("slay -f -Q clean1");
    system("slay -f -Q clean2");
    system("slay -f -Q clean3");
    system("slay -f -Q mul_ser");
    system("slay -f -Q mul_eda");
    system("slay -f -Q mul_ser2");
    system("slay -f -Q sts_msg");
    system("slay -f -Q cmd");
    system("slay -f -Q dig_s07");
    system("slay -f -Q dig_s08");
    system("slay -f -Q dig_ser");
    system("slay -f -Q dig_ser2");
    system("slay -f -Q dig_m18");
    system("slay -f -Q dig_bbc");
    system("slay -f -Q bbc_trg");
    system("slay -f -Q par_gps");
    system("slay -f -Q req_tid");
    system("slay -f -Q par_mrk");
    system("slay -f -Q sys_wat");
    system("slay -f -Q tim_avg");
    system("slay -f -Q watchdog");
    system("slay -f -Q mon");
    system("slay -f -Q dpl");
	system("slay -f -Q ili_seis");
    system("slay -f -Q jmon_s");
    system("slay -f -Q jall_s");
    system("slay -f -Q jrtp_s");
    system("slay -f -Q sndfile");
    system("slay -f -Q web_mon");
    system("slay -f -Q jlgs_s");
    system("slay -f -Q jsts_s");
    system("slay -f -Q jlgf_s");
    system("slay -f -Q fast");
    system("/home/seislog/cls");
    printf("\n");
    printf("\n");
    printf("\n");
    printf("\n");
    printf("\n");
    printf("\n");
    printf("                       SEISLOG Data Acquisition stopped\n");
    system("on -t /dev/con1 /home/seislog/avslutt");
}