/****************************************************************************/
/*                       PC QNX SEISLOG Software              Version 6.0   */
/****************************************************************************/
/*                                                                          */
/*                                      University of Bergen                */
/*                                      Institute of Solid Earth Physics    */
/*                                      Seismological Observatory           */
/*                                      Allegaten 41, 5007 Bergen, Norway   */
/*                                      Tlf. +47 55 213408 +47 55213419     */
/*                                      Fax  +47 55 233337 +47 55320009     */
/*                                      Author: Terje Utheim, Jens Havskov  */
/*                                      E-mail: terje.utheim@ifjf.uib.no    */
/*                                              jens.havskov@ifjf.uib.no    */
/*                                                                          */
/*                                      Date:21/12/94                       */
/* Program: STS                                                             */
/*                                                                          */
/* Last update:                                                             */
/*                                                                          */
/* Program description:                                                     */
/*                                                                          */
/*      Lists out diffferent variables and constants from shared common     */
/*                                                                          */
/****************************************************************************/
#include "shar_mem.h"                  /* shared memory definitions         */
#include <sys/mman.h>
#include <fcntl.h>
#include <errno.h>
#include <stdlib.h>

long   var;
int    i;
int    bp;
main ()
{
int      fd;                                /* return value open share      */
smod     *ptr;                              /* pointer to shared region     */
/*--------------------------------------------------------------------------*/
/* open shared memory region                                                */
/*--------------------------------------------------------------------------*/
fd=shm_open("SEISLOG",O_RDWR | O_CREAT, 0777);
if(fd== -1) 
{
    fprintf(stderr,"STS01 open failed:%s\n",strerror(errno));
    exit(1);
}
/*--------------------------------------------------------------------------*/
/* set size of memory region                                                */
/*--------------------------------------------------------------------------*/
ltrunc(fd,sizeof(smod),SEEK_SET);
/*--------------------------------------------------------------------------*/
/* Compute pointer to shared memory region                                  */
/*--------------------------------------------------------------------------*/
ptr=mmap(0,sizeof(smod),PROT_READ | PROT_WRITE,MAP_SHARED,fd,0);
if((int)ptr == -1) 
{
    fprintf(stderr,"STS_02 mmap failed : %s\n",strerror(errno));
    exit(1);
}

system("/home/seislog/cls");
switch(ptr->unit)
{
    case 30:
printf("Unit used for digitizing of data   :   MET_%2d                 UNIT\n",\
ptr->unit);
    break;
    case 37:
printf("Unit used for digitizing of data   :   RBO_%2d                 UNIT\n",\
ptr->unit);
    break;
    case 11:
printf("Unit used for digitizing of data   :   VADC%2d                 UNIT\n",\
ptr->unit);
    break;
    case 21:
printf("Unit used for digitizing of data   :   VADC%2d                 UNIT\n",\
ptr->unit);
    break;
    case 36:
printf("Unit used for digitizing of data   :   VADC%2d                 UNIT\n",\
ptr->unit);
    break;
    case 53:
printf("Unit used for digitizing of data   :      RD3\
                 UNIT\n",ptr->unit);
    break;
    case 56:
printf("Unit used for digitizing of data   :      RD6\
                 UNIT\n",ptr->unit);
    break;
    case 63:
printf("Unit used for digitizing of data   :EarthData\
                 UNIT\n",ptr->unit);
    break;
    case 95:
printf("Unit used for digitizing of data   :      ILI\
                 UNIT\n",ptr->unit);
    break;
    case 96:
printf("Unit used for digitizing of data   :Synthetic\
                 UNIT\n",ptr->unit);
    break;

}
printf("Number of channels specified       : %8d channels        NCHAN\n",\
ptr->nchan);
printf("Size of EVENT specified in bytes   : %8d bytes           Event_Size\n",\
EVTSIZ);
var=ptr->Data_Size * MEGA;
printf("Size of DATA  specified in bytes   : %8ld bytes           Data_Size\n",\
var);
printf("Header in 4 byte integer           : %8d 4-byte integer  HEADER\n",\
HEADER);
printf("Number of samples/channel/buffer   : %8d samp/ch/buf     NSAMP\n",\
ptr->nsamp);
printf("Buffersize for this configuration  : %8d 4-byte integer  BUFSIZ\n",\
ptr->bufsiz);
printf("Recordsize in bytes RAM CIRCLE     : %8d bytes     \
      RECLENGTH\n",\
ptr->reclength);
printf("Recordsize in bytes HD CIRCLE      : %8d bytes     \
      RECLENGTH_HD\n",\
ptr->reclength_HD);
printf("Number of records on DATA RAM      : %8d records         MAXBLK\n",\
ptr->maxblk);
printf("Number of records on DATA HD       : %8d records         MAXBLK_HD\n",\
ptr->maxblk_HD);
printf("Number of seconds on DATA          : %8d seconds\n",\
ptr->maxblk*ptr->sec_buffer);
printf("Number of records on EVENT         : %8d records         NBLKA\n",\
ptr->nblka);
printf("Array propagation window in buffers: %8d records         PREMAX\n",\
ptr->premax[0]);
printf("Array propagation window in seconds: %8d seconds         PAR_PREMAX\n",\
ptr->premax[0]);
printf("Maximum recording time in buffers  : %8d buffers         MAXBUF\n",\
ptr->maxbuf[0]);
printf("Number of records in ERRLOG        : %8d records         ERRBLK\n",\
ERRREC);
printf("Record length ERRLOG in bytes      : %8d bytes           SIZE_ERR\n",\
ERRSIZ);
printf("Size shared buffer in 4 byte words : %8d bytes           SHARE_SIZ\n",\
ptr->share_siz);
printf("Seconds of data in memory pipe     : %8d seconds         SECONDS\n",\
PIPSIZ*4/ptr->reclength);
printf("Seconds of data in CIRCLE          : %8d seconds         SECONDS\n",\
ptr->sec_in_crc);
}
