/*************************************************************************

TIME PROCEDURES - HEADER FILE

TIMSEC -  Converts time in year, month, day, hour, minutes and seconds
          to double precision seconds after 1/1/1900
SECTIM -  Converts double precision seconds after 1/1/1900 to year,
          day-of-year and date
DTE    -  Converts day-of-year to date
TIMDIF -  Calculates time-difference in double precision secondes of two
          input dates (year,month,day,hour,minute,second)
TIMADD -  Adds double precision seconds to date, and returns the new date

Original Fortran routines by Leif Kvamme 9-4-87

Translated into C by Jane Exton 21/10/92

******************************************************************************/

/* structure definition of date */
#define START 1900
#define TRUE 1
#define FALSE 0

#define SECPERHOUR 3600.0
#define SECPERDAY 86400.0
#define SECPERYEAR 31536000.0

struct date {
             int year;         
             int month;
             int day;
             int hour;
             int min;
             int doy;            /* day of year */
             float secs;         /* seconds     */
             double abs_secs;     /* seconds from 1/1/1900 */
            };

void sectim();
void timsec();
void dte();
double timdif();
void timadd();



