/************************************************************************
  Program name is        TS.F                                           *
 ************************************************************************
     This program will read the two variables  PDETNR & DETNR           *
 	 and also the max_event number (usually 100)                        *
     These hold the number of the last event transferred (PDETNR)       *
      and the currently most recent event number (DETNR).               *
                                                                        *
     They will be displayed on the terminal for quick viewing access    *
     The user has the option of resetting PDETNR if required            *
 ************************************************************************
                                                                        *
   Modified 13-June-91 to pick up the max no of allowed events from     *
   the param file.                                                      *
                                                                        *
   Modified 21-Dec-92 to increase pdetnr from i3 to i4                  *
   Modifed 25.03.96 RJC pdetnr and detnr files now held in /dd/sl/pr    *
   Modified 16.09.97 SMF for Seislog 7.0 (QNX) and converted from       *
                     FORTRAN to C                                       *
 ************************************************************************/

#include <stdio.h>
#include <string.h>

/* names and loctions of detection files */
#define DETNR	"/home/seislog/pr/detnr"
#define PDETNR	"/home/seislog/pr/pdetnr"

void main (void)

{

  int pdetnr, detnr, maxevents, newno;
  FILE *fp;
  
  
  fp = fopen (PDETNR, "r");
  if (! fp)
  {
    printf("ERROR - Problem opening %s\n", PDETNR);
	exit (1);
  }
  fscanf (fp, "%d", &pdetnr);
  fclose (fp);
  fp = fopen (DETNR, "r");
  if (! fp)
  {
    printf("ERROR - Problem opening %s\n", DETNR);
	exit (1);
  }
  fscanf (fp, "%d", &detnr);
  fclose (fp);

  /* pick up the max no of events from the parameter file */
  /* call getparam(maxevents) */
  maxevents=999;

  printf("            TRANSTAT displays and changes the transfer numbers 21-Dec-92\n");
  printf("            ============================================================\n");
  printf("                        Maximum Allowed events is %d\n", maxevents);
  printf("Latest event no. is %d Last transferred was %d\n", detnr, pdetnr);
  printf ("\n");
  printf("Change the last transferred no. (%d) ? ", pdetnr);
  fflush (stdout);

  if (strchr ("Yy", getch()))
  {
    printf("\nNew PDETNR No(%d)  : ",pdetnr);
	scanf ("%d", &newno);
	fp = fopen (PDETNR, "w");
	fprintf (fp, "%d", newno);
    if (fp && (! ferror (fp))) printf("PDETNR has been changed to %d\n", newno);
    else printf ("ERROR - writing to %s\n", PDETNR);
    fclose (fp);
  }
  else printf ("\n");

 exit (0);
 
}



/* old (unused) FORTRAN sunroutine: */

/*
      subroutine getparam(evlimit)
      integer evlimit
      character*50 line,evline
      data evline/'Number of blocks in EVENT file     :'/
      open(11,err=999,file='/dd/sl/pr/param',status='old')
100   read(11,1,end=900)line
1     format(3x,a50)
C      write(1,2)line
2     format(1x,a50)
      if(line(1:36).ne.evline(1:36))go to 100
C event number line has been found now decode the number
      read(line,4)evlimit
4     format(36x,i6)
      close(11)
      return
900   write(1,5)
5     format('Stop:',/,'Error - EOF reading /dd/sl/pr/param')
      close(11)
      stop
999   write(1,3)
3     format('Stop:',/,'Error - opening /dd/sl/pr/param')
      close(11)
      stop
      end
*/      
