/****************************************************************************/
/*                       PC QNX SEISLOG Software              Version 6.0   */
/****************************************************************************/
/*                                                                          */
/*                                      University of Bergen                */
/*                                      Institute of Solid Earth Physics    */
/*                                      Seismological Observatory           */
/*                                      Allegaten 41, 5007 Bergen, Norway   */
/*                                      Tlf. +47 55 213408 +47 55213419     */
/*                                      Fax  +47 55 233337 +47 55320009     */
/*                                      Author: Terje Utheim, Jens Havskov  */
/*                                      E-mail: terje.utheim@ifjf.uib.no    */
/*                                              jens.havskov@ifjf.uib.no    */
/*                                                                          */
/*                                      Date:02/05/96                       */
/* Program:VERSION.C                                                        */
/*                                                                          */
/* Last update:                                                             */
/*                                                                          */
/* Program description:                                                     */
/*                                                                          */
/* The program asks for the SEISLOG version and make a file called          */
/* VERSION.LIS including the date of the backup. The program is called by   */
/* the BCK_STRU program.                                                    */
/*                                                                          */
/****************************************************************************/
#include <stdio.h>
#include <time.h>
main()
{
struct   tm time_of_day;
time_t   ltime;
char     syscall[80];
auto     char com[26];
int      i;
float    vno;                          /* version number                    */
FILE*    buf;                          /* pointer to file                   */
/*--------------------------------------------------------------------------*/
/* check if a file containing version and date already exists               */
/*--------------------------------------------------------------------------*/
if((buf=fopen("/home/seislog/version.lis","r"))!=NULL)
{
    fclose(buf); 
    printf("Current version:\n");
    system("cat /home/seislog/version.lis");   /* print it                  */
    system("rm -f /home/seislog/version.lis"); /* remove it                 */
}   
/*--------------------------------------------------------------------------*/
/* make new one                                                             */
/*--------------------------------------------------------------------------*/
printf("Enter SEISLOG version number:");
scanf("%f",&vno);
time(&ltime);
_localtime(&ltime,&time_of_day);
sprintf(syscall,"Date and time is: %s SEISLOG version: %5.2f\n",
_asctime(&time_of_day,com),vno);
syscall[42]=' ';
if((buf=fopen("/home/seislog/version.lis","w"))!=NULL)
{
    fprintf(buf,"%s\n",syscall);
    fclose(buf); 
}   
}
