/****************************************************************************/
/*                       PC QNX SEISLOG Software              Version 6.0   */
/****************************************************************************/
/*                                                                          */
/*                                      University of Bergen                */
/*                                      Institute of Solid Earth Physics    */
/*                                      Seismological Observatory           */
/*                                      Allegaten 41, 5007 Bergen, Norway   */
/*                                      Tlf. +47 55 213408 +47 55213419     */
/*                                      Fax  +47 55 233337 +47 55320009     */
/*                                      Author: Terje Utheim, Jens Havskov  */
/*                                      E-mail: terje.utheim@ifjf.uib.no    */
/*                                              jens.havskov@ifjf.uib.no    */
/*                                                                          */
/*                                      Date:12/04/96                       */
/* Program:SYS_WAT                                                          */
/*                                                                          */
/* Last update:                                                             */
/*                                                                          */
/* Program description:                                                     */
/*                                                                          */
/*                                                                          */
/****************************************************************************/     

#include "shar_mem.h"                  /* shared memory definitions         */
#include <sys/mman.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/dev.h>
#include <fcntl.h>
#include <errno.h>
#include <stdlib.h>
#include <unistd.h>
#include <i86.h>
#include <time.h>
#include <conio.h>

int      fd;                           /* return value open share           */
smod     *ptr;                         /* pointer to shared region          */

main()
{
struct   timespec start;
int      i;                            /* counter                           */
unsigned char bit;                     /* bit on par port 0-9               */
/*--------------------------------------------------------------------------*/
/* open shared memory region                                                */
/*--------------------------------------------------------------------------*/
fd=shm_open("SEISLOG",O_RDWR | O_CREAT, 0777);
if(fd== -1) 
{
    fprintf(stderr,"SYS_WAT_01 open failed:%s\n",strerror(errno));
    exit(1);
}
/*--------------------------------------------------------------------------*/
/* set size of memory region                                                */
/*--------------------------------------------------------------------------*/
ltrunc(fd,sizeof(smod),SEEK_SET);
/*--------------------------------------------------------------------------*/
/* Compute pointer to shared memory region                                  */
/*--------------------------------------------------------------------------*/
ptr=mmap(0,sizeof(smod),PROT_READ | PROT_WRITE,MAP_SHARED,fd,0);
if((int)ptr == -1) 
{
    fprintf(stderr,"SYS_WAT_02 mmap failed : %s\n",strerror(errno));
    exit(1);
}
sleep(10);                             /* wait until all processes run      */
for(;;)
{
    for(i=0;i<10;i++)
        ptr->alive[i]=0;               /* zero all indicators               */
    sleep(10);                         /* sleep for 15 seconds              */
    if(ptr->alive[0]==0)               /* check if BUF_PIPE is alive ?      */
    {                                  /* no, do something                  */
        printf("BUF_PIP is not running\n");
        sprintf(ptr->err_msg,"SYS_WAT: *** AUTO RESTART *** BUF_PIP dead");
        errlog(ptr);

        if(ptr->err_mail == 1)
            system("/home/seislog/message 3");
        sleep(20);
        system("/home/seislog/sys_boot");

    }
    if(ptr->alive[1]==0)               /* check if digitizer is alive ?     */
    {                                  /* no, do something                  */
        printf("Digitizer driver is not running\n");
        sprintf(ptr->err_msg,"SYS_WAT: *** AUTO RESTART *** DIGITIZING dead");
        errlog(ptr);

        if(ptr->err_mail == 1)
            system("/home/seislog/message 4&");
        sleep(20);
        system("/home/seislog/sys_boot");
    }
    if(ptr->alive[2]==0)               /* check if DETEC_01 is alive ?      */
    {                                  /* no, do something                  */
        printf("DET_EVT is not running\n");
        sprintf(ptr->err_msg,"SYS_WAT: *** AUTO RESTART *** DET_EVT dead");
        errlog(ptr);

        if(ptr->err_mail == 1)
            system("/home/seislog/message 5&");
        sleep(20);
        system("/home/seislog/sys_boot");
    }
    if(ptr->alive[3]==0)               /* check if TIMING is alive ?        */
    {                                  /* no, do something                  */
        printf("TIMING is not running\n");
        sprintf(ptr->err_msg,"SYS_WAT: Clock program gets TIMEOUT, kill/restart");
        errlog(ptr);

        if(ptr->err_mail == 1)
            system("/home/seislog/message 6&");
        sleep(20);
        system("/home/seislog/sys_boot");
    }
    if(ptr->alive[4]==0)               /* check if CAT_EVTS is alive ?      */
    {                                  /* no, do something                  */
        printf("CAT_EVT is not running\n");
        sprintf(ptr->err_msg,"SYS_WAT: *** AUTO RESTART *** CAT_EVT dead");

        if(ptr->err_mail == 1)
            system("/home/seislog/message 7&");
        sleep(20);
        system("/home/seislog/sys_boot");
    }
}
}
