/****************************************************************************/
/*                       PC QNX SEISLOG Software              Version 6.0   */
/****************************************************************************/
/*                                                                          */
/*                                      University of Bergen                */
/*                                      Institute of Solid Earth Physics    */
/*                                      Seismological Observatory           */
/*                                      Allegaten 41, 5007 Bergen, Norway   */
/*                                      Tlf. +47 55 213408 +47 55213419     */
/*                                      Fax  +47 55 233337 +47 55320009     */
/*                                      Author: Terje Utheim, Jens Havskov  */
/*                                      E-mail: terje.utheim@ifjf.uib.no    */
/*                                              jens.havskov@ifjf.uib.no    */
/*                                                                          */
/*                                      Date:12/04/96                       */
/* Program:WEB_MON                                                          */
/*                                                                          */
/* Last update:                                                             */
/*                                                                          */
/* Program description:                                                     */
/*                                                                          */
/*                                                                          */
/****************************************************************************/
#include "shar_mem.h"                  /* shared memory definitions         */
#include <sys/mman.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/dev.h>
#include <fcntl.h>
#include <errno.h>
#include <stdlib.h>
#include <unistd.h>
#include <i86.h>
#include <time.h>
#include <conio.h>
int      fd;                           /* return value open share           */
smod     *ptr;                         /* pointer to shared region          */
main()
{
struct   timespec start;
int      i;                            /* counter                           */
unsigned char bit;                     /* bit on par port 0-9               */
/*--------------------------------------------------------------------------*/
/* open shared memory region                                                */
/*--------------------------------------------------------------------------*/
fd=shm_open("SEISLOG",O_RDWR | O_CREAT, 0777);
if(fd== -1)
{
    fprintf(stderr,"SYS_WAT_01 open failed:%s\n",strerror(errno));
    exit(1);
}
/*--------------------------------------------------------------------------*/
/* set size of memory region                                                */
/*--------------------------------------------------------------------------*/
ltrunc(fd,sizeof(smod),SEEK_SET);
/*--------------------------------------------------------------------------*/
/* Compute pointer to shared memory region                                  */
/*--------------------------------------------------------------------------*/
ptr=mmap(0,sizeof(smod),PROT_READ | PROT_WRITE,MAP_SHARED,fd,0);
if((int)ptr == -1)
{
    fprintf(stderr,"SYS_WAT_02 mmap failed : %s\n",strerror(errno));
    exit(1);
}
sleep(10);                             /* wait until all processes run      */
for(;;)
{
    for(i=0;i<10;i++)
        ptr->servers[i]=0;               /* zero all indicators               */
    sleep(10);                         /* sleep for 15 seconds              */
//    if(ptr->servers[0]==0)               /* check if JMON_S is alive ?      */
//    {                                  /* no, do something                  */
//        printf("JMON_S is not running\n");
//        sprintf(ptr->err_msg,"WEB_MON: *** RESTART JMON_S *** ");
//        errlog(ptr);
//        if(ptr->err_mail == 1)
//            system("/home/seislog/message 3");
//        sleep(20);
//        system("on -t /dev/con6 /home/seislog/jmon_s&");
//    }
//    if(ptr->servers[1]==0)               /* check if JSTS_S is alive ?      */
//    {                                    /* no, do something                */
//        printf("JSTS_S is not running\n");
//        sprintf(ptr->err_msg,"WEB_MON: *** RESTART JSTS_S *** ");
//        errlog(ptr);
//        system("on -t /dev/con6 /home/seislog/jsts_s&");
//    }
//    if(ptr->servers[2]==0)               /* check if JLGS_S is alive ?      */
//    {                                    /* no, do something                */
//        printf("JLGS_S is not running\n");
//        sprintf(ptr->err_msg,"WEB_MON: *** RESTART JLGS_S *** ");
//        errlog(ptr);
//        system("on -t /dev/con6 /home/seislog/jlgs_s&");
//    }
//    if(ptr->servers[3]==0)               /* check if JALL_S is alive ?      */
//    {                                    /* no, do something                */
//        printf("JALL_S is not running\n");
//        sprintf(ptr->err_msg,"WEB_MON: *** RESTART JALL_S *** ");
//        errlog(ptr);
//        system("slay -f -Q jall_s");
//        system("on -t /dev/con6 /home/seislog/jall_s&");
//    }
//    if(ptr->servers[4]==0)               /* check if JRTP_S is alive ?      */
//    {                                    /* no, do something                */
//        printf("JRTP_S is not running\n");
//        sprintf(ptr->err_msg,"WEB_MON: *** RESTART JRTP_S *** ");
//        errlog(ptr);
//        system("on -t /dev/con6 /home/seislog/jrtp_s&");
//    }
    if(ptr->servers[5]==0)               /* check if SNDFILE is alive ?      */
    {                                    /* no, do something                 */
        printf("SNDFILE is not running\n");
        sprintf(ptr->err_msg,"WEB_MON: *** RESTART SNDFILE *** ");
//        errlog(ptr);
        system("on -t /dev/con6 /home/seislog/sndfile&");
    }
    if(ptr->servers[6]==0)               /* check if JLGF_S is alive ?      */
    {                                    /* no, do something                */
        printf("JLGF_S is not running\n");
        sprintf(ptr->err_msg,"WEB_MON: *** RESTART JLGF_S *** ");
//        errlog(ptr);
        system("on -t /dev/con6 /home/seislog/jlgf_s&");
    }
//    if(ptr->servers[7]==0)               /* check if FAST is alive ?       */
//    {                                    /* no, do something               */
//        printf("FAST is not running\n");
//        sprintf(ptr->err_msg,"WEB_MON: *** RESTART FAST *** ");
//        errlog(ptr);
//        system("on -t /dev/con6 /home/seislog/fast&");
//    }
}
}
