/*   Updates                      */
/*   March 95 by jh: font problems, background and forground      */
/*   Dec 96        : xcurs do not send back null char, remian in loop */
/*                   mouse sends a blank like on the pc, was l     */
/*                                                                */
#include <X11/Xlib.h>
#include <X11/Xutil.h>
char hello[] = {"Hello, World."};
char hi [] = {"Hi!"};
Display *mydisplay;
Window mywindow;
Window rootw,pointw;
int rootx,rooty,pointx,pointy, keybut;
XColor  col[7];     /* Array of colours */
int nvis;                   /* Number of visuals in list */
XVisualInfo visTmp;         /* Temporary used for checking visual type */
XVisualInfo *visList;       /* list of visuals */
GC mygc;
XFontStruct *font_info;
XEvent myevent;
KeySym mykey;
XSizeHints myhint;
XWindowAttributes winAtt;
int myscreen;
float wscale,xscale,yscale;            /*scaling factor for window*/
unsigned long myforeground, mybackground;
int i;
int ih;                   /*xwindow y size in picels*/
char text[10];
int done;
/**/
/*   open a new x window    */
/**/
/*xopen_(size,type,background) */
xopen(size,type)
int *size;       /* input:  window size in pixels */
int *type;       /* output: 1: color screen, 0: black white */
/*int *background;   color of background */
{
   int argc;
   char **argv;
   int  nxpix,nypix;    /* # pixels on screen */
   int xsize;
char **fntList;            /* List of font names */
int fix;                   /* index for accepted font */
int fntCnt;                /* No. elements in fntList & fntInfolist */
XFontStruct *fntInfolist;  /* List of font attributes */
XFontStruct *defFnt;       /* Attributes for default font */
Font f1id,f2id;            /* Font IDs */


XColor  dummyCol;   /* Just a dummy variable */

    *type=0;  /* default is bw */

mydisplay = XOpenDisplay ("");
myscreen  = DefaultScreen (mydisplay);
mybackground = WhitePixel (mydisplay, myscreen);
myforeground = BlackPixel (mydisplay, myscreen);


/* --------- GET ROOT WINDOW SIZE ------vvvv--------- */

     nxpix = DisplayWidth(mydisplay,myscreen);
     nypix = DisplayHeight(mydisplay,myscreen);

/* --------- GET ROOT WINDOW SIZE ------^^^^--------- */

/* scale window so it still fits with tektronics, calculate scaling factor*/
/* to be used in all subsequent operations*/

xsize=((*size)*nxpix)/100 ;
wscale=xsize/1024.0;
myhint.x      = 1; 
myhint.y      = 1;
myhint.width  = 1024*wscale; 
myhint.height = 780*wscale;
xscale=wscale;                 /*initially same scale for x and y */
yscale=wscale;
ih=myhint.height;
myhint.flags  = PPosition | PSize;

/* Try to get RGB colours from default colour map if color screen: */
/* Checking display type (if 8bit PseudoColor not supported, use black&white) */
    visTmp.depth = 8;
    visTmp.screen = myscreen;
    visTmp.class = PseudoColor;
    visList = XGetVisualInfo (mydisplay,VisualScreenMask|VisualDepthMask
                             ,&visTmp,&nvis);
/*    printf(" nvis %d\n",nvis);*/ 
    if (nvis>0) {
      *type=1;    /* indicate a color screen */
if (!XAllocNamedColor(mydisplay, DefaultColormap(mydisplay,myscreen), "red"
                     ,&(col[3]),&dummyCol)) {
   printf ("--colour-- ERROR: Unable to get red colour\n");
   exit(-1);
}

if (!XAllocNamedColor(mydisplay, DefaultColormap(mydisplay,myscreen), "green"
                     ,&(col[2]),&dummyCol)) {
   printf ("--colour-- ERROR: Unable to get green colour\n");
   exit(-1);
}

if (!XAllocNamedColor(mydisplay, DefaultColormap(mydisplay,myscreen), "blue"
                     ,&(col[1]),&dummyCol)) {

   printf ("--colour-- ERROR: Unable to get blue colour\n");
   exit(-1);
}
if (!XAllocNamedColor(mydisplay, DefaultColormap(mydisplay,myscreen), "yellow"
                     ,&(col[4]),&dummyCol)) {
   printf ("--colour-- ERROR: Unable to get red colour\n");
   exit(-1);
}}

if (!XAllocNamedColor(mydisplay, DefaultColormap(mydisplay,myscreen), "white"
                     ,&(col[5]),&dummyCol)) {
   printf ("--colour-- ERROR: Unable to get white colour\n");
   exit(-1);
}
if (!XAllocNamedColor(mydisplay, DefaultColormap(mydisplay,myscreen), "black"
                     ,&(col[6]),&dummyCol)) {
   printf ("--colour-- ERROR: Unable to get black colour\n");
   exit(-1);
}
/*printf(" col 1 %d\n",col[1].pixel);
printf(" col 2 %d\n",col[2].pixel);
printf(" col 3 %d\n",col[3].pixel);
printf(" col 4 %d\n",col[4].pixel);
printf(" col 5 %d\n",col[5].pixel);
printf(" col 6 %d\n",col[6].pixel);
printf("white,fore %d %d\n",col[5].pixel,myforeground);
printf("black,fore %d %d\n",col[6].pixel,myforeground);*/ 
/*printf("color back, background %d  %d\n",col[(*background)],mybackground);*/ 

mywindow = XCreateSimpleWindow (mydisplay, DefaultRootWindow (mydisplay),
           myhint.x, myhint.y, myhint.width, myhint.height, 5,
           myforeground, mybackground); 
/*           myforeground, col[*background].pixel);*/ 

mygc = XCreateGC (mydisplay, mywindow, 0, 0);
/*XSetStandardProperties (mydisplay, mywindow," "," ", None,
                        argv, argc, &myhint);
*/

/**/

/* --------- FONTS ---------------------vvvv--------- */

  fntList = XListFontsWithInfo (mydisplay,"-*-*-*-r-*-*-*-*-*-*-m-*-iso8859-*"
            ,1,&fntCnt,&fntInfolist);
  if (fntList) {
    f1id = XLoadFont (mydisplay,*(fntList));
    XFreeFontInfo (fntList,fntInfolist,fntCnt);
  }
  else {
   printf ("--fonts-- ERROR: Unable to get small font\n");
   exit(-1);
  }
  XSetFont (mydisplay,mygc,f1id);

/*  fntList = XListFontsWithInfo (mydisplay,"-*-*-*-r-*-*-20-*-*-*-m-*-iso8859-*"
               ,1,&fntCnt,&fntInfolist);
  if (fntList) {
    f2id = XLoadFont (mydisplay,*(fntList));
    XFreeFontInfo (fntList,fntInfolist,fntCnt);
  }
  else {
   printf ("--fonts-- ERROR: Unable to get large font\n");
   exit(-1); 

  } */
/* --------- FONTS ---------------------^^^^--------- */


XSetBackground (mydisplay, mygc, mybackground);
XSetForeground (mydisplay, mygc, myforeground);

XSelectInput (mydisplay, mywindow, 
              ButtonPressMask | KeyPressMask | ExposureMask);

XMapRaised (mydisplay, mywindow);


done = 0;
while (done==0) {
  
   done=1;
   XNextEvent (mydisplay, &myevent);
   switch (myevent.type) {
   case Expose:
      if (myevent.xexpose.count ==0)
/*         XDrawImageString (myevent.xexpose.display, myevent.xexpose.window,*/
/*                           mygc, 50, 50, hello, strlen(hello) ); */
/*         done=0;*/
         break;
   case MappingNotify:
      XRefreshKeyboardMapping (&myevent);
      break;
   case ButtonPress:
      XDrawImageString (myevent.xbutton.display, myevent.xbutton.window,
                        mygc, myevent.xbutton.x, myevent.xbutton.y, hi,
                        strlen(hi) );
       XDrawLine (myevent.xexpose.display, myevent.xexpose.window, mygc,
                   myevent.xbutton.x, myevent.xbutton.y,
		    myevent.xbutton.x, myevent.xbutton.y+20);

      break;
   case KeyPress:
      i = XLookupString (&myevent, text, 10, &mykey, 0);
      XDrawImageString (myevent.xbutton.display, myevent.xbutton.window,
                        mygc, myevent.xbutton.x, myevent.xbutton.y,text,
                        strlen(text) );
      if (i==1 && text[0]=='q') done = 1;
      break;
   }  /* switch */
}  /* while */
}
xclose()
{
XFreeGC (mydisplay, mygc);
XDestroyWindow (mydisplay, mywindow);
XCloseDisplay (mydisplay);
/*exit(0);*/
}

xmore()
{
done = 0;
while (done==0) {
  
   XNextEvent (mydisplay, &myevent);
   switch (myevent.type) {
   case Expose:
      if (myevent.xexpose.count ==0)
         XDrawImageString (myevent.xexpose.display, myevent.xexpose.window,
                           mygc, 50, 50, hello, strlen(hello) );
         break;
   case MappingNotify:
      XRefreshKeyboardMapping (&myevent);
      break;
   case ButtonPress:
      XDrawImageString (myevent.xbutton.display, myevent.xbutton.window,
                        mygc, myevent.xbutton.x, myevent.xbutton.y+50, hi,
                        strlen(hi) );
       XDrawLine (myevent.xexpose.display, myevent.xexpose.window, mygc,
                   myevent.xbutton.x, myevent.xbutton.y,
		    myevent.xbutton.x, myevent.xbutton.y+20);

      break;
   case KeyPress:
      i = XLookupString (&myevent, text, 10, &mykey, 0);
      if (i==1 && text[0]=='q') done = 1;
      break;
   }  /* switch */
}  /* while */

}
xline()
{
       XDrawLine (mydisplay, mywindow, mygc,
                 20,20,50,50); 
}
/***********************************************************************/
/* move cursor to ix,iy, units are tectronics*/

void xmoveto(ix,iy)
long *ix;
long *iy;
{
   short int x,y;
   x=(*ix)*xscale;
   y=ih-*iy*yscale;
   XDrawLine (mydisplay, mywindow, mygc,x,y,x,y);
}
/************************************************************************/
/* draw a line between ix1,iy1 and ix2, iy2, units are tectronics*/

void xlineto(ix1,iy1,ix2,iy2)
long *ix1,*ix2;
long *iy1,*iy2;
{
short int x1,y1,x2,y2;
x1=*ix1*xscale;
x2=*ix2*xscale;
y1=ih-*iy1*yscale;
y2=ih-*iy2*yscale;
   XDrawLine (mydisplay, mywindow, mygc,x1,y1,x2,y2);
}
/***********************************************************************/
/* plot a text string text with n characters starting at position ix,iy  */

void xtext(text,n,ix,iy)
long *n,*ix,*iy;
char *text;
{
short int x,y;
  x=*ix*xscale;
  y=ih-*iy*yscale;
  XDrawString (mydisplay, mywindow,
                    mygc,x,y,text,*n);
}
/**********************************************************************/
/* graphic cursor  */
void xcursr(cha,ix,iy)
long *ix,*iy;
char *cha;
{
int i;
start:
   *cha=NULL;
   XNextEvent (mydisplay, &myevent);
   switch (myevent.type) {
   case Expose:
      if (myevent.xexpose.count ==0)
         break;
/*   case MappingNotify:
      XRefreshKeyboardMapping (&myevent);
      break; */
   case ButtonPress:
   strcpy(cha," ");      /* mouse press send a blank   */
   break;
   case KeyPress:
   i = XLookupString (&myevent, cha, 10, &mykey, 0);
   if(strncmp(cha,"\0",1)==0) goto start;
}
  *ix=myevent.xbutton.x/xscale;
  *iy=(ih-myevent.xbutton.y)/yscale;
}
/**********************************************************************/
/*  clear screen    */
void xclear()
{
  XClearWindow(mydisplay,mywindow);
}
/**/
void update_window_size()
{
XGetWindowAttributes(mydisplay,mywindow,&winAtt);
/*printf("%d %d\n",winAtt.width,winAtt.height);*/
ih=winAtt.height;
xscale=winAtt.width/1024.0;
yscale=winAtt.height/780.0;
}




   void  promptx (mDSP,mGC,mWIN,fg,bg,xmin,ymin,xlen,ylen,prompt,ans,nans)
/* ----------------------------------------------------------------------- */
/* A quick hack to read a string from the keyboard in an existing X11      */
/* application                                                             */
/*                                                                         */
/* Compile with '-DFTNSTRING', or uncomment the '#define   FTNSTRING   1'  */
/* line below to strip trailing blanks in FORTRAN strings.                 */
/*                                                                         */
/*                                                                         */
/*  NOTE: - The routine wipes out all graphics in the answer area !        */
/*        - *NO* checks are performed on the input parameters !            */
/*                                                                         */
/*                                                                         */
/* 940905as: Initial version.                                              */
/* 940906as: Now possible to strip trailing blanks (FORTRAN strings).      */
/*                                                                         */


#define   FTNSTRING   1  /* Uncomment to strip trailing blanks in *prompt */

/* Input parameters: */
  Display  *mDSP;       /* Display           */
  Window   mWIN;        /* Main window       */
  GC       mGC;         /* Graphics context  */
  unsigned long fg;     /* foreground colour */
  unsigned long bg;     /* background colour */
  int      xmin;        /* X coordinate for upper left corer of answer area */
  int      ymin;        /* Y coordinate for upper left corer of answer area */
  int      xlen;        /* Width of answer area */
  int      ylen;        /* Height of answer area */
  char     *prompt;     /* Prompt string     */
  int      nans;        /* Max number of characters in answer string */


/* Output parameters: */
  char  *ans;           /* answer string     */


{


/* Variables: */
   Window   pWIN;       /* Main window       */
   XEvent pEV;          /* X event */
   KeySym pKEY;         /* Keysym */
   int pSCR;            /* Screen */
   char text[10];
   char scrSTR[250];    
   char tmpSTR[250];    
   int done;
   int i,tmp;

#ifdef FTNSTRING
   for (i=strlen(prompt)-1;i>=0;i--)    
     if(!isspace(prompt[i]))
       break;
   tmpSTR[i+1]='\0';
   for ( ; i>=0; i--)
      tmpSTR[i]=prompt[i];
#define PROMPTSTRING tmpSTR
#else
#define PROMPTSTRING prompt
#endif


   pWIN = XCreateSimpleWindow(mDSP,mWIN,xmin,ymin,xlen,ylen,2,fg,bg);
   XSelectInput (mDSP,pWIN,  KeyPressMask | ExposureMask);
   XMapRaised (mDSP,pWIN);
   XFlush (mDSP);

   ans[0] = 0;
   sprintf (scrSTR,"%s %s",PROMPTSTRING,ans);

   done = 0;
   while (done==0) {
      XNextEvent (mDSP, &pEV);
      switch (pEV.type) {
      case Expose:
         if (pEV.xexpose.count ==0) {
           XSetForeground (mDSP, mGC, fg);
           XSetBackground (mDSP, mGC, bg);
           XDrawImageString (pEV.xexpose.display, pEV.xexpose.window,
                             mGC,10,20,scrSTR,strlen(scrSTR));
           XFlush (mDSP);
         }
         break;
      case KeyPress:
         i = XLookupString (&pEV, text, 10, &pKEY, 0);
         if (i==1) {
           if (text[0]==13)    /* RETURN */
             done = 1;
           else {
             if ((text[0]==8 || text[0]==127) && strlen(ans)>0) {  /* DEL/BS */
               ans[strlen(ans)-1] = 0;
               XClearWindow (mDSP,pWIN);
             }
             else if (text[0]>31) {  /* only accepts printable characters */ 
               tmp = strlen(ans);
               if (tmp>=nans) {      /* not room for more characters */
                 XFillRectangle (mDSP,pWIN,mGC,0,0,xlen,ylen);
                 XSetForeground (mDSP, mGC, bg);
                 XSetBackground (mDSP, mGC, fg);
                 XDrawImageString (mDSP, pWIN,mGC,10,20
                                  ,"Not room for more characters",28);
                 XFlush (mDSP);
                 sleep(2);
                 XSetForeground (mDSP, mGC, fg);
                 XSetBackground (mDSP, mGC, bg);
                 XClearWindow (mDSP,pWIN);
                 XDrawImageString (mDSP,pWIN,mGC,10,20,scrSTR,strlen(scrSTR));
               }
               else {
                 ans[tmp] = text[0];
                 ans[tmp+1] = 0;
               }
             }
             sprintf (scrSTR,"%s %s",PROMPTSTRING,ans);
             XDrawImageString (mDSP, pWIN,mGC,10,20,scrSTR,strlen(scrSTR));
             XFlush (mDSP);
             break;
           }  
         }  
      } 
    }  

    XUnmapWindow (mDSP,pWIN);
         for(done=strlen(ans);done<nans;done++)
          ans[done]=' ';

}



   void one_line(question,nq,answer,na,x0,y0)
/* question: prompt question                               */
/* nq:       number of characters in question              */
/* naswer:   answer                                        */
/* na        number of characters in anaswe                */
/* x0,y0     posion of string                              */
   float *x0;
   float *y0;
   int *na;
   int *nq;
   char *answer;
   char *question;
{
   int xlen;
   int  ylen;
   int ix;
   int iy;
   ix=*x0;
   iy=*y0;
   xlen=(*nq+*na)*8;
   ylen=30;
   ix=ix*xscale;
   iy=ih-iy*yscale;
/*   printf("%d %d %d %d\n",ix,iy,xlen,ylen);*/ 
   promptx (mydisplay,mygc,mywindow,myforeground,mybackground,ix,iy,xlen,ylen,question,answer,*na);
}
   void xget_abs_position()
{
/* Get the current abs cursor position: */
if (!XQueryPointer(mydisplay, DefaultRootWindow (mydisplay), &rootw, &pointw,
    &rootx,&rooty,&pointx,&pointy,&keybut) )
       exit (-1);
}
   void xmove_to_alpha()
{
/* Move the cursor back to where is was found: */
XWarpPointer(mydisplay, None, DefaultRootWindow(mydisplay), None, None, 0, 0,
    rootx, rooty);
XFlush (mydisplay);
}
   void xmove_to_graphics()
{
XWarpPointer(mydisplay, None, mywindow, None, None, 0, 0,
    200, 200);
XFlush (mydisplay);
}
/*    set color      */
void set_color_x(coll)
int *coll;
{
/*printf(" col 1 %d\n",col[1].pixel);
printf(" col 2 %d\n",col[2].pixel);
printf(" col 3 %d\n",col[3].pixel);
printf(" col 4 %d\n",col[4].pixel);
printf(" col 5 %d\n",col[5].pixel);
printf(" col 6 %d\n",col[6].pixel);
printf("color given outside %d\n",*coll);
printf("color set,forground %d %d\n",col[*coll].pixel,myforeground); 
printf("back ground %d\n",mybackground);*/ 
        XSetForeground (mydisplay, mygc, col[*coll].pixel);
}
/*    set background color      */
void set_back_x(coll)
int *coll;
{
        xclear;
        XSetWindowBackground (mydisplay, mywindow, col[*coll].pixel);
        xclear;
}
/*    fill rectangel  with current color, x1,y1,x2,y2 are corners      */

void fill_box(x1,y1,x2,y2)
float *x1,*y1,*x2,*y2;
{
   int xlen,ylen,x0,y0;
   x0=(*x1)*xscale;
   y0=ih-(*y2)*yscale;
   xlen=((*x2)-(*x1))*xscale;
   ylen=((*y2)-(*y1))*yscale;
   XFillRectangle (mydisplay,mywindow,mygc,x0,y0,xlen,ylen);
}
xflu()
{
    XFlush(mydisplay);
}